define(["exports", "../../../lit-element/lit-element.js", "../a11y-collapse.js"], function (_exports, _litElement, _a11yCollapse) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.A11yCollapseGroup = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject2_6ee89830425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          margin: var(--a11y-collapse-group-margin, 15px 0);\n          --a11y-collapse-margin: 15px;\n        }\n        #heading {\n          font-weight: bold;\n        }\n        .wrapper {\n          border-radius: 0;\n          --a11y-collapse-margin: 0;\n          --a11y-collapse-border-between: none;\n        }\n      "]);

    _templateObject2_6ee89830425211ea8ef51d3abfe05f78 = function _templateObject2_6ee89830425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  function _templateObject_6ee89830425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <div class=\"wrapper\"><slot></slot></div>\n    "]);

    _templateObject_6ee89830425211ea8ef51d3abfe05f78 = function _templateObject_6ee89830425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  /**
   * `a11y-collapse-group`
   * @customElement a11y-collapse-group
   * a group of `a11y-collapse` elements
   * 
  ### Styling
  
  `<a11y-collapse-group>` provides the following custom properties
  for styling:
  
  Custom property | Description | Default
  ----------------|-------------|----------
  `--a11y-collapse-group-margin` | margin around the a11y-collapse-group | 15px 0
   *
  
   * @extends A11yCollapse
   * @see ../a11y-collapse.js
   * @demo ./demo/group.html collapse groups
   */
  var A11yCollapseGroup =
  /*#__PURE__*/
  function (_A11yCollapse) {
    babelHelpers.inherits(A11yCollapseGroup, _A11yCollapse);
    babelHelpers.createClass(A11yCollapseGroup, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_6ee89830425211ea8ef51d3abfe05f78());
      }
    }], [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_6ee89830425211ea8ef51d3abfe05f78())];
      }
    }]);

    function A11yCollapseGroup() {
      var _this;

      babelHelpers.classCallCheck(this, A11yCollapseGroup);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(A11yCollapseGroup).call(this));
      _this.accordion = null;
      _this.disabled = null;
      _this.expanded = null;
      _this.icon = null;
      _this.iconExpanded = null;
      _this.label = null;
      _this.labelExpanded = null;
      _this.tooltip = null;
      _this.tooltipExpanded = null;
      _this.globalOptions = {};
      _this.radio = false;
      _this.__items = [];

      _this.addEventListener("a11y-collapse-attached", function (e) {
        this._attachItem(e.detail);
      });

      _this.addEventListener("a11y-collapse-detached", function (e) {
        this._detachItem(e.detail);
      });

      _this.addEventListener("a11y-collapse-click", function (e) {
        this.radioToggle(e.detail);
      });

      return _this;
    }

    babelHelpers.createClass(A11yCollapseGroup, [{
      key: "_attachItem",

      /**
       * Adds a11y-collapse item to __items array.
       * @param {object} item an a11y-collapse item
       */
      value: function _attachItem(item) {
        this.__items.push(item);
      }
      /**
       * Updates a11y-collapse item when properties change
       */

    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          _this2.__items.forEach(function (item) {
            if (propName === "globalOptions" || propName === "__items") {
              if (_this2.globalOptions !== {}) for (var key in _this2.globalOptions) {
                if (_this2.globalOptions.hasOwnProperty(key)) {
                  item[key] = _this2.globalOptions[key];
                }
              }
            }

            if (propName === "expanded" && _this2.expanded) {
              item.expanded = true;
            }

            if (propName === "radio" && _this2.radio) {
              item.expanded = false;
            }

            if (propName === "accordion" || propName === "disabled" || propName === "icon" || propName === "iconExpanded" || propName === "label" || propName === "lanelExpanded" || propName === "tooltip" || propName === "tooltipExpanded") {
              if (_this2[propName] !== null) item[propName] = _this2[propName];
            }
          });
        });
      }
      /**
       * Removes a detached item from __items array.
       * @param {object} item an a11y-collapse item
       */

    }, {
      key: "_detachItem",
      value: function _detachItem(item) {
        if (this.__items && item) {
          for (var i = 0; i < this.__items.length; i++) {
            if (this.__items[i] === item) this.__items.splice(i, 1);
          }
        }
      }
      /**
       * Toggles off all previous choices.
       * @param {object} item an a11y-collapse item
       */

    }, {
      key: "radioToggle",
      value: function radioToggle(item) {
        if (this.radio && item.expanded) {
          for (var i = 0; i < this.__items.length; i++) {
            if (this.__items[i] !== item) this.__items[i].toggle(false);
          }
        }
      }
    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this.removeEventListener("a11y-collapse-click", function (e) {
          this.radioToggle(e.detail);
        });
        this.removeEventListener("a11y-collapse-attached", function (e) {
          this.push("__items", e.detail);
        });
        this.removeEventListener("a11y-collapse-detached", function (e) {
          this._detachItem(e.detail);
        });
        babelHelpers.get(babelHelpers.getPrototypeOf(A11yCollapseGroup.prototype), "disconnectedCallback", this).call(this);
      }
    }], [{
      key: "tag",
      get: function get() {
        return "a11y-collapse-group";
      }
    }, {
      key: "properties",
      get: function get() {
        return _objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(A11yCollapseGroup), "properties", this), {
          /**
           * an array of globalProperties to override every a11y-collapse item
           * For example, {"icon": "arrow-drop-down"} would set every item's icon to "arrow-drop-down"
           */
          globalOptions: {
            type: Object,
            attribute: "global-options",
            reflect: true
          },

          /**
           * is every a11y-collapse item radio button?
           */
          radio: {
            type: Boolean
          },

          /**
           * is radio button
           */
          __items: {
            type: Array
          }
        });
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return null;
      }
    }]);
    return A11yCollapseGroup;
  }(_a11yCollapse.A11yCollapse);

  _exports.A11yCollapseGroup = A11yCollapseGroup;
  window.customElements.define(A11yCollapseGroup.tag, A11yCollapseGroup);
});