define(["exports", "require", "../../lit-element/lit-element.js", "../schema-behaviors/schema-behaviors.js"], function (_exports, _require, _litElement, _schemaBehaviors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.A11yGifPlayer = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject4_4af93920425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: inline-flex;\n        }\n        *[hidden] {\n          display: none;\n        }\n        button {\n          padding: 0;\n          display: flex;\n          align-items: stretch;\n          position: relative;\n          width: auto;\n          border: var(--a11y-gif-player-border, none);\n          border-radius: var(--a11y-gif-player-border-radius, 0);\n        }\n        button:active,\n        button:focus,\n        button:hover {\n          border: var(--a11y-gif-player-focus-border, none);\n          cursor: var(--a11y-gif-player-cursor, pointer);\n          outline: var(--a11y-gif-player-outline, 3px solid);\n        }\n        button[disabled] {\n          cursor: var(--a11y-gif-player-disabled-cursor, not-allowed);\n        }\n        button > * {\n          width: 100%;\n          min-width: 100%;\n          min-height: 100%;\n          flex: 1 1 100%;\n        }\n        div {\n          display: flex;\n          align-items: center;\n          flex-direction: column;\n          position: absolute;\n        }\n        svg {\n          flex: 1 1 100%;\n          width: var(--a11y-gif-player-arrow-size, 30%);\n          height: var(--a11y-gif-player-arrow-size, 30%);\n        }\n        g {\n          opacity: var(--a11y-gif-player-arrow-opacity, 0.5);\n        }\n        button:not([disabled]):active g,\n        button:not([disabled]):hover g,\n        button:not([disabled]):focus g {\n          opacity: var(--a11y-gif-player-button-focus-opacity, 0.7);\n        }\n        polygon {\n          fill: var(--a11y-gif-player-button-color, #000000);\n          stroke: var(--a11y-gif-player-arrow-border-color, #ffffff);\n          stroke-width: var(--a11y-gif-player-arrow-border-width, 15px);\n        }\n        text {\n          fill: var(--a11y-gif-player-button-text-color, #ffffff);\n        }\n        img {\n          position: absolute;\n        }\n        button[aria-pressed=\"true\"] svg,\n        button[aria-pressed=\"true\"] img {\n          opacity: 0;\n        }\n        button[data-no-image] .button-bg {\n          background-color: var(--a11y-gif-player-button-bg, #cccccc);\n        }\n        button[aria-pressed=\"true\"][data-no-image] .button-bg {\n          background-color: transparent;\n        }\n        simple-tooltip {\n          --simple-tooltip-background: #000000;\n          --simple-tooltip-opacity: 1;\n          --simple-tooltip-text-color: #ffffff;\n          --simple-tooltip-delay-in: 0;\n        }\n      "]);

    _templateObject4_4af93920425211ea8ef51d3abfe05f78 = function _templateObject4_4af93920425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  function _templateObject3_4af93920425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral([""]);

    _templateObject3_4af93920425211ea8ef51d3abfe05f78 = function _templateObject3_4af93920425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  function _templateObject2_4af93920425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n              <img\n                id=\"static\"\n                loading=\"lazy\"\n                alt=\"", "\"\n                src=\"", "\"\n              />\n            "]);

    _templateObject2_4af93920425211ea8ef51d3abfe05f78 = function _templateObject2_4af93920425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  function _templateObject_4af93920425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <button\n        id=\"button\"\n        aria-controls=\"gif\"\n        aria-pressed=\"", "\"\n        @click=\"", "\"\n        ?data-no-image=\"", "\"\n        ?disabled=\"", "\"\n      >\n        <iron-image id=\"gif\" src=\"", "\" ?hidden=\"", "\">\n        </iron-image>\n        ", "\n        <div class=\"button-bg\">\n          <svg\n            id=\"svg\"\n            xmlns=\"http://www.w3.org/2000/svg\"\n            viewBox=\"0 0 200 200\"\n          >\n            <g>\n              <polygon points=\"30,20 30,180 170,100\"></polygon>\n              <text x=\"50\" y=\"115\" font-size=\"40px\">GIF</text>\n            </g>\n          </svg>\n        </div>\n      </button>\n\n      <simple-tooltip for=\"button\" offset=\"30\" animation-delay=\"0\">\n        ", "\n      </simple-tooltip>\n    "]);

    _templateObject_4af93920425211ea8ef51d3abfe05f78 = function _templateObject_4af93920425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  /**
   * `a11y-gif-player`
   * plays gifs in an accessible way by having the user click to play their animation
  ### Styling
  
  `<a11y-gif-player>` provides the following custom properties
  for styling:
  
  Custom property | Description | Default
  ----------------|-------------|----------
  `--a11y-gif-player-border` | border around player/button | none
  `--a11y-gif-player-border-radius` | border-radius for player/button | 0
  `--a11y-gif-player-focus-border` | border-radius for player/button when hovered or focused | none
  `--a11y-gif-player-cursor` | cursor for player/button when hovered or focused | pointer
  `--a11y-gif-player-outline` | outline for player/button when hovered or focused | 
  `--a11y-gif-player-disabled-cursor` | cursor for player/button when disabled | not-allowed
  `--a11y-gif-player-arrow-size` | arrow icon size | 30%
  `--a11y-gif-player-arrow-opacity` | default arrow icon opacity | 0.5
  `--a11y-gif-player-button-focus-opacity` | arrow icon opacity when hovered or focused | 0.7
  `--a11y-gif-player-button-color` | arrow icon color | #000000
  `--a11y-gif-player-arrow-border-color` | arrow icon border color | #ffffff
  `--a11y-gif-player-arrow-border-width` | arrow icon border width | 15px
  `--a11y-gif-player-button-text-color` | arrow icon text color | #ffffff
  `--a11y-gif-player-button-bg` | button background color when no static image | #cccccc
   *
   * @demo ./demo/index.html
   * @customElement a11y-gif-player
   */
  var A11yGifPlayer =
  /*#__PURE__*/
  function (_SchemaBehaviors) {
    babelHelpers.inherits(A11yGifPlayer, _SchemaBehaviors);

    function A11yGifPlayer() {
      var _this;

      babelHelpers.classCallCheck(this, A11yGifPlayer);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(A11yGifPlayer).call(this));
      _this.alt = null;
      _this.disabled = false;
      _this.src = null;
      _this.tooltip = "Toggle animation";
      _this.tooltipPlaying = null;
      _this.srcWithoutAnimation = null;
      _this.__playing = false;
      _this.noImage = true;
      new Promise(function (res, rej) {
        return _require.default(["../simple-tooltip/simple-tooltip.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../@polymer/iron-image/iron-image.js"], res, rej);
      });
      return _this;
    }
    /**
     * LitElement render styles
     */


    babelHelpers.createClass(A11yGifPlayer, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_4af93920425211ea8ef51d3abfe05f78(), this.__playing ? "true" : "false", this.toggle, this.noImage, this.disabled || !this.src, this.src, !this.src, !this.noImage ? (0, _litElement.html)(_templateObject2_4af93920425211ea8ef51d3abfe05f78(), this.alt, this.srcWithoutAnimation) : (0, _litElement.html)(_templateObject3_4af93920425211ea8ef51d3abfe05f78()), this.__playing && this.tooltipPlaying ? this.tooltipPlaying : this.tooltip);
      }
      /**
       * Convention
       */

    }, {
      key: "updated",

      /**
       * LitElement properties updated
       */
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "srcWithoutAnimation") {
            if (_this2[propName] != null && _this2[propName] != "") {
              _this2.noImage = false;
            } else {
              _this2.noImage = true;
            }
          }
        });
      }
      /**
       * plays the animation regarless of previous state
       */

    }, {
      key: "play",
      value: function play() {
        this.__playing = true;
      }
      /**
       * stops the animation regarless of previous state
       */

    }, {
      key: "stop",
      value: function stop() {
        this.__playing = false;
      }
      /**
       * toggles the animation based on current state
       */

    }, {
      key: "toggle",
      value: function toggle() {
        if (this.__playing) {
          this.stop();
        } else {
          this.play();
        }
      }
      /**
       * deprecated. toggles the animation based on current state
       */

    }, {
      key: "toggleAnimation",
      value: function toggleAnimation() {
        if (this.__playing) {
          this.stop();
        } else {
          this.play();
        }
      }
      /**
       * HAX
       */

    }], [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject4_4af93920425211ea8ef51d3abfe05f78())];
      }
    }, {
      key: "tag",
      get: function get() {
        return "a11y-gif-player";
      }
      /**
       * LitElement / popular convention
       */

    }, {
      key: "properties",
      get: function get() {
        return _objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(A11yGifPlayer), "properties", this), {
          /**
           * Alt text of gif
           */
          alt: {
            type: String
          },

          /**
           * Whether button is disabled
           */
          disabled: {
            type: Boolean
          },

          /**
           * Source of animated gif
           */
          src: {
            type: String
          },

          /**
           * Source of static version of image
           */
          srcWithoutAnimation: {
            type: String,
            attribute: "src-without-animation"
          },

          /**
           * default tooltip
           */
          tooltip: {
            type: String
          },

          /**
           * tooltip when playing
           */
          tooltipPlaying: {
            type: String,
            attribute: "tooltip-playing"
          },

          /**
           * whether GIF is playing
           */
          __playing: {
            type: Boolean
          },

          /**
           * Boolean for if theres a source image or not
           */
          noImage: {
            type: Boolean
          }
        });
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: false,
          gizmo: {
            title: "Accessible GIF",
            description: "Makes animated GIFs accessible.",
            icon: "gif",
            color: "grey",
            groups: ["Images", "Media"],
            handles: [{
              type: "image",
              source: "src",
              source2: "srcWithoutAnimation",
              alt: "alt"
            }],
            meta: {
              author: "ELMS:LN"
            }
          },
          settings: {
            quick: [{
              property: "src",
              title: "Animated GIF",
              description: "The URL to your animated GIF.",
              inputMethod: "textfield",
              icon: "link",
              validationType: "url",
              required: true
            }, {
              property: "srcWithoutAnimation",
              title: "Still Image",
              description: "The URL to a still image version of your GIF.",
              inputMethod: "textfield",
              icon: "link",
              validationType: "url",
              required: true
            }, {
              property: "alt",
              title: "Alt Text",
              description: "Alternative text for the image.",
              inputMethod: "textfield",
              icon: "accessibility",
              required: true
            }],
            configure: [{
              property: "src",
              title: "Animated GIF",
              description: "The URL to your animated GIF.",
              inputMethod: "haxupload",
              icon: "link",
              validationType: "url",
              required: true
            }, {
              property: "srcWithoutAnimation",
              title: "Still Image",
              description: "The URL to a still image version of your GIF.",
              inputMethod: "haxupload",
              icon: "link",
              validationType: "url",
              required: true
            }, {
              property: "alt",
              title: "Alt Text",
              description: "Alternative text for the image.",
              inputMethod: "alt",
              icon: "accessibility",
              required: true
            }],
            advanced: []
          }
        };
      }
    }]);
    return A11yGifPlayer;
  }((0, _schemaBehaviors.SchemaBehaviors)(_litElement.LitElement));

  _exports.A11yGifPlayer = A11yGifPlayer;
  window.customElements.define(A11yGifPlayer.tag, A11yGifPlayer);
});