define(["exports", "../../../lit-element/lit-element.js", "../../simple-search/lib/simple-search-content.js"], function (_exports, _litElement, _simpleSearchContent) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.A11yMediaTranscriptCue = void 0;

  function _templateObject2_6efd58b0425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          cursor: default;\n          display: table-row;\n          width: 100%;\n          color: var(--a11y-media-transcript-cue-color);\n          background-color: var(--a11y-media-transcript-cue-bg-color);\n          transition: color 0.25s, background-color 0.25s;\n          --simple-search-match-text-color: var(\n            --a11y-media-transcript-match-color\n          );\n          --simple-search-match-bg-color: var(\n            --a11y-media-transcript-match-bg-color\n          );\n          --simple-search-match-border-color: var(\n            --a11y-media-transcript-match-border-color\n          );\n          --simple-search-match-border: none;\n          --simple-search-match-border-radius: 4px;\n          --simple-search-match-font-weight: normal;\n        }\n        :host([hide-timestamps]) {\n          display: inline;\n        }\n        :host(:not([active]):not([disabled]):active),\n        :host(:not([active]):not([disabled]):focus),\n        :host(:not([active]):not([disabled]):hover) {\n          cursor: pointer;\n          color: var(--a11y-media-transcript-focused-cue-color);\n          background-color: var(--a11y-media-transcript-focused-cue-bg-color);\n          outline: 1px dotted var(--a11y-media-transcript-focused-cue-color);\n        }\n        :host([active]) {\n          color: var(--a11y-media-transcript-active-cue-color);\n          background-color: var(--a11y-media-transcript-active-cue-bg-color);\n        }\n        #text {\n          display: table-cell;\n          width: 100%;\n          line-height: 200%;\n        }\n        :host([hide-timestamps]) #text {\n          display: inline;\n        }\n        #time {\n          display: table-cell;\n          font-size: 80%;\n          padding: 0 16px 0 0;\n          white-space: nowrap;\n          font-family: monospace;\n        }\n        :host([hide-timestamps]) #time {\n          display: none;\n        }\n        @media print {\n          :host,\n          :host([active]),\n          :host(:not([active]):not([disabled]):active),\n          :host(:not([active]):not([disabled]):focus),\n          :host(:not([active]):not([disabled]):hover) {\n            color: #000000;\n            background-color: #ffffff;\n          }\n        }\n      "]);

    _templateObject2_6efd58b0425211ea8ef51d3abfe05f78 = function _templateObject2_6efd58b0425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  function _templateObject_6efd58b0425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <span id=\"time\">\n        ", " - ", "\n      </span>\n      <span id=\"text\">\n        <slot></slot>\n      </span>\n    "]);

    _templateObject_6efd58b0425211ea8ef51d3abfe05f78 = function _templateObject_6efd58b0425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  /**
   * `a11y-media-transcript-cue`
   * a single cue in a11y-media-transcriptas static text or as an button that controls media.
   * 
   * Custom styles:
  ```--a11y-media-transcript-bg-color: background color of the transcript, default is #ffffff
  --a11y-media-transcript-text-color: color of the transcript text, default is #000000```
   *   
   * Custom styles for focused cue:
  ```--a11y-media-transcript-focused-cue-text: color of the focused cue text, default is --a11y-media-transcript-text-color
  --a11y-media-transcript-focused-cue-bg: background color of the focused cue, default is --a11y-media-transcript-bg-color
  --a11y-media-transcript-focused-cue-weight: font-weight of the focused cue, default is bold```
   *   
   * Custom styles for active cue:
  ```--a11y-media-transcript-active-cue-text: color of the active cue text, default is --a11y-media-transcript-text-color
  --a11y-media-transcript-active-cue-bg: background color of the active cue, default is #ccfffd
  --a11y-media-transcript-active-cue-weight: font-weight of the active cue, default is normal```
   *
   * @customElement a11y-media-transcript-cue
   */
  var A11yMediaTranscriptCue =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(A11yMediaTranscriptCue, _LitElement);
    babelHelpers.createClass(A11yMediaTranscriptCue, null, [{
      key: "properties",
      // properties available to the custom element for data binding
      get: function get() {
        return _objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(A11yMediaTranscriptCue), "properties", this), {
          /**
           * whether to hide the timestamps
           */
          active: {
            attribute: "active",
            type: Boolean,
            reflect: true
          },

          /**
           * whether to hide the timestamps
           */
          disabled: {
            attribute: "disabled",
            type: Boolean,
            reflect: true
          },

          /**
           * cue end time
           */
          end: {
            type: String
          },

          /**
           * whether to hide the timestamps
           */
          hideTimestamps: {
            attribute: "hide-timestamps",
            type: Boolean,
            reflect: true
          },

          /**
           * cue start time
           */
          start: {
            type: String
          }
        });
      }
      /**
       * Store the tag name to make it easier to obtain directly.
        */

    }, {
      key: "tag",
      get: function get() {
        return "a11y-media-transcript-cue";
      } //inherit styles from a11y-media-player or a11y-media-transcript

    }]);

    function A11yMediaTranscriptCue() {
      var _this;

      babelHelpers.classCallCheck(this, A11yMediaTranscriptCue);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(A11yMediaTranscriptCue).call(this));
      _this.active = false;
      _this.disabled = false;
      _this.hideTimestamps = false;
      _this.start = "";
      _this.end = "";
      return _this;
    } //render function


    babelHelpers.createClass(A11yMediaTranscriptCue, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_6efd58b0425211ea8ef51d3abfe05f78(), this.start, this.end);
      }
    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName === "active" && _this2.active) _this2.dispatchEvent(new CustomEvent("active-changed", {
            detail: {
              element: _this2,
              oldValue: oldValue,
              value: _this2.active
            }
          }));
        });
      }
    }], [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_6efd58b0425211ea8ef51d3abfe05f78())];
      }
    }]);
    return A11yMediaTranscriptCue;
  }(_litElement.LitElement);

  _exports.A11yMediaTranscriptCue = A11yMediaTranscriptCue;
  window.customElements.define(A11yMediaTranscriptCue.tag, A11yMediaTranscriptCue);
});