define(["exports", "../../lit-element/lit-element.js", "../simple-colors/simple-colors.js"], function (_exports, _litElement, _simpleColors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.AccentCard = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject2_49bd84d0425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          border-radius: 2px;\n          margin: 0 0 15px;\n          box-shadow: var(\n            --accent-card-box-shadow,\n            0 2px 2px 0 rgba(0, 0, 0, 0.14),\n            0 1px 5px 0 rgba(0, 0, 0, 0.12),\n            0 3px 1px -2px rgba(0, 0, 0, 0.2)\n          );\n          color: var(\n            --accent-card-color,\n            var(--simple-colors-default-theme-grey-9, #222)\n          );\n          background-color: var(\n            --accent-card-background-color,\n            var(--simple-colors-default-theme-grey-1, #fff)\n          );\n          --accent-card-image-width: 30%;\n          --accent-card-image-height: 10%;\n          --accent-card-border-color: var(\n            --simple-colors-default-theme-accent-6,\n            #ddd\n          );\n          --accent-card-heading-color: var(\n            --simple-colors-default-theme-accent-7,\n            #000\n          );\n          --accent-card-footer-border-color: var(\n            --simple-colors-default-theme-grey-3,\n            #ddd\n          );\n        }\n        :host([dark]) {\n          color: var(\n            --accent-card-color,\n            var(--simple-colors-default-theme-grey-12, #fff)\n          );\n          --accent-card-border-color: var(\n            --simple-colors-default-theme-accent-7,\n            #fff\n          );\n          --accent-card-footer-border-color: var(\n            --simple-colors-default-theme-grey-6,\n            #666\n          );\n        }\n        :host([accent-background]) {\n          background-color: var(\n            --accent-card-background-color,\n            var(--simple-colors-default-theme-accent-1, #fff)\n          );\n          --accent-card-footer-border-color: var(--accent-card-border-color);\n        }\n        :host section {\n          width: 100%;\n          box-sizing: border-box;\n        }\n        :host([horizontal]) section {\n          display: flex;\n          justify-content: space-between;\n          align-items: stretch;\n        }\n        :host([flat]) {\n          box-shadow: none;\n        }\n        :host([flat]:not([accent-background])) {\n          border: 1px solid var(--accent-card-footer-border-color);\n        }\n        :host(:not([horizontal]):not([no-border])) section {\n          border-top: 4px solid var(--accent-card-border-color);\n        }\n        :host([horizontal]:not([no-border])) section {\n          border-left: 4px solid var(--accent-card-border-color);\n        }\n        :host .image-outer {\n          box-sizing: border-box;\n          position: relative;\n          overflow: visible;\n        }\n        :host([horizontal]) .image-outer {\n          height: auto;\n          width: var(--accent-card-image-width);\n        }\n        :host(:not([horizontal])) .image-outer {\n          height: auto;\n          width: 100%;\n        }\n        :host .image {\n          height: 100%;\n          width: 100%;\n          background-size: cover;\n          background-position-x: var(--accent-card-image-x, center);\n          background-position-y: var(--accent-card-image-y, center);\n        }\n        :host([image-align=\"left\"]) .image {\n          background-position-x: left;\n        }\n        :host([image-align=\"center\"]) .image {\n          background-position-x: center;\n        }\n        :host([image-align=\"right\"]) .image {\n          background-position-x: right;\n        }\n        :host([image-valign=\"top\"]) .image {\n          background-position-y: top;\n        }\n        :host([image-valign=\"center\"]) .image {\n          background-position-y: center;\n        }\n        :host([image-valign=\"bottom\"]) .image {\n          background-position-y: bottom;\n        }\n        :host(:not([horizontal])) .image {\n          height: 0;\n          padding-top: var(--accent-card-image-height);\n        }\n        :host .body {\n          flex-grow: 1;\n          overflow: visible;\n        }\n        :host #heading {\n          padding-top: var(--accent-card-padding, 20px);\n          padding-left: var(--accent-card-padding, 20px);\n          padding-right: var(--accent-card-padding, 20px);\n          padding-bottom: 0;\n          margin: 0;\n        }\n        :host([accent-heading][accent-color]) #heading {\n          color: var(--accent-card-heading-color);\n        }\n        :host #subheading {\n          font-size: 90%;\n          font-style: italic;\n          padding-left: var(--accent-card-padding, 20px);\n          padding-right: var(--accent-card-padding, 20px);\n        }\n        :host #content {\n          font-size: 100%;\n          padding: var(--accent-card-padding, 20px);\n        }\n        :host #content:not(:last-child) {\n          border-bottom: 1px solid var(--accent-card-footer-border-color);\n        }\n        :host #footer {\n          padding-left: var(--accent-card-padding, 20px);\n          padding-right: var(--accent-card-padding, 20px);\n        }\n      "]);

    _templateObject2_49bd84d0425211ea8ef51d3abfe05f78 = function _templateObject2_49bd84d0425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  function _templateObject_49bd84d0425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <section id=\"card\">\n        <div class=\"image-outer\" ?hidden=\"", "\">\n          <div\n            class=\"image\"\n            .style=\"", "\"\n          ></div>\n        </div>\n        <div class=\"body\">\n          <h1 id=\"heading\"><slot name=\"heading\"></slot></h1>\n          <div id=\"subheading\"><slot name=\"subheading\"></slot></div>\n          <div id=\"content\"><slot name=\"content\"></slot></div>\n          <div id=\"footer\"><slot name=\"footer\"></slot></div>\n        </div>\n      </section>\n    "]);

    _templateObject_49bd84d0425211ea8ef51d3abfe05f78 = function _templateObject_49bd84d0425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  /**
   * `accent-card`
   * @customElement accent-card
   * a card with optional accent stylings.
   * 
  ### Styling
  
  `<accent-card>` provides the following custom properties and mixins
  for styling:
  
  Custom property | Description | Default
  ----------------|-------------|----------
  `--accent-card-image-width` | Width of image when card is horizontal. | 30%
  `--accent-card-image-height` | Height of image when card is vertical. | 10%
  `--accent-card-padding` | Sets padding inside the accent card. | 20px
  `--accent-card-footer-border-color` | Card footer's border color.* | `--simple-colors-default-theme-grey-3`
  `--accent-card-box-shadow` | Card footer's box-shadow. | 0 2px 2px 0 rgba(0, 0, 0, 0.14), 0 1px 5px 0 rgba(0, 0, 0, 0.12), 0 3px 1px -2px rgba(0, 0, 0, 0.2)
  `--accent-card-color`	| Card's text color.* | `--simple-colors-default-theme-grey-9`
  `--accent-card-background-color` | Card's background color.* | varies based on attributes
  `--accent-card-border-color` | Card's border color.* | varies based on attributes
  `--accent-card-heading-color` | Card's heading color.* | varies based on attributes
  * Overrides colors set by accent-color and dark attributes.
   *
   * @extends SimpleColors
  
   * @demo ./demo/index.html demo
   * @demo ./demo/colors.html colors
   * @demo ./demo/orientation.html card orientation
   * @demo ./demo/borders.html borders and shadow
   * @demo ./demo/images.html image aligmnent
   * @demo ./demo/variables.html css variables
   */
  var AccentCard =
  /*#__PURE__*/
  function (_SimpleColors) {
    babelHelpers.inherits(AccentCard, _SimpleColors);
    babelHelpers.createClass(AccentCard, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_49bd84d0425211ea8ef51d3abfe05f78(), !this.imageSrc, this.imageSrc ? "background-image: url(".concat(this.imageSrc, ");") : "display: none;");
      } // haxProperty definition

    }], [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */
      get: function get() {
        return "accent-card";
      } // render function

    }, {
      key: "styles",
      get: function get() {
        return [].concat(babelHelpers.toConsumableArray(babelHelpers.get(babelHelpers.getPrototypeOf(AccentCard), "styles", this)), [(0, _litElement.css)(_templateObject2_49bd84d0425211ea8ef51d3abfe05f78())]);
      }
    }, {
      key: "haxProperties",
      get: function get() {
        var _ref;

        return _ref = {
          canEditSource: false,
          canPosition: false
        }, babelHelpers.defineProperty(_ref, "canEditSource", false), babelHelpers.defineProperty(_ref, "gizmo", {
          title: "Accent Card",
          description: "A card with optional accent styling.",
          icon: "chrome-reader-mode",
          color: "light-blue",
          groups: ["Media", "Text"],
          handles: [{
            type: "media",
            url: "source"
          }, {
            type: "text",
            url: "source"
          }],
          meta: {
            author: "nikkimk",
            owner: "The Pennsylvania State University"
          }
        }), babelHelpers.defineProperty(_ref, "settings", {
          quick: [{
            property: "accentColor",
            title: "Accent Color",
            description: "An optional accent color.",
            inputMethod: "colorpicker",
            icon: "editor:format-color-fill"
          }, {
            property: "dark",
            title: "Dark Theme",
            description: "Enable Dark Theme",
            inputMethod: "boolean",
            icon: "icons:invert-colors"
          }, {
            property: "horizontal",
            title: "Horizontal",
            description: "Horizontal orientation?",
            inputMethod: "boolean"
          }],
          configure: [{
            slot: "heading",
            title: "Heading",
            description: "A heading for the card.",
            inputMethod: "textfield"
          }, {
            slot: "subheading",
            title: "Subheading",
            description: "An optional subheading for the card.",
            inputMethod: "textfield"
          }, {
            slot: "content",
            title: "Content",
            description: "Content for the card.",
            inputMethod: "textfield"
          }, {
            slot: "footer",
            title: "Footer",
            description: "An optional footer for the card.",
            inputMethod: "textfield"
          }, {
            property: "imageSrc",
            title: "Image",
            description: "Optional image",
            inputMethod: "haxupload",
            icon: "editor:insert-photo"
          }, {
            property: "imageAlign",
            title: "imageAlign",
            description: "Image Horizontal Alignment",
            inputMethod: "select",
            options: {
              left: "left",
              center: "center",
              right: "right"
            }
          }, {
            property: "imageValign",
            title: "imageValign",
            description: "Image Vertical Alignment",
            inputMethod: "select",
            options: {
              top: "top",
              center: "center",
              bottom: "bottom"
            }
          }, {
            property: "accentColor",
            title: "Accent Color",
            description: "An optional accent color.",
            inputMethod: "colorpicker",
            icon: "editor:format-color-fill"
          }, {
            property: "dark",
            title: "Dark Theme",
            description: "Enable Dark Theme",
            inputMethod: "boolean",
            icon: "icons:invert-colors"
          }, {
            property: "horizontal",
            title: "Horizontal",
            description: "Horizontal orientation?",
            inputMethod: "boolean"
          }, {
            property: "accentHeading",
            title: "Heading Accent",
            description: "Apply the accent color to the heading?",
            inputMethod: "boolean"
          }, {
            property: "accentBackground",
            title: "Background Accent",
            description: "Apply the accent color to the card background?",
            inputMethod: "boolean"
          }, {
            property: "noBorder",
            title: "No Border Accent",
            description: "Remove the border accent?",
            inputMethod: "boolean"
          }, {
            property: "flat",
            title: "Flat",
            description: "Remove the box shadow?",
            inputMethod: "boolean"
          }],
          advanced: []
        }), babelHelpers.defineProperty(_ref, "saveOptions", {
          unsetAttributes: ["colors"]
        }), _ref;
      }
    }]);

    function AccentCard() {
      var _this;

      babelHelpers.classCallCheck(this, AccentCard);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(AccentCard).call(this));
      _this.accentBackground = false;
      _this.accentHeading = false;
      _this.flat = false;
      _this.horizontal = false;
      _this.imageAlign = null;
      _this.imageSrc = null;
      _this.imageValign = null;
      _this.noBorder = false;
      return _this;
    } // properties available to the custom element for data binding


    babelHelpers.createClass(AccentCard, null, [{
      key: "properties",
      get: function get() {
        return _objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(AccentCard), "properties", this), {
          /**
           * Apply accent color to card background
           */
          accentBackground: {
            type: Boolean,
            attribute: "accent-background",
            reflect: true
          },

          /**
           * Apply accent color to heading
           */
          accentHeading: {
            type: Boolean,
            attribute: "accent-heading",
            reflect: true
          },

          /**
           * Display the card as flat (no box shadow);
           */
          flat: {
            type: Boolean,
            reflect: true
          },

          /**
           * Display the card as a horizontal layout? Default is vertical.
           */
          horizontal: {
            type: Boolean,
            reflect: true
          },

          /**
           * "Optional": The horizontal alignment of the image, so that:
           * - "left" will align the left edge of the image.
           * - "right" will align the right edge of the image.
           * - "center" will align the center of the image
           * - A null will allow temporary support to the deprecated CSS variables
           */
          imageAlign: {
            type: String,
            attribute: "image-align",
            reflect: true
          },

          /**
           * "Optional": The source for an image on the card
           */
          imageSrc: {
            type: String,
            attribute: "image-src"
          },

          /**
           * "Optional": The vertical alignment of the image, so that:
           * - "top" will align the top of edge of the image.
           * - "bottom" will align the bottom edge of the image.
           * - "center" will align the middle of the image.
           * - A null will allow temporary support to the deprecated CSS variables
           */
          imageValign: {
            type: String,
            attribute: "image-valign",
            reflect: true
          },

          /**
           * Removes the think accent border
           */
          noBorder: {
            type: Boolean,
            attribute: "no-border",
            reflect: true
          }
        });
      }
    }]);
    return AccentCard;
  }(_simpleColors.SimpleColors);

  _exports.AccentCard = AccentCard;
  window.customElements.define(AccentCard.tag, AccentCard);
});