define(["exports", "require", "../../../lit-element/lit-element.js", "../../grafitto-filter/grafitto-filter.js", "../../utils/utils.js"], function (_exports, _require, _litElement, _grafittoFilter, _utils) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HaxAppBrowser = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject3_704ac040425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n          <hax-app-browser-item\n            index=\"", "\"\n            title=\"", "\"\n            icon=\"", "\"\n            image=\"", "\"\n            color=\"", "\"\n            meta=\"", "\"\n            groups=\"", "\"\n            handles=\"", "\"\n            description=\"", "\"\n            rating=\"", "\"\n            tags=\"", "\"\n          ></hax-app-browser-item>\n        "]);

    _templateObject3_704ac040425211ea8ef51d3abfe05f78 = function _templateObject3_704ac040425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  function _templateObject2_704ac040425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <h3 class=\"title\"><iron-icon icon=\"search\"></iron-icon> ", "</h3>\n      <div class=\"toolbar-inner\">\n        <dropdown-select\n          id=\"filtertype\"\n          label=\"Filter by\"\n          value=\"details.title\"\n          @change=\"", "\"\n        >\n          <paper-item value=\"details.title\">Title</paper-item>\n        </dropdown-select>\n        <paper-input\n          label=\"Filter\"\n          id=\"inputfilter\"\n          @value-changed=\"", "\"\n          aria-controls=\"filter\"\n          value=\"\"\n          always-float-label=\"\"\n        ></paper-input>\n      </div>\n      <grafitto-filter\n        id=\"filter\"\n        .items=\"", "\"\n        like=\"\"\n        @filtered-changed=\"", "\"\n        where=\"details.title\"\n        ><template></template\n      ></grafitto-filter>\n      ", "\n      <hax-app-search\n        id=\"haxappsearch\"\n        .hidden=\"", "\"\n      ></hax-app-search>\n      <slot></slot>\n    "]);

    _templateObject2_704ac040425211ea8ef51d3abfe05f78 = function _templateObject2_704ac040425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  function _templateObject_704ac040425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n        :host *[hidden] {\n          display: none;\n        }\n        hax-app-browser-item {\n          margin: 8px;\n          -webkit-transition: 0.3s all linear;\n          transition: 0.3s all linear;\n          display: inline-flex;\n        }\n        .title {\n          position: relative;\n          padding: 16px;\n          outline: 0;\n          font-weight: 600;\n          text-align: left;\n          margin: 0;\n          background-color: var(--hax-color-menu-heading-bg);\n          font-size: 18px;\n          line-height: 18px;\n          font-family: \"Noto Serif\", serif;\n          color: var(--hax-color-menu-heading-color);\n        }\n        grafitto-filter {\n          color: black;\n        }\n        .toolbar-inner {\n          display: inline-flex;\n          padding: 0 16px;\n        }\n      "]);

    _templateObject_704ac040425211ea8ef51d3abfe05f78 = function _templateObject_704ac040425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  /**
   * `hax-app-browser`
   * @customElement hax-app-browser
   *
   * `Browse a list of apps. This provides a listing of our gizmos that we've integrated with.`
   * @microcopy - the mental model for this element
   * - hax-app - expression of how to communicate and visualize a data source
   * - gizmo - silly name for the general public when talking about hax-app and what it provides in the end
   */
  var HaxAppBrowser =
  /*#__PURE__*/
  function (_winEventsElement) {
    babelHelpers.inherits(HaxAppBrowser, _winEventsElement);
    babelHelpers.createClass(HaxAppBrowser, null, [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject_704ac040425211ea8ef51d3abfe05f78())];
      }
    }]);

    function HaxAppBrowser() {
      var _this;

      babelHelpers.classCallCheck(this, HaxAppBrowser);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(HaxAppBrowser).call(this));
      _this.__winEvents = {
        "hax-app-selected": "_appSelected",
        "hax-store-property-updated": "_haxStorePropertyUpdated"
      };
      _this.title = "Search for media";
      _this.searching = false;
      _this.activeApp = null;
      _this.appList = [];
      _this.filtered = [];
      _this.hasActive = false;
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/paper-input/paper-input.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/paper-item/paper-item.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../dropdown-select/dropdown-select.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["./hax-app-browser-item.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["./hax-app-search.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(HaxAppBrowser, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject2_704ac040425211ea8ef51d3abfe05f78(), this.title, this.filtertypeChange, this.inputfilterChanged, this.appList, this.filteredChanged, this.filtered.map(function (app) {
          return (0, _litElement.html)(_templateObject3_704ac040425211ea8ef51d3abfe05f78(), app.index, app.details.title, app.details.icon, app.details.tag, app.details.color, app.details.meta, app.details.groups, app.details.handles, app.details.description, app.details.rating, app.details.tags);
        }), !this.searching);
      }
    }, {
      key: "filteredChanged",
      value: function filteredChanged(e) {
        this.filtered = babelHelpers.toConsumableArray(e.detail.value);
      }
    }, {
      key: "inputfilterChanged",
      value: function inputfilterChanged(e) {
        this.shadowRoot.querySelector("#filter").like = e.target.value;
      }
    }, {
      key: "filtertypeChange",
      value: function filtertypeChange(e) {
        this.shadowRoot.querySelector("#inputfilter").value = "";
        this.shadowRoot.querySelector("#filter").where = e.detail.value;
        this.shadowRoot.querySelector("#filter").like = "";
      }
    }, {
      key: "firstUpdated",
      value: function firstUpdated(changedProperties) {
        this.resetBrowser();
      }
    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "activeApp") {
            _this2._activeAppChanged(_this2[propName], oldValue);
          }
        });
      }
      /**
       * App has been selected.
       */

    }, {
      key: "_appSelected",
      value: function _appSelected(e) {
        // item bubbled up
        if (babelHelpers.typeof(e.detail) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
          this.__activeApp = e.detail;
          this.searching = true;
          window.HaxStore.write("activeApp", this.appList[e.detail], this);
        }
      }
      /**
       * Active app updated, so scroll it into view
       */

    }, {
      key: "_activeAppChanged",
      value: function _activeAppChanged(newValue, oldValue) {
        if (babelHelpers.typeof(oldValue) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined)) && newValue != null) {
          window.HaxStore.instance.haxManager.searching = true;
          this.hasActive = true;
        } else {
          this.hasActive = false;
        }
      }
      /**
       * Store updated, sync.
       */

    }, {
      key: "_haxStorePropertyUpdated",
      value: function _haxStorePropertyUpdated(e) {
        if (e.detail && babelHelpers.typeof(e.detail.value) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined)) && e.detail.property) {
          this[e.detail.property] = e.detail.value;
        }
      }
      /**
       * Reset this browser.
       */

    }, {
      key: "resetBrowser",
      value: function resetBrowser() {
        this.searching = false;
        this.appList = babelHelpers.toConsumableArray(window.HaxStore.instance.appList);
        this.filtered = this.appList;
        this.shadowRoot.querySelector("#inputfilter").value = "";
        this.shadowRoot.querySelector("#filtertype").value = "details.title";
        this.shadowRoot.querySelector("#filter").value = "";
        this.shadowRoot.querySelector("#filter").filter();
        this.shadowRoot.querySelector("#filter").where = "details.title";
        this.shadowRoot.querySelector("#filter").like = "";
      }
    }], [{
      key: "tag",
      get: function get() {
        return "hax-app-browser";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Search term
           */
          search: {
            type: String
          },

          /**
           * Title of the browser, for translation.
           */
          title: {
            type: String
          },

          /**
           * Searching mode
           */
          searching: {
            type: Boolean,
            reflect: true
          },

          /**
           * Global activeApp object.
           */
          activeApp: {
            type: Object
          },

          /**
           * If we have an active, scale everything
           */
          hasActive: {
            reflect: true,
            type: Boolean,
            attribute: "has-active"
          },
          filtered: {
            type: Array
          },
          appList: {
            type: Array
          }
        };
      }
    }]);
    return HaxAppBrowser;
  }((0, _utils.winEventsElement)(_litElement.LitElement));

  _exports.HaxAppBrowser = HaxAppBrowser;
  window.customElements.define(HaxAppBrowser.tag, HaxAppBrowser);
});