define(["exports", "require", "../../../../../lit-element/lit-element.js", "../../../../../@polymer/paper-styles/shadow.js", "../../../../../@polymer/paper-styles/typography.js", "../../../../../@polymer/paper-styles/color.js", "../../../../../@polymer/polymer/lib/elements/custom-style.js"], function (_exports, _require, _litElement, _shadow, _typography, _color, _customStyle) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SiteLogin = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject2_7ad1c220425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <custom-style>\n        <style>\n          #loginbtn {\n            --paper-button-raised-keyboard-focus: {\n              background-color: var(\n                --login-btn-raised-background-color,\n                var(--paper-pink-a200)\n              ) !important;\n              color: var(--login-btn-text-color, white) !important;\n            }\n            @apply --login-btn;\n          }\n\n          h1 {\n            @apply --paper-font-display1;\n            @apply --login-title;\n          }\n\n          h2 {\n            @apply --paper-font-title;\n            @apply --login-subtitle;\n          }\n\n          #errormsg {\n            @apply --paper-font-menu;\n          }\n        </style>\n      </custom-style>\n      <div id=\"loginform\">\n        <paper-progress\n          ?disabled=\"", "\"\n          indeterminate\n        ></paper-progress>\n        <div id=\"loginformcontent\">\n          <h1>", "</h1>\n          <h2>", "</h2>\n          <div id=\"errormsg\">", "</div>\n          <paper-input\n            id=\"userinput\"\n            .value=\"", "\"\n            @value-changed=\"", "\"\n            ?disabled=\"", "\"\n            type=\"text\"\n            label=\"", "\"\n            required\n            error-message=\"", "\"\n          ></paper-input>\n          <paper-input\n            id=\"passinput\"\n            .value=\"", "\"\n            @value-changed=\"", "\"\n            ?disabled=\"", "\"\n            type=\"password\"\n            label=\"", "\"\n            required\n            error-message=\"", "\"\n          ></paper-input>\n          <paper-button\n            @click=\"", "\"\n            ?disabled=\"", "\"\n            id=\"loginbtn\"\n            raised\n            class=\"indigo\"\n            >", "</paper-button\n          >\n          <slot name=\"links\"></slot>\n        </div>\n      </div>\n    "]);

    _templateObject2_7ad1c220425211ea8ef51d3abfe05f78 = function _templateObject2_7ad1c220425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  function _templateObject_7ad1c220425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        #loginform {\n          width: 450px;\n          height: 450px;\n          background: var(--login-form-background-color, white);\n          box-shadow: 0 12px 16px 1px rgba(0, 0, 0, 0.14),\n            0 4px 22px 3px rgba(0, 0, 0, 0.12),\n            0 6px 7px -4px rgba(0, 0, 0, 0.4);\n        }\n        #loginformcontent {\n          padding: 48px;\n        }\n        #loginformcontent > * {\n          margin-top: 8px;\n          margin-bottom: 8px;\n        }\n        #loginbtn {\n          margin-top: 24px;\n          float: right;\n          background-color: var(\n            --login-btn-background-color,\n            var(--paper-indigo-500)\n          );\n          color: var(--login-btn-text-color, white);\n        }\n        #loginbtn[disabled] {\n          background-color: var(\n            --login-btn-disabled-background-color,\n            var(--paper-indigo-100)\n          );\n        }\n        h1 {\n          margin: 0;\n        }\n        h2 {\n          margin: 0;\n        }\n        paper-progress {\n          width: 100%;\n        }\n        #errormsg {\n          margin-top: 16px;\n          color: var(--login-error-label-color, var(--error-color));\n        }\n      "]);

    _templateObject_7ad1c220425211ea8ef51d3abfe05f78 = function _templateObject_7ad1c220425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  /**
   * `site-login`
   * `Visual element to broker a user login`
   *
  
   * @polymer
   * @demo demo/index.html
   */
  var SiteLogin =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(SiteLogin, _LitElement);
    babelHelpers.createClass(SiteLogin, null, [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject_7ad1c220425211ea8ef51d3abfe05f78())];
      }
      /**
       * HTMLElement life cycle
       */

    }]);

    function SiteLogin() {
      var _this;

      babelHelpers.classCallCheck(this, SiteLogin);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(SiteLogin).call(this));
      _this.loading = false;
      _this.userInputLabel = "Username";
      _this.userInputErrMsg = "Username required";
      _this.passwordInputLabel = "Password";
      _this.passwordInputErrMsg = "Password required";
      _this.loginBtnText = "Login";
      new Promise(function (res, rej) {
        return _require.default(["../../../../../@polymer/paper-button/paper-button.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../../../@polymer/paper-input/paper-input.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../../../@polymer/paper-progress/paper-progress.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(SiteLogin, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject2_7ad1c220425211ea8ef51d3abfe05f78(), !this.loading, this.title, this.subtitle, this.errorMsg, this.username, this.usernameChanged, this.loading, this.userInputLabel, this.userInputErrMsg, this.password, this.passwordChanged, this.loading, this.passwordInputLabel, this.passwordInputErrMsg, this._login, this.loading, this.loginBtnText);
      }
    }, {
      key: "usernameChanged",
      value: function usernameChanged(e) {
        this.username = e.detail.value;
      }
    }, {
      key: "passwordChanged",
      value: function passwordChanged(e) {
        this.password = e.detail.value;
      }
    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          // notify when any of these change
          if (["username", "password"].includes(propName)) {
            _this2.dispatchEvent(new CustomEvent("".concat(propName, "-changed"), {
              detail: {
                value: _this2[propName]
              }
            }));
          }
        });
      }
    }, {
      key: "firstUpdated",
      value: function firstUpdated(changedProperties) {
        this.shadowRoot.querySelector("#loginform").addEventListener("keypress", this._keyPress.bind(this));
      }
    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this.shadowRoot.querySelector("#loginform").removeEventListener("keypress", this._keyPress.bind(this));
        babelHelpers.get(babelHelpers.getPrototypeOf(SiteLogin.prototype), "disconnectedCallback", this).call(this);
      }
      /**
       * Listen for key presses
       */

    }, {
      key: "_keyPress",
      value: function _keyPress(e) {
        if (e.keyCode == 13) {
          //Enter
          this._login();

          return false;
        }
      }
    }, {
      key: "_login",
      value: function _login() {
        if (this.shadowRoot.querySelector("#userinput").validate() && this.shadowRoot.querySelector("#passinput").validate()) {
          this.dispatchEvent(new CustomEvent("login-btn-click", {
            bubbles: true,
            composed: true
          }));
        }
      }
    }], [{
      key: "tag",
      get: function get() {
        return "site-login";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Title of the loginscreen
           */
          title: String,

          /**
           * Subtitle of the loginscreen
           */
          subtitle: String,

          /**
           * Error message to show (example : "Invalid username")
           */
          errorMsg: String,

          /**
           * Content of the username field
           */
          username: {
            type: String
          },

          /**
           * Content of the password field
           */
          password: {
            type: String
          },

          /**
           * When true, all fields are disabled and the progress bar is visible
           */
          loading: {
            type: Boolean
          },

          /**
           * Placeholder of the username field
           */
          userInputLabel: {
            type: String,
            attribute: "user-input-label"
          },

          /**
           * Error message of the username field
           */
          userInputErrMsg: {
            type: String,
            attribute: "user-input-err-msg"
          },

          /**
           * Placeholder of the password field
           */
          passwordInputLabel: {
            type: String,
            attribute: "password-input-label"
          },

          /**
           * Error message of the password field
           */
          passwordInputErrMsg: {
            type: String,
            attribute: "password-input-err-msg"
          },

          /**
           * Login button label
           */
          loginBtnText: {
            type: String,
            attribute: "login-btn-text"
          }
        };
      }
    }]);
    return SiteLogin;
  }(_litElement.LitElement);

  _exports.SiteLogin = SiteLogin;
  window.customElements.define(SiteLogin.tag, SiteLogin);
});