define(["exports", "../../../lit-element/lit-element.js"], function (_exports, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrndesignGalleryDetails = void 0;

  function _templateObject2_72a1cfa0425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n        :host([hidden]) {\n          display: none;\n        }\n      "]);

    _templateObject2_72a1cfa0425211ea8ef51d3abfe05f78 = function _templateObject2_72a1cfa0425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  function _templateObject_72a1cfa0425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <div id=\"details\"></div>\n    "]);

    _templateObject_72a1cfa0425211ea8ef51d3abfe05f78 = function _templateObject_72a1cfa0425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  /**
   * `lrndesign-gallery-details`
   * `An element that renders the print view of a gallery item.`
   *
   * @microcopy - language worth noting:```
  <lrndesign-gallery-details 
    details="<strong>HTML MARKUP HERE</strong>"       //required, an array of item data
  </lrndesign-gallery-details>```
   *
   * @customElement lrndesign-gallery-details
   */
  var LrndesignGalleryDetails =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(LrndesignGalleryDetails, _LitElement);
    babelHelpers.createClass(LrndesignGalleryDetails, [{
      key: "render",
      // render function
      value: function render() {
        return (0, _litElement.html)(_templateObject_72a1cfa0425211ea8ef51d3abfe05f78());
      }
    }], [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_72a1cfa0425211ea8ef51d3abfe05f78())];
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       */

    }, {
      key: "tag",
      get: function get() {
        return "lrndesign-gallery-details";
      }
    }]);

    function LrndesignGalleryDetails() {
      var _this;

      babelHelpers.classCallCheck(this, LrndesignGalleryDetails);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(LrndesignGalleryDetails).call(this));
      _this.details = null;
      return _this;
    }

    babelHelpers.createClass(LrndesignGalleryDetails, [{
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "details") {
            _this2._detailsChanged(_this2[propName]);
          }
        });
      } // properties available to the custom element for data binding

    }, {
      key: "_detailsChanged",

      /**
       * updates the details
       */
      value: function _detailsChanged(newValue) {
        if (this.shadowRoot) {
          this.shadowRoot.querySelector("#details").innerHTML = newValue;
        }
      }
    }], [{
      key: "properties",
      get: function get() {
        return {
          /**
           * image's details in as a string of HTML
           */
          details: {
            type: String
          }
        };
      }
    }]);
    return LrndesignGalleryDetails;
  }(_litElement.LitElement);

  _exports.LrndesignGalleryDetails = LrndesignGalleryDetails;
  window.customElements.define(LrndesignGalleryDetails.tag, LrndesignGalleryDetails);
});