define(["exports", "require", "../../lit-element/lit-element.js"], function (_exports, _require, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.RCoder = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject2_6bcc6410425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n\n        :host([hidden]) {\n          display: none;\n        }\n\n        #editor {\n          height: var(--r-coder-editor-height, 300px);\n          width: var(--r-coder-editor-width, 100%);\n        }\n\n        #button {\n          margin: var(--r-code-button-margin, 10px 0);\n        }\n      "]);

    _templateObject2_6bcc6410425211ea8ef51d3abfe05f78 = function _templateObject2_6bcc6410425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  function _templateObject_6bcc6410425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <code-editor id=\"editor\" language=\"r\"></code-editor>\n      <paper-button\n        id=\"button\"\n        ?disabled=\"", "\"\n        @click=\"", "\"\n        raised\n        >Process</paper-button\n      >\n      <div id=\"output\"></div>\n    "]);

    _templateObject_6bcc6410425211ea8ef51d3abfe05f78 = function _templateObject_6bcc6410425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  /**
   * `r-coder`
   * `R coder interface for the r-service backend.`
   * @demo demo/index.html
   * @customElement r-coder
   */
  var RCoder =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(RCoder, _LitElement);
    babelHelpers.createClass(RCoder, [{
      key: "render",
      // render function
      value: function render() {
        return (0, _litElement.html)(_templateObject_6bcc6410425211ea8ef51d3abfe05f78(), !this.__connected, this.process);
      } // haxProperty definition

    }, {
      key: "firstUpdated",

      /**
       * life cycle, element is afixed to the DOM
       */
      value: function firstUpdated() {
        this.ping();
        this.shadowRoot.getElementById("editor").editorValue = this.textContent.trim();
      }
    }], [{
      key: "styles",
      //styles function
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_6bcc6410425211ea8ef51d3abfe05f78())];
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: false,
          gizmo: {
            title: "R coder",
            description: "R coder interface for the r-service backend.",
            icon: "icons:android",
            color: "green",
            groups: ["Coder"],
            handles: [{
              type: "todo:read-the-docs-for-usage"
            }],
            meta: {
              author: "heymp",
              owner: "PSU"
            }
          },
          settings: {
            quick: [],
            configure: [{
              property: "endpoint",
              description: "",
              inputMethod: "textfield",
              required: false,
              icon: "icons:android"
            }],
            advanced: []
          }
        };
      } // properties available to the custom element for data binding

    }, {
      key: "properties",
      get: function get() {
        return _objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(RCoder), "properties", this), {
          endpoint: {
            type: String
          },
          __connected: {
            type: Boolean
          }
        });
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */

    }, {
      key: "tag",
      get: function get() {
        return "r-coder";
      }
    }]);

    function RCoder() {
      var _this;

      babelHelpers.classCallCheck(this, RCoder);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(RCoder).call(this));
      _this.endpoint = "/service/r-service";
      setTimeout(function () {
        new Promise(function (res, rej) {
          return _require.default(["../../@polymer/paper-button/paper-button.js"], res, rej);
        });
        new Promise(function (res, rej) {
          return _require.default(["../code-editor/code-editor.js"], res, rej);
        });
      }, 0);
      return _this;
    }

    babelHelpers.createClass(RCoder, [{
      key: "ping",
      value: function () {
        var _ping = babelHelpers.asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee() {
          var status;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return fetch(this.endpoint, {
                    method: "GET"
                  }).then(function (res) {
                    return res.status;
                  });

                case 2:
                  status = _context.sent;
                  this.__connected = status === 200;

                case 4:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function ping() {
          return _ping.apply(this, arguments);
        }

        return ping;
      }()
      /**
       * life cycle, element is removed from the DOM
       */
      //disconnectedCallback() {}

    }, {
      key: "process",
      value: function () {
        var _process = babelHelpers.asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee2() {
          var code, data;
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  code = this.shadowRoot.getElementById("editor").value;
                  _context2.next = 3;
                  return fetch(this.endpoint, {
                    method: "POST",
                    body: code
                  }).then(function (res) {
                    return res.text();
                  });

                case 3:
                  data = _context2.sent;
                  this.shadowRoot.getElementById("output").innerText = data;

                case 5:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function process() {
          return _process.apply(this, arguments);
        }

        return process;
      }()
    }]);
    return RCoder;
  }(_litElement.LitElement);

  _exports.RCoder = RCoder;
  window.customElements.define(RCoder.tag, RCoder);
});