define(["exports", "../responsive-utility.js"], function (_exports, _responsiveUtility) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ResponsiveUtilityBehaviors = void 0;

  /**
   * `responsive-utility-nehaviors`
   * @customElement responsive-utility-nehaviors
   * `A simpler way to use responsive utility.`
   */
  var ResponsiveUtilityBehaviors = function ResponsiveUtilityBehaviors(SuperClass) {
    return (
      /*#__PURE__*/
      function (_SuperClass) {
        babelHelpers.inherits(_class, _SuperClass);

        function _class() {
          babelHelpers.classCallCheck(this, _class);
          return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(_class).apply(this, arguments));
        }

        babelHelpers.createClass(_class, [{
          key: "connectedCallback",

          /**
           * init the utility & register element
           */
          value: function connectedCallback() {
            babelHelpers.get(babelHelpers.getPrototypeOf(_class.prototype), "connectedCallback", this).call(this);
            window.ResponsiveUtility.requestAvailability();
            this.dispatchEvent(new CustomEvent("responsive-element", {
              bubbles: true,
              cancelable: true,
              composed: true,
              detail: {
                element: this,
                sm: this.sm,
                md: this.md,
                lg: this.lg,
                xl: this.xl,
                responsiveToParent: this.responsiveToParent,
                attribute: this.attribute
              }
            }));
          }
          /**
           * detached the element
           */

        }, {
          key: "disconnectedCallback",
          value: function disconnectedCallback() {
            this.dispatchEvent(new CustomEvent("responsive-element-deleted", {
              bubbles: true,
              cancelable: true,
              composed: true,
              detail: this
            }));
            babelHelpers.get(babelHelpers.getPrototypeOf(_class.prototype), "disconnectedCallback", this).call(this);
          }
        }], [{
          key: "properties",
          get: function get() {
            var _ref;

            return _ref = {
              /*
               * parent size for responsive styling
               */
              responsiveSize: {
                type: String,
                value: "xs",
                reflectToAttribute: true
              },

              /*
               * acts like an element query instead of @media query
               */
              responsiveToParent: {
                type: Boolean,
                value: true
              },

              /*
               * Miniumum value for small breakpoint
               */
              sm: {
                type: Number,
                value: 600
              },

              /*
               * Miniumum value for medium breakpoint
               */
              md: {
                type: Number,
                value: 900
              }
            }, babelHelpers.defineProperty(_ref, "md", {
              type: Number,
              value: 1200
            }), babelHelpers.defineProperty(_ref, "md", {
              type: Number,
              value: 1500
            }), _ref;
          }
        }]);
        return _class;
      }(SuperClass)
    );
  };

  _exports.ResponsiveUtilityBehaviors = ResponsiveUtilityBehaviors;
});