define(["exports", "../../../lit-element/lit-element.js"], function (_exports, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SimpleSearchContent = void 0;

  function _templateObject_74dc5650425211ea8ef51d3abfe05f78() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <slot></slot>\n    "]);

    _templateObject_74dc5650425211ea8ef51d3abfe05f78 = function _templateObject_74dc5650425211ea8ef51d3abfe05f78() {
      return data;
    };

    return data;
  }

  /**
   * `simple-search-content`
   * content that can be searched with simple-search (DEPRECATED)
   *
   *
  
   * @demo ./demo/index.html
   */
  var SimpleSearchContent =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(SimpleSearchContent, _LitElement);

    function SimpleSearchContent() {
      babelHelpers.classCallCheck(this, SimpleSearchContent);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(SimpleSearchContent).apply(this, arguments));
    }

    babelHelpers.createClass(SimpleSearchContent, [{
      key: "enableSearch",

      /**
       * associates simple-search-content with a simple-search
       *
       * @param {object} the simple-search element
       */
      value: function enableSearch(searchObject) {
        var _this = this;

        searchObject.addEventListener("simple-search", function (e) {
          return _this._searchContent(searchObject);
        });
        searchObject.addEventListener("goto-result", function (e) {
          return _this.focus(e.detail);
        });
      }
      /**
       * sets focus on a matched result based on match number
       */

    }, {
      key: "_searchContent",
      value: function _searchContent(searchObject) {
        var html = this.innerHTML;
        this.innerHTML = searchObject.findMatches(html);
      }
      /**
       * sets focus on a matched result based on match number
       *
       * @param {number} the number of a search result
       */

    }, {
      key: "focus",
      value: function focus(matchNumber) {
        var result = this.querySelector('[match-number="' + matchNumber + '"]');
        if (result !== undefined && result !== null) result.focus();
      }
    }, {
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_74dc5650425211ea8ef51d3abfe05f78());
      }
    }], [{
      key: "tag",
      get: function get() {
        return "simple-search-content";
      }
    }]);
    return SimpleSearchContent;
  }(_litElement.LitElement);

  _exports.SimpleSearchContent = SimpleSearchContent;
  customElements.define(SimpleSearchContent.tag, SimpleSearchContent);
});