define(["exports", "../../@polymer/polymer/lib/utils/async.js", "../../@polymer/polymer/lib/utils/debounce.js", "../../@polymer/polymer/lib/utils/flush.js", "../vaadin-usage-statistics/vaadin-usage-statistics.js"], function (_exports, _async, _debounce, _flush, _vaadinUsageStatistics) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ElementMixin = void 0;

  if (!window.Vaadin) {
    window['Vaadin'] = {};
  }
  /**
   * Array of Vaadin custom element classes that have been finalized.
   */


  window['Vaadin'].registrations = window.Vaadin.registrations || []; // Use the hack to prevent polymer-modulizer from converting to exports

  window['Vaadin'].developmentModeCallback = window.Vaadin.developmentModeCallback || {};

  window['Vaadin'].developmentModeCallback['vaadin-usage-statistics'] = function () {
    if (_vaadinUsageStatistics.usageStatistics) {
      (0, _vaadinUsageStatistics.usageStatistics)();
    }
  };

  var statsJob;
  var registered = new Set();
  /**
   * @polymerMixin
   */

  var ElementMixin = function ElementMixin(superClass) {
    return (
      /*#__PURE__*/
      function (_superClass) {
        babelHelpers.inherits(VaadinElementMixin, _superClass);
        babelHelpers.createClass(VaadinElementMixin, null, [{
          key: "finalize",

          /** @protected */
          value: function finalize() {
            babelHelpers.get(babelHelpers.getPrototypeOf(VaadinElementMixin), "finalize", this).call(this);
            var is = this.is; // Registers a class prototype for telemetry purposes.

            if (is && !registered.has(is)) {
              window.Vaadin.registrations.push(this);
              registered.add(is);

              if (window.Vaadin.developmentModeCallback) {
                statsJob = _debounce.Debouncer.debounce(statsJob, _async.idlePeriod, function () {
                  window.Vaadin.developmentModeCallback['vaadin-usage-statistics']();
                });
                (0, _flush.enqueueDebouncer)(statsJob);
              }
            }
          }
        }]);

        function VaadinElementMixin() {
          var _this;

          babelHelpers.classCallCheck(this, VaadinElementMixin);
          _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(VaadinElementMixin).call(this));

          if (document.doctype === null) {
            console.warn('Vaadin components require the "standards mode" declaration. Please add <!DOCTYPE html> to the HTML document.');
          }

          return _this;
        }

        return VaadinElementMixin;
      }(superClass)
    );
  };

  _exports.ElementMixin = ElementMixin;
});