define(["exports","../../lit-element/lit-element.js","../../@polymer/paper-icon-button/paper-icon-button.js","../../@polymer/iron-icons/iron-icons.js","../simple-tooltip/simple-tooltip.js"],(function(_exports,_litElement,_paperIconButton,_ironIcons,_simpleTooltip){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.A11yCollapse=void 0;class A11yCollapse extends _litElement.LitElement{static get styles(){return[_litElement.css`
        :host {
          display: block;
          margin: var(--a11y-collapse-margin, 15px 0);
          border: var(--a11y-collapse-border, 1px solid);
          transition: all 0.5s;
        }
        :host(:not(:first-of-type)) {
          border-top: var(
            --a11y-collapse-border-between,
            var(--a11y-collapse-border, 1px solid)
          );
        }
        :host([disabled]) {
          opacity: 0.5;
        }
        *[aria-controls="content"][disabled] {
          cursor: not-allowed;
        }
        #heading {
          display: flex;
          justify-content: stretch;
          align-items: center;
          padding: 0
            var(
              --a11y-collapse-padding-right,
              var(--a11y-collapse-horizontal-padding, 16px)
            )
            0
            var(
              --a11y-collapse-padding-left,
              var(--a11y-collapse-horizontal-padding, 16px)
            );
          font-weight: var(--a11y-collapse-heading-font-weight, bold);
          margin: var(--a11y-collapse-margin, unset);
          color: var(--a11y-collapse-heading-color, unset);
          background-color: var(
            --a11y-collapse-heading-background-color,
            unset
          );
        }
        #text {
          flex-grow: 1;
        }
        #expand {
          transition: transform 0.5s;
          padding: (--a11y-collapse-icon-padding, unset);
        }
        #expand[rotated] {
          transform: rotate(-90deg);
        }
        #content {
          max-height: 0;
          overflow: hidden;
          padding: 0
            var(
              --a11y-collapse-padding-right,
              var(--a11y-collapse-horizontal-padding, 16px)
            )
            0
            var(
              --a11y-collapse-padding-left,
              var(--a11y-collapse-horizontal-padding, 16px)
            );
          border-top: 0px solid rgba(255, 255, 255, 0);
          transition: all 0.5s ease-in-out;
        }
        :host #content-inner {
          overflow: hidden;
        }
        :host([expanded]) #content {
          max-height: unset;
          overflow: hidden;
          padding: var(
              --a11y-collapse-padding-top,
              var(--a11y-collapse-vertical-padding, 16px)
            )
            var(
              --a11y-collapse-padding-right,
              var(--a11y-collapse-horizontal-padding, 16px)
            )
            var(
              --a11y-collapse-padding-bottom,
              var(--a11y-collapse-vertical-padding, 16px)
            )
            var(
              --a11y-collapse-padding-left,
              var(--a11y-collapse-horizontal-padding, 16px)
            );
          border-top: var(--a11y-collapse-border, 1px solid);
        }
        :host([expanded]) #content-inner {
          overflow: unset;
        }
      `]}render(){return _litElement.html`
      ${this.accordion?this._makeAccordionButton():this._makeIconButton()}
      <div
        id="content"
        aria-hidden="${this.expanded?"false":"true"}"
        aria-labelledby="heading"
        aria-live="polite"
      >
        <div id="content-inner">
          <slot name="content"></slot>
          <slot></slot>
        </div>
      </div>
    `}static get tag(){return"a11y-collapse"}static get properties(){return{accordion:{type:Boolean,reflect:!0},disabled:{type:Boolean,reflect:!0},expanded:{type:Boolean,reflect:!0},icon:{type:String},iconExpanded:{type:String,attribute:"icon-expanded"},label:{type:String},labelExpanded:{type:String,attribute:"label-expanded"},tooltip:{type:String},tooltipExpanded:{type:String,attribute:"tooltip-expanded"}}}constructor(){super(),this.accordion=!1,this.disabled=!1,this.expanded=!1,this.icon="expand-more",this.iconExpanded=null,this.label="expand/collapse",this.labelExpanded=null,this.tooltip="toggle expand/collapse",this.tooltipExpanded=null,this.dispatchEvent(new CustomEvent("a11y-collapse-attached",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}static get haxProperties(){return{canScale:!1,canPosition:!0,canEditSource:!1,gizmo:{title:"Single Expand Collapse",description:"A single instance of an expand collapse.",icon:"view-day",color:"grey",groups:["Text"]},settings:{quick:[{property:"accordion",title:"Heading Button",description:"Make entire heading clickble.",inputMethod:"boolean"},{property:"expanded",title:"Expanded",description:"Expand by default",inputMethod:"boolean"}],configure:[{slot:"heading",title:"Heading",description:"The heading for the collapse.",inputMethod:"textfield"},{slot:"content",title:"Content",description:"The content for the collapse.",inputMethod:"textfield"},{property:"accordion",title:"Heading Button",description:"Make entire heading clickble.",inputMethod:"boolean"},{property:"expanded",title:"Expanded",description:"Expand by default",inputMethod:"boolean"},{property:"icon",title:"Icon",description:"The icon for the toggle expand/collapse button.",inputMethod:"textfield"},{property:"iconExpanded",title:"Icon (when expanded)",description:"Optional: The icon for the toggle expand/collapse button when expanded",inputMethod:"textfield"},{property:"label",title:"Label",description:"The label of the toggle expand/collapse button",inputMethod:"textfield"},{property:"labelExpanded",title:"Label (when expanded)",description:"The label of the toggle expand/collapse button when expanded.",inputMethod:"textfield"},{property:"tooltip",title:"Tooltip",description:"The tooltip for the toggle expand/collapse button",inputMethod:"textfield"},{property:"tooltipExpanded",title:"Tooltip (when expanded)",description:"The tooltip for the toggle expand/collapse button when expanded",inputMethod:"textfield"}],advanced:[]}}}disconnectedCallback(){this.dispatchEvent(new CustomEvent("a11y-collapse-detached",{bubbles:!0,cancelable:!0,composed:!0,detail:this})),super.disconnectedCallback()}collapse(){this.toggle(!1)}expand(){this.toggle(!0)}toggle(open=!this.expanded){this.expanded=open}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{"expanded"===propName&&this._fireToggleEvents()})}_fireToggleEvents(){this.dispatchEvent(new CustomEvent("toggle",{bubbles:!0,cancelable:!0,composed:!0,detail:this})),this.dispatchEvent(new CustomEvent("a11y-collapse-toggle",{bubbles:!0,cancelable:!0,composed:!0,detail:this})),this.expanded?this.dispatchEvent(new CustomEvent("expand",{bubbles:!0,cancelable:!0,composed:!0,detail:this})):this.dispatchEvent(new CustomEvent("collapse",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}_getExpanded(defaultProp,expandedProp,expanded){return expanded&&null!==expandedProp?expandedProp:defaultProp}_makeAccordionButton(){return _litElement.html`
      <div
        id="heading"
        aria-controls="content"
        aria-expanded="${this.expanded?"true":"false"}"
        role="button"
        @click="${this._onClick}"
        ?disabled="${this.disabled}"
        .label="${this._getExpanded(this.label,this.labelExpanded,this.expanded)}"
      >
        <div id="text"><slot name="heading"></slot></div>
        <iron-icon
          id="expand"
          ?rotated="${!this.expanded&&null===this.iconExpanded}"
          .icon="${this._getExpanded(this.icon,this.iconExpanded,this.expanded)}"
          aria-hidden="true"
        >
        </iron-icon>
      </div>
      <simple-tooltip for="heading"
        >${this._getExpanded(this.tooltip,this.tooltipExpanded,this.expanded)}</simple-tooltip
      >
    `}_makeIconButton(){return _litElement.html`
      <div id="heading">
        <div id="text"><slot name="heading"></slot></div>
        <paper-icon-button
          id="expand"
          @click="${this._onClick}"
          ?disabled="${this.disabled}"
          ?rotated="${!this.expanded&&null===this.iconExpanded}"
          .label="${this._getExpanded(this.label,this.labelExpanded,this.expanded)}"
          .icon="${this._getExpanded(this.icon,this.iconExpanded,this.expanded)}"
          aria-controls="content"
          aria-expanded="${this.expanded?"true":"false"}"
        >
        </paper-icon-button>
        <simple-tooltip for="expand"
          >${this._getExpanded(this.tooltip,this.tooltipExpanded,this.expanded)}</simple-tooltip
        >
      </div>
    `}_onClick(){this.disabled||(this.toggle(),this.dispatchEvent(new CustomEvent("a11y-collapse-click",{bubbles:!0,cancelable:!0,composed:!0,detail:this})))}}_exports.A11yCollapse=A11yCollapse,window.customElements.define(A11yCollapse.tag,A11yCollapse)}));