define(["exports","meta","../../lit-element/lit-element.js"],(function(_exports,meta,_litElement){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.AwesomeExplosion=void 0,meta=babelHelpers.interopRequireWildcard(meta);
/**
   * Copyright 2018 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class AwesomeExplosion extends _litElement.LitElement{static get styles(){return[_litElement.css`
        :host {
          display: inline-block;
        }
        :host([size="tiny"]) #image {
          width: 80px;
          height: 80px;
        }
        :host([size="small"]) #image {
          width: 160px;
          height: 160px;
        }
        :host([size="medium"]) #image {
          width: 240px;
          height: 240px;
        }
        :host([size="large"]) #image {
          width: 320px;
          height: 320px;
        }
        :host([size="epic"]) #image {
          width: 720px;
          height: 720px;
        }

        :host([color="red"]) #image {
          filter: sepia() saturate(10000%) hue-rotate(30deg);
        }
        :host([color="purple"]) #image {
          filter: sepia() saturate(10000%) hue-rotate(290deg);
        }
        :host([color="blue"]) #image {
          filter: sepia() saturate(10000%) hue-rotate(210deg);
        }
        :host([color="orange"]) #image {
          filter: sepia() saturate(10000%) hue-rotate(320deg);
        }
        :host([color="yellow"]) #image {
          filter: sepia() saturate(10000%) hue-rotate(70deg);
        }
        #image {
          width: 240px;
          height: 240px;
        }
      `]}pathFromUrl(url){return url.substring(0,url.lastIndexOf("/")+1)}constructor(){super();const basePath=this.pathFromUrl(decodeURIComponent(meta.url));this.state="stop",this.image=basePath+"assets/explode.gif",this.sound=basePath+"assets/273320__clagnut__fireworks.mp3",this.size="medium",this.color="",this.resetSound=!1,setTimeout(()=>{this.addEventListener("click",this._setPlaySound.bind(this)),this.addEventListener("mouseover",this._setPlaySound.bind(this)),this.addEventListener("mouseout",this._setStopSound.bind(this))},0)}render(){return _litElement.html`
      <img
        loading="lazy"
        src="${this.image}"
        id="image"
        class="image-tag"
        alt=""
      />
    `}static get tag(){return"awesome-explosion"}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{"state"==propName&&(this.stopped=this._calculateStopped(this.state),this.playing=this._calculatePlaying(this.state),this.paused=this._calculatePaused(this.state))})}static get properties(){return{state:{type:String,reflect:!0},stopped:{type:Boolean},playing:{type:Boolean},paused:{type:Boolean},image:{type:String},sound:{type:String},size:{type:String,reflect:!0},color:{type:String,reflect:!0},resetSound:{type:Boolean,reflect:!0,attribute:"reset-sound"}}}_calculateStopped(newValue,oldValue){"stop"==newValue?(this.stopped=!0,void 0!==window.audio&&(window.audio.currentTime=0),this._stopSound(),this.dispatchEvent(new CustomEvent("awesome-event",{bubbles:!0,cancelable:!0,composed:!0,detail:{message:"Sound stopped"}}))):this.stopped=!1}_calculatePlaying(newValue,oldValue){"play"==newValue?(this.playing=!0,this._playSound(),this.dispatchEvent(new CustomEvent("awesome-event",{bubbles:!0,cancelable:!0,composed:!0,detail:{message:"Sound played"}}))):this.playing=!1}_calculatePaused(newValue,oldValue){"pause"==newValue?(this.paused=!0,this._stopSound(),this.dispatchEvent(new CustomEvent("awesome-event",{bubbles:!0,cancelable:!0,composed:!0,detail:{message:"Sound paused"}}))):this.paused=!1}_stopSound(){void 0!==window.audio&&(window.audio.pause(),this.resetSound&&(window.audio.currentTime=0))}_setPlaySound(e){this.state="play"}_setStopSound(e){this.state="pause"}_playSound(){void 0===window.audio&&(window.audio=new Audio(this.sound)),window.audio.play()}}_exports.AwesomeExplosion=AwesomeExplosion,window.customElements.define(AwesomeExplosion.tag,AwesomeExplosion)}));