define(["exports","../../lit-element/lit-element.js","../schema-behaviors/schema-behaviors.js","../license-element/license-element.js","../utils/utils.js"],(function(_exports,_litElement,_schemaBehaviors,_licenseElement,_utils){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.CitationElement=void 0;class CitationElement extends((0,_schemaBehaviors.SchemaBehaviors)(_litElement.LitElement)){static get styles(){return[_litElement.css`
        :host {
          display: block;
          color: var(--license-text-color);
        }
        :host([display-method="footnote"]) {
          visibility: hidden;
          opacity: 0;
        }
        :host([display-method="popup"]) {
          display: block;
        }
        .license-link {
          font-size: 16px;
          line-height: 16px;
          font-style: italic;
        }
        .citation-date {
          font-size: 16px;
          line-height: 16px;
          font-style: italic;
        }
        .license-link img {
          margin-right: 8px;
        }
      `]}render(){return _litElement.html`
      <meta
        about="${this.relatedResource}"
        property="cc:attributionUrl"
        content="${this.source}"
      />
      <meta
        about="${this.relatedResource}"
        property="cc:attributionName"
        typeof="oer:Text"
        content="${this.title}"
      />
      <meta
        rel="cc:license"
        href="${this.licenseLink}"
        content="License: ${this.licenseName}"
      />
      <cite
        ><a target="_blank" rel="noopener noreferrer" href="${this.source}"
          >${this.title}</a
        >
        by ${this.creator}, licensed under
        <a
          class="license-link"
          rel="noopener noreferrer"
          target="_blank"
          href="${this.licenseLink}"
          ><img
            loading="lazy"
            alt="${this.licenseName} graphic"
            src="${this.licenseImage}"
            ?hidden="${!this.licenseImage}"
            width="44px"
            height="16px"
          />${this.licenseName}</a
        >. Accessed <span class="citation-date">${this.date}</span>.</cite
      >
    `}static get tag(){return"citation-element"}constructor(){super(),this.scope="sibling",this.source=""}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{"scope"==propName&&this._scopeChanged(this[propName]),"license"==propName&&this._licenseUpdated(this[propName]),["relatedResource","licenseLink"].includes(propName)&&(this._aboutLink=this._generateAboutLink(this.relatedResource,this.licenseLink)),"source"==propName&&(this._licenseLink=this._generateLicenseLink(this.source))})}static get properties(){return{...super.properties,title:{type:String},scope:{type:String},displayMethod:{type:String,reflect:!0,attribute:"display-method"},creator:{type:String},source:{type:String},date:{type:String},licenseName:{type:String,attribute:"license-name"},licenseLink:{type:String,attribute:"license-link"},license:{type:String}}}_generateLicenseLink(source){this._licenseLink&&document.head.removeChild(this._licenseLink);let link=document.createElement("link");return link.setAttribute("typeof","resource"),link.setAttribute("rel","license"),link.setAttribute("src",source),document.head.appendChild(link),link}_generateAboutLink(relatedResource,licenseLink){this._aboutLink&&document.head.removeChild(this._aboutLink);let link=document.createElement("link");return link.setAttribute("about",relatedResource),link.setAttribute("property","cc:license"),link.setAttribute("content",licenseLink),document.head.appendChild(link),link}_scopeChanged(newValue){if("sibling"===newValue&&null!==this.previousElementSibling){if(this.previousElementSibling.getAttribute("resource"))this.relatedResource=this.previousElementSibling.getAttribute("resource");else{let uuid=(0,_utils.generateResourceID)();this.relatedResource=uuid,this.previousElementSibling.setAttribute("resource",uuid)}this.previousElementSibling.setAttribute("prefix",this.getAttribute("prefix"))}else if("parent"===newValue){if(this.parentNode.getAttribute("resource"))this.relatedResource=this.parentNode.getAttribute("resource");else{let uuid=(0,_utils.generateResourceID)();this.relatedResource=uuid,this.parentNode.setAttribute("resource",uuid)}this.parentNode.setAttribute("prefix",this.getAttribute("prefix"))}}static get haxProperties(){return{canScale:!1,canPosition:!1,canEditSource:!1,gizmo:{title:"Citation",description:"A basic citation element with 3 presentation modes",icon:"editor:title",color:"grey",groups:["Content","Text","Copyright"],handles:[{type:"citation",source:"source",title:"title",author:"creator",license:"license",accessDate:"date"}],meta:{author:"ELMS:LN"}},settings:{quick:[{property:"title",title:"Title",description:"The title of the work being cited.",inputMethod:"textfield",icon:"editor:title"}],configure:[{property:"title",title:"Title",description:"The title of the work being cited.",inputMethod:"textfield",icon:"editor:title"},{property:"source",title:"Source link",description:"The source url for the element this is citing.",inputMethod:"textfield",icon:"link",validationType:"url"},{property:"date",title:"Date accessed",description:"The date this was accessed.",inputMethod:"textfield",icon:"link"},{property:"scope",title:"Scope",description:"Scope of what to cite.",inputMethod:"select",options:{sibling:"Sibling element",parent:"Parent element"},icon:"code"},{property:"license",title:"License",description:"The source url for the element this is citing.",inputMethod:"select",options:new _licenseElement.licenseList("select"),icon:"link"},{property:"creator",title:"Creator",description:"Who made or owns this.",inputMethod:"textfield",icon:"link"}],advanced:[]}}}_licenseUpdated(newValue){if(void 0!==newValue){var list=new _licenseElement.licenseList;void 0!==list[newValue]&&(this.licenseName=list[newValue].name,this.licenseLink=list[newValue].link,this.licenseImage=list[newValue].image)}}}_exports.CitationElement=CitationElement,window.customElements.define(CitationElement.tag,CitationElement)}));