define(["exports","require","../../lit-element/lit-element.js","../utils/utils.js","../../@polymer/iron-a11y-keys/iron-a11y-keys.js","../json-outline-schema/json-outline-schema.js"],(function(_exports,_require,_litElement,_utils,_ironA11yKeys,_jsonOutlineSchema){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.EditableOutline=void 0,_require=babelHelpers.interopRequireWildcard(_require);
/**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class EditableOutline extends _litElement.LitElement{static get styles(){return[_litElement.css`
        :host {
          display: block;
          font-family: "Noto Serif", serif;
        }

        :host([hidden]) {
          display: none;
        }

        .button-wrapper {
          line-height: 36px;
          position: -webkit-sticky;
          position: sticky;
          top: 0px;
          background-color: white;
          display: block;
          justify-content: space-evenly;
        }
        @media (max-width: 1000px) {
          button span {
            opacity: 0;
            visibility: hidden;
            position: absolute;
            left: -9999px;
          }
        }
        button {
          height: 32px;
          font-size: 10px;
          margin: 0;
          padding: 0 8px;
        }

        button span {
          padding-left: 4px;
          pointer-events: none;
        }

        #outline {
          margin: 0;
        }
        ul {
          font-size: 16px;
          line-height: 32px;
          padding-left: 32px;
          visibility: visible;
          opacity: 1;
          overflow: hidden;
          height: auto;
          transition: 0.2s ease-in-out all;
        }
        li {
          font-size: 16px;
          line-height: 32px;
          padding: 4px;
          transition: 0.2s linear all;
        }
        ul:hover {
          outline: 1px solid #eeeeee;
        }
        li.collapsed-title {
          background-color: #dddddd;
        }
        li.collapsed-title:after {
          content: "    ( Double-click to expand )";
        }
        li:after {
          transition: 0.4s ease-in-out all;
          opacity: 0;
          font-size: 11px;
          visibility: hidden;
        }
        li.collapsed-title:hover:after {
          font-style: italic;
          opacity: 1;
          visibility: visible;
        }
        ul.collapsed-content {
          visibility: hidden;
          opacity: 0;
          height: 0;
        }
        li:focus,
        li:active,
        li:hover {
          background-color: #eeeeee;
          outline: 1px solid #cccccc;
        }

        iron-icon {
          pointer-events: none;
        }
      `]}render(){return _litElement.html`
      <iron-a11y-keys
        keys="enter"
        @keys-pressed="${this._enterPressed}"
        stop-keyboard-event-propagation
      ></iron-a11y-keys>
      <iron-a11y-keys
        keys="up"
        @keys-pressed="${this._upPressed}"
        stop-keyboard-event-propagation
      ></iron-a11y-keys>
      <iron-a11y-keys
        keys="down"
        @keys-pressed="${this._downPressed}"
        stop-keyboard-event-propagation
      ></iron-a11y-keys>
      <div class="button-wrapper">
        <button @click="${this.buttonEvents}" id="add" title="Add a new node">
          <iron-icon icon="icons:add"></iron-icon><span>Add</span>
        </button>
        <button
          @click="${this.buttonEvents}"
          id="collapse"
          title="Toggle active node collapsed status"
        >
          <iron-icon icon="icons:swap-vert"></iron-icon
          ><span>Toggle active</span>
        </button>
        <button
          @click="${this.buttonEvents}"
          id="collapseall"
          title="Collapse all nodes"
        >
          <iron-icon icon="icons:swap-vert"></iron-icon
          ><span>Collapse all</span>
        </button>
        <button
          @click="${this.buttonEvents}"
          id="expandall"
          title="Expand all nodes"
        >
          <iron-icon icon="icons:swap-vert"></iron-icon><span>Expand all</span>
        </button>
        <button
          @click="${this.buttonEvents}"
          id="down"
          title="Move active node down"
        >
          <iron-icon icon="icons:arrow-downward"></iron-icon
          ><span>Move down</span>
        </button>
        <button
          @click="${this.buttonEvents}"
          id="up"
          title="Move active node up"
        >
          <iron-icon icon="icons:arrow-upward"></iron-icon><span>Move up</span>
        </button>
        <button
          @click="${this.buttonEvents}"
          id="outdent"
          title="Outdent active node"
        >
          <iron-icon icon="editor:format-indent-decrease"></iron-icon
          ><span>Outdent</span>
        </button>
        <button
          @click="${this.buttonEvents}"
          id="indent"
          title="Indent active node"
        >
          <iron-icon icon="editor:format-indent-increase"></iron-icon
          ><span>Indent</span>
        </button>
        <button
          @click="${this.buttonEvents}"
          id="duplicate"
          title="Duplicate active node tree"
        >
          <iron-icon icon="icons:content-copy"></iron-icon
          ><span>Duplicate</span>
        </button>
        <button
          @click="${this.buttonEvents}"
          id="delete"
          title="Delete active node"
        >
          <iron-icon icon="icons:delete"></iron-icon><span>Delete</span>
        </button>
      </div>
      <ul id="outline"></ul>
    `}static get properties(){return{...super.properties,items:{type:Array},editMode:{type:Boolean,attribute:"edit-mode"},__outlineNode:{type:Object}}}constructor(){super(),this.items=[],this.editMode=!1,this.jos=window.JSONOutlineSchema.requestAvailability(),new Promise((res,rej)=>_require.default(["../../@polymer/iron-icon/iron-icon.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../@polymer/iron-icons/iron-icons.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../@polymer/iron-icons/editor-icons.js"],res,rej)),setTimeout(()=>{this.addEventListener("dblclick",this._collapseClickHandler.bind(this))},0)}static get tag(){return"editable-outline"}_collapse(e){let node=this.getSelectionNode();node&&"LI"===node.tagName&&node.nextElementSibling&&"UL"===node.nextElementSibling.tagName&&(node.classList.toggle("collapsed-title"),node.nextElementSibling.classList.toggle("collapsed-content"))}_expandall(e){this.shadowRoot.querySelectorAll("li").forEach(el=>{el.classList.remove("collapsed-title")}),this.shadowRoot.querySelectorAll("ul").forEach(el=>{el.classList.remove("collapsed-content")})}_collapseall(e){this.shadowRoot.querySelectorAll("li").forEach(el=>{el.nextElementSibling&&"UL"===el.nextElementSibling.tagName&&(el.classList.add("collapsed-title"),el.nextElementSibling.classList.add("collapsed-content"))})}_onKeyDown(e){if(this.editMode)switch(e.key){case"Tab":e.shiftKey?this._tabBackKeyPressed(e):this._tabKeyPressed(e)}}_collapseClickHandler(e){let el,i=0,notFound=!0;for(;notFound&&e.path.length>i+1;)el=e.path[i],"LI"===el.tagName&&el.nextElementSibling&&"UL"===el.nextElementSibling.tagName&&(el.classList.toggle("collapsed-title"),el.nextElementSibling.classList.toggle("collapsed-content"),notFound=!1),i++}_delete(e){let node=this.getSelectionNode();if(node&&"LI"===node.tagName){const parent=node.parentNode;node.remove(),0===parent.children.length&&parent.remove()}}firstUpdated(){this.__outlineNode=this.shadowRoot.querySelector("#outline"),this.shadowRoot.querySelectorAll("iron-a11y-keys").forEach(el=>{el.target=this.__outlineNode}),this.__outlineNode.addEventListener("keydown",this._onKeyDown.bind(this)),this._observer=new MutationObserver(this._observeRecord.bind(this)),this._observer.observe(this.__outlineNode,{childList:!0,subtree:!0})}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{if(["editMode","items"].includes(propName)){let eventName=`${propName.replace(/([a-z0-9]|(?=[A-Z]))([A-Z])/g,"$1-$2").toLowerCase()}-changed`;this.dispatchEvent(new CustomEvent(eventName,{detail:{value:this[propName]}}))}})}_observeRecord(record){for(var index in record){let info=record[index];if(info.addedNodes.length>0)for(let i in info.addedNodes)info.addedNodes[i].tagName&&("LI"===info.addedNodes[i].tagName?this.__blockScrub?info.addedNodes[i].setAttribute("contenteditable","true"):(this.jos.scrubElementJOSData(info.addedNodes[i]),info.addedNodes[i].setAttribute("contenteditable","true")):"UL"===info.addedNodes[i].tagName&&(this.__blockScrub||this.jos.scrubElementJOSData(info.addedNodes[i])))}setTimeout(()=>{this.__blockScrub=!1},100)}disconnectedCallback(){this.__outlineNode.removeEventListener("keydown",this._onKeyDown.bind(this)),this._observer.disconnect(),super.disconnectedCallback()}buttonEvents(e){switch(e.target.id){case"add":this._add(e);break;case"collapse":this._collapse(e);break;case"collapseall":this._collapseall(e);break;case"expandall":this._expandall(e);break;case"indent":this._indent();break;case"outdent":this._outdent();break;case"up":this._move("up");break;case"down":this._move("down");break;case"duplicate":this._duplicate();break;case"delete":this._delete()}}_duplicate(){try{this.__blockScrub=!1;let activeItem=this.getSelectionNode();if(activeItem&&"LI"===activeItem.tagName)if(null!==activeItem.nextElementSibling&&"UL"===activeItem.nextElementSibling.tagName){const clone2=activeItem.nextElementSibling.cloneNode(!0);activeItem.parentNode.insertBefore(clone2,activeItem.nextElementSibling.nextElementSibling);const clone=activeItem.cloneNode(!0);activeItem.parentNode.insertBefore(clone,activeItem.nextElementSibling.nextElementSibling)}else{const clone=activeItem.cloneNode(!0);activeItem.parentNode.insertBefore(clone,activeItem.nextElementSibling)}}catch(e){console.log(e)}}_move(direction){try{let activeItem=this.getSelectionNode(),test=activeItem,valid=!1;if(null==activeItem)return!1;for(;!valid&&test.parentNode;)"outline"===test.id&&(valid=!0),test=test.parentNode;valid&&activeItem&&"LI"===activeItem.tagName&&("up"===direction?null!==activeItem.previousElementSibling&&(activeItem.nextElementSibling&&"UL"===activeItem.nextElementSibling.tagName?("UL"===activeItem.previousElementSibling.tagName&&(this.__blockScrub=!0,activeItem.parentNode.insertBefore(activeItem.previousElementSibling,activeItem.nextElementSibling.nextElementSibling)),this.__blockScrub=!0,activeItem.parentNode.insertBefore(activeItem.previousElementSibling,activeItem.nextElementSibling.nextElementSibling),activeItem.focus()):("UL"===activeItem.previousElementSibling.tagName&&(this.__blockScrub=!0,activeItem.parentNode.insertBefore(activeItem.previousElementSibling,activeItem.nextElementSibling)),this.__blockScrub=!0,activeItem.parentNode.insertBefore(activeItem.previousElementSibling,activeItem.nextElementSibling),activeItem.focus())):"down"===direction&&null!==activeItem.nextElementSibling&&(activeItem.nextElementSibling&&"UL"===activeItem.nextElementSibling.tagName&&null!==activeItem.nextElementSibling.nextElementSibling?("LI"===activeItem.nextElementSibling.nextElementSibling.tagName&&null!==activeItem.nextElementSibling.nextElementSibling.nextElementSibling&&"UL"===activeItem.nextElementSibling.nextElementSibling.nextElementSibling.tagName&&(this.__blockScrub=!0,activeItem.parentNode.insertBefore(activeItem.nextElementSibling.nextElementSibling,activeItem)),this.__blockScrub=!0,activeItem.parentNode.insertBefore(activeItem.nextElementSibling.nextElementSibling,activeItem),activeItem.focus()):"LI"===activeItem.nextElementSibling.tagName&&(null!==activeItem.nextElementSibling.nextElementSibling&&"UL"===activeItem.nextElementSibling.nextElementSibling.tagName&&(this.__blockScrub=!0,activeItem.parentNode.insertBefore(activeItem.nextElementSibling,activeItem)),this.__blockScrub=!0,activeItem.parentNode.insertBefore(activeItem.nextElementSibling,activeItem),activeItem.focus())))}catch(e){console.log(e)}}importJsonOutlineSchemaItems(){return this.__blockScrub=!0,setTimeout(()=>{for(;this.__outlineNode.firstChild;)this.__outlineNode.removeChild(this.__outlineNode.firstChild);0===this.items.length&&(this.items=[...this.jos.items]);let outline=this.jos.itemsToNodes(this.items);for(;outline.firstChild;)this.__blockScrub=!0,this.__outlineNode.appendChild(outline.firstChild);this.shadowRoot.querySelectorAll("li").forEach(el=>{el.setAttribute("contenteditable","true")})},0),outline}exportJsonOutlineSchemaItems(save=!1){return this.jos.nodesToItems(this.__outlineNode,save)}_upPressed(e){let node=this.getSelectionNode();node&&node.previousSibling&&"LI"===node.previousSibling.tagName?node.previousSibling.focus():node&&node.previousSibling&&"UL"===node.previousSibling.tagName&&node.previousSibling.firstChild&&"LI"===node.previousSibling.firstChild.tagName?node.previousSibling.firstChild.focus():node&&null==node.previousSibling&&"UL"===node.parentNode.tagName&&node.parentNode.previousSibling&&"LI"===node.parentNode.previousSibling.tagName&&node.parentNode.previousSibling.focus()}_downPressed(e){let node=this.getSelectionNode();node&&node.nextSibling&&"LI"===node.nextSibling.tagName?node.nextSibling.focus():node&&node.nextSibling&&"UL"===node.nextSibling.tagName&&node.nextSibling.firstChild&&"LI"===node.nextSibling.firstChild.tagName?node.nextSibling.firstChild.focus():node&&null==node.nextSibling&&"UL"===node.parentNode.tagName&&node.parentNode.nextSibling&&"LI"===node.parentNode.nextSibling.tagName&&node.parentNode.nextSibling.focus()}_tabKeyPressed(e){e.preventDefault(),e.stopPropagation(),e.stopImmediatePropagation(),e.detail.keyboardEvent&&(e.detail.keyboardEvent.preventDefault(),e.detail.keyboardEvent.stopPropagation(),e.detail.keyboardEvent.stopImmediatePropagation());try{this._indent()}catch(e){}}_tabBackKeyPressed(e){e.preventDefault(),e.stopPropagation(),e.stopImmediatePropagation(),e.detail.keyboardEvent&&(e.detail.keyboardEvent.preventDefault(),e.detail.keyboardEvent.stopPropagation(),e.detail.keyboardEvent.stopImmediatePropagation());try{this._outdent()}catch(e){}}_enterPressed(e){e.preventDefault(),e.stopPropagation(),e.stopImmediatePropagation(),e.detail.keyboardEvent&&(e.detail.keyboardEvent.preventDefault(),e.detail.keyboardEvent.stopPropagation(),e.detail.keyboardEvent.stopImmediatePropagation()),this._add()}_add(){let li=document.createElement("li");li.setAttribute("contenteditable","true");let node=this.getSelectionNode();if(null==this.__outlineNode.querySelector("li")||!node||node.tagName&&"UL"!=node.tagName&&"LI"!=node.tagName)this.__outlineNode.appendChild(li);else{null!=node.tagName&&"LI"==node.tagName||!node.parentNode||(node=node.parentNode),null==node.nextSibling?node.parentNode.appendChild(li):node.parentNode.insertBefore(li,node.nextSibling);try{li.focus()}catch(e){}}}_outdent(){this.__blockScrub=!0;try{let node=this.getSelectionNode();if(null==node)return!1;const parent=node.parentNode;node.parentNode&&node.parentNode!=this.__outlineNode&&null!=node.parentNode.nextSibling?(node.parentNode.parentNode.insertBefore(node,node.parentNode.nextSibling),0==parent.children.length&&parent.remove()):node.parentNode&&node.parentNode!=this.__outlineNode&&null==node.parentNode.nextSibling&&(node.parentNode.parentNode.appendChild(node),0==parent.children.length&&parent.remove()),node.focus()}catch(e){console.warn(e)}}_indent(){this.__blockScrub=!0;try{let node=this.getSelectionNode();if(null==node)return!1;if(null!=node.previousSibling&&"LI"===node.previousSibling.tagName){let ul;node.nextSibling&&"UL"===node.nextSibling.tagName?ul=node.nextSibling:(ul=document.createElement("ul"),node.parentNode.insertBefore(ul,node)),ul.appendChild(node),node.focus()}else null!=node.previousSibling&&"UL"===node.previousSibling.tagName&&(node.previousSibling.appendChild(node),node.focus())}catch(e){console.warn(e)}}getSelectionNode(){let node=this.getDeepSelection().anchorNode;return node&&(null==node.tagName||"LI"!=node.tagName)&&node.parentNode&&(node=node.parentNode),node}getDeepSelection(){return this.shadowRoot.getSelection?this.shadowRoot.getSelection():(0,_utils.getRange)(this.__outlineNode.parentNode)?(0,_utils.getRange)(this.__outlineNode.parentNode):window.getSelection()}getDeepRange(){let sel=this.getDeepSelection();return sel.getRangeAt&&sel.rangeCount?sel.getRangeAt(0):sel||void 0}}_exports.EditableOutline=EditableOutline,window.customElements.define(EditableOutline.tag,EditableOutline)}));