define(["exports", "../../../../@polymer/polymer/polymer-element.js", "../../../../@polymer/polymer/lib/utils/render-status.js", "../../../../@polymer/polymer/lib/legacy/class.js", "../../../../@polymer/iron-resizable-behavior/iron-resizable-behavior.js", "../../../../@polymer/paper-card/paper-card.js", "../../../../@polymer/paper-button/paper-button.js", "../../../lrn-icon/lrn-icon.js", "../../../../@polymer/polymer/lib/elements/dom-if.js", "../../../lrndesign-avatar/lrndesign-avatar.js"], function (_exports, _polymerElement, _renderStatus, _class, _ironResizableBehavior, _paperCard, _paperButton, _lrnIcon, _domIf, _lrndesignAvatar) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnappBlockRecentCommentsComment = void 0;

  class LrnappBlockRecentCommentsComment extends (0, _class.mixinBehaviors)([_ironResizableBehavior.IronResizableBehavior], _polymerElement.PolymerElement) {
    static get template() {
      return _polymerElement.html`
      <style>
        :host {
          display: block;
        }

        paper-card {
          padding: 2em 2em 0 2em;
          clear: right;
        }

        paper-button {
          background-color: var(--paper-grey-100);
          margin: 1em;
        }

        .card-content {
          padding-left: 2em;
          padding-right: 2em;
          width: 100%;
        }

        .card-actions {
          width: 100%;
        }

        .card-actions paper-button {
          display: flex;
        }

        lrndesign-avatar {
          float: left;
          margin-right: 1em;
        }

        .flex-wrap {
          @apply --layout-horizontal;
          @apply --layout-wrap;
        }

        .inactive {
          max-height: 4.6em;
          overflow: hidden;
        }

        paper-button {
          background: white;
          width: 100%;
          display: flex;
        }

        lrn-icon {
          color: black;
          width: 100%;
        }

        .hidden {
          display: none;
        }
      </style>
      <paper-card elevation="3" class="flex-wrap">
        <div class="card-content">
          <lrndesign-avatar
            label="[[commentUser.name]]"
            src="[[commentUser.avatar]]"
          ></lrndesign-avatar>
          <h3>[[commentUser.display_name]]</h3>
          <div id="wrapper" class="button-wrapper">
            <div id="comment" class="inactive"><slot></slot></div>
            <paper-button id="btn" class="hidden">
              <lrn-icon icon="chevron-down" id="icon"></lrn-icon>
            </paper-button>
          </div>
        </div>
        <div class="card-actions">
          <template is="dom-if" if="[[actionView]]">
            <a href$="[[actionView]]" tabindex="-1">
              <paper-button raised="" id="view">View thread</paper-button>
            </a>
          </template>
        </div>
      </paper-card>
    `;
    }

    static get tag() {
      return "lrnapp-block-recent-comments-comment";
    }

    onHeightChange() {
      var height = this.$.comment.offsetHeight;

      if (height > 80) {
        this.$.btn.classList.toggle("hidden", this.hidden);
      }
    }

    static get properties() {
      return {
        elmslnCourse: {
          type: String
        },
        elmslnSection: {
          type: String
        },
        basePath: {
          type: String
        },
        csrfToken: {
          type: String
        },
        endPoint: {
          type: String
        },
        commentTitle: {
          type: String,
          value: "Comment title",
          reflectToAttribute: true,
          notify: true
        },
        actionView: {
          type: String,
          reflectToAttribute: true,
          notify: true
        },
        dateUpdated: {
          type: String,
          reflectToAttribute: true,
          notify: true
        },
        commentUser: {
          type: Object,
          value: {},
          reflectToAttribute: true,
          notify: true
        }
      };
    }
    /**
     * attached life cycle
     */


    connectedCallback() {
      super.connectedCallback();
      (0, _renderStatus.afterNextRender)(this, function () {
        this.$.wrapper.addEventListener("click", function (e) {
          this.$.comment.classList.toggle("inactive", this.inactive);
        });
        this.addEventListener("iron-resize", this.onHeightChange.bind(this));
      });
    }
    /**
     * detached life cycle
     */


    disconnectedCallback() {
      this.$.wrapper.removeEventListener("click", function (e) {
        this.$.comment.classList.toggle("inactive", this.inactive);
      });
      this.removeEventListener("iron-resize", this.onHeightChange.bind(this));
      super.disconnectedCallback();
    }

  }

  _exports.LrnappBlockRecentCommentsComment = LrnappBlockRecentCommentsComment;
  window.customElements.define(LrnappBlockRecentCommentsComment.tag, LrnappBlockRecentCommentsComment);
});