define(["exports", "../../../../@polymer/polymer/polymer-element.js", "../../../../@polymer/polymer/lib/elements/dom-if.js", "../../../../@polymer/polymer/lib/elements/dom-repeat.js", "./lrnapp-studio-submission-comment.js"], function (_exports, _polymerElement, _domIf, _domRepeat, _lrnappStudioSubmissionComment) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnappStudioSubmissionComments = void 0;

  class LrnappStudioSubmissionComments extends _polymerElement.PolymerElement {
    static get template() {
      return _polymerElement.html`
      <style>
        :host {
          display: block;
        }
      </style>
      <template is="dom-if" if="[[submission.relationships.comments]]">
        <template
          is="dom-repeat"
          items="[[_toArray(submission.relationships.comments.data)]]"
          as="comment"
        >
          <lrnapp-studio-submission-comment
            comment="{{comment}}"
          ></lrnapp-studio-submission-comment>
        </template>
      </template>
    `;
    }

    static get tag() {
      return "lrnapp-studio-submission-comments";
    }

    static get properties() {
      return {
        submission: {
          type: Object
        }
      };
    }
    /**
     * Simple way to convert from object to array.
     */


    _toArray(obj) {
      if (obj == null) {
        return [];
      }

      return Object.keys(obj).map(function (key) {
        return obj[key];
      });
    }

  }

  _exports.LrnappStudioSubmissionComments = LrnappStudioSubmissionComments;
  window.customElements.define(LrnappStudioSubmissionComments.tag, LrnappStudioSubmissionComments);
});