define(["exports", "../../../../@polymer/polymer/polymer-element.js", "../../../../@polymer/polymer/lib/elements/dom-if.js", "../../../../@vaadin/vaadin-split-layout/vaadin-split-layout.js", "./lrnapp-studio-submission-media-editoverlay.js", "./lrnapp-studio-submission-edit-images.js", "./lrnapp-studio-submission-edit-files.js", "./lrnapp-studio-submission-edit-video.js", "./lrnapp-studio-submission-edit-links.js", "./lrnapp-studio-submission-display.js", "./lrnapp-studio-submission-edit-textarea.js", "./lrnapp-studio-block.js", "./lrnapp-studio-submission-critique-panel.js"], function (_exports, _polymerElement, _domIf, _vaadinSplitLayout, _lrnappStudioSubmissionMediaEditoverlay, _lrnappStudioSubmissionEditImages, _lrnappStudioSubmissionEditFiles, _lrnappStudioSubmissionEditVideo, _lrnappStudioSubmissionEditLinks, _lrnappStudioSubmissionDisplay, _lrnappStudioSubmissionEditTextarea, _lrnappStudioBlock, _lrnappStudioSubmissionCritiquePanel) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnappStudioSubmissionCritique = void 0;

  class LrnappStudioSubmissionCritique extends _polymerElement.PolymerElement {
    static get template() {
      return _polymerElement.html`
      <style>
        :host {
          display: block;
        }

        .submission-critique {
          display: flex;
          justify-content: space-around;
        }

        .submission-critique-panel {
          flex: 1 1 auto;
          width: 100%;
          flex-wrap: nowrap;
          margin: 0.3em;
        }
      </style>
      <template is="dom-if" if="{{submission}}">
        <template is="dom-if" if="[[!edit]]">
          <div class="submission-critique">
            <!-- critique panel -->
            <div class="submission-critique-panel" id="crititque-panel">
              <lrnapp-studio-submission-display
                submission="[[submission.relationships.relatedSubmission]]"
              ></lrnapp-studio-submission-display>
            </div>
            <!-- critique panel -->
            <div class="submission-critique-panel">
              <lrnapp-studio-submission-critique-panel
                submission="[[submission]]"
                edit="[[edit]]"
              ></lrnapp-studio-submission-critique-panel>
            </div>
          </div>
        </template>
        <template is="dom-if" if="[[edit]]">
          <vaadin-split-layout class="submission-critique">
            <!-- critique panel -->
            <div class="submission-critique-panel" id="crititque-panel">
              <lrnapp-studio-submission-display
                submission="[[submission.relationships.relatedSubmission]]"
              ></lrnapp-studio-submission-display>
            </div>
            <!-- critique panel -->
            <div class="submission-critique-panel">
              <lrnapp-studio-submission-critique-panel
                submission="{{submission}}"
                edit="[[edit]]"
              ></lrnapp-studio-submission-critique-panel>
            </div>
          </vaadin-split-layout>
        </template>
      </template>
    `;
    }

    static get tag() {
      return "lrnapp-studio-submission-critique";
    }

    static get properties() {
      return {
        submission: {
          type: Object,
          notify: true
        },
        edit: {
          type: Boolean,
          value: false,
          reflectToAttribute: true
        }
      };
    }
    /**
     * Simple way to convert from object to array.
     */


    _toArray(obj) {
      if (obj == null) {
        return [];
      }

      return Object.keys(obj).map(function (key) {
        return obj[key];
      });
    }

  }

  _exports.LrnappStudioSubmissionCritique = LrnappStudioSubmissionCritique;
  window.customElements.define(LrnappStudioSubmissionCritique.tag, LrnappStudioSubmissionCritique);
});