define(["exports","require","../../../lit-element/lit-element.js"],(function(_exports,_require,_litElement){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.HaxInputMixer=void 0,_require=babelHelpers.interopRequireWildcard(_require);class HaxInputMixer extends _litElement.LitElement{static get styles(){return[_litElement.css`
        :host {
          display: block;
          margin: 0;
          border: none;
          padding: 0;
          border: 1px solid var(--hax-color-border-outline);
        }
        .wrapper {
          background-color: #ffffff;
          color: #222222;
          display: flex;
          align-items: center;
          justify-content: space-between;
        }
        hax-context-item {
          margin: 0;
        }
        #elementoptions {
          height: inherit;
        }
        #input {
          color: var(--hax-color-text);
        }
        paper-checkbox {
          --paper-checkbox-label-color: var(--hax-color-text);
        }
        paper-textarea,
        paper-input {
          height: 40px;
          font-size: 14px;
          margin-bottom: 6px;
        }
        .input-method {
          color: var(--hax-color-text);
          padding: 0 8px;
          width: 80%;
        }
        #updatebutton {
          outline: 1px solid black;
        }
        #updatebutton:hover {
          border: none;
        }
      `]}constructor(){super(),this.value=null,this.options={},this.icon="android",this.inputMethod=null,this.__inputtextarea=!1,this.__inputtextfield=!1,this.__inputboolean=!1,this.__inputcolorpicker=!1,this.__inputflipboolean=!1,new Promise((res,rej)=>_require.default(["../../simple-colors/lib/simple-colors-picker.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../../@polymer/paper-input/paper-textarea.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../../@polymer/paper-input/paper-input.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../../@polymer/paper-checkbox/paper-checkbox.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../simple-tooltip/simple-tooltip.js"],res,rej)),new Promise((res,rej)=>_require.default(["./hax-context-item-menu.js"],res,rej)),new Promise((res,rej)=>_require.default(["./hax-context-item.js"],res,rej))}render(){return _litElement.html`
      <custom-style>
        <style>
          paper-textarea,
          paper-input {
            --paper-input-container: {
              padding: 0;
              font-size: 14px;
            }
            --paper-input-container-label-floating: {
              color: var(--hax-color-text);
              font-size: 12px;
            }
            --paper-input-container-underline: {
              margin: 0;
            }
            --paper-input-container-color: var(--hax-color-text);
            --paper-input-container-focus-color: var(--hax-color-text);
            --paper-input-container-invalid-color: var(--hax-color-text);
            --paper-input-container-input-color: var(--hax-color-text);
            --paper-input-container-shared-input-style: {
              color: var(--hax-color-text);
              background: transparent;
              margin: 0;
              padding: 0;
              line-height: 14px;
              font-size: 14px;
              outline: none;
              border: none;
            }
          }
        </style>
      </custom-style>
      <div class="wrapper">
        ${this.__inputselect?_litElement.html`
              <span class="input-mixer-label">${this.label}</span>
              <hax-context-item-menu
                selected-value="${this.__selectedValue}"
                @selected-value-changed="${this.__selectedValueChanged}"
                .icon="${this.icon}"
                id="input"
              >
                <slot></slot>
              </hax-context-item-menu>
            `:_litElement.html``}
        <span class="input-method">
          ${this.__inputtextarea?_litElement.html`
                <paper-textarea
                  id="input"
                  label="${this.label}"
                  .value="${this.value}"
                  @value-changed="${this.valueChanged}"
                  auto-validate=""
                  pattern="${this.validation}"
                  required="${this.required}"
                ></paper-textarea>
              `:_litElement.html``}
          ${this.__inputtextfield?_litElement.html`
                <paper-input
                  id="input"
                  type="${this.validationType}"
                  label="${this.label}"
                  .value="${this.value}"
                  @value-changed="${this.valueChanged}"
                  auto-validate=""
                  pattern="${this.validation}"
                  required="${this.required}"
                ></paper-input>
              `:_litElement.html``}
          ${this.__inputboolean?_litElement.html`
                <paper-checkbox
                  id="input"
                  .checked="${this.value}"
                  @checked-changed="${this.valueChanged}"
                  >${this.label}</paper-checkbox
                >
              `:_litElement.html``}
          ${this.__inputflipboolean?_litElement.html`
                <paper-checkbox
                  id="input"
                  .checked="${this.value}"
                  @checked-changed="${this.valueChanged}"
                  >${this.label}</paper-checkbox
                >
              `:_litElement.html``}
          ${this.__inputcolorpicker?_litElement.html`
                <span>${this.label}</span>
                <simple-colors-picker
                  id="input"
                  .value="${this.value}"
                  @value-changed="${this.valueChanged}"
                ></simple-colors-picker>
              `:_litElement.html``}
        </span>
        <simple-tooltip for="input" position="top" offset="14">
          ${this.description}
        </simple-tooltip>
        <hax-context-item
          id="updatebutton"
          icon="subdirectory-arrow-right"
          label="Update ${this.label}"
          event-name="hax-update-tap"
        ></hax-context-item>
      </div>
    `}__selectedValueChanged(e){this.__selectedValue=e.detail.value}valueChanged(e){void 0!==e.detail.value?this.value=e.detail.value:this.value=e.detail}static get tag(){return"hax-input-mixer"}static get properties(){return{value:{type:String},label:{type:String,reflect:!0},validation:{type:String,reflect:!0},validationType:{type:String,reflect:!0,attribute:"validation-type"},required:{type:Boolean,reflect:!0},options:{type:Object},icon:{type:String,reflect:!0},description:{type:String,reflect:!0},inputMethod:{type:String,reflect:!0},propertyToBind:{type:String,reflect:!0,attribute:"property-to-bind"},slotToBind:{type:String,reflect:!0,attribute:"slot-to-bind"},__inputflipboolean:{type:Boolean},__inputcolorpicker:{type:Boolean},__inputboolean:{type:Boolean},__inputtextfield:{type:Boolean},__inputtextarea:{type:Boolean}}}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{"inputMethod"==propName&&this._inputMethodChanged(this[propName],oldValue)})}firstUpdated(changedProperties){this._resetInputMethods(),setTimeout(()=>{this.addEventListener("hax-context-item-selected",this._haxContextOperation.bind(this))},0)}_inputMethodChanged(newValue,oldValue){if(null!=newValue){let method=newValue;if(this.validInputMethods().includes(method)){for(this._resetInputMethods(),this["__input"+method]=!0;null!==this.firstChild;)this.removeChild(this.firstChild);var item;if("select"===method&&void 0!==this.options)for(var val in this.options)(item=document.createElement("paper-item")).attributes.value=val,item.innerHTML=this.options[val],this.appendChild(item.cloneNode(!0));setTimeout(()=>{this.shadowRoot.querySelector("#input")&&"function"==typeof this.shadowRoot.querySelector("#input").hideMenu&&this.shadowRoot.querySelector("#input").hideMenu(),this.shadowRoot.querySelector("#input").focus()},500)}}}validInputMethods(){return["flipboolean","boolean","select","textfield","textarea","datepicker","haxupload","colorpicker","iconpicker","alt","number","code-editor","array"]}_resetInputMethods(){let methods=this.validInputMethods();for(var i=0;i<methods.length;i++)this["__input"+methods[i]]=!1}_haxContextOperation(e){switch(e.detail.eventName){case"hax-update-tap":if("boolean"==this.inputMethod)this.value=this.value;else if("flipboolean"==this.inputMethod)this.value=!this.value;else if("select"==this.inputMethod){var count=0;for(var val in this.options)count==this.__selectedValue&&(this.value=val),count++}let mixer={value:this.value,propertyToBind:this.propertyToBind,slotToBind:this.slotToBind};this.dispatchEvent(new CustomEvent("hax-input-mixer-update",{bubbles:!0,cancelable:!0,composed:!0,detail:{inputMixer:mixer}}))}}}_exports.HaxInputMixer=HaxInputMixer,window.customElements.define(HaxInputMixer.tag,HaxInputMixer)}));