define(["exports", "require", "../../../../../lit-element/lit-element.js", "../../core/haxcms-site-store.js", "../../../../../mobx/lib/mobx.module.js", "../../../../utils/utils.js"], function (_exports, _require, _litElement, _haxcmsSiteStore, _mobxModule, _utils) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SiteGitCorner = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  class SiteGitCorner extends _litElement.LitElement {
    static get tag() {
      return "site-git-corner";
    }

    static get styles() {
      return [_litElement.css`
        :host {
          display: block;
          float: var(--site-git-corner-float);
        }
        :host([direction="right"]) {
          float: right;
        }
        :host([direction="left"]) {
          float: left;
        }
      `];
    }

    render() {
      return _litElement.html`
      <git-corner
        alt="${this.alt}"
        source="${this.activeGitFileLink}"
      ></git-corner>
    `;
    }

    constructor() {
      super();
      this.alt = "See page source";
      this.direction = "right";
      this.activeGitFileLink = "";
      this.__disposer = [];
      (0, _mobxModule.autorun)(reaction => {
        if ((0, _utils.varGet)(_haxcmsSiteStore.store.manifest, "metadata.site.git.publicRepoUrl", "") != "" && !window.customElements.get("git-corner")) {
          new Promise((res, rej) => _require.default(["../../../../git-corner/git-corner.js"], res, rej));
        }

        this.__disposer.push(reaction);
      });
      (0, _mobxModule.autorun)(reaction => {
        if (_haxcmsSiteStore.store.activeItem) {
          this.activeGitFileLink = (0, _utils.varGet)(_haxcmsSiteStore.store.manifest, "metadata.site.git.publicRepoUrl", "") + _haxcmsSiteStore.store.activeItem.location;
        }

        this.__disposer.push(reaction);
      });
    }

    disconnectedCallback() {
      for (var i in this.__disposer) {
        this.__disposer[i].dispose();
      }

      super.disconnectedCallback();
    }

    static get properties() {
      return {
        activeGitFileLink: {
          type: String,
          attribute: "active-git-file-link"
        },
        direction: {
          type: String,
          reflect: true
        },
        alt: {
          type: String
        }
      };
    }

  }

  _exports.SiteGitCorner = SiteGitCorner;
  window.customElements.define(SiteGitCorner.tag, SiteGitCorner);
});