define(["exports","require","../../lit-element/lit-element.js","../schema-behaviors/schema-behaviors.js"],(function(_exports,_require,_litElement,_schemaBehaviors){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.ImageCompareSlider=void 0,_require=babelHelpers.interopRequireWildcard(_require);class ImageCompareSlider extends((0,_schemaBehaviors.SchemaBehaviors)(_litElement.LitElement)){static get styles(){return[_litElement.css`
        :host {
          display: inline-flex;
          width: 100%;
        }
        :host > div,
        :host #container,
        :host #top {
          width: 100%;
        }
        :host #container {
          background-size: cover;
          overflow: visible;
        }
        :host #top {
          background-size: auto 100%;
          overflow: hidden;
        }
        :host #slider {
          width: calc(100% + 30px);
          margin-left: -15px;
        }
      `]}constructor(){super(),this.opacity=!1,new Promise((res,rej)=>_require.default(["../user-action/user-action.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../@polymer/iron-image/iron-image.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../@polymer/paper-slider/paper-slider.js"],res,rej))}render(){return _litElement.html`
      <div>
        <h2>${this.title}</h2>
        <div id="container" style="background-image: url(${this.bottomSrc});">
          <div id="top" style="background-image: url(${this.topSrc});"></div>
        </div>
        <user-action track="click">
          <paper-slider id="slider" value="50"></paper-slider>
        </user-action>
        <div></div>
      </div>
    `}static get tag(){return"image-compare-slider"}static get properties(){return{...super.properties,title:{type:String},topSrc:{type:String,attribute:"top-src"},opacity:{type:Boolean},bottomSrc:{type:String,attribute:"bottom-src"}}}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{["topSrc"].includes(propName)&&(this._updateAspect(),this._slide())})}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Image comparison",description:"Simple element to allow one image to swipe over top of the other.",icon:"image:compare",color:"orange",groups:["Image","Media"],handles:[{type:"image",source:"bottomSrc",source2:"topSrc",title:"title"}],meta:{author:"ELMS:LN"}},settings:{quick:[{property:"title",title:"Title",description:"The title of the element",inputMethod:"textfield",icon:"editor:title"},{property:"opacity",title:"Slider Behavior",description:"Do you want the slider to wipe the top image across the bottom one (default), or to adjust the opacity of the top image?",inputMethod:"select",options:{false:"wipe across",true:"adjust opacity"},icon:"image:compare"}],configure:[{property:"title",title:"Title",description:"The title of the element",inputMethod:"textfield"},{property:"bottomSrc",title:"Bottom image",description:"The base image to swipe over",inputMethod:"haxupload",validationType:"url"},{property:"topSrc",title:"Top image",description:"The top image that swipes over",inputMethod:"haxupload",validationType:"url"}],advanced:[]}}}firstUpdated(){this.shadowRoot.querySelector("#slider").addEventListener("immediate-value-changed",e=>{this._slide()})}_slide(){!1===this.opacity?this.shadowRoot.querySelector("#top").style.width=this.shadowRoot.querySelector("#slider").immediateValue+"%":this.shadowRoot.querySelector("#top").style.opacity=this.shadowRoot.querySelector("#slider").immediateValue/100}_updateAspect(){let img=document.createElement("img"),el=this.shadowRoot.querySelector("#top"),getAspect=img=>{el.style.paddingTop=100*img.height/img.width+"%"};this.__aspect="75",img.setAttribute("src",this.topSrc),void 0!==img.height&&img.height>0?getAspect(img):img.addEventListener("load",(function(){getAspect(img)}))}}_exports.ImageCompareSlider=ImageCompareSlider,window.customElements.define(ImageCompareSlider.tag,ImageCompareSlider)}));