define(["exports","require","../../lit-element/lit-element.js","../materializecss-styles/lib/colors.js"],(function(_exports,_require,_litElement,_colors){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.LrnButton=void 0,_require=babelHelpers.interopRequireWildcard(_require);
/**
   * Copyright 2018 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class LrnButton extends _litElement.LitElement{static get styles(){return[_litElement.css`
        :host {
          display: block;
          --lrnsys-button-height: 48px;
        }

        :host(.center) {
          text-align: center;
        }

        a {
          text-decoration: none;
          display: block;
          color: #000000;
        }

        paper-button {
          transition: 0.3s;
          margin: 0;
          max-width: 50%;
          height: inherit;
          -webkit-justify-content: flex-start;
          justify-content: flex-start;
          align-items: center;
          border-radius: unset;
        }

        paper-button iron-icon {
          height: var(--lrnsys-button-height);
          margin: 0 12px;
        }

        paper-button div.inner {
          height: var(--lrnsys-button-height);
          line-height: var(--lrnsys-button-height);
          padding: 0 12px;
        }

        paper-button span.label {
          height: var(--lrnsys-button-height);
          line-height: var(--lrnsys-button-height);
        }

        .no-margin {
          margin: 0 !important;
        }

        .no-right-padding {
          padding-right: 0 !important;
        }

        .no-left-padding {
          padding-left: 0 !important;
        }

        .center {
          text-align: center;
          margin: 0 auto;
        }
      `]}render(){return _litElement.html`
      <a
        tabindex="-1"
        id="lrnsys-button-link"
        href="${this.showHref}"
        data-prefetch-hover="${this.prefetch}"
        target="${this.target}"
      >
        <paper-button
          id="button"
          raised="${this.raised}"
          class="${this.class} ${this.color} ${this.textColor}"
          ?disabled="${this.disabled}"
        >
          <div class="inner ${this.innerClass}">
            ${this.icon?_litElement.html`
                  <iron-icon
                    icon="${this.icon}"
                    id="icon"
                    class="${this.iconClass}"
                  ></iron-icon>
                `:""}
            ${this.label?_litElement.html`
                  <span class="label">
                    ${this.label}
                  </span>
                `:""}
            <slot></slot>
          </div>
        </paper-button>
      </a>
      <simple-tooltip for="lrnsys-button-link" animation-delay="0"
        >${this.alt}</simple-tooltip
      >
    `}static get properties(){return{...super.properties,href:{type:String},showHref:{type:String,attribute:"show-href"},raised:{type:Boolean},label:{type:String},target:{type:String},icon:{type:String},hoverClass:{type:String,attribute:"hover-class"},iconClass:{type:String,attribute:"icon-class"},innerClass:{type:String,attribute:"inner-class"},color:{type:String},textColor:{type:String,attribute:"text-color"},prefetch:{type:String},alt:{type:String},disabled:{type:Boolean},focusState:{type:Boolean,attribute:"focus-state"}}}static get tag(){return"lrn-button"}constructor(){super(),this.href="#",this.label="",this.target="",this.disabled=!1,this.focusState=!1,setTimeout(()=>{this.addEventListener("mousedown",this.tapEventOn),this.addEventListener("mouseover",this.tapEventOn),this.addEventListener("mouseout",this.tapEventOff),this.addEventListener("focusin",this.tapEventOn),this.addEventListener("focusout",this.tapEventOff),new Promise((res,rej)=>_require.default(["../../@polymer/paper-button/paper-button.js"],res,rej)),new Promise((res,rej)=>_require.default(["../simple-tooltip/simple-tooltip.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../@polymer/iron-icons/iron-icons.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../@polymer/iron-icon/iron-icon.js"],res,rej))},0)}firstUpdated(){this.shadowRoot.querySelector("#button").addEventListener("focused-changed",this.focusToggle),this.disabled||(this.showHref=this.href)}tapEventOn(e){void 0===this.hoverClass||this.disabled||this.hoverClass.split(" ").forEach((item,index)=>{""!=item&&(this.shadowRoot.querySelector("#button").classList.add(item),-1!=item.indexOf("-")&&this.shadowRoot.querySelector("#icon").classList.add(item))})}tapEventOff(e){void 0===this.hoverClass||this.disabled||this.hoverClass.split(" ").forEach((item,index)=>{""!=item&&(this.shadowRoot.querySelector("#button").classList.remove(item),-1!=item.indexOf("-")&&this.shadowRoot.querySelector("#icon").classList.remove(item))})}focusToggle(e){(this.dispatchEvent(new CustomEvent("focus-changed",{bubbles:!0,composed:!0,detail:{focus:this.focusState}})),void 0===this.hoverClass||this.disabled)||this.hoverClass.split(" ").forEach((item,index)=>{""!=item&&(this.focusState?(this.shadowRoot.querySelector("#button").classList.add(item),-1!=item.indexOf("-")&&this.shadowRoot.querySelector("#icon").classList.add(item)):(this.shadowRoot.querySelector("#button").classList.remove(item),-1!=item.indexOf("-")&&this.shadowRoot.querySelector("#icon").classList.remove(item)))});this.focusState=!this.focusState}}_exports.LrnButton=LrnButton,window.customElements.define(LrnButton.tag,LrnButton)}));