define(["exports","../../lit-element/lit-element.js","../simple-colors/simple-colors.js","../chartist-render/chartist-render.js","../../@polymer/iron-ajax/iron-ajax.js"],(function(_exports,_litElement,_simpleColors,_chartistRender,_ironAjax){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.LrndesignChart=void 0;
/**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class LrndesignChart extends _simpleColors.SimpleColors{static get styles(){let styles=[_litElement.css`
        :host {
          --chartist-color-1: var(--simple-colors-default-theme-red-8);
          --chartist-color-2: var(--simple-colors-default-theme-blue-8);
          --chartist-color-3: var(--simple-colors-default-theme-yellow-8);
          --chartist-color-4: var(--simple-colors-default-theme-purple-8);
          --chartist-color-5: var(--simple-colors-default-theme-green-8);
          --chartist-color-6: var(--simple-colors-default-theme-orange-7);
          --chartist-color-7: var(--simple-colors-default-theme-pink-8);
          --chartist-color-8: var(--simple-colors-default-theme-deep-orange-8);
          --chartist-color-9: var(--simple-colors-default-theme-red-9);
          --chartist-color-10: var(--simple-colors-default-theme-blue-9);
          --chartist-color-11: var(--simple-colors-default-theme-yellow-9);
          --chartist-color-12: var(--simple-colors-default-theme-purple-9);
          --chartist-color-13: var(--simple-colors-default-theme-green-9);
          --chartist-color-14: var(--simple-colors-default-theme-orange-8);
          --chartist-color-15: var(--simple-colors-default-theme-pink-9);
        }

        :host([dark]) {
          --chartist-color-1: var(--simple-colors-default-theme-red-4);
          --chartist-color-2: var(--simple-colors-default-theme-blue-4);
          --chartist-color-3: var(--simple-colors-default-theme-yellow-4);
          --chartist-color-4: var(--simple-colors-default-theme-purple-4);
          --chartist-color-5: var(--simple-colors-default-theme-green-4);
          --chartist-color-6: var(--simple-colors-default-theme-orange-5);
          --chartist-color-7: var(--simple-colors-default-theme-pink-4);
          --chartist-color-8: var(--simple-colors-default-theme-deep-orange-4);
          --chartist-color-9: var(--simple-colors-default-theme-red-3);
          --chartist-color-10: var(--simple-colors-default-theme-blue-3);
          --chartist-color-11: var(--simple-colors-default-theme-yellow-3);
          --chartist-color-12: var(--simple-colors-default-theme-purple-3);
          --chartist-color-13: var(--simple-colors-default-theme-green-3);
          --chartist-color-14: var(--simple-colors-default-theme-orange-4);
          --chartist-color-15: var(--simple-colors-default-theme-pink-3);
        }

        :host([accent-color="red"]) {
          --chartist-color-1: var(--simple-colors-default-theme-red-8);
          --chartist-color-2: var(--simple-colors-default-theme-pink-9);
          --chartist-color-3: var(--simple-colors-default-theme-deep-orange-10);
          --chartist-color-4: var(--simple-colors-default-theme-purple-8);
          --chartist-color-5: var(--simple-colors-default-theme-orange-9);
          --chartist-color-6: var(--simple-colors-default-theme-red-10);
          --chartist-color-7: var(--simple-colors-default-theme-pink-8);
          --chartist-color-8: var(--simple-colors-default-theme-deep-orange-9);
          --chartist-color-9: var(--simple-colors-default-theme-purple-10);
          --chartist-color-10: var(--simple-colors-default-theme-orange-8);
          --chartist-color-11: var(--simple-colors-default-theme-red-9);
          --chartist-color-12: var(--simple-colors-default-theme-pink-10);
          --chartist-color-13: var(--simple-colors-default-theme-deep-orange-8);
          --chartist-color-14: var(--simple-colors-default-theme-purple-9);
          --chartist-color-15: var(--simple-colors-default-theme-orange-10);
        }

        :host([dark][accent-color="red"]) {
          --chartist-color-1: var(--simple-colors-default-theme-red-4);
          --chartist-color-2: var(--simple-colors-default-theme-pink-3);
          --chartist-color-3: var(--simple-colors-default-theme-deep-orange-2);
          --chartist-color-4: var(--simple-colors-default-theme-purple-4);
          --chartist-color-5: var(--simple-colors-default-theme-orange-3);
          --chartist-color-6: var(--simple-colors-default-theme-red-2);
          --chartist-color-7: var(--simple-colors-default-theme-pink-4);
          --chartist-color-8: var(--simple-colors-default-theme-deep-orange-3);
          --chartist-color-9: var(--simple-colors-default-theme-purple-2);
          --chartist-color-10: var(--simple-colors-default-theme-orange-4);
          --chartist-color-11: var(--simple-colors-default-theme-red-3);
          --chartist-color-12: var(--simple-colors-default-theme-pink-2);
          --chartist-color-13: var(--simple-colors-default-theme-deep-orange-4);
          --chartist-color-14: var(--simple-colors-default-theme-purple-3);
          --chartist-color-15: var(--simple-colors-default-theme-orange-2);
        }

        :host([accent-color="pink"]) {
          --chartist-color-1: var(--simple-colors-default-theme-pink-8);
          --chartist-color-2: var(--simple-colors-default-theme-purple-9);
          --chartist-color-3: var(--simple-colors-default-theme-red-10);
          --chartist-color-4: var(--simple-colors-default-theme-purple-8);
          --chartist-color-5: var(--simple-colors-default-theme-deep-orange-9);
          --chartist-color-6: var(--simple-colors-default-theme-pink-10);
          --chartist-color-7: var(--simple-colors-default-theme-purple-8);
          --chartist-color-8: var(--simple-colors-default-theme-red-9);
          --chartist-color-9: var(--simple-colors-default-theme-purple-10);
          --chartist-color-10: var(--simple-colors-default-theme-deep-orange-8);
          --chartist-color-11: var(--simple-colors-default-theme-pink-9);
          --chartist-color-12: var(--simple-colors-default-theme-purple-10);
          --chartist-color-13: var(--simple-colors-default-theme-red-8);
          --chartist-color-14: var(--simple-colors-default-theme-purple-9);
          --chartist-color-15: var(
            --simple-colors-default-theme-deep-orange-10
          );
        }

        :host([dark][accent-color="pink"]) {
          --chartist-color-1: var(--simple-colors-default-theme-pink-4);
          --chartist-color-2: var(--simple-colors-default-theme-purple-3);
          --chartist-color-3: var(--simple-colors-default-theme-red-2);
          --chartist-color-4: var(--simple-colors-default-theme-purple-4);
          --chartist-color-5: var(--simple-colors-default-theme-deep-orange-3);
          --chartist-color-6: var(--simple-colors-default-theme-pink-2);
          --chartist-color-7: var(--simple-colors-default-theme-purple-4);
          --chartist-color-8: var(--simple-colors-default-theme-red-3);
          --chartist-color-9: var(--simple-colors-default-theme-purple-2);
          --chartist-color-10: var(--simple-colors-default-theme-deep-orange-4);
          --chartist-color-11: var(--simple-colors-default-theme-pink-3);
          --chartist-color-12: var(--simple-colors-default-theme-purple-2);
          --chartist-color-13: var(--simple-colors-default-theme-red-4);
          --chartist-color-14: var(--simple-colors-default-theme-purple-3);
          --chartist-color-15: var(--simple-colors-default-theme-deep-orange-2);
        }

        :host([accent-color="purple"]) {
          --chartist-color-1: var(--simple-colors-default-theme-purple-8);
          --chartist-color-2: var(--simple-colors-default-theme-deep-purple-9);
          --chartist-color-3: var(--simple-colors-default-theme-pink-10);
          --chartist-color-4: var(--simple-colors-default-theme-indigo-8);
          --chartist-color-5: var(--simple-colors-default-theme-red-9);
          --chartist-color-6: var(--simple-colors-default-theme-purple-10);
          --chartist-color-7: var(--simple-colors-default-theme-deep-purple-8);
          --chartist-color-8: var(--simple-colors-default-theme-pink-9);
          --chartist-color-9: var(--simple-colors-default-theme-indigo-10);
          --chartist-color-10: var(--simple-colors-default-theme-red-8);
          --chartist-color-11: var(--simple-colors-default-theme-purple-9);
          --chartist-color-12: var(
            --simple-colors-default-theme-deep-purple-10
          );
          --chartist-color-13: var(--simple-colors-default-theme-pink-8);
          --chartist-color-14: var(--simple-colors-default-theme-indigo-9);
          --chartist-color-15: var(--simple-colors-default-theme-red-10);
        }

        :host([dark][accent-color="purple"]) {
          --chartist-color-1: var(--simple-colors-default-theme-purple-4);
          --chartist-color-2: var(--simple-colors-default-theme-deep-purple-3);
          --chartist-color-3: var(--simple-colors-default-theme-pink-2);
          --chartist-color-4: var(--simple-colors-default-theme-indigo-4);
          --chartist-color-5: var(--simple-colors-default-theme-red-3);
          --chartist-color-6: var(--simple-colors-default-theme-purple-2);
          --chartist-color-7: var(--simple-colors-default-theme-deep-purple-4);
          --chartist-color-8: var(--simple-colors-default-theme-pink-3);
          --chartist-color-9: var(--simple-colors-default-theme-indigo-2);
          --chartist-color-10: var(--simple-colors-default-theme-red-4);
          --chartist-color-11: var(--simple-colors-default-theme-purple-3);
          --chartist-color-12: var(--simple-colors-default-theme-deep-purple-2);
          --chartist-color-13: var(--simple-colors-default-theme-pink-4);
          --chartist-color-14: var(--simple-colors-default-theme-indigo-3);
          --chartist-color-15: var(--simple-colors-default-theme-red-2);
        }

        :host([accent-color="deep-purple"]) {
          --chartist-color-1: var(--simple-colors-default-theme-deep-purple-8);
          --chartist-color-2: var(--simple-colors-default-theme-indigo-9);
          --chartist-color-3: var(--simple-colors-default-theme-purple-10);
          --chartist-color-4: var(--simple-colors-default-theme-blue-8);
          --chartist-color-5: var(--simple-colors-default-theme-pink-9);
          --chartist-color-6: var(--simple-colors-default-theme-deep-purple-10);
          --chartist-color-7: var(--simple-colors-default-theme-indigo-8);
          --chartist-color-8: var(--simple-colors-default-theme-purple-9);
          --chartist-color-9: var(--simple-colors-default-theme-blue-10);
          --chartist-color-10: var(--simple-colors-default-theme-pink-8);
          --chartist-color-11: var(--simple-colors-default-theme-deep-purple-9);
          --chartist-color-12: var(--simple-colors-default-theme-indigo-10);
          --chartist-color-13: var(--simple-colors-default-theme-purple-8);
          --chartist-color-14: var(--simple-colors-default-theme-blue-9);
          --chartist-color-15: var(--simple-colors-default-theme-pink-10);
        }

        :host([dark][accent-color="deep-purple"]) {
          --chartist-color-1: var(--simple-colors-default-theme-deep-purple-4);
          --chartist-color-2: var(--simple-colors-default-theme-indigo-3);
          --chartist-color-3: var(--simple-colors-default-theme-purple-2);
          --chartist-color-4: var(--simple-colors-default-theme-blue-4);
          --chartist-color-5: var(--simple-colors-default-theme-pink-3);
          --chartist-color-6: var(--simple-colors-default-theme-deep-purple-2);
          --chartist-color-7: var(--simple-colors-default-theme-indigo-4);
          --chartist-color-8: var(--simple-colors-default-theme-purple-3);
          --chartist-color-9: var(--simple-colors-default-theme-blue-2);
          --chartist-color-10: var(--simple-colors-default-theme-pink-4);
          --chartist-color-11: var(--simple-colors-default-theme-deep-purple-3);
          --chartist-color-12: var(--simple-colors-default-theme-indigo-2);
          --chartist-color-13: var(--simple-colors-default-theme-purple-4);
          --chartist-color-14: var(--simple-colors-default-theme-blue-3);
          --chartist-color-15: var(--simple-colors-default-theme-pink-2);
        }

        :host([accent-color="indigo"]) {
          --chartist-color-1: var(--simple-colors-default-theme-indigo-8);
          --chartist-color-2: var(--simple-colors-default-theme-blue-9);
          --chartist-color-3: var(--simple-colors-default-theme-deep-purple-10);
          --chartist-color-4: var(--simple-colors-default-theme-light-blue-8);
          --chartist-color-5: var(--simple-colors-default-theme-purple-9);
          --chartist-color-6: var(--simple-colors-default-theme-indigo-10);
          --chartist-color-7: var(--simple-colors-default-theme-blue-8);
          --chartist-color-8: var(--simple-colors-default-theme-deep-purple-9);
          --chartist-color-9: var(--simple-colors-default-theme-light-blue-10);
          --chartist-color-10: var(--simple-colors-default-theme-purple-8);
          --chartist-color-11: var(--simple-colors-default-theme-indigo-9);
          --chartist-color-12: var(--simple-colors-default-theme-blue-10);
          --chartist-color-13: var(--simple-colors-default-theme-deep-purple-8);
          --chartist-color-14: var(--simple-colors-default-theme-light-blue-9);
          --chartist-color-15: var(--simple-colors-default-theme-purple-10);
        }

        :host([dark][accent-color="indigo"]) {
          --chartist-color-1: var(--simple-colors-default-theme-indigo-4);
          --chartist-color-2: var(--simple-colors-default-theme-blue-3);
          --chartist-color-3: var(--simple-colors-default-theme-deep-purple-2);
          --chartist-color-4: var(--simple-colors-default-theme-light-blue-4);
          --chartist-color-5: var(--simple-colors-default-theme-purple-3);
          --chartist-color-6: var(--simple-colors-default-theme-indigo-2);
          --chartist-color-7: var(--simple-colors-default-theme-blue-4);
          --chartist-color-8: var(--simple-colors-default-theme-deep-purple-3);
          --chartist-color-9: var(--simple-colors-default-theme-light-blue-2);
          --chartist-color-10: var(--simple-colors-default-theme-purple-4);
          --chartist-color-11: var(--simple-colors-default-theme-indigo-3);
          --chartist-color-12: var(--simple-colors-default-theme-blue-2);
          --chartist-color-13: var(--simple-colors-default-theme-deep-purple-4);
          --chartist-color-14: var(--simple-colors-default-theme-light-blue-3);
          --chartist-color-15: var(--simple-colors-default-theme-purple-2);
        }

        :host([accent-color="blue"]) {
          --chartist-color-1: var(--simple-colors-default-theme-blue-8);
          --chartist-color-2: var(--simple-colors-default-theme-light-blue-9);
          --chartist-color-3: var(--simple-colors-default-theme-indigo-10);
          --chartist-color-4: var(--simple-colors-default-theme-cyan-8);
          --chartist-color-5: var(--simple-colors-default-theme-deep-purple-9);
          --chartist-color-6: var(--simple-colors-default-theme-blue-10);
          --chartist-color-7: var(--simple-colors-default-theme-light-blue-8);
          --chartist-color-8: var(--simple-colors-default-theme-indigo-9);
          --chartist-color-9: var(--simple-colors-default-theme-cyan-10);
          --chartist-color-10: var(--simple-colors-default-theme-deep-purple-8);
          --chartist-color-11: var(--simple-colors-default-theme-blue-9);
          --chartist-color-12: var(--simple-colors-default-theme-light-blue-10);
          --chartist-color-13: var(--simple-colors-default-theme-indigo-8);
          --chartist-color-14: var(--simple-colors-default-theme-cyan-9);
          --chartist-color-15: var(
            --simple-colors-default-theme-deep-purple-10
          );
        }

        :host([dark][accent-color="blue"]) {
          --chartist-color-1: var(--simple-colors-default-theme-blue-4);
          --chartist-color-2: var(--simple-colors-default-theme-light-blue-3);
          --chartist-color-3: var(--simple-colors-default-theme-indigo-2);
          --chartist-color-4: var(--simple-colors-default-theme-cyan-4);
          --chartist-color-5: var(--simple-colors-default-theme-deep-purple-3);
          --chartist-color-6: var(--simple-colors-default-theme-blue-2);
          --chartist-color-7: var(--simple-colors-default-theme-light-blue-4);
          --chartist-color-8: var(--simple-colors-default-theme-indigo-3);
          --chartist-color-9: var(--simple-colors-default-theme-cyan-2);
          --chartist-color-10: var(--simple-colors-default-theme-deep-purple-4);
          --chartist-color-11: var(--simple-colors-default-theme-blue-3);
          --chartist-color-12: var(--simple-colors-default-theme-light-blue-2);
          --chartist-color-13: var(--simple-colors-default-theme-indigo-4);
          --chartist-color-14: var(--simple-colors-default-theme-cyan-3);
          --chartist-color-15: var(--simple-colors-default-theme-deep-purple-2);
        }

        :host([accent-color="light-blue"]) {
          --chartist-color-1: var(--simple-colors-default-theme-light-blue-8);
          --chartist-color-2: var(--simple-colors-default-theme-cyan-9);
          --chartist-color-3: var(--simple-colors-default-theme-blue-10);
          --chartist-color-4: var(--simple-colors-default-theme-teal-8);
          --chartist-color-5: var(--simple-colors-default-theme-indigo-9);
          --chartist-color-6: var(--simple-colors-default-theme-light-blue-10);
          --chartist-color-7: var(--simple-colors-default-theme-cyan-8);
          --chartist-color-8: var(--simple-colors-default-theme-blue-9);
          --chartist-color-9: var(--simple-colors-default-theme-teal-10);
          --chartist-color-10: var(--simple-colors-default-theme-indigo-8);
          --chartist-color-11: var(--simple-colors-default-theme-light-blue-9);
          --chartist-color-12: var(--simple-colors-default-theme-cyan-10);
          --chartist-color-13: var(--simple-colors-default-theme-blue-8);
          --chartist-color-14: var(--simple-colors-default-theme-teal-9);
          --chartist-color-15: var(--simple-colors-default-theme-indigo-10);
        }

        :host([dark][accent-color="light-blue"]) {
          --chartist-color-1: var(--simple-colors-default-theme-light-blue-4);
          --chartist-color-2: var(--simple-colors-default-theme-cyan-3);
          --chartist-color-3: var(--simple-colors-default-theme-blue-2);
          --chartist-color-4: var(--simple-colors-default-theme-teal-4);
          --chartist-color-5: var(--simple-colors-default-theme-indigo-3);
          --chartist-color-6: var(--simple-colors-default-theme-light-blue-2);
          --chartist-color-7: var(--simple-colors-default-theme-cyan-4);
          --chartist-color-8: var(--simple-colors-default-theme-blue-3);
          --chartist-color-9: var(--simple-colors-default-theme-teal-2);
          --chartist-color-10: var(--simple-colors-default-theme-indigo-4);
          --chartist-color-11: var(--simple-colors-default-theme-light-blue-3);
          --chartist-color-12: var(--simple-colors-default-theme-cyan-2);
          --chartist-color-13: var(--simple-colors-default-theme-blue-4);
          --chartist-color-14: var(--simple-colors-default-theme-teal-3);
          --chartist-color-15: var(--simple-colors-default-theme-indigo-2);
        }

        :host([accent-color="cyan"]) {
          --chartist-color-1: var(--simple-colors-default-theme-cyan-8);
          --chartist-color-2: var(--simple-colors-default-theme-teal-9);
          --chartist-color-3: var(--simple-colors-default-theme-light-blue-10);
          --chartist-color-4: var(--simple-colors-default-theme-green-8);
          --chartist-color-5: var(--simple-colors-default-theme-blue-9);
          --chartist-color-6: var(--simple-colors-default-theme-cyan-10);
          --chartist-color-7: var(--simple-colors-default-theme-teal-8);
          --chartist-color-8: var(--simple-colors-default-theme-light-blue-9);
          --chartist-color-9: var(--simple-colors-default-theme-green-10);
          --chartist-color-10: var(--simple-colors-default-theme-blue-8);
          --chartist-color-11: var(--simple-colors-default-theme-cyan-9);
          --chartist-color-12: var(--simple-colors-default-theme-teal-10);
          --chartist-color-13: var(--simple-colors-default-theme-light-blue-8);
          --chartist-color-14: var(--simple-colors-default-theme-green-9);
          --chartist-color-15: var(--simple-colors-default-theme-blue-10);
        }

        :host([dark][accent-color="cyan"]) {
          --chartist-color-1: var(--simple-colors-default-theme-cyan-4);
          --chartist-color-2: var(--simple-colors-default-theme-teal-3);
          --chartist-color-3: var(--simple-colors-default-theme-light-blue-2);
          --chartist-color-4: var(--simple-colors-default-theme-green-4);
          --chartist-color-5: var(--simple-colors-default-theme-blue-3);
          --chartist-color-6: var(--simple-colors-default-theme-cyan-2);
          --chartist-color-7: var(--simple-colors-default-theme-teal-4);
          --chartist-color-8: var(--simple-colors-default-theme-light-blue-3);
          --chartist-color-9: var(--simple-colors-default-theme-green-2);
          --chartist-color-10: var(--simple-colors-default-theme-blue-4);
          --chartist-color-11: var(--simple-colors-default-theme-cyan-3);
          --chartist-color-12: var(--simple-colors-default-theme-teal-2);
          --chartist-color-13: var(--simple-colors-default-theme-light-blue-4);
          --chartist-color-14: var(--simple-colors-default-theme-green-3);
          --chartist-color-15: var(--simple-colors-default-theme-blue-2);
        }

        :host([accent-color="teal"]) {
          --chartist-color-1: var(--simple-colors-default-theme-teal-8);
          --chartist-color-2: var(--simple-colors-default-theme-green-9);
          --chartist-color-3: var(--simple-colors-default-theme-cyan-10);
          --chartist-color-4: var(--simple-colors-default-theme-light-green-8);
          --chartist-color-5: var(--simple-colors-default-theme-light-blue-9);
          --chartist-color-6: var(--simple-colors-default-theme-teal-10);
          --chartist-color-7: var(--simple-colors-default-theme-green-8);
          --chartist-color-8: var(--simple-colors-default-theme-cyan-9);
          --chartist-color-9: var(--simple-colors-default-theme-light-green-10);
          --chartist-color-10: var(--simple-colors-default-theme-light-blue-8);
          --chartist-color-11: var(--simple-colors-default-theme-teal-9);
          --chartist-color-12: var(--simple-colors-default-theme-green-10);
          --chartist-color-13: var(--simple-colors-default-theme-cyan-8);
          --chartist-color-14: var(--simple-colors-default-theme-light-green-9);
          --chartist-color-15: var(--simple-colors-default-theme-light-blue-10);
        }

        :host([dark][accent-color="teal"]) {
          --chartist-color-1: var(--simple-colors-default-theme-teal-4);
          --chartist-color-2: var(--simple-colors-default-theme-green-3);
          --chartist-color-3: var(--simple-colors-default-theme-cyan-2);
          --chartist-color-4: var(--simple-colors-default-theme-light-green-4);
          --chartist-color-5: var(--simple-colors-default-theme-light-blue-3);
          --chartist-color-6: var(--simple-colors-default-theme-teal-2);
          --chartist-color-7: var(--simple-colors-default-theme-green-4);
          --chartist-color-8: var(--simple-colors-default-theme-cyan-3);
          --chartist-color-9: var(--simple-colors-default-theme-light-green-2);
          --chartist-color-10: var(--simple-colors-default-theme-light-blue-4);
          --chartist-color-11: var(--simple-colors-default-theme-teal-3);
          --chartist-color-12: var(--simple-colors-default-theme-green-2);
          --chartist-color-13: var(--simple-colors-default-theme-cyan-4);
          --chartist-color-14: var(--simple-colors-default-theme-light-green-3);
          --chartist-color-15: var(--simple-colors-default-theme-light-blue-2);
        }

        :host([accent-color="green"]) {
          --chartist-color-1: var(--simple-colors-default-theme-green-8);
          --chartist-color-2: var(--simple-colors-default-theme-light-green-9);
          --chartist-color-3: var(--simple-colors-default-theme-teal-10);
          --chartist-color-4: var(--simple-colors-default-theme-lime-8);
          --chartist-color-5: var(--simple-colors-default-theme-cyan-9);
          --chartist-color-6: var(--simple-colors-default-theme-green-10);
          --chartist-color-7: var(--simple-colors-default-theme-light-green-8);
          --chartist-color-8: var(--simple-colors-default-theme-teal-9);
          --chartist-color-9: var(--simple-colors-default-theme-lime-10);
          --chartist-color-10: var(--simple-colors-default-theme-cyan-8);
          --chartist-color-11: var(--simple-colors-default-theme-green-9);
          --chartist-color-12: var(
            --simple-colors-default-theme-light-green-10
          );
          --chartist-color-13: var(--simple-colors-default-theme-teal-8);
          --chartist-color-14: var(--simple-colors-default-theme-lime-9);
          --chartist-color-15: var(--simple-colors-default-theme-cyan-10);
        }

        :host([dark][accent-color="green"]) {
          --chartist-color-1: var(--simple-colors-default-theme-green-4);
          --chartist-color-2: var(--simple-colors-default-theme-light-green-3);
          --chartist-color-3: var(--simple-colors-default-theme-teal-2);
          --chartist-color-4: var(--simple-colors-default-theme-lime-4);
          --chartist-color-5: var(--simple-colors-default-theme-cyan-3);
          --chartist-color-6: var(--simple-colors-default-theme-green-2);
          --chartist-color-7: var(--simple-colors-default-theme-light-green-4);
          --chartist-color-8: var(--simple-colors-default-theme-teal-3);
          --chartist-color-9: var(--simple-colors-default-theme-lime-2);
          --chartist-color-10: var(--simple-colors-default-theme-cyan-4);
          --chartist-color-11: var(--simple-colors-default-theme-green-3);
          --chartist-color-12: var(--simple-colors-default-theme-light-green-2);
          --chartist-color-13: var(--simple-colors-default-theme-teal-4);
          --chartist-color-14: var(--simple-colors-default-theme-lime-3);
          --chartist-color-15: var(--simple-colors-default-theme-cyan-2);
        }

        :host([accent-color="light-green"]) {
          --chartist-color-1: var(--simple-colors-default-theme-light-green-8);
          --chartist-color-2: var(--simple-colors-default-theme-lime-9);
          --chartist-color-3: var(--simple-colors-default-theme-green-10);
          --chartist-color-4: var(--simple-colors-default-theme-amber-8);
          --chartist-color-5: var(--simple-colors-default-theme-teal-9);
          --chartist-color-6: var(--simple-colors-default-theme-light-green-10);
          --chartist-color-7: var(--simple-colors-default-theme-lime-8);
          --chartist-color-8: var(--simple-colors-default-theme-green-9);
          --chartist-color-9: var(--simple-colors-default-theme-amber-10);
          --chartist-color-10: var(--simple-colors-default-theme-teal-8);
          --chartist-color-11: var(--simple-colors-default-theme-light-green-9);
          --chartist-color-12: var(--simple-colors-default-theme-lime-10);
          --chartist-color-13: var(--simple-colors-default-theme-green-8);
          --chartist-color-14: var(--simple-colors-default-theme-amber-9);
          --chartist-color-15: var(--simple-colors-default-theme-teal-10);
        }

        :host([dark][accent-color="light-green"]) {
          --chartist-color-1: var(--simple-colors-default-theme-light-green-4);
          --chartist-color-2: var(--simple-colors-default-theme-lime-3);
          --chartist-color-3: var(--simple-colors-default-theme-green-2);
          --chartist-color-4: var(--simple-colors-default-theme-amber-4);
          --chartist-color-5: var(--simple-colors-default-theme-teal-3);
          --chartist-color-6: var(--simple-colors-default-theme-light-green-2);
          --chartist-color-7: var(--simple-colors-default-theme-lime-4);
          --chartist-color-8: var(--simple-colors-default-theme-green-3);
          --chartist-color-9: var(--simple-colors-default-theme-amber-2);
          --chartist-color-10: var(--simple-colors-default-theme-teal-4);
          --chartist-color-11: var(--simple-colors-default-theme-light-green-3);
          --chartist-color-12: var(--simple-colors-default-theme-lime-2);
          --chartist-color-13: var(--simple-colors-default-theme-green-4);
          --chartist-color-14: var(--simple-colors-default-theme-amber-3);
          --chartist-color-15: var(--simple-colors-default-theme-teal-2);
        }

        :host([accent-color="lime"]) {
          --chartist-color-1: var(--simple-colors-default-theme-lime-8);
          --chartist-color-2: var(--simple-colors-default-theme-yellow-9);
          --chartist-color-3: var(--simple-colors-default-theme-light-green-10);
          --chartist-color-4: var(--simple-colors-default-theme-orange-8);
          --chartist-color-5: var(--simple-colors-default-theme-green-9);
          --chartist-color-6: var(--simple-colors-default-theme-lime-10);
          --chartist-color-7: var(--simple-colors-default-theme-yellow-8);
          --chartist-color-8: var(--simple-colors-default-theme-light-green-9);
          --chartist-color-9: var(--simple-colors-default-theme-orange-10);
          --chartist-color-10: var(--simple-colors-default-theme-green-8);
          --chartist-color-11: var(--simple-colors-default-theme-lime-9);
          --chartist-color-12: var(--simple-colors-default-theme-yellow-10);
          --chartist-color-13: var(--simple-colors-default-theme-light-green-8);
          --chartist-color-14: var(--simple-colors-default-theme-orange-9);
          --chartist-color-15: var(--simple-colors-default-theme-green-10);
        }

        :host([dark][accent-color="lime"]) {
          --chartist-color-1: var(--simple-colors-default-theme-lime-4);
          --chartist-color-2: var(--simple-colors-default-theme-yellow-3);
          --chartist-color-3: var(--simple-colors-default-theme-light-green-2);
          --chartist-color-4: var(--simple-colors-default-theme-orange-4);
          --chartist-color-5: var(--simple-colors-default-theme-green-3);
          --chartist-color-6: var(--simple-colors-default-theme-lime-2);
          --chartist-color-7: var(--simple-colors-default-theme-yellow-4);
          --chartist-color-8: var(--simple-colors-default-theme-light-green-3);
          --chartist-color-9: var(--simple-colors-default-theme-orange-2);
          --chartist-color-10: var(--simple-colors-default-theme-green-4);
          --chartist-color-11: var(--simple-colors-default-theme-lime-3);
          --chartist-color-12: var(--simple-colors-default-theme-yellow-2);
          --chartist-color-13: var(--simple-colors-default-theme-light-green-4);
          --chartist-color-14: var(--simple-colors-default-theme-orange-3);
          --chartist-color-15: var(--simple-colors-default-theme-green-2);
        }

        :host([accent-color="yellow"]) {
          --chartist-color-1: var(--simple-colors-default-theme-yellow-8);
          --chartist-color-2: var(--simple-colors-default-theme-amber-9);
          --chartist-color-3: var(--simple-colors-default-theme-lime-10);
          --chartist-color-4: var(--simple-colors-default-theme-deep-orange-8);
          --chartist-color-5: var(--simple-colors-default-theme-light-green-9);
          --chartist-color-6: var(--simple-colors-default-theme-yellow-10);
          --chartist-color-7: var(--simple-colors-default-theme-amber-8);
          --chartist-color-8: var(--simple-colors-default-theme-lime-9);
          --chartist-color-9: var(--simple-colors-default-theme-deep-orange-10);
          --chartist-color-10: var(--simple-colors-default-theme-light-green-8);
          --chartist-color-11: var(--simple-colors-default-theme-yellow-9);
          --chartist-color-12: var(--simple-colors-default-theme-amber-10);
          --chartist-color-13: var(--simple-colors-default-theme-lime-8);
          --chartist-color-14: var(--simple-colors-default-theme-deep-orange-9);
          --chartist-color-15: var(
            --simple-colors-default-theme-light-green-10
          );
        }

        :host([dark][accent-color="yellow"]) {
          --chartist-color-1: var(--simple-colors-default-theme-yellow-4);
          --chartist-color-2: var(--simple-colors-default-theme-amber-3);
          --chartist-color-3: var(--simple-colors-default-theme-lime-2);
          --chartist-color-4: var(--simple-colors-default-theme-deep-orange-4);
          --chartist-color-5: var(--simple-colors-default-theme-light-green-3);
          --chartist-color-6: var(--simple-colors-default-theme-yellow-2);
          --chartist-color-7: var(--simple-colors-default-theme-amber-4);
          --chartist-color-8: var(--simple-colors-default-theme-lime-3);
          --chartist-color-9: var(--simple-colors-default-theme-deep-orange-2);
          --chartist-color-10: var(--simple-colors-default-theme-light-green-4);
          --chartist-color-11: var(--simple-colors-default-theme-yellow-3);
          --chartist-color-12: var(--simple-colors-default-theme-amber-2);
          --chartist-color-13: var(--simple-colors-default-theme-lime-4);
          --chartist-color-14: var(--simple-colors-default-theme-deep-orange-3);
          --chartist-color-15: var(--simple-colors-default-theme-light-green-2);
        }

        :host([accent-color="amber"]) {
          --chartist-color-1: var(--simple-colors-default-theme-amber-8);
          --chartist-color-2: var(--simple-colors-default-theme-orange-9);
          --chartist-color-3: var(--simple-colors-default-theme-yellow-10);
          --chartist-color-4: var(--simple-colors-default-theme-red-8);
          --chartist-color-5: var(--simple-colors-default-theme-lime-9);
          --chartist-color-6: var(--simple-colors-default-theme-amber-10);
          --chartist-color-7: var(--simple-colors-default-theme-orange-8);
          --chartist-color-8: var(--simple-colors-default-theme-yellow-9);
          --chartist-color-9: var(--simple-colors-default-theme-red-10);
          --chartist-color-10: var(--simple-colors-default-theme-lime-8);
          --chartist-color-11: var(--simple-colors-default-theme-amber-9);
          --chartist-color-12: var(--simple-colors-default-theme-orange-10);
          --chartist-color-13: var(--simple-colors-default-theme-yellow-8);
          --chartist-color-14: var(--simple-colors-default-theme-red-9);
          --chartist-color-15: var(--simple-colors-default-theme-lime-10);
        }

        :host([dark][accent-color="amber"]) {
          --chartist-color-1: var(--simple-colors-default-theme-amber-4);
          --chartist-color-2: var(--simple-colors-default-theme-orange-3);
          --chartist-color-3: var(--simple-colors-default-theme-yellow-2);
          --chartist-color-4: var(--simple-colors-default-theme-red-4);
          --chartist-color-5: var(--simple-colors-default-theme-lime-3);
          --chartist-color-6: var(--simple-colors-default-theme-amber-2);
          --chartist-color-7: var(--simple-colors-default-theme-orange-4);
          --chartist-color-8: var(--simple-colors-default-theme-yellow-3);
          --chartist-color-9: var(--simple-colors-default-theme-red-2);
          --chartist-color-10: var(--simple-colors-default-theme-lime-4);
          --chartist-color-11: var(--simple-colors-default-theme-amber-3);
          --chartist-color-12: var(--simple-colors-default-theme-orange-2);
          --chartist-color-13: var(--simple-colors-default-theme-yellow-4);
          --chartist-color-14: var(--simple-colors-default-theme-red-3);
          --chartist-color-15: var(--simple-colors-default-theme-lime-2);
        }

        :host([accent-color="orange"]) {
          --chartist-color-1: var(--simple-colors-default-theme-orange-8);
          --chartist-color-2: var(--simple-colors-default-theme-deep-orange-9);
          --chartist-color-3: var(--simple-colors-default-theme-amber-10);
          --chartist-color-4: var(--simple-colors-default-theme-pink-8);
          --chartist-color-5: var(--simple-colors-default-theme-yellow-9);
          --chartist-color-6: var(--simple-colors-default-theme-orange-10);
          --chartist-color-7: var(--simple-colors-default-theme-deep-orange-8);
          --chartist-color-8: var(--simple-colors-default-theme-amber-9);
          --chartist-color-9: var(--simple-colors-default-theme-pink-10);
          --chartist-color-10: var(--simple-colors-default-theme-yellow-8);
          --chartist-color-11: var(--simple-colors-default-theme-orange-9);
          --chartist-color-12: var(
            --simple-colors-default-theme-deep-orange-10
          );
          --chartist-color-13: var(--simple-colors-default-theme-amber-8);
          --chartist-color-14: var(--simple-colors-default-theme-pink-9);
          --chartist-color-15: var(--simple-colors-default-theme-yellow-10);
        }

        :host([dark][accent-color="orange"]) {
          --chartist-color-1: var(--simple-colors-default-theme-orange-4);
          --chartist-color-2: var(--simple-colors-default-theme-deep-orange-3);
          --chartist-color-3: var(--simple-colors-default-theme-amber-2);
          --chartist-color-4: var(--simple-colors-default-theme-pink-4);
          --chartist-color-5: var(--simple-colors-default-theme-yellow-3);
          --chartist-color-6: var(--simple-colors-default-theme-orange-2);
          --chartist-color-7: var(--simple-colors-default-theme-deep-orange-4);
          --chartist-color-8: var(--simple-colors-default-theme-amber-3);
          --chartist-color-9: var(--simple-colors-default-theme-pink-2);
          --chartist-color-10: var(--simple-colors-default-theme-yellow-4);
          --chartist-color-11: var(--simple-colors-default-theme-orange-3);
          --chartist-color-12: var(--simple-colors-default-theme-deep-orange-2);
          --chartist-color-13: var(--simple-colors-default-theme-amber-4);
          --chartist-color-14: var(--simple-colors-default-theme-pink-3);
          --chartist-color-15: var(--simple-colors-default-theme-yellow-2);
        }

        :host([accent-color="deep-orange"]) {
          --chartist-color-1: var(--simple-colors-default-theme-deep-orange-8);
          --chartist-color-2: var(--simple-colors-default-theme-red-9);
          --chartist-color-3: var(--simple-colors-default-theme-orange-10);
          --chartist-color-4: var(--simple-colors-default-theme-purple-8);
          --chartist-color-5: var(--simple-colors-default-theme-amber-9);
          --chartist-color-6: var(--simple-colors-default-theme-deep-orange-10);
          --chartist-color-7: var(--simple-colors-default-theme-red-8);
          --chartist-color-8: var(--simple-colors-default-theme-orange-9);
          --chartist-color-9: var(--simple-colors-default-theme-purple-10);
          --chartist-color-10: var(--simple-colors-default-theme-amber-8);
          --chartist-color-11: var(--simple-colors-default-theme-deep-orange-9);
          --chartist-color-12: var(--simple-colors-default-theme-red-10);
          --chartist-color-13: var(--simple-colors-default-theme-orange-8);
          --chartist-color-14: var(--simple-colors-default-theme-purple-9);
          --chartist-color-15: var(--simple-colors-default-theme-amber-10);
        }

        :host([dark][accent-color="deep-orange"]) {
          --chartist-color-1: var(--simple-colors-default-theme-deep-orange-4);
          --chartist-color-2: var(--simple-colors-default-theme-red-3);
          --chartist-color-3: var(--simple-colors-default-theme-orange-2);
          --chartist-color-4: var(--simple-colors-default-theme-purple-4);
          --chartist-color-5: var(--simple-colors-default-theme-amber-3);
          --chartist-color-6: var(--simple-colors-default-theme-deep-orange-2);
          --chartist-color-7: var(--simple-colors-default-theme-red-4);
          --chartist-color-8: var(--simple-colors-default-theme-orange-3);
          --chartist-color-9: var(--simple-colors-default-theme-purple-2);
          --chartist-color-10: var(--simple-colors-default-theme-amber-4);
          --chartist-color-11: var(--simple-colors-default-theme-deep-orange-3);
          --chartist-color-12: var(--simple-colors-default-theme-red-2);
          --chartist-color-13: var(--simple-colors-default-theme-orange-4);
          --chartist-color-14: var(--simple-colors-default-theme-purple-3);
          --chartist-color-15: var(--simple-colors-default-theme-amber-2);
        }

        :host([accent-color="brown"]) {
          --chartist-color-1: var(--simple-colors-default-theme-brown-8);
          --chartist-color-2: var(--simple-colors-default-theme-red-9);
          --chartist-color-3: var(--simple-colors-default-theme-deep-orange-10);
          --chartist-color-4: var(--simple-colors-default-theme-brown-11);
          --chartist-color-5: var(--simple-colors-default-theme-red-12);
          --chartist-color-6: var(--simple-colors-default-theme-deep-orange-8);
          --chartist-color-7: var(--simple-colors-default-theme-brown-9);
          --chartist-color-8: var(--simple-colors-default-theme-red-10);
          --chartist-color-9: var(--simple-colors-default-theme-deep-orange-11);
          --chartist-color-10: var(--simple-colors-default-theme-brown-12);
          --chartist-color-11: var(--simple-colors-default-theme-red-8);
          --chartist-color-12: var(--simple-colors-default-theme-deep-orange-9);
          --chartist-color-13: var(--simple-colors-default-theme-brown-10);
          --chartist-color-14: var(--simple-colors-default-theme-red-11);
          --chartist-color-15: var(
            --simple-colors-default-theme-deep-orange-12
          );
        }

        :host([dark][accent-color="brown"]) {
          --chartist-color-1: var(--simple-colors-default-theme-brown-4);
          --chartist-color-2: var(--simple-colors-default-theme-red-3);
          --chartist-color-3: var(--simple-colors-default-theme-deep-orange-2);
          --chartist-color-4: var(--simple-colors-default-theme-brown-1);
          --chartist-color-5: var(--simple-colors-default-theme-red-0);
          --chartist-color-6: var(--simple-colors-default-theme-deep-orange-4);
          --chartist-color-7: var(--simple-colors-default-theme-brown-3);
          --chartist-color-8: var(--simple-colors-default-theme-red-2);
          --chartist-color-9: var(--simple-colors-default-theme-deep-orange-1);
          --chartist-color-10: var(--simple-colors-default-theme-brown-0);
          --chartist-color-11: var(--simple-colors-default-theme-red-4);
          --chartist-color-12: var(--simple-colors-default-theme-deep-orange-3);
          --chartist-color-13: var(--simple-colors-default-theme-brown-2);
          --chartist-color-14: var(--simple-colors-default-theme-red-1);
          --chartist-color-15: var(--simple-colors-default-theme-deep-orange-0);
        }

        :host {
          display: block;
        }
      `];return super.styles&&(styles=Object.assign(super.styles,styles)),styles}render(){return _litElement.html`
      <iron-ajax
        auto
        handle-as="text"
        url="${this.dataSource}"
        @response="${this.handleResponse}"
      ></iron-ajax>
      <chartist-render
        id="chartist"
        .type="${this.type}"
        .scale="${this.scale}"
        .chart-title="${this.chartTitle}"
        .chart-desc="${this.chartDesc}"
        .data="${this.data}"
        .responsive-options="${this.responsiveOptions}"
      ></chartist-render>
    `}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{description:"Creates an accessible chart based on a CSV.",color:"green darken-4",groups:["Data","Presentation"],handles:[{type:"data",url:"csvFile"}],meta:{author:"LRNWebComponents"}},settings:{quick:[{property:"chartTitle",title:"Chart Title",description:"Accessible alt text for your chart.",inputMethod:"textfield",icon:"text-field",required:!0}],configure:[{property:"data-source",title:"CSV File",description:"The URL for your CSV file.",inputMethod:"textfield",icon:"link",validationType:"url",required:!0},{property:"chartTitle",title:"Chart Title",description:"Accessible alt text for your chart.",inputMethod:"textfield",icon:"text-field",required:!0},{property:"chartDesc",title:"Chart Description",description:"Accessible description of your chart.",inputMethod:"textfield",icon:"text-field"}],advanced:[{property:"scale",title:"Scale Name",description:"The ratio of width:height of the chart (See https://gionkunz.github.io/chartist-js/getting-started.html#default-sass-settings for $ct-scales and $ct-scales-names).",inputMethod:"textfield",icon:"text-field"},{property:"reverseData",title:"Reverse Data",description:"Reverse data including labels, the series order as well as the whole series data arrays.",inputMethod:"boolean",icon:"check-box"}]}}}static get properties(){return{...super.properties,dataSource:{type:String,attribute:"data-source"},height:{type:String},rawData:{type:String,attribute:"raw-data"},reverseData:{type:Boolean,attribute:"reverse-data"},width:{type:String}}}constructor(){super(),this.setProperties();let checkReady=setInterval(()=>{this.__dataReady&&(this.makeChart(),clearInterval(checkReady))},1)}static get tag(){return"lrndesign-chart"}static get lineBarProperties(){return{axisXLabelOffsetX:{attribute:"axis-x-label-offset-x",type:Number},axisXLabelOffsetY:{attribute:"axis-x-label-offset-y",type:Number},axisXOffset:{attribute:"axis-x-offset",type:Number},axisXPosition:{attribute:"axis-x-position",type:String},axisXShowGrid:{attribute:"axis-x-show-grid",type:Boolean},axisXShowLabel:{attribute:"axis-x-show-label",type:Boolean},axisYLabelOffsetX:{attribute:"axis-y-label-offset-x",type:Number},axisYLabelOffsetY:{attribute:"axis-y-label-offset-y",type:Number},axisYPosition:{attribute:"axis-y-position",type:String},axisYScaleMinSpace:{attribute:"axis-y-scale-min-space",type:Number},axisYOffset:{attribute:"axis-y-offset",type:Number},axisYOnlyInteger:{attribute:"axis-y-only-integer",type:Boolean},axisYshowGrid:{attribute:"axis-y-show-grid",type:Boolean},axisYshowLabel:{attribute:"axis-y-show-label",type:Boolean},axisYTopLeft:{attribute:"axis-y-top-left",type:Boolean},chartPaddingBottom:{attribute:"chart-padding-bottom",type:String},chartPaddingLeft:{attribute:"chart-padding-left",type:String},chartPaddingRight:{attribute:"chart-padding-right",type:String},chartPaddingTop:{attribute:"chart-padding-top",type:String},high:{type:Number},low:{type:Number},showGridBackground:{attribute:"show-grid-background",type:Boolean}}}static get lineBarHaxProperties(){return{gridBackground:[{property:"showGridBackground",title:"Show Grid Background",inputMethod:"boolean"}],padding:[{property:"chartPaddingTop",title:"Chart Padding (top)",inputMethod:"text-field"},{property:"chartPaddingBottom",title:"Chart Padding (bottom)",inputMethod:"text-field"},{property:"chartPaddingLeft",title:"Chart Padding (left)",inputMethod:"text-field"},{property:"chartPaddingRight",title:"Chart Padding (right)",inputMethod:"text-field"}],minMax:[{property:"low",title:"Chart Minimum",description:"\n          Overriding the natural low of the chart allows you to zoom in \n          or limit the chart's lowest displayed value",inputMethod:"number"},{property:"high",title:"Chart Maximum",description:"\n          Overriding the natural high of the chart allows you to zoom in \n          or limit the chart's highest displayed value",inputMethod:"number"}],xAxis:[{property:"axisXShowGrid",title:"X-Axis Show Grid",description:"Show the X-Axis's grid.",inputMethod:"boolean"},{property:"axisXOffset",title:"X-Axis Offset",inputMethod:"number"},{property:"axisXPosition",title:"X-Axis Position",description:'\n            Position where labels are placed. Can be set to "start" or "end" \n            where "start" is equivalent to left or top on vertical axis\n            and "end" is equivalent to right or bottom on horizontal axis',inputMethod:"text-field"},{property:"axisXShowLabel",title:"X-Axis Show Label",description:"Show the X-Axis's label.",inputMethod:"boolean"},{property:"axisXLabelOffsetX",title:"X-Axis Label (horizontal offset)",description:"Horizontal position of the X-Axis's label.",inputMethod:"number"},{property:"axisXLabelOffsetY",title:"X-Axis Label (vertical offset)",description:"Vertical position of the X-Axis's label.",inputMethod:"number"}],yAxis:[{property:"axisYShowGrid",title:"Y-Axis: Show Grid",description:"Show the Y-Axis's grid.",inputMethod:"boolean"},{property:"axisYOffset",title:"Y-Axis Offset",inputMethod:"number"},{property:"axisYPosition",title:"Y-Axis Position",description:'\n            Position where labels are placed. Can be set to "start" or "end" \n            where "start" is equivalent to left or top on vertical axis\n            and "end" is equivalent to right or bottom on horizontal axis',inputMethod:"text-field"},{property:"axisYShowLabel",title:"Y-Axis Show Label",description:"Show the Y-Axis's label.",inputMethod:"boolean"},{property:"axisYLabelOffsetX",title:"Y-Axis Label (horizontal offset)",description:"Horizontal position of the Y-Axis's label.",inputMethod:"number"},{property:"axisYLabelOffsetY",title:"Y-Axis Label (vertical offset)",description:"Vertical position of the Y-Axis's label.",inputMethod:"number"},{property:"axisYScaleMinSpace",title:"Y-Axis Scale Minimum Space",description:"Specifies minimum height in pixel of scale steps.",inputMethod:"number"},{property:"axisYOnlyInteger",title:"Y-Axis Scale (only integers)",description:"Use only integer values (whole numbers) for the scale steps.",inputMethod:"boolean"}]}}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{"dataSource"===propName&&this.dispatchEvent(new CustomEvent("data-source-changed",{detail:this})),"rawData"===propName&&this.dispatchEvent(new CustomEvent("raw-data-changed",{detail:this})),this.__dataReady&&this.makeChart()})}makeChart(){let chart=this.shadowRoot.querySelector("#chartist");chart&&(chart.options=this._getOptions(),this.dispatchEvent(new CustomEvent("options-changed",{detail:this})),chart.makeChart(),this.dispatchEvent(new CustomEvent("chart-changed",{detail:this})))}setProperties(){this.chartTitle=null,this.chartDesc=null,this.scale="ct-minor-seventh",this.reverseData=!1,this.rawData=""}setBarLineProperties(){this.high=void 0,this.low=void 0,this.axisXLabelOffsetX=0,this.axisXLabelOffsetY=0,this.axisXOffset=30,this.axisXPosition="end",this.axisXShowGrid=!0,this.axisXShowLabel=!0,this.axisXTopLeft=!1,this.axisYLabelOffsetX=0,this.axisYLabelOffsetY=0,this.axisYOffset=30,this.axisYOnlyInteger=!1,this.axisYPosition="start",this.axisYScaleMinSpace=20,this.axisYShowGrid=!0,this.axisYshowLabel=!0,this.axisYTopLeft=!0,this.showGridBackground=!1,this.chartPaddingBottom=5,this.chartPaddingLeft=10,this.chartPaddingRight=15,this.chartPaddingTop=15}handleResponse(e){this.rawData=e.detail.response;let raw=this.CSVtoArray(this.rawData);this.data={labels:raw[0],series:"pie"!==this.type?raw.slice(1,raw.length):raw[1]},this.__dataReady=!0}_getOptions(){return{reverseData:this.reverseData}}_getLineBarOptions(){return{high:this.high,low:this.low,axisX:{labelOffset:{x:this.axisXLabelOffsetX,y:this.axisXLabelOffsetY,offset:this.axisXOffset},position:this.axisXPosition,showGrid:this.axisXShowGrid,showLabel:this.axisXShowLabel},axisY:{labelOffset:{x:this.axisYLabelOffsetX,y:this.axisYLabelOffsetY,offset:this.axisYOffset},position:this.axisYPosition,showGrid:this.axisYShowGrid,showLabel:this.axisYShowLabel,onlyInteger:this.axisYOnlyInteger,scaleMinSpace:this.axisYScaleMinSpace},showGridBackground:this.showGridBackground,chartPadding:{bottom:this.chartPaddingBottom,left:this.chartPaddingLeft,right:this.chartPaddingRight,top:this.chartPaddingTop}}}CSVtoArray(text){let l,p="",row=[""],ret=[row],i=0,r=0,s=!0;for(l in text)l=text[l],'"'===l?(s&&l===p&&(row[i]+=l),s=!s):","===l&&s?(null!==row[i].trim().match(/^\d+$/m)&&(row[i]=parseInt(row[i].trim())),l=row[++i]=""):"\n"===l&&s?("\r"===p&&(row[i]=row[i].slice(0,-1)),null!==row[i].trim().match(/^\d+$/m)&&(row[i]=parseInt(row[i].trim())),row=ret[++r]=[l=""],i=0):row[i]+=l,p=l;return null!==row[i].trim().match(/^\d+$/m)&&(row[i]=parseInt(row[i].trim())),ret}}_exports.LrndesignChart=LrndesignChart,window.customElements.define(LrndesignChart.tag,LrndesignChart)}));