define(["exports", "require", "../../../lit-element/lit-element.js"], function (_exports, _require, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnsysDialogToolbarButton = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  class LrnsysDialogToolbarButton extends _litElement.LitElement {
    /**
     * LitElement constructable styles enhancement
     */
    static get styles() {
      return [_litElement.css`
        :host {
          display: inline-block;
        }
        iron-icon {
          display: inline-block;
          height: 16px;
          width: 16px;
        }
      `];
    }
    /**
     * LitElement render
     */


    render() {
      return _litElement.html`
      <paper-button
        raised
        @click="${this._onTap}"
        id="${this.id}"
        aria-label="${this.title}"
      >
        <iron-icon icon="${this.icon}"></iron-icon> ${this.title}
      </paper-button>
      <simple-tooltip for="${this.id}" animation-delay="0"
        >${this.title}</simple-tooltip
      >
    `;
    }

    static get tag() {
      return "lrnsys-dialog-toolbar-button";
    }
    /**
     * HTMLElement
     */


    constructor() {
      super();
      new Promise((res, rej) => _require.default(["../../../@polymer/paper-button/paper-button.js"], res, rej));
      new Promise((res, rej) => _require.default(["../../../@polymer/iron-icon/iron-icon.js"], res, rej));
      new Promise((res, rej) => _require.default(["../../../@polymer/iron-icons/iron-icons.js"], res, rej));
      new Promise((res, rej) => _require.default(["../../simple-tooltip/simple-tooltip.js"], res, rej));
    }
    /**
     * LitElement / popular convention
     */


    static get properties() {
      return {
        /**
         * The title of the button.
         */
        title: {
          type: String
        },

        /**
         * The button icon.
         */
        icon: {
          type: String
        },

        /**
         * The button ID.
         */
        id: {
          type: String
        }
      };
    }
    /**
     * Ready lifecycle
     */


    firstUpdated(changedProperties) {
      this.dispatchEvent(new CustomEvent("button-initialized", {
        detail: {
          id: this.id
        }
      }));
    }
    /**
     * Button has been tapped.
     */


    _onTap(e) {
      this.dispatchEvent(new CustomEvent("dialog-toolbar-button-tapped", {
        detail: {
          id: e.target.getAttribute("id")
        }
      }));
    }

  }

  _exports.LrnsysDialogToolbarButton = LrnsysDialogToolbarButton;
  window.customElements.define(LrnsysDialogToolbarButton.tag, LrnsysDialogToolbarButton);
});