define(["exports","require","../../lit-element/lit-element.js","../schema-behaviors/schema-behaviors.js","../simple-colors/simple-colors.js"],(function(_exports,_require,_litElement,_schemaBehaviors,_simpleColors){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.MultipleChoice=void 0,_require=babelHelpers.interopRequireWildcard(_require);class MultipleChoice extends((0,_schemaBehaviors.SchemaBehaviors)(_simpleColors.SimpleColors)){static get styles(){return[...super.styles,_litElement.css`
        :host {
          display: block;
          padding: 16px 16px 54px 16px;
          background-color: var(--simple-colors-default-theme-grey-1);
          color: var(--simple-colors-default-theme-grey-12);
          --paper-checkbox-unchecked-color: var(
            --simple-colors-default-theme-grey-12
          );
          --paper-checkbox-unchecked-ink-color: var(
            --simple-colors-default-theme-grey-12
          );
          --paper-checkbox-checked-color: var(
            --simple-colors-default-theme-accent-8
          );
          --paper-checkbox-checked-ink-color: var(
            --simple-colors-default-theme-accent-8
          );
          --paper-checkbox-checkmark-color: var(
            --simple-colors-default-theme-grey-1
          );
          --paper-checkbox-label-color: var(
            --simple-colors-default-theme-grey-12
          );
          --paper-checkbox-error-color: var(
            --simple-colors-default-theme-red-8
          );
        }
        :host([accent-color="grey"]),
        :host([accent-color="red"]),
        :host([accent-color="green"]) {
          --paper-checkbox-checked-color: var(
            --simple-colors-default-theme-blue-8
          );
          --paper-checkbox-checked-ink-color: var(
            --simple-colors-default-theme-blue-8
          );
        }
        :host #check {
          background-color: var(--simple-colors-default-theme-accent-8);
          color: var(--simple-colors-default-theme-grey-1);
        }
        :host #check:hover {
          background-color: var(--simple-colors-default-theme-accent-9);
        }
        :host([accent-color="red"]) #check,
        :host([accent-color="green"]) #check {
          background-color: var(--simple-colors-default-theme-blue-8);
          color: var(--simple-colors-default-theme-grey-1);
        }
        :host([accent-color="red"]) #check:hover,
        :host([accent-color="green"]) #check:hover {
          background-color: var(--simple-colors-default-theme-blue-9);
        }
        :host([accent-color="grey"]) #check,
        :host paper-button {
          background-color: var(--simple-colors-default-theme-grey-1);
          color: var(--simple-colors-default-theme-grey-12);
        }
        :host([accent-color="grey"]) #check:hover,
        :host paper-button:hover {
          cursor: pointer;
          background-color: var(--simple-colors-default-theme-grey-2);
          color: var(--simple-colors-default-theme-grey-12);
        }
        .red {
          background-color: var(--simple-colors-default-theme-red-8);
        }
        .green {
          background-color: var(--simple-colors-default-theme-green-8);
        }
        h3 {
          margin: 8px;
        }
        ul {
          list-style: none;
          padding: 0;
          margin: 0;
        }
        ul li {
          padding: 8px;
        }
        paper-radio-button {
          padding: 8px;
          display: block;
        }
        paper-checkbox {
          padding: 8px;
        }
        iron-icon {
          display: inline-flex;
        }
      `]}static get tag(){return"multiple-choice"}constructor(){super(),new Promise((res,rej)=>_require.default(["../../@polymer/paper-toast/paper-toast.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../@polymer/iron-icons/iron-icons.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../@polymer/iron-icon/iron-icon.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../@polymer/paper-button/paper-button.js"],res,rej)),this.randomize=!1,this.hideButtons=!1,this.title="",this.disabled=!1,this.singleOption=!1,this.checkLabel="Check answer",this.resetLabel="Reset",this.hideTitle=!1,this.question="",this.answers=[],this.displayedAnswers=[],this.correctText="Great job!",this.incorrectText="Better luck next time!",this.quizName="default"}updated(changedProperties){super.updated&&super.updated(changedProperties),changedProperties.forEach((oldValue,propName)=>{if(["answers","displayedAnswers"].includes(propName)){let eventName=`${propName.replace(/([a-z0-9]|(?=[A-Z]))([A-Z])/g,"$1-$2").toLowerCase()}-changed`;this.dispatchEvent(new CustomEvent(eventName,{detail:{value:this[propName]}}))}["answers","randomize"].includes(propName)&&(this.displayedAnswers=[...this._computeDisplayedAnswers(this.answers,this.randomize)]),"singleOption"==propName&&this.singleOptionChanged(this[propName])})}singleOptionChanged(singleOption){singleOption?(new Promise((res,rej)=>_require.default(["../../@polymer/paper-radio-group/paper-radio-group.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../@polymer/paper-radio-button/paper-radio-button.js"],res,rej))):new Promise((res,rej)=>_require.default(["../../@polymer/paper-checkbox/paper-checkbox.js"],res,rej))}render(){return _litElement.html`
      <meta property="oer:assessing" content="${this.relatedResource}" />
      ${this.title?_litElement.html`
            <h3><span property="oer:name">${this.title}</span></h3>
          `:""}
      <div>${this.question}</div>
      ${this.singleOption?_litElement.html`
            <paper-radio-group>
              ${this.displayedAnswers.map((answer,index)=>_litElement.html`
                  <paper-radio-button
                    ?disabled="${this.disabled}"
                    property="oer:answer"
                    name="${index}"
                    ?checked="${answer.userGuess}"
                    @checked-changed="${this.checkedEvent}"
                    >${answer.label}</paper-radio-button
                  >
                `)}
            </paper-radio-group>
          `:_litElement.html`
            <ul>
              ${this.displayedAnswers.map((answer,index)=>_litElement.html`
                  <li>
                    <paper-checkbox
                      ?disabled="${this.disabled}"
                      property="oer:answer"
                      name="${index}"
                      ?checked="${answer.userGuess}"
                      @checked-changed="${this.checkedEvent}"
                      >${answer.label}</paper-checkbox
                    >
                  </li>
                `)}
            </ul>
          `}
      ${this.hideButtons?"":_litElement.html`
            <div id="buttons">
              <paper-button
                id="check"
                ?disabled="${this.disabled}"
                raised
                @click="${this._verifyAnswers}"
                >${this.checkLabel}</paper-button
              >
              <paper-button
                id="reset"
                ?disabled="${this.disabled}"
                raised
                @click="${this.resetAnswers}"
                >${this.resetLabel}</paper-button
              >
            </div>
          `}
      <paper-toast
        id="toast"
        scroll-action="cancel"
        duration="6000"
        position-target="${this.positionTarget}"
        class="fit-bottom ${this.__toastColor}"
      >
        ${this.__toastText}
        <iron-icon
          icon="${this.__toastIcon}"
          style="margin-left:16px;"
        ></iron-icon>
      </paper-toast>
    `}checkedEvent(e){let attr=this.displayedAnswers;attr[e.target.name].userGuess=e.detail.value,this.displayedAnswers=[...attr]}static get properties(){return{...super.properties,title:{type:String},positionTarget:{type:Object},disabled:{type:Boolean},singleOption:{type:Boolean,attribute:"single-option"},checkLabel:{type:String,attribute:"check-label"},resetLabel:{type:String,attribute:"reset-label"},relatedResource:{type:String,attribute:"related-resource"},hideTitle:{type:Boolean,attribute:"hide-title"},question:{type:String},answers:{type:Array},displayedAnswers:{type:Array},correctText:{type:String,attribute:"correct-text"},incorrectText:{type:String,attribute:"incorrect-text"},quizName:{type:String,attribute:"quiz-name"},randomize:{type:Boolean,reflect:!0},hideButtons:{type:Boolean,attribute:"hide-buttons"},__toastText:{type:String},__toastColor:{type:String},__toastIcon:{type:String}}}resetAnswers(e){this.shadowRoot.querySelector("#toast").hide(),this.displayedAnswers=[];const answers=this.answers;this.answers.forEach(el=>{el.userGuess=!1}),this.answers=[...answers]}checkAnswers(){let gotRight=!0;for(var i in this.displayedAnswers)0!=gotRight&&this.displayedAnswers[i].correct&&this.displayedAnswers[i].userGuess?gotRight=!0:this.displayedAnswers[i].correct&&!this.displayedAnswers[i].userGuess?gotRight=!1:!this.displayedAnswers[i].correct&&this.displayedAnswers[i].userGuess&&(gotRight=!1);return gotRight}_verifyAnswers(e){this.shadowRoot.querySelector("#toast").hide();let gotRight=this.checkAnswers();gotRight?(this.__toastColor="green",this.__toastIcon="thumb-up",this.__toastText=this.correctText):(this.__toastColor="red",this.__toastIcon="thumb-down",this.__toastText=this.incorrectText),this.shadowRoot.querySelector("#toast").show();let eventData={activityDisplay:"answered",objectName:this.quizName,resultSuccess:gotRight};this.dispatchEvent(new CustomEvent("user-engagement",{bubbles:!0,composed:!0,cancelable:!1,detail:eventData}))}_computeDisplayedAnswers(answers,randomize){if(void 0!==answers&&null!=answers&&answers.length>0&&randomize){let random=answers;for(var temporaryValue,randomIndex,currentIndex=random.length;0!==currentIndex;)randomIndex=Math.floor(Math.random()*currentIndex),temporaryValue=random[currentIndex-=1],random[currentIndex]=random[randomIndex],random[randomIndex]=temporaryValue;return random}return answers}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Multiple choice",description:"Multiple choice self check",icon:"icons:list",color:"purple",groups:["Instructional"],handles:[],meta:{author:"ELMS:LN"}},settings:{quick:[{property:"title",title:"Title",description:"The title of the element",inputMethod:"textfield",icon:"editor:title"},{property:"question",title:"Question",description:"Question for users to respond to.",inputMethod:"textfield",icon:"icons:help"}],configure:[{property:"title",title:"Title",description:"The title of the element",inputMethod:"textfield"},{property:"hideTitle",title:"Hide title",description:"Whether or not to display the title",inputMethod:"boolean"},{property:"question",title:"Question",description:"Question for users to respond to.",inputMethod:"textfield"},{property:"randomize",title:"Randomize",description:"Randomize the answers dynamically",inputMethod:"boolean"},{property:"answers",title:"Answer set",description:"Answers in a multiple choice",inputMethod:"array",itemLabel:"label",properties:[{property:"correct",title:"Correct",description:"If this is correct or not",inputMethod:"boolean"},{property:"label",title:"Answer",description:"Possible answer to the question",inputMethod:"textfield",required:!0}]},{property:"correctText",title:"Correct feedback",description:"Feedback when they get it right",inputMethod:"textfield"},{property:"incorrectText",title:"Incorrect feedback",description:"Feedback when they get it wrong",inputMethod:"textfield"},{property:"quizName",title:"Name of the quiz",description:"Quiz name passed in",inputMethod:"textfield"}],advanced:[{property:"checkLabel",title:"Check answers label",description:"Label for getting solution feedback",inputMethod:"textfield"},{property:"resetLabel",title:"Reset label",description:"label for the reset button",inputMethod:"textfield"}]},saveOptions:{unsetAttributes:["__utils","displayed-answers","displayedAnswers"]}}}preProcessHaxInsertContent(detail){return detail.properties.answers=detail.properties.answers.map((function(val){return val.userGuess&&delete val.userGuess,val})),detail}firstUpdated(changedProperties){super.firstUpdated&&super.firstUpdated(changedProperties),this.shadowRoot.querySelector("#positionTarget")&&(this.positionTarget=this.shadowRoot.querySelector("#positionTarget")),this.setAttribute("typeof","oer:Assessment"),this.shadowRoot.querySelector("#toast").fitInto=this}}_exports.MultipleChoice=MultipleChoice,window.customElements.define(MultipleChoice.tag,MultipleChoice)}));