define(["exports","meta","require","../../lit-element/lit-element.js","../es-global-bridge/es-global-bridge.js","../../@polymer/iron-ajax/iron-ajax.js"],(function(_exports,meta,_require,_litElement,_esGlobalBridge,_ironAjax){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.RssItems=void 0,meta=babelHelpers.interopRequireWildcard(meta),_require=babelHelpers.interopRequireWildcard(_require);
/**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   *
   * Based on https://github.com/TherapyChat/rss-items
   */
class RssItems extends _litElement.LitElement{static get styles(){return[_litElement.css`
        :host([hidden]) {
          display: none;
        }
        :host {
          display: flex;
          flex-wrap: wrap;
          flex-direction: row;
          align-items: flex-start;
          justify-content: space-between;
        }

        :host * {
          box-sizing: border-box;
        }

        h3,
        p {
          margin: 0;
        }

        a {
          color: var(--primary-color, inherit);
          text-decoration: none;
        }

        article {
          margin-bottom: 2em;
        }

        .thumbnail-container {
          display: block;
          overflow: hidden;
          width: 100%;
          height: 180px;
        }

        .thumbnail {
          width: 100%;
          height: 100%;
          transition: transform 0.5s ease-out;
        }

        .thumbnail-container:hover .thumbnail,
        .thumbnail-container:focus .thumbnail {
          transform: scale3d(1.3, 1.3, 1);
        }

        .title {
          min-height: 3em;
          margin: 1em 0 0.5em;
        }

        .excerpt {
          min-height: 6em;
          margin: 0.5em 0 2em;
        }

        @media (max-width: 599px) {
          .title,
          .excerpt {
            min-height: 0;
          }
        }

        @media (min-width: 600px) {
          article {
            flex: 1 1 40%;
            margin-right: 2em;
          }

          article:nth-of-type(2n),
          article:last-of-type {
            margin-right: 0;
          }
        }

        @media (min-width: 900px) {
          article {
            flex: 1 1 30%;
          }

          article:nth-of-type(2n) {
            margin-right: 2em;
          }

          article:nth-of-type(3n) {
            margin-right: 0;
          }
        }
      `]}render(){return _litElement.html`
      <iron-ajax
        id="rssajax"
        url="${this.url}"
        handle-as="xml"
        @last-response-changed="${this.xmlEvent}"
      ></iron-ajax>
      ${this.items.map(item=>_litElement.html`
          <article>
            ${item.imageSrc?_litElement.html`
                  <a
                    class="thumbnail-container"
                    href="${item.link}"
                    title="${item.title}"
                  >
                    <iron-image
                      class="thumbnail"
                      src="${item.imageSrc}"
                      alt="${item.title}"
                      sizing="cover"
                    ></iron-image>
                  </a>
                `:""}
            <a href="${item.link}" title="${item.title}">
              <span class="title"
                >${this._truncateText(item.title,this.maxTitleLength)}</span
              >
            </a>
            <div class="excerpt">
              ${this._truncateText(item.excerpt,this.maxExcerptLength)}
            </div>
            ${this.showReadMore?_litElement.html`
                  <a
                    tabindex="-1"
                    href="${item.link}"
                    class="read-more"
                    title="${item.title}"
                    >${this.readMoreAnchorText}
                    <paper-icon-button
                      icon="icons:arrow-forward"
                      class="read-more-icon"
                      alt="${this.readMoreImageAlt}"
                    ></paper-icon-button>
                  </a>
                `:""}
          </article>
        `)}
    `}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Rss feed",description:"visualize RSS items",icon:"communication:rss-feed",color:"orange",groups:["RSS"],handles:[{type:"rss",source:"source"}],meta:{author:"btopro",owner:"The Pennsylvania State University"}},settings:{quick:[],configure:[{property:"url",title:"Feed URL",description:"URL to the XML feed",inputMethod:"textfield"},{property:"max",title:"Max items",description:"Max number of feed items to display",inputMethod:"number"}],advanced:[]}}}static get properties(){return{...super.properties,auto:{type:Boolean},items:{type:Array},max:{type:Number},maxExcerptLength:{type:Number,attribute:"max-excerpt-length"},maxTitleLength:{type:Number,attribute:"max-title-length"},readMoreAnchorText:{type:Boolean,attribute:"read-more-anchor-text"},readMoreImageAlt:{type:Boolean,attribute:"read-more-image-alt"},showReadMore:{type:Boolean,attribute:"show-read-more"},url:{type:String},xml:{type:Object}}}static get tag(){return"rss-items"}initRequest(){this.shadowRoot.querySelector("#rssajax").generateRequest()}_maxChanged(newValue){this.xml&&newValue&&this._x2js&&this.__ready&&this.xmlToItems(this.xml)}xmlToItems(newValue){if(newValue&&this._x2js&&this.__ready){var json=(new X2JS).xml2json(newValue);if(json){var items=json.rss?json.rss.channel.item:json.channel.item;items=void 0===this.max?items:items.splice(0,this.max),this.items=[...this._parseItems(items)]}}}_urlChanged(newValue){newValue&&this._x2js&&this.__ready&&this.initRequest()}xmlEvent(e){this.xml={},setTimeout(()=>{this.xml=e.detail.value},0)}_parseItems(items){return items.map(item=>(item.excerpt=this._getItemExcerpt(item),item.imageSrc=this._getItemImageScr(item),item))}_getItemExcerpt(item){var element=document.createElement("div");return element.innerHTML=item.description,element.textContent.trim()}_getItemImageScr(item){if(item.thumbnail&&item.thumbnail._url)return item.thumbnail._url;var element=document.createElement("div");return element.innerHTML=item.description,(element.querySelector("img")||{}).src||""}_truncateText(text,maxLength){if(text)return maxLength&&text.length>maxLength?text.substr(0,maxLength)+"...":text}pathFromUrl(url){return url.substring(0,url.lastIndexOf("/")+1)}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{if(["items"].includes(propName)){let eventName=`${propName.replace(/([a-z0-9]|(?=[A-Z]))([A-Z])/g,"$1-$2").toLowerCase()}-changed`;this.dispatchEvent(new CustomEvent(eventName,{detail:{value:this[propName]}}))}"max"==propName&&this._maxChanged(this[propName],oldValue),"url"==propName&&this._urlChanged(this[propName],oldValue),"xml"==propName&&this.xmlToItems(this[propName],oldValue)})}constructor(){super(),this.items=[],this.auto=!1,this.max=10,this.maxExcerptLength=100,this.maxTitleLength=50,this.readMoreAnchorText="Read more",this.readMoreImageAlt="",this.showReadMore=!1,new Promise((res,rej)=>_require.default(["../../@polymer/iron-image/iron-image.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../@polymer/paper-icon-button/paper-icon-button.js"],res,rej)),new Promise((res,rej)=>_require.default(["../../@polymer/iron-icons/iron-icons.js"],res,rej));const location=`${this.pathFromUrl(decodeURIComponent(meta.url))}lib/x2js.js`;window.ESGlobalBridge.requestAvailability(),window.ESGlobalBridge.instance.load("x2js",location),window.addEventListener("es-bridge-x2js-loaded",this._x2jsLoaded.bind(this))}_x2jsLoaded(e){this._x2js=!0,this.__ready&&(this.auto?this.shadowRoot.querySelector("#rssajax").auto=this.auto:this.initRequest())}firstUpdated(){this.__ready=!0,this._x2js&&(this.auto?this.shadowRoot.querySelector("#rssajax").auto=this.auto:this.initRequest())}disconnectedCallback(){window.removeEventListener(`es-bridge-${name}-loaded`,this._x2jsLoaded.bind(this)),super.disconnectedCallback()}}_exports.RssItems=RssItems,window.customElements.define(RssItems.tag,RssItems)}));