define(["exports","../../lit-element/lit-element.js","../simple-colors/simple-colors.js","../schema-behaviors/schema-behaviors.js","../media-behaviors/media-behaviors.js","../a11y-media-player/a11y-media-player.js"],(function(_exports,_litElement,_simpleColors,_schemaBehaviors,_mediaBehaviors,_a11yMediaPlayer){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.VideoPlayer=void 0;
/**
   * Copyright 2018 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class VideoPlayer extends((0,_mediaBehaviors.MediaBehaviorsVideo)((0,_schemaBehaviors.SchemaBehaviors)(_simpleColors.SimpleColors))){static get styles(){return[...super.styles,_litElement.css`
        :host {
          display: block;
          margin: 0 0 15px;
        }
        .video-caption {
          font-style: italic;
          margin: 0;
          padding: 8px;
        }
      `]}render(){return _litElement.html`
      ${this.isA11yMedia?_litElement.html`
            <a11y-media-player
              .accent-color="${this.accentColor||void 0}"
              ?audio-only="${this.audioOnly}"
              ?dark="${this.dark}"
              ?dark-transcript="${this.darkTranscript}"
              ?disable-interactive="${this.disableInteractive}"
              ?hide-timestamps="${this.hideTimestamps}"
              ?hide-transcript="${this.hideTiranscript}"
              id="${this.playerId}"
              lang="${this.lang||"en"}"
              ?linkable="${this.linkable}"
              preload="${this.preload||"metadata"}"
              .media-title="${this.mediaTitle||void 0}"
              .sources="${this.sourceData}"
              ?stand-alone="${this.standAlone}"
              sticky-corner="${this.stickyCorner||"top-right"}"
              .thumbnail-src="${this.thumbnailSrc}"
              .tracks="${this.trackData}"
              .crossorigin="${this.crossorigin?this.crossorigin:void 0}"
              .width="${this.width}"
              .height="${this.height}"
            >
              ${this.youtubeId?_litElement.html`
                    <iframe
                      width="${this.width||"560"}"
                      height="${this.height||"315"}"
                      src="https://www.youtube.com/embed/${this.youtubeId}"
                      allowfullscreen
                      frameborder="0"
                    ></iframe>
                  `:_litElement.html``}
              ${this.audioOnly?_litElement.html`
                    <audio preload="${this.preload||"metadata"}">
                      ${this.html5}
                    </audio>
                  `:_litElement.html`
                    <video preload="${this.preload||"metadata"}">
                      ${this.html5}
                    </video>
                  `}
            </a11y-media-player>
          `:_litElement.html`
            <div
              class="responsive-video-container"
              .lang="${this.lang||void 0}"
            >
              ${this.sandboxed?_litElement.html``:_litElement.html`
                    <webview
                      resource="${this.schemaResourceID}-video"
                      .src="${this.sourceData&&this.sourceData[0]&&this.sourceData[0].src||void 0}"
                      .width="${this.width||void 0}"
                      .height="${this.height||void 0}"
                      frameborder="0"
                    >
                    </webview>
                  `}
              ${this.sandboxed||!this.iframed?_litElement.html``:_litElement.html`
                    <iframe
                      resource="${this.schemaResourceID}-video"
                      .src="${this.sourceData&&this.sourceData[0]&&this.sourceData[0].src||void 0}"
                      width="${this.width}"
                      height="${this.height}"
                      frameborder="0"
                      webkitallowfullscreen=""
                      mozallowfullscreen=""
                      allowfullscreen=""
                    ></iframe>
                  `}
            </div>
            <div id="videocaption" class="video-caption">
              <p>
                ${this.mediaTitle}
                <span class="media-type print-only">(embedded media)</span>
              </p>
              <slot name="caption"></slot>
              <slot hidden></slot>
            </div>
          `}
    `}static get haxProperties(){return{canScale:{min:25,step:12.5},canPosition:!0,canEditSource:!1,gizmo:{title:"Video player",description:"This can present video in a highly accessible manner regardless of source.",icon:"av:play-circle-filled",color:"red",groups:["Video","Media"],handles:[{type:"video",source:"source",title:"caption",caption:"caption",description:"caption",color:"primaryColor"}],meta:{author:"LRNWebComponents"}},settings:{quick:[{property:"accentColor",title:"Accent color",description:"Select the accent color for the player.",inputMethod:"colorpicker",icon:"editor:format-color-fill"},{attribute:"dark",title:"Dark theme",description:"Enable dark theme for the player.",inputMethod:"boolean",icon:"invert-colors"}],configure:[{property:"source",title:"Source",description:"The URL for this video.",inputMethod:"haxupload",icon:"link",required:!0,noCamera:!0,noVoiceRecord:!0,validationType:"url"},{property:"track",title:"Closed captions",description:"The URL for the captions file.",inputMethod:"textfield",icon:"link",required:!0,validationType:"url"},{property:"thumbnailSrc",title:"Thumbnail image",description:"Optional. The URL for a thumbnail/poster image.",inputMethod:"haxupload",icon:"link",required:!0,noVoiceRecord:!0,validationType:"url"},{property:"mediaTitle",title:"Title",description:"Simple title for under video",inputMethod:"textfield",icon:"av:video-label",required:!1,validationType:"text"},{property:"accentColor",title:"Accent color",description:"Select the accent color for the player.",inputMethod:"colorpicker",icon:"editor:format-color-fill"},{attribute:"dark",title:"Dark theme",description:"Enable dark theme for the player.",inputMethod:"boolean",icon:"invert-colors"}],advanced:[{property:"darkTranscript",title:"Dark theme for transcript",description:"Enable dark theme for the transcript.",inputMethod:"boolean"},{property:"hideTimestamps",title:"Hide timestamps",description:"Hide the time stamps on the transcript.",inputMethod:"boolean"},{property:"linkable",title:"Include a share link?",description:"Provides a link to share the video.",inputMethod:"boolean"},{property:"preload",title:"Preload source(s).",description:"How the sources should be preloaded, i.e. auto, metadata (default), or none.",inputMethod:"select",options:{preload:"Preload all media",metadata:"Preload media metadata only",none:"Don't preload anything"}},{property:"stickyCorner",title:"Sticky Corner",description:"Set the corner where a video plays when scrolled out of range, or choose none to disable sticky video.",inputMethod:"select",options:{none:"none","top-left":"top-left","top-right":"top-right","bottom-left":"bottom-left","bottom-right":"bottom-right"}},{property:"sources",title:"Other sources",description:"List of other sources",inputMethod:"array",properties:[{property:"src",title:"Source",description:"The URL for this video.",inputMethod:"textfield"},{property:"type",title:"Type",description:"Media type data",inputMethod:"select",options:{"audio/aac":"acc audio","audio/flac":"flac audio","audio/mp3":"mp3 audio","video/mp4":"mp4 video","video/mov":"mov video","audio/ogg":"ogg audio","video/ogg":"ogg video","audio/wav":"wav audio","audio/webm":"webm audio","video/webm":"webm video"}}]},{property:"tracks",title:"Track list",description:"Tracks of different languages of closed captions",inputMethod:"array",properties:[{property:"kind",title:"Kind",description:"Kind of track",inputMethod:"select",options:{subtitles:"subtitles"}},{property:"label",title:"Label",description:'The human-readable name for this track, eg. "English Subtitles"',inputMethod:"textfield"},{property:"src",title:"Source",description:"Source of the track",inputMethod:"textfield"},{property:"srclang",title:'Two letter, language code, eg. \'en\' for English, "de" for German, "es" for Spanish, etc.',description:"Label",inputMethod:"textfield"}]}]}}}static get properties(){return{...super.properties,audioOnly:{type:Boolean},accentColor:{type:String,attribute:"accent-color",reflect:!0},crossorigin:{type:String,attribute:"crossorigin",reflect:!0},dark:{type:Boolean,attribute:"dark",reflect:!0},darkTranscript:{type:Boolean},disableInteractive:{type:Boolean},height:{type:String},hideTimestamps:{type:Boolean},hideTranscript:{type:Boolean},id:{type:String,attribute:"id",reflect:!0},lang:{type:String},linkable:{type:Boolean},mediaTitle:{type:String},playerId:{type:String},preload:{type:String},source:{type:String,attribute:"source",reflect:!0},sources:{type:Array},stickyCorner:{type:String,attribute:"sticky-corner",reflect:!0},track:{type:String},tracks:{type:Array},thumbnailSrc:{type:String,attribute:"thumbnail-src",reflect:!0},width:{type:String}}}static get tag(){return"video-player"}constructor(){super(),this.audioOnly=!1,this.dark=!1,this.darkTranscript=!1,this.disableInteractive=!1,this.hideTimestamps=!1,this.hideTranscript=!1,this.lang="en",this.linkable=!1,this.preload="metadata",this.sources=[],this.stickyCorner="top-right",this.tracks=[]}get html5(){return _litElement.html`
      ${this.sourceData.filter(item=>"youtube"!==item.type).map(sd=>{_litElement.html`
            <source
              .src="${sd.src||void 0}"
              .type="${sd.type||void 0}"
            />
          `})}
      ${this.trackData.map(track=>{track.src,track.kind,track.label,track.lang})}
    `}get iframed(){return!(!(this.sourceData&&this.sourceData.length>0&&void 0!==this.sourceData[0]&&window.MediaBehaviors.Video._sourceIsIframe(this.sourceData[0].src))||this.sandboxed)}get isA11yMedia(){return!(this.sandboxed||"youtube"!=this.sourceType&&"local"!=this.sourceType)}get sandboxed(){if(this.sourceData&&this.sourceData.length>0&&void 0!==typeof this.sourceData[0]&&window.MediaBehaviors.Video._sourceIsIframe(this.sourceData[0].src)){if("function"==typeof document.createElement("webview").reload)return!0}return!1}get sourceData(){let temp="string"==typeof this.sources?JSON.parse(this.sources):this.sources.slice(),slotted=this.querySelectorAll("video source, audio source, iframe");return this.source&&temp.unshift({src:this.source}),slotted.forEach(slot=>{this.sources.unshift({src:slot.src}),slot.remove()}),temp&&temp.length>0&&temp.forEach(item=>{item.type=item.type||this._computeMediaType(item.src),item.src=this._computeSRC(item.src,item.type)}),temp}get standAlone(){return void 0===this.trackData||null===this.trackData||this.trackData.length<1}get sourceType(){return this.sourceData&&this.sourceData.length>0&&void 0!==this.sourceData[0]&&void 0!==this.sourceData[0].src?window.MediaBehaviors.Video.getVideoType(this.sourceData[0].src):null}get trackData(){let temp="string"==typeof this.tracks?JSON.parse(this.tracks).slice():this.tracks.slice();return this.querySelectorAll("video track, audio track").forEach(slot=>{let track={src:slot.src};slot.lang&&(track.lang=slot.lang),slot.srclang&&(track.srclang=slot.srclang),slot.label&&(track.label=slot.label),slot.kind&&(track.kind=slot.kind),this.tracks.unshift(track),slot.remove()}),void 0!==this.track&&null!==this.track&&""!==this.track&&temp.push({src:this.track,srclang:this.lang,label:"en"===this.lang?"English":this.lang,kind:"subtitles"}),temp}get youtubeId(){if(this.sourceData&&this.sourceData[0]&&"youtube"===this.sourceType)return this._computeSRC(this.sourceData[0].src).replace(/.*\/embed\//,"")}get playerId(){return`${this.id||this.schemaResourceID}-media`}_computeMediaType(source){let type="",findType=(text,data)=>{data.forEach(item=>{""===type&&void 0!==typeof source&&null!==source&&source.toLowerCase().indexOf("."+item)>-1&&("audio"===text&&(this.audioOnly=!0),type=text+"/"+item)})};return findType("audio",["aac","flac","mp3","oga","wav"]),findType("video",["mov","mp4","ogv","webm"]),type}_computeSRC(source,type){return null!==source&&void 0!==typeof source&&(type=type||window.MediaBehaviors.Video.getVideoType(source),source=window.MediaBehaviors.Video.cleanVideoSource(source,type),"vimeo"==type?(this.vimeoTitle?source+="?title=1":source+="?title=0",this.vimeoByline?source+="&byline=1":source+="&byline=0",this.vimeoPortrait?source+="&portrait=1":source+="&portrait=0"):"dailymotion"==type&&(source+="&ui-start-screen-info=false",source+="&ui-logo=false",source+="&sharing-enable=false",source+="&endscreen-enable=false")),source}postProcesshaxNodeToContent(content){return content=(content=content.replace(' sources="[]",',"")).replace(' tracks="[]",',"")}}_exports.VideoPlayer=VideoPlayer,window.customElements.define(VideoPlayer.tag,VideoPlayer)}));