define(["../../polymer/polymer-legacy.js","../../iron-flex-layout/iron-flex-layout.js","../../iron-resizable-behavior/iron-resizable-behavior.js","../../polymer/lib/legacy/polymer-fn.js","../../polymer/lib/utils/html-tag.js","../app-scroll-effects/app-scroll-effects-behavior.js"],(function(_polymerLegacy,_ironFlexLayout,_ironResizableBehavior,_polymerFn,_htmlTag,_appScrollEffectsBehavior){
/**
  @license
  Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
  This code may only be used under the BSD style license found at
  http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
  http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
  found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
  part of the polymer project is also subject to an additional IP rights grant
  found at http://polymer.github.io/PATENTS.txt
  */
(0,_polymerFn.Polymer)({_template:_htmlTag.html`
    <style>
      :host {
        position: relative;
        display: block;
      }

      #background {
        @apply --layout-fit;
        overflow: hidden;
        height: 100%;
      }

      #backgroundFrontLayer {
        min-height: 100%;
        pointer-events: none;
        background-size: cover;
        @apply --app-box-background-front-layer;
      }

      #contentContainer {
        position: relative;
        width: 100%;
        height: 100%;
      }

      :host([disabled]),
      :host([disabled]) #backgroundFrontLayer {
        transition: none !important;
      }
    </style>

    <div id="background">
      <div id="backgroundFrontLayer">
        <slot name="background"></slot>
      </div>
    </div>
    <div id="contentContainer">
      <slot></slot>
    </div>
`,is:"app-box",behaviors:[_appScrollEffectsBehavior.AppScrollEffectsBehavior,_ironResizableBehavior.IronResizableBehavior],listeners:{"iron-resize":"_resizeHandler"},_progress:0,attached:function(){this.resetLayout()},_debounceRaf:function(fn){var self=this;this._raf&&window.cancelAnimationFrame(this._raf),this._raf=window.requestAnimationFrame((function(){self._raf=null,fn.call(self)}))},resetLayout:function(){this._debounceRaf((function(){if(0!==this.offsetWidth||0!==this.offsetHeight){var scrollTop=this._clampedScrollTop,savedDisabled=this.disabled;this.disabled=!0,this._elementTop=this._getElementTop(),this._elementHeight=this.offsetHeight,this._cachedScrollTargetHeight=this._scrollTargetHeight,this._setUpEffect(),this._updateScrollState(scrollTop),this.disabled=savedDisabled}}))},_getElementTop:function(){for(var currentNode=this,top=0;currentNode&&currentNode!==this.scrollTarget;)top+=currentNode.offsetTop,currentNode=currentNode.offsetParent;return top},_updateScrollState:function(scrollTop){if(this.isOnScreen()){var viewportTop=this._elementTop-scrollTop;this._progress=1-(viewportTop+this._elementHeight)/this._cachedScrollTargetHeight,this._runEffects(this._progress,scrollTop)}},isOnScreen:function(){return this._elementTop<this._scrollTop+this._cachedScrollTargetHeight&&this._elementTop+this._elementHeight>this._scrollTop},_resizeHandler:function(){this.resetLayout()},_getDOMRef:function(id){return"background"===id?this.$.background:"backgroundFrontLayer"===id?this.$.backgroundFrontLayer:void 0},getScrollState:function(){return{progress:this._progress}}})}));