/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement,html,css}from"../../lit-element/lit-element.js";import"../responsive-utility/responsive-utility.js";import"../../@polymer/paper-button/paper-button.js";import"../../@polymer/iron-icons/iron-icons.js";import"../simple-tooltip/simple-tooltip.js";import"./lib/a11y-tab.js";class A11yTabs extends LitElement{static get styles(){return[css`
        :host {
          display: block;
          --a11y-tabs-border-radius: 2px;
          --a11y-tabs-justify-tabs: flex-start;
          --ally-tabs-wrap: unset;
          --a11y-tabs-background: white;
          --a11y-tabs-border-color: #ddd;
          --a11y-tabs-color: #222;
          --a11y-tabs-focus-color: #000;
          --a11y-tabs-faded-background: #eee;
          --a11y-tabs-content-padding: 16px;
          --a11y-tabs-button-padding: 0.7em 0.57em;
          --a11y-tabs-vertical-button-padding: unset;
          --a11y-tabs-horizontal-border-radius: unset;
          --a11y-tabs-vertical-border-radius: unset;
          --a11y-tabs-horizontal-button-padding: 2px 5px;
          height: var(--a11y-tabs-height);
          overflow: var(--a11y-tabs-overflow);
        }
        :host([vertical]) {
          border: 1px solid var(--a11y-tabs-border-color);
          border-radius: var(
            --a11y-tabs-vertical-border-radius,
            var(--a11y-tabs-border-radius)
          );
          display: flex;
          justify-content: space-between;
          align-items: stretch;
        }
        :host([hidden]) {
          display: none;
        }
        :host #tabs {
          align-items: stretch;
          flex-wrap: var(--ally-tabs-wrap, unset);
          margin: 0;
          display: flex;
          list-style: none;
          padding: 0;
        }
        :host([vertical]) #tabs {
          background-color: var(--a11y-tabs-border-color);
          justify-content: var(
            --a11y-tabs-vertical-justify-tabs,
            var(--a11y-tabs-justify-tabs, flex-start)
          );
          flex-wrap: var(
            --ally-tabs-vertical-wrap,
            var(--ally-tabs-wrap, unset)
          );
          border-left: none;
          flex: 0 1 auto;
          flex-direction: column;
        }
        :host(:not([vertical])) #tabs {
          justify-content: var(
            --a11y-tabs-horizontal-justify-tabs,
            var(--a11y-tabs-justify-tabs, flex-start)
          );
        }
        :host #tabs .flag-type {
          position: absolute;
          left: -99999px;
          height: 0;
          overflow: hidden;
        }
        :host #content {
          padding: var(--a11y-tabs-content-padding);
          background-color: var(--a11y-tabs-background);
          border: 1px solid var(--a11y-tabs-border-color);
        }
        :host([vertical]) #content {
          flex: 1 0 auto;
          border: none;
        }
        :host(:not([vertical])) #content {
          border-radius: var(
            --a11y-tabs-horizontal-border-radius,
            var(--a11y-tabs-border-radius)
          );
          margin-top: -1px;
        }
        :host #tabs paper-button {
          margin: 0;
          text-transform: unset;
          color: var(--a11y-tabs-color);
          background-color: var(--a11y-tabs-faded-background);
          border: 1px solid var(--a11y-tabs-border-color);
          padding: var(--a11y-tabs-button-padding, 0.7em 0.57em);
        }
        :host([vertical]) #tabs paper-button {
          border-top: none;
          border-left: none;
          border-radius: 0;
          display: flex;
          justify-content: space-between;
          align-items: center;
          padding: var(
            --a11y-tabs-vertical-button-padding,
            var(--a11y-tabs-button-padding)
          );
        }
        :host(:not([vertical])) #tabs paper-button {
          width: 100%;
          border-bottom: none;
          border-radius: var(
              --a11y-tabs-horizontal-border-radius,
              var(--a11y-tabs-border-radius)
            )
            var(
              --a11y-tabs-horizontal-border-radius,
              var(--a11y-tabs-border-radius)
            )
            0 0;
          padding: var(
            --a11y-tabs-horizontal-button-padding,
            var(--a11y-tabs-button-padding)
          );
        }
        :host(:not([vertical])) #tabs li:not(:first-of-type) paper-button {
          border-left: none;
        }
        :host #tabs paper-button:active,
        :host #tabs paper-button:focus,
        :host #tabs paper-button:hover {
          color: var(--a11y-tabs-focus-color);
          background-color: var(--a11y-tabs-faded-background);
        }
        :host #tabs paper-button[disabled] {
          color: var(--a11y-tabs-focus-color);
          background-color: var(--a11y-tabs-background);
        }
        :host([vertical]) #tabs paper-button[disabled] {
          border-right-color: var(--a11y-tabs-background);
        }
        :host(:not([vertical])) #tabs paper-button[disabled] {
          border-bottom: 1px solid var(--a11y-tabs-background);
        }
        :host #tabs span.label,
        :host #tabs .flag-icon {
          margin-right: 8px;
        }
        :host #tabs.icons-only paper-button {
          justify-content: center;
        }
        :host #tabs.icons-only span.label {
          display: none;
        }
        :host #tabs:not(.icons-only) simple-tooltip {
          display: none;
        }
      `]}render(){return html`
      <ul
        id="tabs"
        .class="${this._showIcons(this.__hasIcons,this.iconBreakpoint,this.layoutBreakpoint,this.responsiveSize)}"
      >
        ${this.__items.map(tab=>html`
            <li>
              <paper-button
                id="${tab.id}-button"
                controls="${tab.id}"
                @click="${e=>this._handleTab(`${tab.id}`)}"
                ?disabled="${tab.id===this.activeTab}"
                .flag="${tab.flag}"
              >
                <iron-icon
                  class="flag-icon"
                  ?hidden="${!tab.flagIcon}"
                  .icon="${tab.flagIcon}"
                >
                </iron-icon>
                <span class="label">${tab.label}</span>
                <span class="flag-type" ?hidden="${!tab.flag}">
                  ${tab.flag}
                </span>
                <iron-icon
                  class="icon"
                  ?hidden="${!tab.icon}"
                  .icon="${tab.icon}"
                >
                </iron-icon>
              </paper-button>
              <simple-tooltip for="${tab.id}-button"
                >${tab.label}</simple-tooltip
              >
            </li>
          `)}
      </ul>
      <div id="content">
        <slot></slot>
      </div>
    `}static get haxProperties(){return{}}static get properties(){return{...super.properties,activeTab:{type:String,attribute:"active-tab"},disabled:{type:Boolean,reflect:!0},hidden:{type:Boolean,reflect:!0},iconBreakpoint:{type:Number,attribute:"icon-breakpoint"},id:{type:String,reflect:!0},layoutBreakpoint:{type:Number,attribute:"layout-breakpoint"},responsiveSize:{type:String,reflect:!0,attribute:"responsive-size"},vertical:{type:Boolean,reflect:!0},__hasIcons:{type:Boolean},__items:{type:Array},__observer:{type:Object}}}static get tag(){return"a11y-tabs"}constructor(){super();this.activeTab=null,this.disabled=!1,this.hidden=!1,this.iconBreakpoint=400,this.id=null,this.layoutBreakpoint=600,this.responsiveSize="xs",this.vertical=!1,this.__hasIcons=!1,this.__items=[],this.updateItems(),this.__observer=new MutationObserver((mutationsList,observer)=>this.updateItems()),this._breakpointChanged(),window.ResponsiveUtility.requestAvailability(),this.__observer.observe(this,{attributes:!1,childList:!0,subtree:!1}),this.addEventListener("a11y-tab-changed",e=>this.updateItems())}connectedCallback(){super.connectedCallback()}disconnectedCallback(){this.__observer&&this.__observer.disconnect&&this.__observer.disconnect(),this.removeEventListener("a11y-tab-changed",e=>this.updateItems()),this._unsetBreakpoints(),super.disconnectedCallback()}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{"id"===propName&&this._idChanged(this.id,oldValue),"activeTab"===propName&&this.selectTab(this.activeTab),"iconBreakpoint"===propName&&this._breakpointChanged(),"layoutBreakpoint"===propName&&this._breakpointChanged(),"responsiveSize"===propName&&this._setVertical()})}selectTab(id){let tabs=this.querySelectorAll("a11y-tab"),selected=id&&this.querySelector(`a11y-tab#${id}`)?this.querySelector(`a11y-tab#${id}`):this.querySelector("a11y-tab");selected&&selected.id!==id?this.activeTab=selected.id:tabs&&tabs.length>0&&tabs.forEach(tab=>{tab.hidden=tab.id!==id})}updateItems(e){this.__items=[];let tabs=this.querySelectorAll("a11y-tab");this.__hasIcons=!0,this.id||(this.id=this._generateUUID()),tabs&&tabs.length>0&&tabs.forEach(tab=>{this.__items.push({id:tab.id||"tab-1",flag:tab.flag,flagIcon:tab.flagIcon,icon:tab.icon,label:tab.label||"Tab 1"}),tab.icon||(this.__hasIcons=!1),tab.__xOfY=`1 of ${tabs.length}`,tab.__toTop=this.id}),this.selectTab(this.activeTab)}_activeTabChanged(newValue){this.selectTab(newValue)}_breakpointChanged(){this._unsetBreakpoints(),this._setBreakpoints(),this._setVertical()}_generateUUID(){return"ss-s-s-s-sss".replace(/s/g,Math.floor(65536*(1+Math.random())).toString(16).substring(1))}_handleTab(id){this.activeTab=id}_idChanged(newValue,oldValue){newValue||(this.id="a11y-tabs"+this._generateUUID())}_setBreakpoints(){let v=this.layoutBreakpoint>-1?this.layoutBreakpoint:0,i=this.iconBreakpoint>-1?this.iconBreakpoint:0,sm=i>v?v:i,md=i>v?i:v,lg=Math.max(i,v)+1,xl=Math.max(i,v)+2;window.dispatchEvent(new CustomEvent("responsive-element",{detail:{element:this,attribute:"responsive-size",relativeToParent:!0,sm,md,lg,xl}}))}_setVertical(){this.vertical=-1===this.layoutBreakpoint||this.iconBreakpoint>this.layoutBreakpoint?"xs"===this.responsiveSize:this.responsiveSize.indexOf("s")>-1}_showIcons(hasIcons,icon,layout,size){return hasIcons&&-1!==icon&&("xs"===size||icon>layout&&"sm"===size)?"icons-only":""}_unsetBreakpoints(){window.dispatchEvent(new CustomEvent("responsive-element-deleted",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}}window.customElements.define(A11yTabs.tag,A11yTabs);export{A11yTabs};