import{LitElement,html,css}from"../../../lit-element/lit-element.js";import{wipeSlot}from"../../utils/utils.js";import"../../../@polymer/iron-ajax/iron-ajax.js";class CMSToken extends LitElement{static get styles(){return[css`
        :host {
          display: inline;
          min-width: 112px;
          min-height: 112px;
          transition: 0.6s all ease;
          background-color: transparent;
        }
        #replacementcontent {
          transition: 0.6s all ease;
          visibility: visible;
          opacity: 1;
          height: auto;
          width: auto;
        }
        :host([loading]) {
          text-align: center;
        }
        :host([loading]) #replacementcontent {
          opacity: 0;
          visibility: hidden;
          height: 0;
          width: 0;
        }
      `]}render(){return html`
      <iron-ajax
        id="tokenrequest"
        method="GET"
        url="${this.tokenEndPoint}"
        handle-as="json"
        @last-response-changed="${this.tokenDataChanged}"
      ></iron-ajax>
      ${this.loading?html`
            <hexagon-loader
              item-count="4"
              loading
              size="small"
            ></hexagon-loader>
          `:html``}
      <span id="replacementcontent"><slot></slot></span>
    `}tokenDataChanged(e){this.tokenData=e.detail.value}constructor(){super(),this.loading=!1,this.tokenPrefix="[",this.tokenSuffix="]",this._clickInvoked=!1,this._displayMode="full",import("../../hexagon-loader/hexagon-loader.js")}static get tag(){return"cms-token"}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{["token","_clickInvoked"].includes(propName)&&(this.bodyData=this._generateBodyData(this.token,this._clickInvoked)),"bodyData"==propName&&this._bodyDataChanged(this[propName]),"tokenData"==propName&&this._handleTokenResponse(this[propName]),"_displayMode"==propName&&this._displayModeChanged(this[propName])})}static get properties(){return{loading:{type:Boolean,reflect:!0},token:{type:String,reflect:!0},tokenEndPoint:{type:String,attribute:"token-end-point"},bodyData:{type:Object},_clickInvoked:{type:String},tokenData:{type:String,attribute:"token-data"},tokenPrefix:{type:String,attribute:"token-prefix"},tokenSuffix:{type:String,attribute:"token-suffix"},_displayMode:{type:String}}}_displayModeChanged(newValue,oldValue){void 0!==newValue&&""!=newValue&&void 0!==this.token&&(this.token=this.token.replace(oldValue,newValue))}_generateBodyData(token,$editingState){if(null!==token&&""!==token){return{token:`${this.tokenPrefix}${token}${this.tokenSuffix}`,cachedResponse:$editingState}}}_handleTokenResponse(newValue){if(null!==newValue&&void 0!==newValue.content){null!=document.getElementById("cmstokenidtolockonto")&&(document.getElementById("cmstokenidtolockonto").setAttribute("href",newValue.editEndpoint),document.getElementById("cmstokenidtolockonto").innerHTML=newValue.editText,document.getElementById("cmstokenidtolockonto").addEventListener("click",this.__tokenClicked.bind(this))),wipeSlot(this);let template=document.createElement("template");template.innerHTML=newValue.content,this.appendChild(document.importNode(template.content,!0)),this.loading=!1}}_bodyDataChanged(newValue){void 0===newValue||""===newValue||this.loading||(void 0===this.tokenEndPoint&&void 0!==window.cmstokenEndPoint&&(this.tokenEndPoint=window.cmstokenEndPoint),this.tokenEndPoint&&(this.loading=!0,this.shadowRoot.querySelector("#tokenrequest").body=newValue,this.shadowRoot.querySelector("#tokenrequest").generateRequest()))}_windowVisibilityChanged(e){!this.loading&&this._clickInvoked&&(this.shadowRoot.querySelector("#tokenrequest").generateRequest(),this._clickInvoked=!1)}__tokenClicked(e){this._clickInvoked=!0}connectedCallback(){super.connectedCallback(),setTimeout(()=>{document.addEventListener("visibilitychange",this._windowVisibilityChanged.bind(this))},0)}disconnectedCallback(){document.removeEventListener("visibilitychange",this._windowVisibilityChanged.bind(this)),super.disconnectedCallback()}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"CMS Token",description:"CMS token rendered on the backend",icon:"icons:code",color:"light-blue",groups:["CMS"],handles:[{type:"cmstoken",token:"token"}],meta:{author:"ELMS:LN"}},settings:{quick:[],configure:[{property:"token",title:"Token",description:"Token from our CMS",inputMethod:"textfield",icon:"editor:title"}],advanced:[]},saveOptions:{wipeSlot:!0,unsetAttributes:["loading","token-data","body-data","token-end-point"]}}}postProcessgetHaxJSONSchema(schema){let href="",slot="Edit";if(void 0!==this.tokenData)for(var i in href=this.tokenData.editEndpoint,slot=this.tokenData.editText,this.tokenData.schema)schema.properties[i]=this.tokenData.schema[i];return schema.properties.__editThis={type:"string",component:{name:"a",properties:{id:"cmstokenidtolockonto",href,target:"_blank"},slot}},schema}}window.customElements.define(CMSToken.tag,CMSToken);export{CMSToken};