import{LitElement,html,css}from"../../../lit-element/lit-element.js";import{wipeSlot}from"../../utils/utils.js";import"../../../@polymer/iron-ajax/iron-ajax.js";class CMSViews extends LitElement{static get styles(){return[css`
        :host {
          display: block;
          min-width: 112px;
          min-height: 112px;
          transition: 0.6s all ease;
          background-color: transparent;
        }
        #replacementcontent {
          visibility: visible;
          opacity: 1;
        }
        :host([loading]) {
          text-align: center;
        }
        :host([loading]) #replacementcontent {
          opacity: 0;
          visibility: hidden;
        }
      `]}render(){return html`
      <iron-ajax
        id="viewsrequest"
        method="GET"
        url="${this.viewsEndPoint}"
        handle-as="json"
        @last-response-changed="${this.viewsDataChanged}"
      ></iron-ajax>
      ${this.loading?html`
            <hexagon-loader
              item-count="4"
              loading
              size="small"
            ></hexagon-loader>
          `:html``}
      <span id="replacementcontent"><slot></slot></span>
    `}viewsDataChanged(e){this.viewsData=e.detail.value}static get tag(){return"cms-views"}constructor(){super(),this.loading=!1,this.viewsPrefix="[",this.viewsSuffix="]",import("../../hexagon-loader/hexagon-loader.js")}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{["viewsName","viewsDisplay"].includes(propName)&&(this.bodyData=this._generateBodyData(this.viewsName,this.viewsDisplay)),"bodyData"==propName&&this._viewsChanged(this[propName]),"viewsData"==propName&&this._handleviewsResponse(this[propName])})}static get properties(){return{loading:{type:Boolean,reflect:!0},viewsName:{type:String,reflect:!0,attribute:"views-name"},viewsDisplay:{type:String,reflect:!0,attribute:"views-display"},viewsEndPoint:{type:String,attribute:"views-end-point"},viewsPrefix:{type:String,attribute:"views-prefix"},viewsSuffix:{type:String,attribute:"views-suffix"},bodyData:{type:Object},viewsData:{type:String,attribute:"views-data"}}}_generateBodyData(name,display){if(null!==name&&""!==name)return{name:`${name}`,display:`${display}`}}_handleviewsResponse(newValue,oldValue){if(null!==newValue&&void 0!==newValue.content){null!=document.getElementById("cmstokenidtolockonto")&&(document.getElementById("cmstokenidtolockonto").setAttribute("href",newValue.editEndpoint),document.getElementById("cmstokenidtolockonto").innerHTML=newValue.editText),wipeSlot(this);let frag=document.createElement("span");frag.innerHTML=newValue.content;let newNode=frag.cloneNode(!0);this.appendChild(newNode),this.loading=!1}}_viewsChanged(newValue){void 0===newValue||""===newValue||this.loading||(void 0===this.viewsEndPoint&&void 0!==window.cmsviewsEndPoint&&(this.viewsEndPoint=window.cmsviewsEndPoint),this.viewsEndPoint&&(this.loading=!0,this.shadowRoot.querySelector("#viewsrequest").body=newValue,this.shadowRoot.querySelector("#viewsrequest").generateRequest()))}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"CMS View",description:"CMS views rendered on the backend",icon:"icons:view-module",color:"light-blue",groups:["CMS"],handles:[{type:"cmsviews",views:"views"}],meta:{author:"ELMS:LN"}},settings:{quick:[],configure:[{property:"viewsName",title:"Name",description:"Name of the view from our CMS",inputMethod:"textfield",icon:"editor:title"},{property:"viewsDisplay",title:"Display",description:"Display within that view from our CMS",inputMethod:"textfield",icon:"editor:title"}],advanced:[]},saveOptions:{wipeSlot:!0,unsetAttributes:["loading","views-data","body-data","views-end-point"]}}}postProcessgetHaxJSONSchema(schema){return schema.properties.__editThis={type:"string",component:{name:"a",properties:{id:"cmstokenidtolockonto",href:"",target:"_blank"},slot:"Edit this view"}},schema}}window.customElements.define(CMSViews.tag,CMSViews);export{CMSViews};