import{html,PolymerElement}from"../../../@polymer/polymer/polymer-element.js";import"../../../@polymer/polymer/lib/elements/dom-if.js";import{AppLocalizeBehavior}from"../../../@polymer/app-localize-behavior/app-localize-behavior.js";import{mixinBehaviors}from"../../../@polymer/polymer/lib/legacy/class.js";import"../../../@polymer/iron-flex-layout/iron-flex-layout-classes.js";import"./eco-json-schema-array.js";import"./eco-json-schema-fieldset.js";import"./eco-json-schema-markup.js";import"./eco-json-schema-tabs.js";import"./eco-json-schema-boolean.js";import"./eco-json-schema-enum.js";import"./eco-json-schema-file.js";import"./eco-json-schema-input.js";class EcoJsonSchemaObject extends(mixinBehaviors([AppLocalizeBehavior],PolymerElement)){static get tag(){return"eco-json-schema-object"}static get template(){return html`
      <custom-style>
        <style is="custom-style" include="iron-flex iron-flex-alignment">
          :host {
            --eco-json-field-margin: 0 0 15px;
            --eco-json-form-border-radius: 2px;
            --eco-json-form-font-family: var(
              --paper-font-caption_-_font-family,
              unset
            );
            --eco-json-form-bg: var(--primary-background-color, #fff);
            --eco-json-form-color: var(--primary-text-color, #222);
            --eco-json-form-faded-color: #888;
            --eco-json-form-active-color: var(--primary-color, #000);
            --eco-json-form-faded-bg: #f0f0f0;
            --eco-json-form-add-color: #008811;
            --eco-json-form-add-focus: #007700;
            --eco-json-form-remove-focus: #cc0000;
            --eco-json-form-remove-color: #dd0000;
            --simple-picker-float-label-color: var(--eco-json-form-faded-color);
            --simple-picker-float-label-active-color: var(
              --eco-json-form-active-color
            );
            --simple-picker-background-color: var(--eco-json-form-bg);
            --simple-picker-border-color: var(--eco-json-form-faded-color);
            --simple-picker-focus-border-color: var(
              --eco-json-form-active-color
            );
            --simple-picker-focus-border-width: 2px;
            --paper-input-container: {
              padding-top: 0;
            }
          }
          div.layout {
            height: auto;
          }
          #form {
            display: block;
            font-family: var(--eco-json-form-font-family);
            background-color: var(--eco-json-form-bg);
            color: var(--eco-json-form-color);
            --simple-tooltip-background: var(--eco-json-form-active-color);
            --simple-tooltip-text-color: var(--eco-json-form-bg);
            @apply --eco-json-schema-object-form;
            @apply --layout-vertical;
            @apply --layout-wrap;
          }
          #form ::slotted(paper-input) {
            margin-bottom: 15px;
          }
          #form ::slotted(*.has-tooltip-desc) {
            margin-bottom: 0;
            padding-bottom: 0;
            --paper-input-container: {
              margin-bottom: 0;
              padding-bottom: 0;
            }
          }
          #form ::slotted(div.tooltip-desc) {
            font-size: 12px;
            margin: var(--eco-json-field-margin);
            color: var(--eco-json-form-faded-color);
          }
          #form ::slotted(paper-input),
          #form ::slotted(div.tooltip-desc) {
            font-family: var(--eco-json-form-font-family);
          }
          #form ::slotted(div.desc-for-paper-textarea) {
            margin-top: -18px;
            margin-right: 35px;
          }
          #form ::slotted(code-editor) {
            margin: 8px 0;
            padding: 0;
            --code-editor-float-label-color: var(--eco-json-form-faded-color);
            --code-editor-float-label-active-color: var(
              --eco-json-form-active-color
            );
            --code-pen-button-color: var(--eco-json-form-faded-color);
            --code-editor-code-border: 1px solid
              var(--eco-json-form-faded-color);
            --code-editor-code-border-radius: 2px;
            --code-editor-focus-code-border: 2px solid
              var(--eco-json-form-active-color);
          }
        </style>
      </custom-style>

      <template is="dom-if" if="{{!wizard}}">
        <div class="header" hidden\$="[[!label]]">[[label]]</div>
      </template>
      <div class="layout vertical flex start-justified">
        <div
          id="form"
          class="layout horizontal flex start-justified"
          aria-live="polite"
        >
          <slot></slot>
        </div>
      </div>
    `}static get properties(){return{language:{value:"en"},resources:{value:()=>({})},schema:{type:Object,notify:!0,observer:"_schemaChanged"},label:{type:String},value:{type:Object,notify:!0,value:()=>({})},error:{type:Object,observer:"_errorChanged"},wizard:{type:Boolean,notify:!0},codeTheme:{type:String,value:"vs-light-2"},autofocus:{type:Boolean,value:!1}}}disconnectedCallback(){this._clearForm(),super.disconnectedCallback()}_buildSchemaProperties(thisSchema=this.schema){var ctx=this;return Object.keys(thisSchema.properties||[]).map(key=>{var schema=thisSchema.properties[key],property={name:key,schema,label:schema.title||key,description:schema.description,component:schema.component||{}};if(property.component.valueProperty||(property.component.valueProperty="value"),property.component.slot||(property.component.slot=""),ctx._isSchemaEnum(schema))property.component.name=property.component.name||"eco-json-schema-enum",void 0===schema.value&&(schema.value=""),property.value=schema.value;else if(ctx._isSchemaBoolean(schema.type))property.component.name=property.component.name||"eco-json-schema-boolean",void 0===schema.value&&(schema.value=!1),property.value=schema.value;else if(ctx._isSchemaFile(schema.type))property.component.name=property.component.name||"eco-json-schema-file",void 0===schema.value&&(schema.value={}),property.value=schema.value;else if(ctx._isSchemaValue(schema.type))property.component.name=property.component.name||"eco-json-schema-input",void 0===schema.value&&(schema.value=""),property.value=schema.value;else if(ctx._isSchemaObject(schema.type))property.component.name=property.component.name||"eco-json-schema-object",void 0===schema.value&&(schema.value={}),property.value=schema.value;else if(ctx._isSchemaArray(schema.type))property.component.name=property.component.name||"eco-json-schema-array",this._buildNestedSchemaProperties(property,schema);else if(ctx._isSchemaFieldset(schema.type))property.component.name=property.component.name||"eco-json-schema-fieldset",this._buildNestedSchemaProperties(property,schema);else if(ctx._isSchemaTabs(schema.type))property.component.name=property.component.name||"eco-json-schema-tabs",this._buildNestedSchemaProperties(property,schema);else{if(!ctx._isSchemaMarkup(schema.type))return console.error("Unknown property type %s",schema.type);property.component.name=property.component.name||"eco-json-schema-markup",void 0===schema.value&&(schema.value=""),property.value=schema.value}return property})}_buildNestedSchemaProperties(property,schema){void 0===schema.value&&(schema.value="array"!==schema.type?{}:[]),property.value=schema.value;for(let key in schema.items.properties)schema.items.properties[key].value=schema.value[key];property.schema.properties=this._buildSchemaProperties(schema.items,property.property+".")}_schemaPropertyChanged(event,detail){if(detail){if(detail.path&&/\.length$/.test(detail.path))return;var ctx=this,property=event.target.schemaProperty,path=["value"].concat(`${event.target.propertyPrefix}${event.target.propertyName}`.split("."));property.property||event.target.propertyName,detail&&detail.value&&this._deepClone(detail.value);if(detail.path&&/\.splices$/.test(detail.path)){for(var parts=detail.path.split(".").slice(1,-1);parts.length;)path.push(parts.shift()),property.keyMap&&property.keyMap[path.join(".")]&&(path=property.keyMap[path.join(".")].split("."));detail.value.keySplices&&property.keyMap&&detail.value.keySplices.forEach(splice=>{splice.removed.forEach(k=>{delete property.keyMap[path.concat([k]).join(".")]})}),detail.value&&detail.value.indexSplices.forEach(splice=>{var args=[path.join("."),splice.index,splice.removed.length];if(splice.addedCount)for(var i=0,ii=splice.addedCount;i<ii;i++)splice.addedKeys&&splice.addedKeys[i]&&(property.keyMap=property.keyMap||{},property.keyMap[path.concat([splice.addedKeys[i]]).join(".")]=path.concat([i+splice.index]).join(".")),args.push(ctx._deepClone(splice.object[i+splice.index]));ctx.splice.apply(ctx,args)})}else if(detail.path){parts=detail.path.split(".").slice(1);for(this.value.hasOwnProperty(property.property)||(this.set("value."+property.property,{}),this.notifyPath("value."+property.property));parts.length;){var k=parts.shift();path.push(k),property.keyMap&&property.keyMap[path.join(".")]&&(path=property.keyMap[path.join(".")].split("."))}this.set(path.join("."),this._deepClone(detail.value)),this.notifyPath(path.join("."))}else this.set(path.join("."),this._deepClone(detail.value)),this.notifyPath("value");event.target.dispatchEvent(new CustomEvent("form-field-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:event.target})),this.dispatchEvent(new CustomEvent("value-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}}_setValue(props=this._schemaProperties,path=""){let setter=path.replace(/\[(\d+)\]/g,".$1");""!=setter&&(setter=`.${setter}`),props.length>0&&(props.forEach(property=>{void 0!==property.value&&this.set(`value${setter}.${property.property}`,this._deepClone(property.value),JSON.stringify(property.value))}),this.notifyPath("value.*"))}_buildForm(props=this._schemaProperties,container=this,prefix=""){let autofocus=this.autofocus;props.forEach(property=>{"code-editor"===property.component.name&&(property.schema.component.properties.editorValue=property.schema.value,property.schema.component.properties.theme=this.codeTheme);let propertyPrefix=""!==prefix?`${prefix}.`:"",propertyName=property.property||property.name;var el=this.create(property.component.name,{label:property.label,schema:property.schema,schemaProperty:property,propertyPrefix,propertyName,language:this.language,resources:this.resources});for(var attr in"paper-input"===property.component.name&&(el.style["background-color"]="transparent",el.style.width="100%"),el.setAttribute("name",`${propertyPrefix}${propertyName}`),property.schema.hidden&&void 0!==property.schema.hidden&&el.setAttribute("hidden",property.schema.hidden),autofocus&&el.setAttribute("autofocus",autofocus),autofocus=!1,el.className="flex start-justified",el[property.component.valueProperty]=property.value,property.component.attributes)el.setAttribute(attr,property.component.attributes[attr]);for(var prop in property.component.properties)el[prop]=property.component.properties[prop];if(this.listen(el,property.component.valueProperty.replace(/([A-Z])/g,"-$1").toLowerCase()+"-changed","_schemaPropertyChanged"),this.listen(el,"build-fieldset","_onBuildFieldset"),void 0!==this.$&&(container.appendChild(el),property.description)){var id="tip-"+property.property,tip=document.createElement("div");el.setAttribute("aria-describedby",id),el.setAttribute("class","has-tooltip-desc"),tip.setAttribute("id",id),tip.setAttribute("class","tooltip-desc desc-for-"+property.component.name),!0===property.schema.hidden&&tip.setAttribute("hidden","hidden"),tip.setAttribute("role","tooltip"),tip.innerHTML=property.description,container.appendChild(tip)}if(""!=property.component.slot){let temp=document.createElement("div");temp.innerHTML=property.component.slot;let cloneDiv=temp.cloneNode(!0);for(;null!==cloneDiv.firstChild;)el.appendChild(cloneDiv.firstChild)}this.dispatchEvent(new CustomEvent("form-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))})}_onBuildFieldset(event,detail){void 0===this.get(`value.${detail.prefix}`)&&this.set(`value.${detail.path}`,this._deepClone(detail.value)),this._clearForm(detail.container),this._buildForm(detail.properties,detail.container,detail.prefix)}_removePropertyEl(el,parent=this){void 0!==el.schemaProperty&&this.unlisten(el,el.schemaProperty.component.valueProperty.replace(/([A-Z])/g,"-$1").toLowerCase()+"-changed","_schemaPropertyChanged"),el.schemaProperty=null,parent.removeChild(el)}_clearForm(container=this){if(void 0!==this.$)for(var formEl=container;formEl.firstChild;)this._removePropertyEl(formEl.firstChild,container)}_schemaChanged(newValue,oldValue){newValue&&newValue!==oldValue&&(this._clearForm(),this._schemaProperties=this._buildSchemaProperties(),this._buildForm(),this._setValue())}_errorChanged(){this.childNodes.forEach(el=>{var name=el.getAttribute("name");this.error&&this.error[name]?el.error=this.error[name]:el.error=null})}_deepClone(o){return JSON.parse(JSON.stringify(o))}_isSchemaValue(type){return this._isSchemaBoolean(type)||this._isSchemaNumber(type)||this._isSchemaString(type)||this._isSchemaFile(type)}_isSchemaFile(type){return Array.isArray(type)?-1!==type.indexOf("file"):"file"===type}_isSchemaBoolean(type){return Array.isArray(type)?-1!==type.indexOf("boolean"):"boolean"===type}_isSchemaEnum(schema){return!!schema.enum}_isSchemaNumber(type){return Array.isArray(type)?-1!==type.indexOf("number")||-1!==type.indexOf("integer"):"number"===type||"integer"===type}_isSchemaString(type){return Array.isArray(type)?-1!==type.indexOf("string"):"string"===type}_isSchemaObject(type){return"object"===type}_isSchemaArray(type){return"array"===type}_isSchemaFieldset(type){return"fieldset"===type}_isSchemaTabs(type){return"tabs"===type}_isSchemaMarkup(type){return"markup"===type}focus(){}}window.customElements.define(EcoJsonSchemaObject.tag,EcoJsonSchemaObject);export{EcoJsonSchemaObject};