/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{html,css}from"../../lit-element/lit-element.js";import{SimpleColors}from"../simple-colors/simple-colors.js";class FilteredImage extends SimpleColors{static get styles(){return[...super.styles,css`
        :host {
          display: block;
        }
        :host([hidden]) {
          display: none;
        }
      `]}render(){return html`
      <svg id="svg" viewBox="0 0 ${this.width} ${this.height}">
        <rect id="rect" x="0" y="0"></rect>
        <filter id="${this.__id}">
          <feColorMatrix
            id="matrix"
            type="matrix"
            values=" 1   0   0   0   0
               0   1   0   0   0
               0   0   1   0   0
               0   0   0   1   0 "
          />
        </filter>
        <image id="image" filter="url(#${this.__id})" x="0" y="0"></image>
      </svg>
    `}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Filtered image",description:"An image using an SVG filter. Can be used to make background images have more contrast with text.",icon:"icons:android",color:"green",groups:["Image"],handles:[{type:"todo:read-the-docs-for-usage"}],meta:{author:"nikkimk",owner:"The Pennsylvania State University"}},settings:{quick:[{property:"src",description:"",inputMethod:"textfield",required:!0,icon:"icons:link",validationType:"url"},{property:"alt",description:"",inputMethod:"alt",required:!0,icon:"icons:accessibility"}],configure:[{property:"src",description:"",inputMethod:"textfield",required:!0,icon:"icons:link",validationType:"url"},{property:"alt",description:"",inputMethod:"alt",required:!0,icon:"icons:accessibility"}],advanced:[]}}}static get properties(){return{...super.properties,src:{type:String},__id:{type:String},alt:{type:String},height:{type:String},width:{type:String},color:{type:String},strength:{type:Number},contrast:{type:Number},__matrix:{type:Array}}}static get tag(){return"filtered-image"}constructor(){super(),this.src="",this.alt="",this.height="",this.width="",this.color="#ffffff",this.strength=1,this.contrast=0}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{"src"==propName&&this._srcChanged(this[propName]),"height"==propName&&this._heightChanged(this[propName]),"width"==propName&&this._widthChanged(this[propName]),["src","matrix"].includes(propName)&&(this.__id=this._getID(this.src,this.matrix)),["color","contrast","strength"].includes(propName)&&(this.__matrix=this._getMatrix(this.color,this.contrast,this.strength))})}_heightChanged(){let svg=this.shadowRoot.querySelector("#svg"),image=svg.querySelector("#image"),rect=svg.querySelector("#rect");svg.setAttribute("height",this.height),image.setAttribute("height",this.height),rect.setAttribute("height",this.height)}_widthChanged(){let svg=this.shadowRoot.querySelector("#svg"),image=svg.querySelector("#image"),rect=svg.querySelector("#rect");svg.setAttribute("width",this.width),image.setAttribute("width",this.width),rect.setAttribute("width",this.width)}_srcChanged(){let image=this.shadowRoot.querySelector("#svg").querySelector("#image");image.setAttribute("href",this.src),image.setAttribute("xlink:href",this.src)}_getMatrix(color,contrast,strength){let values=[[1,0,0,0,0],[0,1,0,0,0],[0,0,1,0,0],[0,0,0,1,0]],matrix=this.shadowRoot.querySelector("#svg").querySelector("#matrix"),rgba=null;if(color.startsWith("#")&&color.length>6)7===color.length&&(color+="ff"),values[0][0]=parseInt(color.substring(1,3),16)/255,values[1][1]=parseInt(color.substring(3,5),16)/255,values[2][2]=parseInt(color.substring(5,7),16)/255,values[3][3]=parseInt(color.substring(7,9),16)/255;else if(color.startsWith("#"))4===color.length&&(color+="f"),values[0][0]=parseInt(color.substring(1,2)+color.substring(1,2),16)/255,values[1][1]=parseInt(color.substring(2,3)+color.substring(2,3),16)/255,values[2][2]=parseInt(color.substring(3,4)+color.substring(3,4),16)/255,values[3][3]=parseInt(color.substring(4,5)+color.substring(4,5),16)/255;else if(color.startsWith("rgb")){rgba=color.replace(/rgba?\(/g,"").replace(/\)/g,"").split(","),values[0][0]=parseInt(rgba[0]/255),values[1][1]=parseInt(rgba[1]/255),values[2][2]=parseInt(rgba[2]/255),values[3][3]=values[3][3]||"1"}return 0!==contrast&&(values[0][3]=values[0][0]*contrast/100,values[1][3]=values[1][1]*contrast/100,values[2][3]=values[2][2]*contrast/100),1!==strength&&(values[0][0]=values[0][0]+(1-strength)*(1-values[0][0]),values[1][1]=values[1][1]+(1-strength)*(1-values[1][1]),values[2][2]=values[2][2]+(1-strength)*(1-values[2][2])),matrix.setAttribute("values",JSON.stringify(values).replace(/[,\[\]]/g," ")),values}_getID(src,matrix){return("svg"+Math.random()).replace(/0./g,"-")}}window.customElements.define(FilteredImage.tag,FilteredImage);export{FilteredImage};