import{html,css}from"../../lit-element/lit-element.js";import{SimpleColors}from"../simple-colors/simple-colors.js";import{encapScript,wipeSlot,generateResourceID}from"../utils/utils.js";var timer=null;const maxStep=25,edgeSize=100;class HaxBody extends SimpleColors{static get styles(){return[...super.styles,css`
        :host,
        :host * ::slotted(*) {
          line-height: 1.8;
        }
        :host ul,
        :host * ::slotted(ul),
        :host ol,
        :host * ::slotted(ol) {
          padding-left: 20px;
          margin-left: 20px;
        }
        :host ul,
        :host * ::slotted(ul) {
          list-style-type: disc;
        }
        :host li,
        :host * ::slotted(li) {
          margin-bottom: 6px;
        }
        :host {
          display: block;
          position: relative;
          min-height: 32px;
          min-width: 32px;
          outline: none;
          --hax-body-editable-border-color: #bbbbbb;
          --hax-body-active-border-color: #000000;
          --hax-body-target-background-color: var(
            --simple-colors-default-theme-grey-3
          );
          --hax-body-possible-target-background-color: var(
            --simple-colors-default-theme-grey-2
          );
        }
        .hax-context-menu {
          padding: 0;
          margin-left: -5000px;
          position: absolute;
          visibility: hidden;
          opacity: 0;
          z-index: 1000;
          float: left;
          display: block;
          pointer-events: none;
          transition: 0.2s opacity ease-in-out, 0.2s visibility ease-in-out;
        }
        #textcontextmenu.hax-context-menu {
          z-index: 1001;
        }
        #haxinputmixer {
          z-index: 10000000;
        }
        .hax-context-visible.hax-active-hover {
          visibility: visible;
          opacity: 1;
          pointer-events: all;
          margin-left: unset;
        }
        :host #bodycontainer ::slotted(h1) {
          font-size: var(--hax-base-styles-h1-font-size, 2.5em);
          line-height: var(--hax-base-styles-h1-line-height, 2.5em);
        }
        :host #bodycontainer ::slotted(h2) {
          font-size: var(--hax-base-styles-h2-font-size, 2em);
        }
        :host #bodycontainer ::slotted(h3) {
          font-size: var(--hax-base-styles-h3-font-size, 1.75em);
        }
        :host #bodycontainer ::slotted(h4) {
          font-size: var(--hax-base-styles-h4-font-size, 1.5em);
        }
        :host #bodycontainer ::slotted(h5) {
          font-size: var(--hax-base-styles-h5-font-size, 1.25em);
        }
        :host #bodycontainer ::slotted(h6) {
          font-size: var(--hax-base-styles-h6-font-size, 1.25em);
        }
        :host #bodycontainer ::slotted(p) {
          min-height: var(--hax-base-styles-p-min-height, 43px);
          font-size: var(--hax-base-styles-p-font-size, 24px);
          line-height: var(--hax-base-styles-p-line-height, 1.8);
          letter-spacing: var(--hax-base-styles-p-letter-spacing, 0.5px);
        }
        :host #bodycontainer ::slotted(a) {
          color: var(--hax-base-styles-a-color, #000);
          font-size: var(--hax-base-styles-a-font-size, 24px);
          font-weight: var(--hax-base-styles-a-font-weight, normal);
        }
        :host #bodycontainer ::slotted(a:visited) {
          color: var(--hax-base-styles-a-color-visited, #2196f3);
        }
        :host #bodycontainer ::slotted(a:active),
        :host #bodycontainer ::slotted(a:focus),
        :host #bodycontainer ::slotted(a:hover) {
          color: var(--hax-base-styles-a-color-active, #2196f3);
          font-weight: var(--hax-base-styles-a-font-weight-active, normal);
        }
        :host #bodycontainer ::slotted(ol),
        :host #bodycontainer ::slotted(ul),
        :host #bodycontainer ::slotted(li) {
          padding-bottom: var(--hax-base-styles-list-padding-bottom, 1.5em);
          line-height: var(--hax-base-styles-list-line-height, 40px);
          font-size: var(--hax-base-styles-list-font-size, 24px);
          max-width: var(--hax-base-styles-list-max-width, 28em);
        }
        :host #bodycontainer ::slotted(ol > li:last-child),
        :host #bodycontainer ::slotted(ul > li:last-child) {
          padding-bottom: var(
            --hax-base-styles-list-last-child-padding-bottom,
            1em
          );
        }
        :host #bodycontainer ::slotted(ul),
        :host #bodycontainer ::slotted(ol) {
          padding-left: var(--hax-base-styles-list-padding-left, 20px);
          padding-left: var(--hax-base-styles-list-margin-left, 20px);
        }

        :host([edit-mode]) #bodycontainer ::slotted(*[data-editable]) {
          outline: none;
          caret-color: var(--hax-color-text);
        }
        :host([edit-mode])
          #bodycontainer
          ::slotted(*:not(grid-plate)[data-editable]:hover) {
          outline: 2px dashed rgba(145, 151, 162, 0.5);
          caret-color: #000000;
        }
        :host([edit-mode])
          #bodycontainer
          ::slotted(*.hax-active[data-editable]:hover) {
          cursor: text !important;
          outline: 2px dashed rgba(145, 151, 162, 0.5);
        }
        :host([edit-mode])
          #bodycontainer
          ::slotted(*:not(grid-plate)[data-editable] .hax-active:hover) {
          cursor: text !important;
          outline: 2px dashed rgba(145, 151, 162, 0.5);
        }
        :host([edit-mode])
          #bodycontainer
          ::slotted(code.hax-active[data-editable]) {
          display: block;
        }
        :host([edit-mode])
          #bodycontainer
          ::slotted(*.hax-active[data-editable]) {
          outline: 2px dashed rgba(145, 151, 162, 0.25);
        }
        :host([edit-mode]) #bodycontainer ::slotted(hr[data-editable]) {
          height: 2px;
          background-color: #eeeeee;
          padding-top: 4px;
          padding-bottom: 4px;
        }
        /** Fix to support safari as it defaults to none */
        :host([edit-mode]) #bodycontainer ::slotted(*[data-editable]) {
          -webkit-user-select: text;
          cursor: pointer;
        }

        :host([edit-mode])
          #bodycontainer
          ::slotted(*[data-editable]::-moz-selection),
        :host([edit-mode])
          #bodycontainer
          ::slotted(*[data-editable] *::-moz-selection) {
          background-color: var(--hax-body-highlight, --paper-yellow-300);
          color: black;
        }
        :host([edit-mode])
          #bodycontainer
          ::slotted(*[data-editable]::selection),
        :host([edit-mode])
          #bodycontainer
          ::slotted(*[data-editable] *::selection) {
          background-color: var(--hax-body-highlight, --paper-yellow-300);
          color: black;
        }
        #bodycontainer {
          -webkit-user-select: text;
          user-select: text;
        }
        :host([edit-mode][hax-ray-mode])
          #bodycontainer
          ::slotted(*[data-editable]):before {
          content: attr(data-hax-ray) " " attr(resource) " " attr(typeof) " "
            attr(property) " " attr(content);
          font-size: 10px;
          font-style: italic;
          left: unset;
          right: unset;
          top: unset;
          background-color: #d3d3d3;
          color: #000000;
          bottom: unset;
          width: auto;
          padding: 8px;
          margin: 0;
          z-index: 1;
          margin: -16px 0 0 0;
          float: right;
          line-height: 2;
        }
        /* drag and drop */
        :host([edit-mode]) #bodycontainer ::slotted(*.mover):before {
          outline: 2px dashed var(--hax-body-editable-border-color);
          background-color: var(--hax-body-possible-target-background-color);
          content: " ";
          width: 100%;
          display: block;
          position: relative;
          margin: -20px 0 0 0;
          z-index: 2;
          height: 20px;
        }
        :host([edit-mode]) #bodycontainer ::slotted(*.moving) {
          outline: 2px dashed var(--hax-body-active-border-color);
          background-color: #eeeeee;
        }
        :host([edit-mode]) #bodycontainer ::slotted(*.hovered):before {
          background-color: var(--hax-body-target-background-color) !important;
          outline: dashed 2px var(--hax-body-active-border-color);
        }
        .hax-context-menu:not(:defined) {
          display: none;
        }
      `]}constructor(){super(),this.___moveLock=!1,this.editMode=!1,this.globalPreferences={},this.haxRayMode=!1,this.activeNode=null,this.activeContainerNode=null,setTimeout(()=>{import("./lib/hax-text-context.js"),import("./lib/hax-ce-context.js"),import("./lib/hax-plate-context.js"),import("./lib/hax-input-mixer.js"),import("../grid-plate/grid-plate.js"),this.polyfillSafe=window.HaxStore.instance.computePolyfillSafe(),this.addEventListener("hax-context-item-selected",this._haxContextOperation.bind(this)),this.addEventListener("hax-input-mixer-update",this._haxInputMixerOperation.bind(this)),this.addEventListener("place-holder-replace",this.replacePlaceholder.bind(this)),this.addEventListener("focusin",this._focusIn.bind(this)),this.addEventListener("mousedown",this._focusIn.bind(this)),this.addEventListener("mouseover",this._mouseOver.bind(this)),this.addEventListener("drop",this.dropEvent.bind(this))},0)}static get tag(){return"hax-body"}_mouseOver(e){this.openDrawer||!this.editMode||this.__tabTrap||this.positionContextMenus()}render(){return html`
      <div id="bodycontainer" class="ignore-activation">
        <slot id="body"></slot>
      </div>
      <hax-text-context
        id="textcontextmenu"
        class="hax-context-menu ignore-activation"
      ></hax-text-context>
      <hax-ce-context
        id="cecontextmenu"
        class="hax-context-menu ignore-activation"
      ></hax-ce-context>
      <hax-plate-context
        id="platecontextmenu"
        class="hax-context-menu ignore-activation"
      ></hax-plate-context>
      <hax-input-mixer
        id="haxinputmixer"
        class="hax-context-menu ignore-activation"
      ></hax-input-mixer>
    `}static get properties(){return{...super.properties,openDrawer:{type:Object},editMode:{type:Boolean,reflect:!0,attribute:"edit-mode"},haxRayMode:{type:Boolean,reflect:!0,attribute:"hax-ray-mode"},globalPreferences:{type:Object},activeNode:{type:Object},activeContainerNode:{type:Object}}}firstUpdated(changedProperties){this.dispatchEvent(new CustomEvent("hax-register-body",{bubbles:!0,cancelable:!0,composed:!0,detail:this}));try{document.execCommand("enableObjectResizing",!1,!1),document.execCommand("defaultParagraphSeparator",!1,"p")}catch(e){console.warn(e)}this.shadowRoot.querySelector("slot").addEventListener("mousemove",this.hoverEvent.bind(this)),this.shadowRoot.querySelector("slot").addEventListener("mouseup",e=>{const tmp=window.HaxStore.getSelection();window.HaxStore._tmpSelection=tmp;try{const range=window.HaxStore.getRange();range.cloneRange&&(window.HaxStore._tmpRange=range.cloneRange())}catch(e){console.warn(e)}}),this.editMode=window.HaxStore.instance.editMode,this.__tabTrap=!1}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{"openDrawer"==propName&&this._openDrawerChanged(this[propName],oldValue),"editMode"==propName&&this._editModeChanged(this[propName],oldValue),"globalPreferences"==propName&&this._globalPreferencesUpdated(this[propName],oldValue),"activeNode"==propName&&(this._activeNodeChanged(this[propName],oldValue),this.dispatchEvent(new CustomEvent("active-node-changed",{detail:{value:this[propName]}}))),"activeContainerNode"==propName&&(this._activeContainerNodeChanged(this[propName],oldValue),this.dispatchEvent(new CustomEvent("active-container-node-changed",{detail:{value:this[propName]}})))})}_openDrawerChanged(newValue,oldValue){newValue?this.hideContextMenus():this.positionContextMenus()}connectedCallback(){super.connectedCallback(),this._observer=new MutationObserver(mutations=>{var mutFind=!1;mutations.forEach(mutation=>{mutation.addedNodes.length>0&&mutation.addedNodes.forEach(node=>{this._validElementTest(node)&&(!this.editMode||"true"!=node.getAttribute("contenteditable")&&!0!==node.getAttribute("contenteditable")&&"contenteditable"!=node.getAttribute("contenteditable")||this.__applyNodeEditableState(node,!this.editMode),this.__applyNodeEditableState(node,this.editMode),this.dispatchEvent(new CustomEvent("hax-body-tag-added",{bubbles:!0,cancelable:!0,composed:!0,detail:{node}})),["H1","H2","H3","H4","H5","H6"].includes(node.tagName)&&null==node.getAttribute("id")&&node.setAttribute("id",generateResourceID("header-")),this.___moveLock||mutFind?this.___moveLock=!1:(mutFind=!0,this.activeNode=node,window.HaxStore.write("activeNode",node,this)))}),mutation.removedNodes.length>0&&mutation.removedNodes.forEach(node=>{this._validElementTest(node)&&!node.classList.contains("hax-active")&&this.dispatchEvent(new CustomEvent("hax-body-tag-removed",{bubbles:!0,cancelable:!0,composed:!0,detail:{node}}))})})}),this._observer.observe(this,{childList:!0}),setTimeout(()=>{window.addEventListener("keydown",this._onKeyDown.bind(this)),window.addEventListener("keypress",this._onKeyPress.bind(this)),document.body.addEventListener("hax-store-property-updated",this._haxStorePropertyUpdated.bind(this)),window.addEventListener("scroll",this._keepContextVisible.bind(this))},0)}disconnectedCallback(){window.removeEventListener("keydown",this._onKeyDown.bind(this)),window.removeEventListener("keypress",this._onKeyPress.bind(this)),document.body.removeEventListener("hax-store-property-updated",this._haxStorePropertyUpdated.bind(this)),window.removeEventListener("scroll",this._keepContextVisible.bind(this)),this._observer.disconnect(),super.disconnectedCallback()}_keepContextVisible(e){!this.openDrawer&&this.editMode&&(clearTimeout(this.__contextVisibleLock),this.__contextVisibleLock=setTimeout(()=>{let el=!1;this.shadowRoot.querySelector("#textcontextmenu").classList.contains("hax-context-visible")?el=this.shadowRoot.querySelector("#textcontextmenu"):this.shadowRoot.querySelector("#cecontextmenu").classList.contains("hax-context-visible")&&(el=this.shadowRoot.querySelector("#cecontextmenu")),el&&(this._positionContextMenu(this.shadowRoot.querySelector("#platecontextmenu"),this.activeContainerNode,-59,0),this.elementInViewport(el)?el.classList.remove("hax-context-pin-bottom","hax-context-pin-top"):this.__OffBottom?el.classList.add("hax-context-pin-top"):el.classList.add("hax-context-pin-bottom"))},50))}_onKeyDown(e){if(!this.openDrawer&&this.editMode&&this.getAttribute("contenteditable")){switch(e.key){case"Tab":window.HaxStore.instance.isTextElement(this.activeContainerNode)&&(e.detail.keyboardEvent&&(e.detail.keyboardEvent.preventDefault(),e.detail.keyboardEvent.stopPropagation(),e.detail.keyboardEvent.stopImmediatePropagation()),e.preventDefault(),e.stopPropagation(),e.stopImmediatePropagation(),e.shiftKey?this._tabBackKeyPressed():this._tabKeyPressed());break;case"Enter":this.setAttribute("contenteditable",!0);case"Backspace":case"Delete":case"ArrowUp":case"ArrowDown":case"ArrowLeft":case"ArrowRight":clearTimeout(this.__keyPressDirection),this.__keyPressDirection=setTimeout(()=>{const rng=window.HaxStore.getRange();rng.commonAncestorContainer&&this.activeNode!==rng.commonAncestorContainer&&"function"==typeof rng.commonAncestorContainer.focus?"HAX-BODY"!==rng.commonAncestorContainer.tagName&&(window.HaxStore.instance.isTextElement(rng.commonAncestorContainer)?this.setAttribute("contenteditable",!0):this.removeAttribute("contenteditable"),rng.commonAncestorContainer.focus(),this.__focusLogic(rng.commonAncestorContainer)):rng.commonAncestorContainer&&rng.commonAncestorContainer.parentNode&&this.activeNode!==rng.commonAncestorContainer.parentNode&&"function"==typeof rng.commonAncestorContainer.parentNode.focus&&("HAX-BODY"!==rng.commonAncestorContainer.parentNode.tagName?(window.HaxStore.instance.isTextElement(rng.commonAncestorContainer.parentNode)?this.setAttribute("contenteditable",!0):this.removeAttribute("contenteditable"),rng.commonAncestorContainer.parentNode.focus(),this.__focusLogic(rng.commonAncestorContainer.parentNode)):(this.activeNode=rng.commonAncestorContainer,this.activeContainerNode=this.activeNode,window.HaxStore.write("activeNode",rng.commonAncestorContainer,this),window.HaxStore.write("activeContainerNode",rng.commonAncestorContainer,this),setTimeout(()=>{this.positionContextMenus()},0)))},50)}this.shadowRoot.querySelector("#platecontextmenu").classList.contains("hax-active-hover")&&this.__dropActiveHover()}}_onKeyPress(e){!this.openDrawer&&this.editMode&&this.shadowRoot.querySelector("#textcontextmenu").classList.contains("hax-active-hover")&&this.activeNode&&window.HaxStore.instance.isTextElement(this.activeNode)?this.__dropActiveHover():!this.openDrawer&&this.editMode&&this.activeNode&&window.HaxStore.instance.isTextElement(this.activeNode)&&(clearTimeout(this.__positionContextTimer),this.__positionContextTimer=setTimeout(()=>{this.positionContextMenus()},2e3))}hoverEvent(e){if(!this.openDrawer&&this.editMode&&(e.target&&null!=e.target.getAttribute("data-hax-ray")?(this.__activeHover=e.target,this.dispatchEvent(new CustomEvent("hax-active-hover-name",{bubbles:!0,cancelable:!0,composed:!0,detail:e.target.getAttribute("data-hax-ray")}))):e.target&&e.target.parentNode&&null!=e.target.parentNode.getAttribute("data-hax-ray")&&(this.__activeHover=e.target.parentNode,this.dispatchEvent(new CustomEvent("hax-active-hover-name",{bubbles:!0,cancelable:!0,composed:!0,detail:e.target.parentNode.getAttribute("data-hax-ray")}))),!this.shadowRoot.querySelector("#platecontextmenu").classList.contains("hax-active-hover"))){let local=e.target;e.target===this.shadowRoot.querySelector("#cecontextmenu")||e.target===this.shadowRoot.querySelector("#textcontextmenu")||e.target===this.shadowRoot.querySelector("#platecontextmenu")||local===this.activeNode||local===this.activeContainerNode||e.target===this.activeNode||e.target===this.activeContainerNode||local.parentNode===this.activeContainerNode||local.parentNode.parentNode===this.activeContainerNode||local.parentNode.parentNode.parentNode===this.activeContainerNode?(this.positionContextMenus(),this.__addActiveHover(),this.__typeLock=!1):this.__dropActiveHover()}}__addActiveHover(){this.shadowRoot.querySelector("#cecontextmenu").classList.add("hax-active-hover"),this.shadowRoot.querySelector("#textcontextmenu").classList.add("hax-active-hover"),this.shadowRoot.querySelector("#platecontextmenu").classList.add("hax-active-hover")}__dropActiveHover(){this.shadowRoot.querySelector("#cecontextmenu").classList.remove("hax-active-hover"),this.shadowRoot.querySelector("#textcontextmenu").classList.remove("hax-active-hover"),this.shadowRoot.querySelector("#platecontextmenu").classList.remove("hax-active-hover")}elementInViewport(el){let top=el.offsetTop-32-window.HaxStore.instance.haxPanel.shadowRoot.querySelector("#drawer").offsetHeight,left=el.offsetLeft,width=el.offsetWidth,height=el.offsetHeight;for(;el.offsetParent;)top+=(el=el.offsetParent).offsetTop,left+=el.offsetLeft;return this.__OffBottom=top<window.pageYOffset+window.innerHeight,top<window.pageYOffset+window.innerHeight&&left<window.pageXOffset+window.innerWidth&&top+height>window.pageYOffset&&left+width>window.pageXOffset}replacePlaceholder(e){if("text"===e.detail){let p=document.createElement("p");p.innerHTML="<br/>",this.haxReplaceNode(this.activeNode,p,this.activeNode.parentNode),setTimeout(()=>{this.activeNode=p,window.HaxStore.write("activeNode",p,this),this.activeContainerNode.setAttribute("contenteditable",!0),p.focus(),this.__focusLogic(p)},210)}else this.replaceElementWorkflow()}replaceElementWorkflow(){let element=window.HaxStore.nodeToHaxElement(this.activeNode,null),type="*",skipPropMatch=!1;"place-holder"===element.tag&&void 0!==element.properties.type&&(type=element.properties.type,skipPropMatch=!0);var props={};if(void 0!==window.HaxStore.instance.elementList[element.tag]&&!1!==window.HaxStore.instance.elementList[element.tag].gizmo&&void 0!==window.HaxStore.instance.elementList[element.tag].gizmo.handles&&window.HaxStore.instance.elementList[element.tag].gizmo.handles.length>0){let gizmo=window.HaxStore.instance.elementList[element.tag].gizmo;for(var i=0;i<gizmo.handles.length;i++)for(var prop in gizmo.handles[i])"type"!==prop&&void 0!==element.properties[gizmo.handles[i][prop]]&&(props[prop]=element.properties[gizmo.handles[i][prop]])}let haxElements=window.HaxStore.guessGizmo(type,props,skipPropMatch);if(haxElements.length>0){let tag=this.activeNode.tagName.toLowerCase(),humanName=tag.replace("-"," ");void 0!==window.HaxStore.instance.elementList[tag]&&!1!==window.HaxStore.instance.elementList[tag].gizmo&&(humanName=window.HaxStore.instance.elementList[tag].gizmo.title),window.HaxStore.instance.haxAppPicker.presentOptions(haxElements,"__convert",`Transform ${humanName} to..`,"gizmo")}else window.HaxStore.toast("Sorry, this can not be transformed!",5e3)}_globalPreferencesUpdated(newValue,oldValue){void 0!==newValue&&null!=newValue&&(this.haxRayMode=newValue.haxRayMode)}_haxStorePropertyUpdated(e){e.detail&&void 0!==e.detail.value&&e.detail.property&&(this[e.detail.property]=e.detail.value)}haxClearBody(confirm=!0){let status=!0;confirm&&(status=prompt("Are you sure you want to delete all content?")),status&&wipeSlot(this)}haxInsert(tag,content,properties={},waitForLock=!0){this.__activeHover=null;var frag=document.createElement(tag);frag.innerHTML=content;var newNode=frag.cloneNode(!0);for(var property in properties){let attributeName=window.HaxStore.camelToDash(property);properties.hasOwnProperty(property)&&(!0===properties[property]?newNode.setAttribute(attributeName,attributeName):!1===properties[property]?newNode.removeAttribute(attributeName):null!=properties[property]&&properties[property].constructor===Array?newNode.properties&&newNode.properties[property].readOnly||(newNode.set?newNode.set(attributeName,properties[property]):newNode[attributeName]=properties[property]):null!=properties[property]&&properties[property].constructor===Object?newNode.properties&&newNode.properties[property].readOnly||(newNode.set?newNode.set(attributeName,properties[property]):newNode[attributeName]=properties[property]):newNode.setAttribute(attributeName,properties[property]))}return null!==window.HaxStore.instance.activePlaceHolder&&void 0!==window.HaxStore.instance.activePlaceHolder.style?(newNode.style.width=window.HaxStore.instance.activePlaceHolder.style.width,newNode.style.float=window.HaxStore.instance.activePlaceHolder.style.float,newNode.style.margin=window.HaxStore.instance.activePlaceHolder.style.margin,newNode.style.display=window.HaxStore.instance.activePlaceHolder.style.display,this.haxReplaceNode(window.HaxStore.instance.activePlaceHolder,newNode,window.HaxStore.instance.activePlaceHolder.parentNode),window.HaxStore.instance.activePlaceHolder=null):null!=this.activeContainerNode?"GRID-PLATE"!==newNode.tagName&&"GRID-PLATE"===this.activeContainerNode.tagName&&this.activeContainerNode!==this.activeNode?(null!=this.activeNode.getAttribute("slot")&&newNode.setAttribute("slot",this.activeNode.getAttribute("slot")),this.activeContainerNode.insertBefore(newNode,this.activeNode)):this.insertBefore(newNode,this.activeContainerNode.nextElementSibling):this.appendChild(newNode),this.shadowRoot.querySelector("#textcontextmenu").highlightOps=!1,this.__updateLockFocus=newNode,waitForLock&&setTimeout(()=>{this.breakUpdateLock()},50),!0}breakUpdateLock(){window.HaxStore.write("activeContainerNode",this.__updateLockFocus,this),window.HaxStore.write("activeNode",this.__updateLockFocus,this),this.__updateLockFocus.focus(),"function"==typeof this.__updateLockFocus.scrollIntoViewIfNeeded?this.__updateLockFocus.scrollIntoViewIfNeeded(!0):this.__updateLockFocus.scrollIntoView({behavior:"smooth",inline:"center"})}haxToContent(){this.hideContextMenus();var __active=this.activeNode;this.activeNode=null,this.activeContainerNode=null,window.HaxStore.write("activeNode",null,this),window.HaxStore.write("activeContainerNode",null,this);let children="slot"===this.shadowRoot.querySelector("#body").localName?this.shadowRoot.querySelector("#body").assignedNodes({flatten:!0}):[];this.globalPreferences.haxDeveloperMode&&console.warn(children);for(var content="",i=0,len=children.length;i<len;i++)this._validElementTest(children[i])?(children[i].removeAttribute("data-editable"),children[i].removeAttribute("data-hax-ray"),children[i].contentEditable=!1,content+=window.HaxStore.nodeToContent(children[i]),"grid-plate"===children[i].tagName.toLowerCase()&&this._applyContentEditable(this.editMode,children[i])):8===children[i].nodeType?content+="\x3c!-- "+children[i].textContent+" --\x3e":1!==children[i].nodeType&&void 0!==children[i].textContent&&"undefined"!==children[i].textContent&&(content+=children[i].textContent);if(content=(content=(content=(content=(content=(content=(content=(content=content.replace(/\scontenteditable=\"false\"/g,"")).replace(/\sdata-editable=\"true\"/g,"")).replace(/\sdata-editable=\"false\"/g,"")).replace(/\sdata-editable=\""/g,"")).replace(/\sdata-editable/g,"")).replace(/\scontenteditable/g,"")).replace(/\sdraggable/g,"")).replace(/\sdata-hax-ray=\".*?\"/g,""),this.parentNode.tagName){let parentTag=this.parentNode.tagName.toLowerCase(),string="style-scope "+parentTag+" x-scope",re=new RegExp(string,"g");content=content.replace(re,""),string="style-scope "+parentTag,re=new RegExp(string,"g"),content=content.replace(re,""),string="x-scope "+parentTag+"-0",re=new RegExp(string,"g"),content=content.replace(re,"");let tags=window.HaxStore.instance.validTagList;for(var i in tags.push("hax-preview"),tags)string="style-scope "+tags[i],re=new RegExp(string,"g"),content=content.replace(re,""),string="x-scope "+tags[i]+"-0 ",re=new RegExp(string,"g"),content=content.replace(re,""),string="x-scope "+tags[i]+"-0",re=new RegExp(string,"g"),content=content.replace(re,"")}return content=(content=content.replace(/\sclass=\"\"/g,"")).replace(/\sclass=\"\s\"/g,""),this._applyContentEditable(this.editMode),window.HaxStore.write("activeNode",__active,this),window.HaxStore.write("activeContainerNode",__active,this),content=encapScript(content),this.globalPreferences.haxDeveloperMode&&console.warn(content),content}haxDuplicateNode(node,parent=this){this.hideContextMenus();let haxElement=window.HaxStore.nodeToHaxElement(node,null);void 0!==node.preProcessHaxInsertContent&&(haxElement=node.preProcessHaxInsertContent(haxElement)),haxElement.content==haxElement.properties.innerHTML&&delete haxElement.properties.innerHTML;var nodeClone=window.HaxStore.haxElementToNode(haxElement.tag,haxElement.content,haxElement.properties);return"webview"===nodeClone.tagName.toLowerCase()&&window.HaxStore.instance._isSandboxed&&void 0!==nodeClone.guestinstance&&delete nodeClone.guestinstance,null!==node?parent.insertBefore(nodeClone,node.nextSibling):parent.appendChild(nodeClone),setTimeout(()=>{parent===this&&window.HaxStore.write("activeContainerNode",nodeClone,this),window.HaxStore.write("activeNode",nodeClone,this)},100),!0}hideContextMenus(){clearTimeout(this.__keyPressDirection),clearTimeout(this.__contextVisibleLock),clearTimeout(this.__positionContextTimer),this._hideContextMenu(this.shadowRoot.querySelector("#textcontextmenu")),this._hideContextMenu(this.shadowRoot.querySelector("#cecontextmenu")),this._hideContextMenu(this.shadowRoot.querySelector("#platecontextmenu")),this._hideContextMenu(this.shadowRoot.querySelector("#haxinputmixer")),this.shadowRoot.querySelector("#textcontextmenu").highlightOps=!1}positionContextMenus(node=this.activeNode,container=this.activeContainerNode){if(node){let tag=node.tagName.toLowerCase();window.HaxStore.instance._isSandboxed&&"webview"===tag&&(tag="iframe");let props=window.HaxStore.instance.elementList[tag];void 0===props||window.HaxStore.instance.isTextElement(node)?(this._hideContextMenu(this.shadowRoot.querySelector("#cecontextmenu")),this._positionContextMenu(this.shadowRoot.querySelector("#textcontextmenu"),container,-58,-40)):(this._hideContextMenu(this.shadowRoot.querySelector("#textcontextmenu")),props.element=node,this.shadowRoot.querySelector("#cecontextmenu").setHaxProperties(props),this._positionContextMenu(this.shadowRoot.querySelector("#cecontextmenu"),container,-58,-40)),this._positionContextMenu(this.shadowRoot.querySelector("#platecontextmenu"),container,-59,0),container&&!window.HaxStore.instance.isTextElement(node)&&node!==container?container.removeAttribute("contenteditable"):container&&container.setAttribute("contenteditable",!0)}}haxMoveGridPlate(direction,node,container){switch(this.___moveLock=!0,direction){case"first":null!==container.previousElementSibling&&this.insertBefore(container,this.firstChild);break;case"up":null!==container.previousElementSibling&&this.insertBefore(container,container.previousElementSibling);break;case"down":null!==container.nextElementSibling&&this.insertBefore(container.nextElementSibling,container);break;case"last":null!==container.nextElementSibling&&this.appendChild(container)}return setTimeout(()=>{this.positionContextMenus(node,container),"function"==typeof container.scrollIntoViewIfNeeded?container.scrollIntoViewIfNeeded(!0):container.scrollIntoView({behavior:"smooth",inline:"center"})},0),!0}haxInjectGridplate(node,side){let changed=!1;if("GRID-PLATE"===node.tagName){switch(node.layout){case"1":node.layout="1-1",changed=!0;break;case"1-1":node.layout="1-1-1",changed=!0;break;case"1-1-1":node.layout="1-1-1-1",changed=!0}changed&&"left"==side&&node.childNodes.forEach(el=>{if(el.tagName){let s=parseInt(el.getAttribute("slot").replace("col-",""),10)+1;el.setAttribute("slot",`col-${s}`)}})}else{let grid=document.createElement("grid-plate");grid.layout="1-1",this.insertBefore(grid,node);let col="2";"right"==side&&(col="1"),setTimeout(()=>{grid.appendChild(node),this.activeContainerNode=grid,window.HaxStore.write("activeContainerNode",grid,this),node.setAttribute("slot","col-"+col)},0)}}haxReplaceNode(node,replacement,parent=this){this.hideContextMenus();try{node&&node.getAttribute&&null!=node.getAttribute("slot")&&replacement.setAttribute("slot",node.getAttribute("slot")),null==node&&(node=this.__oldActiveNode,parent=this.__oldActiveNode.parentNode),parent.replaceChild(replacement,node)}catch(e){console.warn(e)}return replacement}haxChangeTagName(node,tagName){this.hideContextMenus();for(var replacement=document.createElement(tagName),i=0,l=node.attributes.length;i<l;++i){var nodeName=node.attributes.item(i).nodeName,value=node.attributes.item(i).value;replacement.setAttribute(nodeName,value)}replacement.innerHTML=node.innerHTML.trim(),"ul"==tagName||"ol"==tagName?""==replacement.innerHTML?replacement.innerHTML="<li></li>":"ul"!=node.tagName.toLowerCase()&&"ol"!=node.tagName.toLowerCase()&&(replacement.innerHTML="<li>"+node.innerHTML.trim().replace(/<br\/>/g,"</li>\n<li>").replace(/<br>/g,"</li>\n<li>")+"</li>"):"ul"!=node.tagName.toLowerCase()&&"ol"!=node.tagName.toLowerCase()||(replacement.innerHTML=replacement.innerHTML.replace(/<ul>/g,"").replace(/<\/ul>/g,"").replace(/<li><\/li>/g,"").replace(/<li>/g,"").replace(/<\/li>/g,"<br/>"));try{node.parentNode.replaceChild(replacement,node),setTimeout(()=>{let children=replacement.children;children[0]&&children.tagName?children[0].focus():replacement.focus()},50)}catch(e){console.warn(e),console.warn(replacement),console.warn(node)}return replacement}haxDeleteNode(node,parent=this){if(this.hideContextMenus(),null!=this.activeContainerNode&&null!==this.activeContainerNode.previousElementSibling){if(this.activeContainerNode.previousElementSibling.focus(),null!=this.activeContainerNode&&window.HaxStore.instance.isTextElement(this.activeContainerNode)&&""!==this.activeContainerNode.textContent)try{var range=document.createRange(),sel=window.HaxStore.getSelection();range.setStart(this.activeContainerNode,1),range.collapse(!0),sel.removeAllRanges(),sel.addRange(range),this.activeContainerNode.focus()}catch(e){console.warn(e)}}else null!=this.activeContainerNode&&null!==this.activeContainerNode.nextElementSibling?this.activeContainerNode.nextElementSibling.focus():(this.activeNode=null,this.activeContainerNode=null,window.HaxStore.write("activeNode",null,this),window.HaxStore.write("activeContainerNode",null,this));try{return parent.removeChild(node)}catch(e){console.warn(e)}}importContent(html,clear=!0){clear&&wipeSlot(this,"*"),setTimeout(()=>{html=encapScript(html);let fragment=document.createElement("div");for(fragment.insertAdjacentHTML("beforeend",html);null!==fragment.firstChild;)if(void 0!==fragment.firstChild.tagName)if(window.HaxStore.instance._isSandboxed&&"iframe"===fragment.firstChild.tagName.toLowerCase()){for(var replacement=document.createElement("webview"),j=0,l=fragment.firstChild.attributes.length;j<l;++j){var nodeName=fragment.firstChild.attributes.item(j).nodeName,value=fragment.firstChild.attributes.item(j).value;"height"!==nodeName&&"width"!==nodeName||replacement.style[nodeName],replacement.setAttribute(nodeName,value)}this.appendChild(replacement)}else this.appendChild(fragment.firstChild);else fragment.removeChild(fragment.firstChild)},50)}_haxContextOperation(e){let detail=e.detail;var haxElement;switch(detail.eventName){case"text-tag":this.shadowRoot.querySelector("#textcontextmenu").realSelectedValue=detail.value,this.activeNode=this.haxChangeTagName(this.activeNode,detail.value),window.HaxStore.write("activeNode",this.activeNode,this),this.positionContextMenus();break;case"text-tag-ul":this.shadowRoot.querySelector("#textcontextmenu").realSelectedValue="ul",this.activeNode=this.haxChangeTagName(this.activeNode,"ul"),window.HaxStore.write("activeNode",this.activeNode,this),this.positionContextMenus();break;case"text-tag-ol":this.shadowRoot.querySelector("#textcontextmenu").realSelectedValue="ol",this.activeNode=this.haxChangeTagName(this.activeNode,"ol"),window.HaxStore.write("activeNode",this.activeNode,this),this.positionContextMenus();break;case"hax-plate-add-element":if("other"==detail.value)return window.HaxStore.instance.haxInsertAnything({}),!0;let addData=JSON.parse(detail.value);this.haxInsert(addData.tag,addData.content,addData.properties,!1),window.HaxStore.instance.isTextElement(addData)&&setTimeout(()=>{try{var range=document.createRange(),sel=window.HaxStore.getSelection();range.setStart(this.activeNode,0),range.collapse(!0),sel.removeAllRanges(),sel.addRange(range),this.activeNode.focus(),this.activeContainerNode=this.activeNode,window.HaxStore.write("activeContainerNode",this.activeContainerNode,this)}catch(e){console.warn(e)}},0);break;case"text-align-left":this.activeNode.style.textAlign=null;break;case"hax-plate-convert":this.replaceElementWorkflow();break;case"hax-plate-create-left":this.haxInjectGridplate(this.activeContainerNode,"left");break;case"hax-plate-create-right":this.haxInjectGridplate(this.activeContainerNode,"right");break;case"hax-plate-duplicate":this.activeNode===this.activeContainerNode?this.haxDuplicateNode(this.activeNode):this.haxDuplicateNode(this.activeNode,this.activeContainerNode);break;case"hax-plate-delete":if(null!=this.activeNode){let options=[{icon:"thumb-up",color:"green",title:"Yes"},{icon:"thumb-down",color:"red",title:"No"}],tag=this.activeNode.tagName.toLowerCase(),humanName=tag.replace("-"," ");void 0!==window.HaxStore.instance.elementList[tag]&&!1!==window.HaxStore.instance.elementList[tag].gizmo&&(humanName=window.HaxStore.instance.elementList[tag].gizmo.title),window.HaxStore.instance.haxAppPicker.presentOptions(options,"",`Remove this \`${humanName}\`?`,"delete")}break;case"hax-plate-first":this.haxMoveGridPlate("first",this.activeNode,this.activeContainerNode);break;case"hax-plate-up":this.haxMoveGridPlate("up",this.activeNode,this.activeContainerNode);break;case"hax-manager-open":window.HaxStore.write("activeHaxElement",{},this),window.HaxStore.instance.haxManager.resetManager(parseInt(detail.value)),window.HaxStore.write("openDrawer",window.HaxStore.instance.haxManager,this);break;case"hax-plate-down":this.haxMoveGridPlate("down",this.activeNode,this.activeContainerNode);break;case"hax-plate-last":this.haxMoveGridPlate("last",this.activeNode,this.activeContainerNode);break;case"close-menu":this.activeNode=null,this.activeContainerNode=null,window.HaxStore.write("activeNode",null,this),window.HaxStore.write("activeContainerNode",null,this);break;case"hax-edit-property":let haxInputMixer=this.shadowRoot.querySelector("#haxinputmixer");haxInputMixer.label=detail.target.label,haxInputMixer.options=detail.target.options,haxInputMixer.icon=detail.target.icon,haxInputMixer.description=detail.target.description,haxInputMixer.required=detail.target.required,haxInputMixer.validation=detail.target.validation,haxInputMixer.validationType=detail.target.validationType,haxInputMixer.inputMethod=detail.target.inputMethod,haxInputMixer.value="",void 0!==detail.target.propertyToBind&&null!=detail.target.propertyToBind&&0!=detail.target.propertyToBind&&(haxInputMixer.propertyToBind=detail.target.propertyToBind,void 0!==this.activeNode[detail.target.propertyToBind]?haxInputMixer.value=this.activeNode[detail.target.propertyToBind]:haxInputMixer.value=this.activeNode.getAttribute(detail.target.propertyToBind)),this._positionContextMenu(haxInputMixer,this.activeContainerNode,-1,-38);let style=this.shadowRoot.querySelector("#cecontextmenu").currentStyle||window.getComputedStyle(this.shadowRoot.querySelector("#cecontextmenu"));haxInputMixer.style.width=style.width.replace("px","")-40+"px";break;case"hax-align-left":this.activeNode.style.float=null,this.activeNode.style.margin=null,this.activeNode.style.display=null;break;case"hax-align-center":this.activeNode.style.float=null,this.activeNode.style.margin="0 auto",this.activeNode.style.display="block";break;case"hax-size-change":this.activeNode&&(this.activeNode.style.width=detail.value+"%");break;case"hax-manager-configure":this._hideContextMenu(this.shadowRoot.querySelector("#haxinputmixer")),window.HaxStore.instance.haxManager.resetManager(),haxElement=window.HaxStore.nodeToHaxElement(this.activeNode),window.HaxStore.write("activeHaxElement",haxElement,this),window.HaxStore.instance.haxManager.editExistingNode=!0,window.HaxStore.instance.haxManager.selectStep("configure"),window.HaxStore.write("openDrawer",window.HaxStore.instance.haxManager,this),setTimeout(()=>{window.HaxStore.instance.haxManager.shadowRoot.querySelector("#preview").shadowRoot.querySelector("#configurebutton").focus()},100);break;case"hax-manager-configure-container":window.HaxStore.write("activeNode",window.HaxStore.instance.activeContainerNode,this),this._hideContextMenu(this.shadowRoot.querySelector("#haxinputmixer")),window.HaxStore.instance.haxManager.resetManager(),haxElement=window.HaxStore.nodeToHaxElement(window.HaxStore.instance.activeNode),window.HaxStore.write("activeHaxElement",haxElement,this),window.HaxStore.instance.haxManager.editExistingNode=!0,window.HaxStore.instance.haxManager.selectStep("configure"),window.HaxStore.write("openDrawer",window.HaxStore.instance.haxManager,this),setTimeout(()=>{window.HaxStore.instance.haxManager.shadowRoot.querySelector("#preview").shadowRoot.querySelector("#configurebutton").focus()},100)}}_haxInputMixerOperation(e){let mixer=e.detail.inputMixer;null!=mixer.propertyToBind?this.activeNode[mixer.propertyToBind]=mixer.value:null!=mixer.slotToBind&&(item=document.createElement("span"),item.style.height="inherit",item.innerHTML=mixer.value,item.slot=mixer.slotToBind,this.activeNode.appendChild(item)),this._hideContextMenu(this.shadowRoot.querySelector("#haxinputmixer"))}_focusIn(e){this.__focusLogic(e.target)&&e.stopPropagation()}__focusLogic(target){let stopProp=!1;if(this.openDrawer||!this.editMode||this.__tabTrap)this.__tabTrap=!1;else{let containerNode=target;"SPAN"===containerNode.tagName&&window.HaxStore.instance.isTextElement(target.parentNode)&&(containerNode=target.parentNode);let activeNode=null;if(this._validElementTest(containerNode)&&containerNode.parentNode&&containerNode.parentNode.tagName){for(;"HAX-BODY"!=containerNode.parentNode.tagName;)null===activeNode&&"LI"!==containerNode.tagName&&"B"!==containerNode.tagName&&"I"!==containerNode.tagName&&"STRONG"!==containerNode.tagName&&"EM"!==containerNode.tagName&&(activeNode=containerNode),containerNode=containerNode.parentNode;null===activeNode?activeNode=containerNode:window.HaxStore.instance.isGridPlateElement(containerNode)?["UL","OL","LI","P","GRID-PLATE"].includes(containerNode.tagName)&&["UL","OL","LI"].includes(activeNode.tagName)&&(activeNode=containerNode):activeNode=containerNode,this.activeContainerNode===containerNode||containerNode.classList.contains("ignore-activation")?containerNode.classList.contains("ignore-activation")&&(stopProp=!0):(this.hideContextMenus(),this.activeContainerNode=containerNode,window.HaxStore.write("activeContainerNode",containerNode,this),stopProp=!0),this.activeNode===activeNode||activeNode.classList.contains("ignore-activation")||(this.activeNode=activeNode,window.HaxStore.write("activeNode",activeNode,this),this.positionContextMenus(activeNode,containerNode),stopProp=!0)}}return stopProp}_editModeChanged(newValue,oldValue){void 0!==oldValue&&(this._applyContentEditable(newValue),this.setAttribute("tabindex","-1"),newValue&&setTimeout(()=>{this.children&&this.children[0]&&this.children[0].focus?(this.activeNode=this.children[0],this.activeContainerNode=this.activeNode,window.HaxStore.write("activeNode",this.children[0],this),window.HaxStore.write("activeContainerNode",this.children[0],this),setTimeout(()=>{if(window.HaxStore.instance.isTextElement(this.activeNode)){try{var range=document.createRange(),sel=window.HaxStore.getSelection();range.setStart(this.activeNode,0),range.collapse(!0),sel.removeAllRanges(),sel.addRange(range),this.activeNode.focus()}catch(e){console.warn(e)}this.positionContextMenus()}},0)):(this.haxInsert("p","",{},!1),setTimeout(()=>{try{var range=document.createRange(),sel=window.HaxStore.getSelection();range.setStart(this.activeNode,0),range.collapse(!0),sel.removeAllRanges(),sel.addRange(range),this.activeNode.focus(),this.activeContainerNode=this.activeNode,window.HaxStore.write("activeContainerNode",this.activeContainerNode,this)}catch(e){console.warn(e)}this.positionContextMenus()},0))},100)),0==newValue&&(this.removeAttribute("contenteditable"),setTimeout(()=>{this.hideContextMenus()},50))}_haxResolvePreviousElement(node){for(node=node.previousElementSibling;null!=node&&void 0!==node.tagName&&"HAX-"===node.tagName.substring(0,4);)node=node.previousElementSibling;return node}_validElementTest(node){return void 0!==node.tagName&&("HAX-"!==node.tagName.substring(0,4)||"HAX-LOGO"===node.tagName)}_HTMLPrimativeTest(node){return null!=node&&void 0!==node.tagName&&-1==node.tagName.indexOf("-")}_applyContentEditable(status,target=this.shadowRoot.querySelector("#body")){let children="slot"===target.localName?target.assignedNodes({flatten:!0}):[];0===children.length&&(children=target.children);for(var i=0,len=children.length;i<len;i++)this._validElementTest(children[i])&&(!status||!0!==children[i].getAttribute("contenteditable")&&"true"!=children[i].getAttribute("contenteditable")&&"contenteditable"!=children[i].getAttribute("contenteditable"))&&this.__applyNodeEditableState(children[i],status)}__applyNodeEditableState(node,status=!0){let listenerMethod,haxRay=node.tagName.replace("-"," ").toLowerCase(),i=window.HaxStore.instance.gizmoList.findIndex(j=>j.tag===node.tagName.toLowerCase());if(-1!==i&&(haxRay=window.HaxStore.instance.gizmoList[i].title),status?(node.setAttribute("data-editable",status),node.setAttribute("data-hax-ray",haxRay),listenerMethod="addEventListener"):(node.removeAttribute("data-editable"),node.removeAttribute("data-hax-ray"),listenerMethod="removeEventListener"),node[listenerMethod]("drop",this.dropEvent.bind(this)),node[listenerMethod]("dragenter",this.dragEnter.bind(this)),node[listenerMethod]("dragleave",this.dragLeave.bind(this)),node[listenerMethod]("dragover",(function(e){e.preventDefault()})),this._HTMLPrimativeTest(node)&&(status?node.setAttribute("contenteditable",status):node.removeAttribute("contenteditable"),node.querySelectorAll("a").length>0)){let links=node.querySelectorAll("a");for(var j=0,len2=links.length;j<len2;j++)status?(links[j].setAttribute("contenteditable",status),links[j].setAttribute("data-editable",status)):(links[j].removeAttribute("contenteditable"),links[j].removeAttribute("data-editable")),links[j][listenerMethod]("click",e=>{e.preventDefault(),e.stopPropagation(),e.stopImmediatePropagation()})}}dropEvent(e){if(clearTimeout(timer),!this.openDrawer&&this.editMode){setTimeout(()=>{let children=this.children;for(var i in children)void 0!==children[i].classList&&(children[i].classList.remove("mover","hovered","moving","grid-plate-active-item"),"GRID-PLATE"===children[i].tagName&&children[i].dropEvent(e))},0);var target=window.HaxStore.instance.__dragTarget,local=e.target;if(null!=target&&void 0!==local&&target!==local&&target!==local.parentNode&&target.parentNode===this||local.parentNode===this){target.removeAttribute("slot");try{local.parentNode.insertBefore(target,local)}catch(e){console.warn(e)}e.preventDefault(),e.stopPropagation()}target&&"function"==typeof target.focus&&(this.activeNode=target,"GRID-PLATE"===this.activeNode.parentNode.tagName&&(this.activeContainerNode=this.activeNode.parentNode),window.HaxStore.write("activeNode",this.activeNode,this),window.HaxStore.write("activeContainerNode",this.activeContainerNode,this),setTimeout(()=>{this.positionContextMenus()},10))}}dragEnter(e){!this.openDrawer&&this.editMode&&e.target&&e.target.classList&&(e.preventDefault(),e.target.classList.add("hovered"),this.handleMousemove(e))}handleMousemove(e){var viewportX=e.clientX,viewportY=e.clientY,viewportWidth=document.documentElement.clientWidth,viewportHeight=document.documentElement.clientHeight,edgeTop=edgeSize,edgeLeft=edgeSize,edgeBottom=viewportHeight-edgeSize,edgeRight=viewportWidth-edgeSize,isInLeftEdge=viewportX<edgeLeft,isInRightEdge=viewportX>edgeRight,isInTopEdge=viewportY<edgeTop,isInBottomEdge=viewportY>edgeBottom;if(isInLeftEdge||isInRightEdge||isInTopEdge||isInBottomEdge){var documentWidth=Math.max(document.body.scrollWidth,document.body.offsetWidth,document.body.clientWidth,document.documentElement.scrollWidth,document.documentElement.offsetWidth,document.documentElement.clientWidth),documentHeight=Math.max(document.body.scrollHeight,document.body.offsetHeight,document.body.clientHeight,document.documentElement.scrollHeight,document.documentElement.offsetHeight,document.documentElement.clientHeight),maxScrollX=documentWidth-viewportWidth,maxScrollY=documentHeight-viewportHeight;!function checkForWindowScroll(){clearTimeout(timer),function adjustWindowScroll(){var currentScrollX=window.pageXOffset,currentScrollY=window.pageYOffset,canScrollUp=currentScrollY>0,canScrollDown=currentScrollY<maxScrollY,canScrollLeft=currentScrollX>0,canScrollRight=currentScrollX<maxScrollX,nextScrollX=currentScrollX,nextScrollY=currentScrollY;if(isInLeftEdge&&canScrollLeft){nextScrollX-=maxStep*((edgeLeft-viewportX)/edgeSize)}else if(isInRightEdge&&canScrollRight){nextScrollX+=maxStep*((viewportX-edgeRight)/edgeSize)}if(isInTopEdge&&canScrollUp){nextScrollY-=maxStep*((edgeTop-viewportY)/edgeSize)}else if(isInBottomEdge&&canScrollDown){nextScrollY+=maxStep*((viewportY-edgeBottom)/edgeSize)}return nextScrollX=Math.max(0,Math.min(maxScrollX,nextScrollX)),nextScrollY=Math.max(0,Math.min(maxScrollY,nextScrollY)),(nextScrollX!==currentScrollX||nextScrollY!==currentScrollY)&&(window.scrollTo(nextScrollX,nextScrollY),!0)}()&&(timer=setTimeout(checkForWindowScroll,30))}()}else clearTimeout(timer)}dragLeave(e){!this.openDrawer&&this.editMode&&e.target.classList.remove("hovered")}_activeContainerNodeChanged(newValue,oldValue){if(this.editMode&&void 0!==newValue&&null!=newValue&&null!=newValue.tagName){window.HaxStore.instance.isTextElement(newValue)||window.HaxStore.instance.isGridPlateElement(newValue)?(newValue.setAttribute("contenteditable",!0),this.setAttribute("contenteditable",!0)):(newValue.removeAttribute("contenteditable"),this.removeAttribute("contenteditable")),oldValue&&"GRID-PLATE"==oldValue.tagName&&(oldValue.activeItem=null),"grid-plate"===newValue.tagName.toLowerCase()&&(newValue.editMode=this.editMode,this._applyContentEditable(this.editMode,newValue))}}_activeNodeChanged(newValue,oldValue){if(this.querySelectorAll(".hax-active").forEach(el=>{el.classList.remove("hax-active")}),this.editMode&&null!=newValue){let tag=newValue.tagName.toLowerCase();newValue.classList.add("hax-active"),window.HaxStore.instance.isTextElement(newValue)||window.HaxStore.instance.isGridPlateElement(newValue)?(newValue.setAttribute("contenteditable",!0),this.setAttribute("contenteditable",!0),clearTimeout(this.__positionContextTimer),this.__positionContextTimer=setTimeout(()=>{newValue===this.activeNode&&this.positionContextMenus(newValue)},10)):(newValue.removeAttribute("contenteditable"),this.removeAttribute("contenteditable")),this.shadowRoot.querySelector("#textcontextmenu").realSelectedValue=tag,"left"==newValue.style.textAlign?(this.shadowRoot.querySelector("#textcontextmenu").justifyIcon="editor:format-align-left",this.shadowRoot.querySelector("#textcontextmenu").justifyValue="text-align-left"):"left"==newValue.style.float?(this.shadowRoot.querySelector("#cecontextmenu").justifyIcon="editor:format-align-left",this.shadowRoot.querySelector("#cecontextmenu").justifyValue="hax-align-left"):"0 auto"==newValue.style.margin&&(this.shadowRoot.querySelector("#cecontextmenu").justifyIcon="editor:format-align-center",this.shadowRoot.querySelector("#cecontextmenu").justifyValue="hax-align-center")}else null===newValue&&(this.hideContextMenus(),this.__oldActiveNode=oldValue,this.shadowRoot.querySelector("#textcontextmenu").justifyIcon="editor:format-align-left",this.shadowRoot.querySelector("#textcontextmenu").justifyValue="text-align-left")}_getPosition(element){return{x:element.offsetLeft-element.scrollLeft+element.clientLeft,y:element.offsetTop-element.scrollTop+element.clientTop}}_positionContextMenu(menu,target,xoffset,yoffset){if(null!=target){let pos=this._getPosition(target);menu.style.left=null!=xoffset?pos.x+xoffset+"px":pos.x+"px",menu.style.top=null!=yoffset?pos.y+yoffset+"px":pos.y+"px"}menu.setAttribute("on-screen","on-screen"),menu.classList.add("hax-context-visible"),this.__activeHover&&(menu.classList.add("hax-active-hover"),menu.style.marginLeft="",this.__typeLock=!1)}_hideContextMenu(menu){menu.removeAttribute("on-screen"),menu.classList.remove("hax-context-visible","hax-active-hover","hax-context-pin-top","hax-context-pin-bottom"),menu.style.left="-100px"}_tabKeyPressed(){let focus=!1,node=this.activeContainerNode;const activeNodeTagName=this.activeContainerNode.tagName;try{let range=window.HaxStore.getRange().cloneRange();var tagTest=range.commonAncestorContainer.tagName;if(void 0===tagTest&&(tagTest=range.commonAncestorContainer.parentNode.tagName),["UL","OL","LI"].includes(activeNodeTagName)||["UL","OL","LI"].includes(tagTest))this.polyfillSafe&&(document.execCommand("indent"),this.__tabTrap=!0);else for(;!focus;)null==node.nextSibling?focus=!0:"function"===node.nextSibling.focus?(node.nextSibling.focus(),focus=!0):node=node.nextSibling}catch(e){console.warn(e)}}_tabBackKeyPressed(){let node=this.activeContainerNode;const activeNodeTagName=this.activeContainerNode.tagName;try{let range=window.HaxStore.getRange().cloneRange();var tagTest=range.commonAncestorContainer.tagName;if(void 0===tagTest&&(tagTest=range.commonAncestorContainer.parentNode.tagName),["UL","OL","LI"].includes(activeNodeTagName)||["UL","OL","LI"].includes(tagTest))this.polyfillSafe&&(document.execCommand("outdent"),this.__tabTrap=!0);else{if(null!=node)for(;null!=node&&!this._validElementTest(node);)node=node.previousSibling;null!=node&&setTimeout(()=>{node.focus()},50)}}catch(e){console.warn(e)}}}window.customElements.define(HaxBody.tag,HaxBody);export{HaxBody};