import{html,css}from"../../../lit-element/lit-element.js";import{SimpleColors}from"../../simple-colors/simple-colors.js";import{winEventsElement}from"../../utils/utils.js";import"../../../@polymer/polymer/lib/elements/custom-style.js";class HaxPanel extends(winEventsElement(SimpleColors)){static get styles(){return[...super.styles,css`
        :host {
          display: block;
          position: absolute;
          z-index: 1000000;
        }
        :host *[hidden] {
          display: none;
        }
        iron-icon:not(:defined),
        hax-panel-item:not(:defined),
        app-drawer:not(:defined) {
          display: none;
        }
        app-drawer {
          z-index: 100001;
          height: 40px;
          padding: var(--hax-panel-padding, 8px 16px);
          left: 0;
          top: 0;
          align-items: center;
          touch-action: auto;
          visibility: hidden;
          opacity: 0;
          display: flex;
          --app-drawer-width: 100%;
        }
        hax-panel-item {
          margin: 8px 2px;
        }
        hax-panel-item[right] {
          float: right;
        }
        #haxcancelbutton {
          margin-right: 48px;
        }
        :host([edit-mode]) app-drawer {
          visibility: visible;
          transition: 0.3s ease opacity;
          opacity: 1;
          right: 0;
          left: 0;
          top: 0;
        }

        #button {
          color: white;
          position: fixed;
          top: 0;
          left: 0;
          visibility: visible;
          z-index: 10000;
          transition: all 0.3s ease;
          margin: 0;
          border-top-left-radius: 0;
        }
        :host([edit-mode]) #button {
          visibility: hidden;
          opacity: 0;
        }
        #button:hover {
          opacity: 1;
        }
        :host([align="right"]) #button {
          right: 0;
          left: unset;
          border-top-right-radius: 0;
          border-top-left-radius: unset;
        }
        .active-op-name,
        .editing-mode-active {
          display: none;
        }
        :host([edit-mode]) .active-op-name {
          display: flex;
          top: 0;
          right: 0;
          z-index: 1000000;
          position: fixed;
          font-size: 14px;
          border-bottom: 1px solid black;
          border-left: 1px solid black;
          font-weight: bold;
          padding: 16px 28px 16px 16px;
          line-height: 24px;
          height: 23px;
          min-width: 120px;
          justify-content: space-evenly;
          color: var(--hax-color-menu-heading-bg, black);
          background-color: var(--hax-color-menu-heading-color, #eeeeee);
          vertical-align: middle;
        }
        :host([edit-mode]) .editing-mode-active {
          display: flex;
          font-size: 18px;
          margin-left: 100px;
          padding: 0 8px;
          font-weight: bold;
          color: var(--hax-color-menu-heading-bg, black);
          background-color: var(--hax-color-menu-heading-color, #eeeeee);
        }
        @media screen and (max-width: 600px) {
          :host([edit-mode]) .hide-small {
            display: none;
          }
        }
        @media screen and (max-width: 800px) {
          :host([edit-mode]) #haxcancelbutton {
            margin-right: 2px;
          }
          :host([edit-mode]) .editing-mode-active,
          :host([edit-mode]) .active-op-name {
            display: none;
          }
        }
      `]}constructor(){super(),this.__winEvents={"hax-store-property-updated":"_haxStorePropertyUpdated","hax-active-hover-name":"_activeNameChange","hax-panel-operation":"_processItemEvent"},this.canUndo=!0,this.canRedo=!0,this.align="left",this.hideExportButton=!1,this.haxDeveloperMode=!1,this.editModeName="You are editing content",this.hidePreferencesButton=!1,this.hidePanelOps=!1,import("../../../@polymer/iron-icons/iron-icons.js"),import("../../../@polymer/iron-icons/editor-icons.js"),import("../../../@polymer/iron-icons/device-icons.js"),import("../../../@polymer/iron-icons/hardware-icons.js"),import("../../../@polymer/iron-icons/communication-icons.js"),import("../../../@polymer/iron-icons/social-icons.js"),import("../../../@polymer/iron-icons/av-icons.js"),import("../../../@polymer/iron-icons/maps-icons.js"),import("../../../@polymer/app-layout/app-drawer/app-drawer.js"),import("./hax-panel-item.js"),import("../../hax-iconset/hax-iconset.js"),setTimeout(()=>{this.addEventListener("hax-item-selected",this._processItemEvent.bind(this))},0)}firstUpdated(changedProperties){super.firstUpdated&&super.firstUpdated(changedProperties),this.dispatchEvent(new CustomEvent("hax-register-core-piece",{bubbles:!0,cancelable:!0,composed:!0,detail:{piece:"haxPanel",object:this}}))}render(){return html`
      <custom-style>
        <style>
          app-drawer {
            --app-drawer-content-container: {
              align-items: center;
              width: 100%;
              left: 0;
              right: 0;
              background-color: var(--hax-color-bg);
              border-bottom: 1px solid black;
              padding: var(--hax-panel-padding, 0px 16px);
              display: flex;
              touch-action: auto;
              overflow-x: auto;
              overflow: visible !important;
              -webkit-overflow-scrolling: touch;
              white-space: nowrap;
            }
          }
        </style>
      </custom-style>
      <div ?hidden="${this.hidePanelOps}">
        <hax-panel-item
          dark
          large
          .data-opened="${this.editMode}"
          @click="${this._clickEditButton}"
          icon="create"
          id="button"
          label="${this.__tipText}"
        ></hax-panel-item>
      </div>
      <app-drawer
        id="drawer"
        ?opened="${this.editMode}"
        @opened-changed="${this.openedChanged}"
        disable-swipe
        persistent
        transition-duration="300"
      >
        <hax-panel-item
          ?hidden="${this.hidePanelOps}"
          @click="${this._clickSaveButton}"
          icon="save"
          id="haxsavebutton"
          label="${this.__tipText}"
          event-name="save"
          voice-command="save content"
        ></hax-panel-item>
        <hax-panel-item
          ?hidden="${this.hidePanelOps}"
          icon="cancel"
          id="haxcancelbutton"
          label="Cancel"
          event-name="cancel"
          voice-command="cancel"
        ></hax-panel-item>
        <hax-panel-item
          icon="icons:file-upload"
          label="Upload media"
          event-name="hax-manager-open"
          value="0"
          voice-command="(upload)(add) media"
        ></hax-panel-item>
        <hax-panel-item
          icon="search"
          label="Search for media"
          event-name="hax-manager-open"
          value="1"
          voice-command="(search)(find) media"
        ></hax-panel-item>
        <hax-panel-item
          icon="hax:add-brick"
          label="Create page element"
          event-name="hax-manager-open"
          voice-command="create (page) (element)(widget)"
          value="2"
        ></hax-panel-item>
        <hax-panel-item
          icon="icons:view-column"
          label="Insert layout"
          event-name="hax-blox-picker-open"
          voice-command="insert (page) layout"
        ></hax-panel-item>
        <hax-panel-item
          icon="hax:templates"
          label="Insert template"
          event-name="hax-stax-picker-open"
          voice-command="insert (page) template"
        ></hax-panel-item>
        <hax-panel-item
          icon="hax:paragraph"
          label="Insert paragraph"
          event-name="text"
          voice-command="insert (text)(paragraph)"
          class="hide-small"
        ></hax-panel-item>
        <hax-panel-item
          ?hidden="${this.hideExportButton}"
          event-name="open-export-dialog"
          icon="code"
          label="View page source"
          voice-command="view (page) source"
        ></hax-panel-item>
        <slot></slot>
        <hax-panel-item
          icon="icons:undo"
          ?disabled="${!this.canUndo}"
          label="Undo previous action"
          event-name="undo"
          voice-command="undo"
          class="hide-small"
        ></hax-panel-item>
        <hax-panel-item
          icon="icons:redo"
          ?disabled="${!this.canRedo}"
          label="Redo previous action"
          event-name="redo"
          voice-command="redo"
          class="hide-small"
        ></hax-panel-item>
        <hax-panel-item
          right
          ?hidden="${this.hidePreferencesButton}"
          event-name="open-preferences-dialog"
          icon="settings"
          label="Editor preferences"
          voice-command="open (editor) preferences"
        ></hax-panel-item>
        <div class="editing-mode-active">${this.editModeName}</div>
      </app-drawer>
      <div class="active-op-name">${this.activeOperationName}</div>
    `}static get tag(){return"hax-panel"}openedChanged(e){this.editMode=e.detail.value}static get properties(){return{light:{type:Boolean},__tipText:{type:String},align:{type:String,reflect:!0},editMode:{type:Boolean,reflect:!0,attribute:"edit-mode"},hideExportButton:{type:Boolean,reflect:!0,attribute:"hide-export-button"},haxDeveloperMode:{type:Boolean,reflect:!0,attribute:"hax-developer-mode"},activeOperationName:{type:String},editModeName:{type:String},hidePreferencesButton:{type:Boolean,reflect:!0,attribute:"hide-preferences-button"},hidePanelOps:{type:Boolean,reflect:!0,attribute:"hide-panel-ops"},globalPreferences:{type:Object},canUndo:{type:Boolean,attribute:"can-undo"},canRedo:{type:Boolean,attribute:"can-redo"},isDirty:{type:Boolean,attribute:"is-dirty"}}}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{"editMode"==propName&&this._editModeChanged(this[propName],oldValue),"globalPreferences"==propName&&this._globalPreferencesChanged(this[propName],oldValue)})}_activeNameChange(e){this.activeOperationName=e.detail}_globalPreferencesChanged(newValue){newValue&&void 0!==newValue.haxShowExportButton&&(this.hideExportButton=!newValue.haxShowExportButton)}_haxStorePropertyUpdated(e){e.detail&&void 0!==e.detail.value&&e.detail.property&&("globalPreferences"===e.detail.property&&(this[e.detail.property]={}),this[e.detail.property]=e.detail.value)}_processItemEvent(e){let detail=e.detail;switch(detail.eventName){case"open-panel":this._clickButton();break;case"cancel":this.toggle(),this.dispatchEvent(new CustomEvent("hax-cancel",{bubbles:!0,cancelable:!0,composed:!0,detail}));break;case"text":detail.tag="p",detail.content="",this.dispatchEvent(new CustomEvent("hax-insert-content",{bubbles:!0,cancelable:!0,composed:!0,detail}));break;case"open-preferences-dialog":window.HaxStore.write("openDrawer",window.HaxStore.instance.haxPreferences,this);break;case"open-export-dialog":window.HaxStore.write("openDrawer",window.HaxStore.instance.haxExport,this);break;case"divider":detail.tag="hr",detail.content="",detail.properties={style:"width:100%;"},this.dispatchEvent(new CustomEvent("hax-insert-content",{bubbles:!0,cancelable:!0,composed:!0,detail}));break;case"header":detail.tag="h2",detail.content="Header",this.dispatchEvent(new CustomEvent("hax-insert-content",{bubbles:!0,cancelable:!0,composed:!0,detail}));break;case"placeholder":detail.tag="place-holder",detail.content="",detail.properties={style:"width:50%;"},this.dispatchEvent(new CustomEvent("hax-insert-content",{bubbles:!0,cancelable:!0,composed:!0,detail}));break;case"blockquote":detail.tag="blockquote",detail.content="",this.dispatchEvent(new CustomEvent("hax-insert-content",{bubbles:!0,cancelable:!0,composed:!0,detail}));break;case"hax-manager-open":window.HaxStore.write("activeHaxElement",{},this),window.HaxStore.instance.haxManager.resetManager(parseInt(detail.value)),window.HaxStore.write("openDrawer",window.HaxStore.instance.haxManager,this);break;case"hax-stax-picker-open":window.HaxStore.write("openDrawer",window.HaxStore.instance.haxStaxPicker,this);break;case"hax-blox-picker-open":window.HaxStore.write("openDrawer",window.HaxStore.instance.haxBloxPicker,this);break;case"undo":document.execCommand("undo");break;case"redo":document.execCommand("redo")}}_editModeChanged(newValue,oldValue){void 0!==newValue&&newValue?(this.__tipText="Save content",this.shadowRoot.querySelector("#button").icon="save"):(this.__tipText="Edit content",this.shadowRoot.querySelector("#button").icon="create")}_clickEditButton(e){this.toggle(),window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,cancelable:!0,detail:{}}))}_clickSaveButton(e){this.toggle(),this.dispatchEvent(new CustomEvent("hax-save",{bubbles:!0,cancelable:!0,composed:!0,detail:e.detail})),window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,cancelable:!0,detail:{}}))}toggle(e){window.HaxStore.write("editMode",!this.editMode,this),this.shadowRoot.querySelector("#drawer").opened=this.editMode,this.shadowRoot.querySelector("#drawer").opened||window.HaxStore.write("openDrawer",!1,this)}}window.customElements.define(HaxPanel.tag,HaxPanel);export{HaxPanel};