/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement,html,css}from"../../lit-element/lit-element.js";import"../json-editor/json-editor.js";import"../code-editor/code-editor.js";import"../../@vaadin/vaadin-split-layout/vaadin-split-layout.js";import"../../@polymer/paper-button/paper-button.js";import"../hax-body/lib/hax-schema-form.js";import{HAXWiring}from"../hax-body-behaviors/hax-body-behaviors.js";class HaxschemaBuilder extends LitElement{static get styles(){return[css`
        :host {
          display: block;
        }

        :host([hidden]) {
          display: none;
        }
        code-editor {
          height: 500px;
        }
      `]}render(){return html`
      <vaadin-split-layout>
        <div>
          <paper-button raised noink @click="${this.addConfigure}"
            >Add to configure</paper-button
          >
          <paper-button raised noink @click="${this.addAdvanced}"
            >Add to advanced</paper-button
          >
          <code-editor
            id="code"
            @value-changed="${this._editorDataChanged}"
            .value="{}"
            language="json"
          ></code-editor>
          <json-editor
            id="json"
            label="JSON"
            @value-changed="${this.__haxSchemaChanged}"
            value="${this.haxSchema}"
          ></json-editor>
        </div>
        <div>
          <hax-schema-form
            id="form"
            value="${this.value}"
            @value-changed="${this.__valueChanged}"
          ></hax-schema-form>
        </div>
      </vaadin-split-layout>
    `}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!0,gizmo:{title:"Haxschema builder",description:"dynamically build and visualize HAXschema",icon:"icons:android",color:"green",groups:["Builder"],handles:[],meta:{author:"btopro",owner:"The Pennsylvania State University"}},settings:{quick:[],configure:[{property:"source",description:"",inputMethod:"textfield",required:!0,icon:"icons:link",validationType:"url"}],advanced:[]}}}static get properties(){return{...super.properties,haxSchema:{type:String,attribute:"hax-schema"},source:{type:String},value:{type:String}}}static get tag(){return"haxschema-builder"}constructor(){super(),this.HAXWiring=new HAXWiring,this.haxSchema="{}"}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{"haxSchema"==propName&&(this.dispatchEvent(new CustomEvent("hax-schema-changed",{value:this[propName]})),this._haxSchemaChanged(this[propName],oldValue))})}firstUpdated(){setTimeout(()=>{this.source||(this.haxSchema=JSON.stringify(this.HAXWiring.prototypeHaxProperties(),null,2))},0),this.shadowRoot.querySelector("#form").modeTab="advanced",setTimeout(()=>{this.shadowRoot.querySelector("#form").modeTab="configure"},2e3)}_haxSchemaChanged(newValue){newValue&&(this.shadowRoot.querySelector("#code").editorValue=newValue)}_editorDataChanged(e){this.haxSchema=e.detail.value;let hs=JSON.parse(this.haxSchema);for(var key in hs.settings){let schema=this.HAXWiring.getHaxJSONSchema(key,hs);this.shadowRoot.querySelector("#form")[key+"Schema"]=Object.assign({},schema)}}addAdvanced(e){let hs=JSON.parse(this.haxSchema);hs.settings.advanced.push(this.__propPrototype()),this.__refreshSchemas(hs)}addConfigure(e){let hs=JSON.parse(this.haxSchema);hs.settings.configure.push(this.__propPrototype()),this.__refreshSchemas(hs)}__refreshSchemas(hs){for(var key in hs.settings){let schema=this.HAXWiring.getHaxJSONSchema(key,hs);this.shadowRoot.querySelector("#form")[key+"Schema"]=Object.assign({},schema)}this.haxSchema=JSON.stringify(hs)}__propPrototype(){return{property:"title",title:"Title",description:"",inputMethod:"textfield",icon:"android",required:!0,validationType:"text"}}__haxSchemaChanged(e){this.haxSchema=e.detail.value}__valueChanged(e){this.value=e.detail.value}}window.customElements.define(HaxschemaBuilder.tag,HaxschemaBuilder);export{HaxschemaBuilder};