/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement,html,css}from"../../lit-element/lit-element.js";class JsonEditor extends LitElement{static get styles(){return[css`
        :host {
          display: block;
        }
        :host([hidden]) {
          display: none;
        }
      `]}render(){return html`
      <custom-style>
        <style>
          :host([error]) paper-textarea {
            --iron-autogrow-textarea: {
              background-color: #ffeeee;
            }
          }
          paper-textarea {
            --iron-autogrow-textarea: {
              font-family: "Lucida Console", Monaco, monospace;
              font-weight: 600;
              white-space: pre;
              line-height: 20px;
              padding: 9.5px;
              margin: 0 0 10px;
              font-size: 13px;
              color: #000000;
              word-break: break-all;
              word-wrap: break-word;
              background-color: #f5f5f5;
              border: 1px solid #ccc;
              border-radius: 4px;
              transition: 0.3s linear all;
            }
          }
        </style>
      </custom-style>
      <paper-textarea
        label="${this.label}"
        value="${this.value}"
        @value-changed="${this.valueEvent}"
        error-message="Invalid JSON!"
        ?readonly="${this.disabled}"
        ?invalid="${this.error}"
        max-rows="${this.maxRows}"
      ></paper-textarea>
    `}static get properties(){return{...super.properties,label:{type:String},error:{type:Boolean,reflect:!0},disabled:{type:Boolean,reflect:!0},maxRows:{type:Number,reflect:!0,attribute:"max-rows"},value:{type:String,reflect:!1},formatTest:{type:String,attribute:"format-test"},currentData:{type:Object,attribute:"current-data"}}}static get tag(){return"json-editor"}constructor(){super(),this.label="JSON data",this.error=!1,this.disabled=!1,this.maxRows=0,this.value="",import("../../@polymer/paper-input/paper-textarea.js")}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{if(["currentData","value"].includes(propName)){let eventName=`${propName.replace(/([a-z0-9]|(?=[A-Z]))([A-Z])/g,"$1-$2").toLowerCase()}-changed`;this.dispatchEvent(new CustomEvent(eventName,{detail:{value:this[propName]}}))}"value"==propName&&(this.formatTest=this._computeFormattedValue(this[propName]),this.currentData=this._computeCurrentData(this[propName]),this._valueChanged(this[propName]))})}valueEvent(e){this.value=e.detail.value}_valueChanged(newValue,oldValue){try{JSON.parse(newValue)&&(this.error=!1)}catch(e){this.error=!0}}_computeFormattedValue(value){try{let formatted=JSON.stringify(JSON.parse(formatted),null,2);formatted!==value&&(this.value=formatted)}catch(e){}}_computeCurrentData(value){try{return JSON.parse(value)}catch(e){}}}window.customElements.define(JsonEditor.tag,JsonEditor);export{JsonEditor};