/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement,html,css}from"../../lit-element/lit-element.js";import"../../@polymer/paper-tabs/paper-tabs.js";import"../../@polymer/marked-element/marked-element.js";import"../../@polymer/iron-pages/iron-pages.js";import"./lib/lrn-markdown-editor-editor.js";class LrnMarkdownEditor extends LitElement{static get styles(){return[css`
        :host {
          display: block;
        }

        #split-pane {
          display: flex;
        }

        .split-pane > * {
          flex: 1 1 auto;
          min-height: 160px;
        }

        .preview-pane {
          background: lightblue;
        }

        div.pane {
          padding: 16px;
          width: calc(100% - 32px);
        }

        paper-tabs {
          background: #f5f5f5;
          border-style: solid;
          border-color: #dcdcdc;
          border-width: 1px;
          min-width: 500px;
        }

        marked-element.lrn-markdown-editor {
          width: 100%;
          word-wrap: break-word;
        }

        .container-flex {
          display: flex;
          flex-wrap: nowrap;
        }

        .split-pane .container-flex > * {
          width: 50%;
        }

        .split-pane marked-element {
          width: calc(100% - 32px);
          min-width: 150px;
          margin: 0 16px;
          padding: 0 16px;
          background: #fff;
          border-left: solid #dcdcdc 1px;
        }
      `]}render(){return html`
      <div class="mtz-toolbar">
        <paper-tabs
          selected="${this.selected}"
          @selected-changed="${this.__selectedChanged}"
        >
          <paper-tab>Write</paper-tab>
          <paper-tab>Preview</paper-tab>
          <paper-tab>Split View</paper-tab>
        </paper-tabs>
      </div>

      <iron-pages
        selected="${this.selected}"
        @selected-changed="${this.__selectedChanged}"
      >
        <section>
          <div class="pane">
            <lrn-markdown-editor-editor
              content="${this.content}"
              @content-changed="${this.__contentChanged}"
            ></lrn-markdown-editor-editor>
          </div>
        </section>

        <section>
          <div class="pane">
            <marked-element
              markdown="${this.content}"
              @markdown-changed="${this.__contentChanged}"
            ></marked-element>
          </div>
        </section>

        <section class="split-pane">
          <div class="pane">
            <div class="container-flex">
              <lrn-markdown-editor-editor
                content="${this.content}"
                @content-changed="${this.__contentChanged}"
              ></lrn-markdown-editor-editor>
              <marked-element
                class="preview-pane"
                markdown="${this.content}"
                @markdown-changed="${this.__contentChanged}"
              ></marked-element>
            </div>
          </div>
        </section>
      </iron-pages>
    `}__selectedChanged(e){this.selected=e.detail.value}__contentChanged(e){this.content=e.detail.value}constructor(){super(),this.selected="0",this.layout="0",this.content="",this.cookies=!0,this.elReady=!1}static get tag(){return"lrn-markdown-editor"}static get properties(){return{content:{type:String},selected:{type:String,reflect:!0},layout:{type:String},cookies:{type:Boolean},elReady:{type:Boolean,attribute:"el-ready"}}}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{"selected"==propName&&this._selectedChanged(this[propName]),"content"===propName&&this.dispatchEvent(new CustomEvent("content-changed",{detail:{value:this[propName]}}))})}static get observers(){return["_selectedChanged(selected)"]}_selectedChanged(selected){var cookieName=this._getCookieName();2===selected?this._createCookie(cookieName,"true","30"):2!==selected&&!0===this.elReady&&this._eraseCookie(cookieName)}_createCookie(name,value,days){var expires="";if(days){var date=new Date;date.setTime(date.getTime()+24*days*60*60*1e3),expires="; expires="+date.toUTCString()}document.cookie=name+"="+value+expires+"; path=/"}_readCookie(name){for(var nameEQ=name+"=",ca=document.cookie.split(";"),i=0;i<ca.length;i++){for(var c=ca[i];" "==c.charAt(0);)c=c.substring(1,c.length);if(0==c.indexOf(nameEQ))return c.substring(nameEQ.length,c.length)}return null}_eraseCookie(name){this._createCookie(name,"",-1)}_getCookieName(){return"lrnmarkdowneditorsplitview"}firstUpdated(changedProperties){this.elReady=!0;var cookieName=this._getCookieName(),cookie=this._readCookie(cookieName);cookie&&"true"===cookie&&(this.selected=2)}}window.customElements.define(LrnMarkdownEditor.tag,LrnMarkdownEditor);export{LrnMarkdownEditor};