/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement,html,css}from"../../lit-element/lit-element.js";import{SchemaBehaviors}from"../schema-behaviors/schema-behaviors.js";import"../simple-modal/simple-modal.js";class LrnVocab extends(SchemaBehaviors(LitElement)){static get styles(){return[css`
        :host {
          display: inline-flex;
          --lrn-vocab-border: 1px dashed #ccc;
        }
        button {
          text-transform: none;
          min-width: unset;
          margin: 0;
          position: relative;
          top: 0px;
          border-radius: 0;
          border-bottom: var(--lrn-vocab-border);
          background: #f5f5f5;
          font-size: 1.1em;
          padding: 2px;
        }
        button:hover {
          background: #bbdefb;
          border-bottom: 1px dashed #2196f3;
        }
      `]}constructor(){super(),setTimeout(()=>{this.addEventListener("click",this.openDialog.bind(this))},0)}render(){return html`
      <button>${this.term}</button>
    `}static get tag(){return"lrn-vocab"}static get properties(){return{...super.properties,term:{type:String,reflect:!0}}}openDialog(e){let c=document.createElement("div");for(var id in this.children)this.children[id].cloneNode&&c.appendChild(this.children[id].cloneNode(!0));const evt=new CustomEvent("simple-modal-show",{bubbles:!0,cancelable:!0,composed:!0,detail:{title:this.term,elements:{content:c},styles:{"--simple-modal-width":"50vw","--simple-modal-height":"50vh"},invokedBy:this}});this.dispatchEvent(evt)}firstUpdated(changedProperties){super.firstUpdated&&super.firstUpdated(changedProperties),window.SimpleModal.requestAvailability()}static get haxProperties(){return import("../hax-iconset/hax-iconset.js"),{canScale:!1,canPosition:!1,canEditSource:!1,gizmo:{title:"Vocab",description:"Vocabulary term",icon:"hax:vocab",color:"red",groups:["Vocab"],handles:[{type:"inline",text:"term"}],meta:{author:"ELMS:LN"}},settings:{quick:[{property:"term",title:"Term",inputMethod:"textfield",icon:"editor:title",required:!0}],configure:[{property:"term",title:"Term",inputMethod:"textfield",icon:"editor:title",required:!0},{slot:"",title:"Contents",description:"The definitition to display when the term is clicked.",inputMethod:"code-editor",required:!0}],advanced:[]}}}}window.customElements.define(LrnVocab.tag,LrnVocab);export{LrnVocab};