/**
 * Inspired by https://github.com/olivernn/lunr.js
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement,html,css}from"../../lit-element/lit-element.js";import"../es-global-bridge/es-global-bridge.js";import"../../@polymer/iron-ajax/iron-ajax.js";class LunrSearch extends LitElement{static get styles(){return[css`
        :host {
          display: block;
        }

        :host([hidden]) {
          display: none;
        }
      `]}render(){return html`
      <iron-ajax
        auto
        url="${this.dataSource}"
        method="${this.method}"
        handle-as="json"
        @response="${this._dataResponse}"
      ></iron-ajax>
    `}static get properties(){return{...super.properties,dataSource:{type:String,attribute:"data-source"},data:{type:Array},method:{type:String},search:{type:String},results:{type:Array},noStopWords:{type:Boolean,attribute:"no-stop-words"},fields:{type:Array},indexNoStopWords:{type:Object},index:{type:Object},__lunrLoaded:{type:Boolean},limit:{type:Number},minScore:{type:Number},log:{type:Boolean}}}constructor(){super(),this.method="GET",this.noStopWords=!1,this.fields=[],this.limit=500,this.minScore=0,this.log=!1;const location=`${this.pathFromUrl(import.meta.url)}../../lunr/lunr.js`;window.addEventListener("es-bridge-lunr-loaded",this._lunrLoaded.bind(this)),window.ESGlobalBridge.requestAvailability(),window.ESGlobalBridge.instance.load("lunr",location),window.ESGlobalBridge.imports&&window.ESGlobalBridge.imports.lunr&&(this.__lunrLoaded=!0)}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{if(["data","search","results","noStopWords"].includes(propName)){let eventName=`${propName.replace(/([a-z0-9]|(?=[A-Z]))([A-Z])/g,"$1-$2").toLowerCase()}-changed`;this.dispatchEvent(new CustomEvent(eventName,{detail:{value:this[propName]}}))}["data","search","index","minScore","limit"].includes(propName)&&(this.results=this.searched(this.data,this.search,this.index,this.minScore,this.limit)),["data","fields","noStopWords","__lunrLoaded"].includes(propName)&&(this.index=this._createIndex(this.data,this.fields,this.noStopWords,this.__lunrLoaded))})}pathFromUrl(url){return url.substring(0,url.lastIndexOf("/")+1)}disconnectedCallback(){window.removeEventListener("es-bridge-lunr-loaded",this._lunrLoaded.bind(this)),super.disconnectedCallback()}_lunrLoaded(e){this.__lunrLoaded=!0}static get tag(){return"lunr-search"}_dataResponse(e){this.data=[...e.detail.response]}searched(data,search,index,minScore,limit){if(data&&index&&search){var results=[];if(""+search!="")for(var searched=index.search(search),i=0;i<searched.length&&!(i===limit||searched[i].score<minScore);i++){let tmpItem=data.find(j=>j.id==searched[i].ref);results.push(tmpItem)}if(0===results.length&&!this.noStopWords&&""+search!=""){this.indexNoStopWords||(this.indexNoStopWords=this._createIndex(data,this.fields,!0,index)),searched=this.indexNoStopWords.search(search);for(results=[],i=0;i<searched.length&&!(i===limit||searched[i].score<minScore);i++){let tmpItem=data.find(j=>j.id==searched[i].ref);results.push(tmpItem)}}return results}}_createIndex(data,fields,noStopWords,ready){if(ready){let root=this;if(Array.isArray(data)&&data.length>0){if(Array.isArray(fields)&&fields.length>0)return lunr((function(){for(var i=0;i<fields.length;i++)fields[i].charAt(0)===fields[i].charAt(0).toUpperCase()?this.field(fields[i],{boost:10}):this.field(fields[i]);for(i=0;i<data.length;i++){for(var toIndex={id:i},f=0;f<fields.length;f++)data[i].hasOwnProperty(fields[f])&&null!==data[i][fields[f]]&&"function"==typeof data[i][fields[f]].toString&&(data[i][fields[f]].toString().split(" ").length>2||data[i][fields[f]].toString().length<30)?toIndex[fields[f]]=data[i][fields[f]].toString():toIndex[fields[f]]="";this.add(toIndex)}noStopWords&&this.pipeline.remove(lunr.stopWordFilter)}));fields=[];var ddup={};return lunr((function(){for(var indexOfData=0;indexOfData<data.length;indexOfData++)for(var prop in data[indexOfData])"_"!==prop.charAt(0)&&!ddup.hasOwnProperty(prop)&&(prop.toString().split(" ").length>2||prop.toString().length<30)&&(fields.push(prop),prop.charAt(0)===prop.charAt(0).toUpperCase()?this.field(prop,{boost:10}):this.field(prop),ddup[prop]=1);fields.length>0&&(root.fields=fields);for(var i=0;i<data.length;i++){for(var toIndex={id:i},f=0;f<fields.length;f++)data[i].hasOwnProperty(fields[f])&&null!==data[i][fields[f]]&&"function"==typeof data[i][fields[f]].toString&&(data[i][fields[f]].toString().split(" ").length>2||data[i][fields[f]].toString().length<30)?toIndex[fields[f]]=data[i][fields[f]].toString():toIndex[fields[f]]="";this.add(toIndex)}noStopWords&&this.pipeline.remove(lunr.stopWordFilter)}))}}}}window.customElements.define(LunrSearch.tag,LunrSearch);export{LunrSearch};