/**
 * Material design: [Icons](https://material.io/guidelines/style/icons.html)
 * `mdi-audio-iconset-svg`
 * @customElement mdi-audio-iconset-svg is a iconset for the Material Design Icons collection with the "audio" tag
 *
 * Example:
 *   <iron-icon icon="mdi-audio:play"></iron-icon>
 *
 * @demo demo/index.html
 */
import "../../../@polymer/iron-icon/iron-icon.js";
import "../../../@polymer/iron-iconset-svg/iron-iconset-svg.js";
import { html } from "../../../@polymer/polymer/lib/utils/html-tag.js";
const template = html`
  <iron-iconset-svg name="mdi-audio" size="24">
    <svg>
      <g id="fast-forward">
        <path d="M13,6V18L21.5,12M4,18L12.5,12L4,6V18Z"></path>
      </g>

      <g id="pause"><path d="M14,19H18V5H14M6,19H10V5H6V19Z"></path></g>

      <g id="pause-circle">
        <path
          d="M15,16H13V8H15M11,16H9V8H11M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2Z"
        ></path>
      </g>

      <g id="pause-circle-outline">
        <path
          d="M13,16V8H15V16H13M9,16V8H11V16H9M12,2A10,10 0 0,1 22,12A10,10 0 0,1 12,22A10,10 0 0,1 2,12A10,10 0 0,1 12,2M12,4A8,8 0 0,0 4,12A8,8 0 0,0 12,20A8,8 0 0,0 20,12A8,8 0 0,0 12,4Z"
        ></path>
      </g>

      <g id="play"><path d="M8,5.14V19.14L19,12.14L8,5.14Z"></path></g>

      <g id="play-circle">
        <path
          d="M10,16.5V7.5L16,12M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2Z"
        ></path>
      </g>

      <g id="play-circle-outline">
        <path
          d="M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M10,16.5L16,12L10,7.5V16.5Z"
        ></path>
      </g>

      <g id="quality-high">
        <path
          d="M14.5,13.5H16.5V10.5H14.5M18,14A1,1 0 0,1 17,15H16.25V16.5H14.75V15H14A1,1 0 0,1 13,14V10A1,1 0 0,1 14,9H17A1,1 0 0,1 18,10M11,15H9.5V13H7.5V15H6V9H7.5V11.5H9.5V9H11M19,4H5C3.89,4 3,4.89 3,6V18A2,2 0 0,0 5,20H19A2,2 0 0,0 21,18V6C21,4.89 20.1,4 19,4Z"
        ></path>
      </g>

      <g id="rewind">
        <path d="M11.5,12L20,18V6M11,18V6L2.5,12L11,18Z"></path>
      </g>

      <g id="skip-next">
        <path d="M16,18H18V6H16M6,18L14.5,12L6,6V18Z"></path>
      </g>

      <g id="skip-previous">
        <path d="M6,18V6H8V18H6M9.5,12L18,6V18L9.5,12Z"></path>
      </g>

      <g id="stop"><path d="M18,18H6V6H18V18Z"></path></g>
    </svg>
  </iron-iconset-svg>
`;
document.head.appendChild(template.content);