import{SimpleColors}from"../simple-colors/simple-colors.js";import{html,css}from"../../lit-element/lit-element.js";class PlaceHolder extends SimpleColors{static get styles(){return[...super.styles,css`
        :host {
          display: block;
          border: none;
          transition: 0.2s all linear;
        }
        :host([drag-over]) {
          border: var(--place-holder-drag-over-border, 4px dashed #2196f3);
        }
        .wrapper {
          text-align: center;
          padding: 16px;
          color: var(--simple-colors-default-theme-grey-11, #222222);
          background-color: var(--simple-colors-default-theme-grey-2, #eeeeee);
        }
        iron-icon {
          margin: 0 auto;
          width: 50%;
          height: 50%;
          display: block;
        }
        .text {
          line-height: 24px;
          font-size: 24px;
        }
        .directions {
          line-height: 16px;
          font-size: 16px;
          font-style: italic;
        }
      `]}render(){return html`
      <div class="wrapper">
        <iron-icon icon="${this.iconFromType}"></iron-icon>
        <div class="text">${this.calcText}</div>
        <div class="directions">${this.directions}</div>
      </div>
    `}static get tag(){return"place-holder"}static get properties(){return{iconFromType:{type:String},text:{type:String},directions:{type:String},calcText:{type:String},type:{type:String},dragOver:{type:Boolean,reflect:!0,attribute:"drag-over"}}}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{["type","dragOver"].includes(propName)&&(this.iconFromType=this._getIconFromType(this.type,this.dragOver)),["text","type","dragOver"].includes(propName)&&(this.calcText=this._getCalcText(this.text,this.type,this.dragOver))})}fireReplaceEvent(e){this.dispatchEvent(new CustomEvent("place-holder-replace",{bubbles:!0,cancelable:!0,composed:!0,detail:this.type}))}_getCalcText(text,type,dragOver){return dragOver?"Drop file to upload":""===text?"Placeholder for "+type:text}_getIconFromType(type,dragOver){if(dragOver)return import("../../@polymer/iron-icons/iron-icons.js"),"icons:file-upload";switch(type){case"document":return import("../../@polymer/iron-icons/editor-icons.js"),"editor:insert-drive-file";case"audio":return import("../../@polymer/iron-icons/av-icons.js"),"av:music-video";case"video":return import("../../@polymer/iron-icons/notification-icons.js"),"notification:ondemand-video";case"image":return import("../../@polymer/iron-icons/image-icons.js"),"image:crop-original";case"math":return import("../../@polymer/iron-icons/editor-icons.js"),"editor:functions";case"text":default:return import("../../@polymer/iron-icons/editor-icons.js"),"editor:format-align-left"}}constructor(){super(),this.text="",this.type="text",this.dragOver=!1,this.directions="Double click or drag and drop file to replace",this.addEventListener("dragover",(function(e){this.dragOver=!0,e.preventDefault(),e.stopPropagation(),this.classList.add("dragover")})),this.addEventListener("dragleave",(function(e){this.dragOver=!1,e.preventDefault(),e.stopPropagation(),this.classList.remove("dragover")})),this.addEventListener("drop",(function(e){this.dragOver=!1,e.preventDefault(),e.stopPropagation(),this.classList.remove("dragover");try{"file"===e.dataTransfer.items[0].kind&&(e.placeHolderElement=this,this.dispatchEvent(new CustomEvent("place-holder-file-drop",{bubbles:!0,cancelable:!0,composed:!0,detail:e})))}catch(e){}})),this.addEventListener("dblclick",this.fireReplaceEvent.bind(this))}disconnectedCallback(){this.removeEventListener("dragover",(function(e){this.dragOver=!0,e.preventDefault(),e.stopPropagation(),this.classList.add("dragover")})),this.removeEventListener("dragleave",(function(e){this.dragOver=!1,e.preventDefault(),e.stopPropagation(),this.classList.remove("dragover")})),this.removeEventListener("drop",(function(e){this.dragOver=!1,e.preventDefault(),e.stopPropagation(),this.classList.remove("dragover");try{"file"===e.dataTransfer.items[0].kind&&(e.placeHolderElement=this,this.dispatchEvent(new CustomEvent("place-holder-file-drop",{bubbles:!0,cancelable:!0,composed:!0,detail:e})))}catch(e){}})),this.removeEventListener("dblclick",this.fireReplaceEvent.bind(this)),super.disconnectedCallback()}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Placeholder",description:"A place holder that can be converted into the media type that's been selected",icon:"image:transform",color:"grey",groups:["Placeholder"],handles:[],meta:{author:"ELMS:LN"}},settings:{quick:[],configure:[{property:"type",title:"Type",description:"Type of gizmo that this accepts for replacement.",inputMethod:"select",options:{text:"Text / content",document:"Document / file",audio:"Audio",video:"Video",image:"Image",math:"Math"}},{property:"text",title:"Text",description:"Identify the place holder desired in greater detail",inputMethod:"textfield",required:!1}],advanced:[]},saveOptions:{unsetAttributes:["icon-from-type","calc-text","colors"],wipeSlot:!0}}}}window.customElements.define(PlaceHolder.tag,PlaceHolder);export{PlaceHolder};