/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{html,PolymerElement}from"../../@polymer/polymer/polymer-element.js";import"../../@polymer/iron-a11y-keys/iron-a11y-keys.js";import"./lib/rich-text-editor-styles.js";import"./lib/toolbars/rich-text-editor-toolbar.js";import"./lib/toolbars/rich-text-editor-toolbar-mini.js";import"./lib/toolbars/rich-text-editor-toolbar-full.js";class RichTextEditor extends PolymerElement{static get template(){return html`
      <style>
        :host([hidden]) {
          display: none;
        }
        :host {
          display: block;
          min-height: 20px;
          cursor: pointer;
          @apply --rich-text-editor-content;
        }
        :host([contenteditable="true"]) {
          border: var(--rich-text-editor-border);
          overflow: auto;
          @apply --rich-text-editor-content-edit;
        }
        :host(.heightmax[contenteditable="true"]) {
          max-height: calc(100vh - 200px);
          overflow-y: scroll;
          @apply --rich-text-editor-heightmax;
        }
        :host(:empty) {
          border: 1px dashed var(--rich-text-editor-border-color);
          @apply --rich-text-editor-empty;
        }
        :host(:not([contenteditable="true"]):empty):before {
          content: attr(placeholder);
          padding: 0 5px;
          display: block;
          color: var(--rich-text-editor-button-disabled-color);
          @apply --rich-text-editor-empty-placeholder;
        }
        :host([contenteditable="true"]:empty):before {
          @apply --rich-text-editor-empty-editable;
        }
      </style>
      <style include="rich-text-editor-styles"></style>
      <slot></slot>
    `}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Rich text-editor",description:"a standalone rich text editor",icon:"icons:android",color:"green",groups:["Text"],handles:[{type:"todo:read-the-docs-for-usage"}],meta:{author:"nikkimk",owner:"Penn State University"}},settings:{quick:[],configure:[{property:"title",description:"",inputMethod:"textfield",required:!1,icon:"icons:android"}],advanced:[]}}}static get properties(){return{...super.properties,id:{name:"id",type:String,value:""},placeholder:{name:"placeholder",type:String,reflectToAttribute:!0,value:"Click to edit"},toolbar:{name:"toolbar",type:String,value:""},type:{name:"type",type:String,value:"rich-text-editor-toolbar"}}}static get tag(){return"rich-text-editor"}connectedCallback(){super.connectedCallback(),this.id||(this.id=this._generateUUID()),window.RichTextEditorStyleManager.requestAvailability()}ready(){super.ready(),this.getEditor()}getEditor(){let root=this,id=this.toolbar?"#"+this.toolbar:"",both=document.querySelector(this.type+id),idOnly=id?document.querySelector(id):null,typeOnly=document.querySelector(this.type),toolbar=both||idOnly||typeOnly;this.toolbar||(this.toolbar=this._generateUUID()),toolbar&&toolbar.addEditableRegion||(toolbar=document.createElement(this.type),toolbar.id=this.toolbar,root.parentNode.appendChild(toolbar)),toolbar.addEditableRegion(root)}_getRange(){let sel=window.getSelection();return sel.getRangeAt&&sel.rangeCount?sel.getRangeAt(0):sel||void 0}_generateUUID(){let hex=Math.floor(65536*(1+Math.random())).toString(16).substring(1);return"rte-"+"ss-s-s-s-sss".replace(/s/g,hex)}}window.customElements.define(RichTextEditor.tag,RichTextEditor);export{RichTextEditor};