/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement,html,css}from"../../lit-element/lit-element.js";import{record}from"./lib/vmsg-fork.js";class VoiceRecorder extends LitElement{static get styles(){return[css`
        :host {
          display: inline-flex;
        }
      `]}render(){return html`
      <button @click="${this.recordState}">
        <iron-icon icon="${this.iconState}"></iron-icon>${this.textState}
      </button>
      <slot></slot>
    `}static get properties(){return{iconState:{type:String},textState:{type:String},recording:{type:Boolean}}}static get tag(){return"voice-recorder"}constructor(){super(),this.recording=!1,setTimeout(()=>{import("../../@polymer/iron-icon/iron-icon.js"),import("../../@polymer/iron-icons/av-icons.js")},0)}recordState(e){this.recording=!this.recording}updated(changedProperties){changedProperties.forEach((oldValue,propName)=>{"recording"==propName&&(this[propName]?(this.textState="stop",this.iconState="av:stop"):(this.textState="Record",this.iconState="av:play-arrow"),this.toggleRecording(this[propName],oldValue))})}toggleRecording(newValue,oldValue){newValue&&record({wasmURL:this.pathFromUrl(decodeURIComponent(import.meta.url))+"../../vmsg/vmsg.wasm"},this).then(blob=>{this.dispatchEvent(new CustomEvent("voice-recorder-recording",{value:blob}))})}pathFromUrl(url){return url.substring(0,url.lastIndexOf("/")+1)}}customElements.define(VoiceRecorder.tag,VoiceRecorder);export{VoiceRecorder};