define(["exports","../utils/boot.js","../utils/settings.js","../utils/mixin.js","../utils/style-gather.js","../utils/resolve-url.js","../elements/dom-module.js","./property-effects.js","./properties-mixin.js","../utils/wrap.js"],(function(_exports,_boot,_settings,_mixin,_styleGather,_resolveUrl,_domModule,_propertyEffects,_propertiesMixin,_wrap){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.updateStyles=_exports.ElementMixin=_exports.version=void 0;
/**
   * @fileoverview
   * @suppress {checkPrototypalTypes}
   * @license Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
   * This code may only be used under the BSD style license found at
   * http://polymer.github.io/LICENSE.txt The complete set of authors may be found
   * at http://polymer.github.io/AUTHORS.txt The complete set of contributors may
   * be found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by
   * Google as part of the polymer project is also subject to an additional IP
   * rights grant found at http://polymer.github.io/PATENTS.txt
   */
const version="3.3.1";_exports.version=version;const builtCSS=window.ShadyCSS&&window.ShadyCSS.cssBuild,ElementMixin=(0,_mixin.dedupingMixin)(base=>{const polymerElementBase=(0,_propertiesMixin.PropertiesMixin)((0,_propertyEffects.PropertyEffects)(base));return class PolymerElement extends polymerElementBase{static get polymerElementVersion(){return version}static _finalizeClass(){polymerElementBase._finalizeClass.call(this);const observers=function ownObservers(constructor){return constructor.hasOwnProperty(JSCompiler_renameProperty("__ownObservers",constructor))||(constructor.__ownObservers=constructor.hasOwnProperty(JSCompiler_renameProperty("observers",constructor))?constructor.observers:null),constructor.__ownObservers}(this);observers&&this.createObservers(observers,this._properties),this._prepareTemplate()}static _prepareTemplate(){let template=this.template;template&&("string"==typeof template?(console.error("template getter must return HTMLTemplateElement"),template=null):_settings.legacyOptimizations||(template=template.cloneNode(!0))),this.prototype._template=template}static createProperties(props){for(let p in props)proto=this.prototype,name=p,info=props[p],allProps=props,info.computed&&(info.readOnly=!0),info.computed&&(proto._hasReadOnlyEffect(name)?console.warn(`Cannot redefine computed property '${name}'.`):proto._createComputedProperty(name,info.computed,allProps)),info.readOnly&&!proto._hasReadOnlyEffect(name)?proto._createReadOnlyProperty(name,!info.computed):!1===info.readOnly&&proto._hasReadOnlyEffect(name)&&console.warn(`Cannot make readOnly property '${name}' non-readOnly.`),info.reflectToAttribute&&!proto._hasReflectEffect(name)?proto._createReflectedProperty(name):!1===info.reflectToAttribute&&proto._hasReflectEffect(name)&&console.warn(`Cannot make reflected property '${name}' non-reflected.`),info.notify&&!proto._hasNotifyEffect(name)?proto._createNotifyingProperty(name):!1===info.notify&&proto._hasNotifyEffect(name)&&console.warn(`Cannot make notify property '${name}' non-notify.`),info.observer&&proto._createPropertyObserver(name,info.observer,allProps[info.observer]),proto._addPropertyToAttributeMap(name);var proto,name,info,allProps}static createObservers(observers,dynamicFns){const proto=this.prototype;for(let i=0;i<observers.length;i++)proto._createMethodObserver(observers[i],dynamicFns)}static get template(){return this.hasOwnProperty(JSCompiler_renameProperty("_template",this))||(this._template=this.prototype.hasOwnProperty(JSCompiler_renameProperty("_template",this.prototype))?this.prototype._template:function getTemplateFromDomModule(is){let template=null;if(is&&(!_settings.strictTemplatePolicy||_settings.allowTemplateFromDomModule)&&(template=_domModule.DomModule.import(is,"template"),_settings.strictTemplatePolicy&&!template))throw new Error(`strictTemplatePolicy: expecting dom-module or null template for ${is}`);return template}(this.is)||Object.getPrototypeOf(this.prototype).constructor.template),this._template}static set template(value){this._template=value}static get importPath(){if(!this.hasOwnProperty(JSCompiler_renameProperty("_importPath",this))){const meta=this.importMeta;if(meta)this._importPath=(0,_resolveUrl.pathFromUrl)(meta.url);else{const module=_domModule.DomModule.import(this.is);this._importPath=module&&module.assetpath||Object.getPrototypeOf(this.prototype).constructor.importPath}}return this._importPath}constructor(){super(),this._template,this._importPath,this.rootPath,this.importPath,this.root,this.$}_initializeProperties(){this.constructor.finalize(),this.constructor._finalizeTemplate(this.localName),super._initializeProperties(),this.rootPath=_settings.rootPath,this.importPath=this.constructor.importPath;let p$=function propertyDefaults(constructor){if(!constructor.hasOwnProperty(JSCompiler_renameProperty("__propertyDefaults",constructor))){constructor.__propertyDefaults=null;let props=constructor._properties;for(let p in props){let info=props[p];"value"in info&&(constructor.__propertyDefaults=constructor.__propertyDefaults||{},constructor.__propertyDefaults[p]=info)}}return constructor.__propertyDefaults}(this.constructor);if(p$)for(let p in p$){let info=p$[p];if(!this.hasOwnProperty(p)){let value="function"==typeof info.value?info.value.call(this):info.value;this._hasAccessor(p)?this._setPendingProperty(p,value,!0):this[p]=value}}}static _processStyleText(cssText,baseURI){return(0,_resolveUrl.resolveCss)(cssText,baseURI)}static _finalizeTemplate(is){const template=this.prototype._template;if(template&&!template.__polymerFinalized){template.__polymerFinalized=!0;const importPath=this.importPath;!function processElementStyles(klass,template,is,baseURI){if(!builtCSS){const templateStyles=template.content.querySelectorAll("style"),stylesWithImports=(0,_styleGather.stylesFromTemplate)(template),linkedStyles=(0,_styleGather.stylesFromModuleImports)(is),firstTemplateChild=template.content.firstElementChild;for(let idx=0;idx<linkedStyles.length;idx++){let s=linkedStyles[idx];s.textContent=klass._processStyleText(s.textContent,baseURI),template.content.insertBefore(s,firstTemplateChild)}let templateStyleIndex=0;for(let i=0;i<stylesWithImports.length;i++){let s=stylesWithImports[i],templateStyle=templateStyles[templateStyleIndex];templateStyle!==s?(s=s.cloneNode(!0),templateStyle.parentNode.insertBefore(s,templateStyle)):templateStyleIndex++,s.textContent=klass._processStyleText(s.textContent,baseURI)}}window.ShadyCSS&&window.ShadyCSS.prepareTemplate(template,is)}(this,template,is,importPath?(0,_resolveUrl.resolveUrl)(importPath):""),this.prototype._bindTemplate(template)}}connectedCallback(){window.ShadyCSS&&this._template&&window.ShadyCSS.styleElement(this),super.connectedCallback()}ready(){this._template&&(this.root=this._stampTemplate(this._template),this.$=this.root.$),super.ready()}_readyClients(){this._template&&(this.root=this._attachDom(this.root)),super._readyClients()}_attachDom(dom){const n=(0,_wrap.wrap)(this);if(n.attachShadow)return dom?(n.shadowRoot||(n.attachShadow({mode:"open",shadyUpgradeFragment:dom}),n.shadowRoot.appendChild(dom)),_settings.syncInitialRender&&window.ShadyDOM&&window.ShadyDOM.flushInitial(n.shadowRoot),n.shadowRoot):null;throw new Error("ShadowDOM not available. PolymerElement can create dom as children instead of in ShadowDOM by setting `this.root = this;` before `ready`.")}updateStyles(properties){window.ShadyCSS&&window.ShadyCSS.styleSubtree(this,properties)}resolveUrl(url,base){return!base&&this.importPath&&(base=(0,_resolveUrl.resolveUrl)(this.importPath)),(0,_resolveUrl.resolveUrl)(url,base)}static _parseTemplateContent(template,templateInfo,nodeInfo){return templateInfo.dynamicFns=templateInfo.dynamicFns||this._properties,polymerElementBase._parseTemplateContent.call(this,template,templateInfo,nodeInfo)}static _addTemplatePropertyEffect(templateInfo,prop,effect){return!_settings.legacyOptimizations||prop in this._properties||console.warn(`Property '${prop}' used in template but not declared in 'properties'; `+"attribute will not be observed."),polymerElementBase._addTemplatePropertyEffect.call(this,templateInfo,prop,effect)}}});_exports.ElementMixin=ElementMixin;_exports.updateStyles=function(props){window.ShadyCSS&&window.ShadyCSS.styleDocument(props)}}));