define(["exports","../../../@polymer/polymer/lib/utils/debounce.js","../../../@polymer/polymer/lib/utils/async.js"],(function(_exports,_debounce,_async){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.DataProviderMixin=_exports.ItemCache=void 0;
/**
  @license
  Copyright (c) 2017 Vaadin Ltd.
  This program is available under Apache License Version 2.0, available at https://vaadin.com/license/
  */
const ItemCache=class ItemCache{constructor(grid,parentCache,parentItem){this.grid=grid,this.parentCache=parentCache,this.parentItem=parentItem,this.itemCaches={},this.items={},this.effectiveSize=0,this.size=0,this.pendingRequests={}}isLoading(){return Object.keys(this.pendingRequests).length||Object.keys(this.itemCaches).filter(index=>this.itemCaches[index].isLoading())[0]}getItemForIndex(index){const{cache:cache,scaledIndex:scaledIndex}=this.getCacheAndIndex(index);return cache.items[scaledIndex]}updateSize(){this.effectiveSize=!this.parentItem||this.grid._isExpanded(this.parentItem)?this.size+Object.keys(this.itemCaches).reduce((prev,curr)=>{const subCache=this.itemCaches[curr];return subCache.updateSize(),prev+subCache.effectiveSize},0):0}ensureSubCacheForScaledIndex(scaledIndex){if(!this.itemCaches[scaledIndex]){const subCache=new ItemCache(this.grid,this,this.items[scaledIndex]);this.itemCaches[scaledIndex]=subCache,this.grid._loadPage(0,subCache)}}getCacheAndIndex(index){let thisLevelIndex=index;const keys=Object.keys(this.itemCaches);for(var i=0;i<keys.length;i++){const expandedIndex=Number(keys[i]),subCache=this.itemCaches[expandedIndex];if(thisLevelIndex<=expandedIndex)return{cache:this,scaledIndex:thisLevelIndex};if(thisLevelIndex<=expandedIndex+subCache.effectiveSize)return subCache.getCacheAndIndex(thisLevelIndex-expandedIndex-1);thisLevelIndex-=subCache.effectiveSize}return{cache:this,scaledIndex:thisLevelIndex}}};_exports.ItemCache=ItemCache;_exports.DataProviderMixin=superClass=>(class DataProviderMixin extends superClass{static get properties(){return{pageSize:{type:Number,value:50,observer:"_pageSizeChanged"},dataProvider:{type:Object,notify:!0,observer:"_dataProviderChanged"},loading:{type:Boolean,notify:!0,readOnly:!0,reflectToAttribute:!0},_cache:{type:Object,value:function(){return new ItemCache(this)}},itemIdPath:{type:String,value:null},expandedItems:{type:Object,notify:!0,value:()=>[]}}}static get observers(){return["_sizeChanged(size)","_expandedItemsChanged(expandedItems.*)"]}_sizeChanged(size){const delta=size-this._cache.size;this._cache.size+=delta,this._cache.effectiveSize+=delta,this._effectiveSize=this._cache.effectiveSize}_updateRowItem(item,el){el.children.forEach(cell=>{cell._instance&&(cell._instance.item=item)})}_getItem(index,el){if(index>=this._effectiveSize)return;el.index=index;const{cache:cache,scaledIndex:scaledIndex}=this._cache.getCacheAndIndex(index),item=cache.items[scaledIndex];item?(this._toggleAttribute("loading",!1,el),this._updateItem(el,item),this._isExpanded(item)&&cache.ensureSubCacheForScaledIndex(scaledIndex)):(this._toggleAttribute("loading",!0,el),this._loadPage(this._getPageForIndex(scaledIndex),cache))}_pagesForPhysicalItems(){return[this._getPageForIndex(this._firstVisibleIndex+this._vidxOffset)].concat(this._physicalItems.filter(row=>row.index).items(row=>this._getPageForIndex(row.index))).reduce((prev,curr)=>(-1===prev.indexOf(curr)&&prev.push(curr),prev),[])}_expandedInstanceChangedCallback(inst,value){void 0!==inst.item&&(value?this.expandItem(inst.item):this.collapseItem(inst.item))}getItemId(item){return this.itemIdPath?this.get(this.itemIdPath,item):item}_isExpanded(item){return this.expandedItems&&this._getItemIndexInArray(item,this.expandedItems)>-1}_expandedItemsChanged(e){this._cache.updateSize(),this._effectiveSize=this._cache.effectiveSize,this._assignModels()}expandItem(item){this._isExpanded(item)||this.push("expandedItems",item)}collapseItem(item){this._isExpanded(item)&&this.splice("expandedItems",this._getItemIndexInArray(item,this.expandedItems),1)}_getIndexLevel(index){let{cache:cache}=this._cache.getCacheAndIndex(index),level=0;for(;cache.parentCache;)cache=cache.parentCache,level++;return level}_canPopulate(){return this._hasData&&this._columnTree}_loadPage(page,cache){if(!cache.pendingRequests[page]&&this.dataProvider){this._setLoading(!0),cache.pendingRequests[page]=!0;const params={page:page,pageSize:this.pageSize,sortOrders:this._mapSorters(),filters:this._mapFilters(),parentItem:cache.parentItem};this.dataProvider(params,(items,size)=>{void 0!==size?cache.size=size:params.parentItem&&(cache.size=items.length),items.forEach((item,itemsIndex)=>{const itemIndex=page*this.pageSize+itemsIndex;cache.items[itemIndex]=item,this._isExpanded(item)&&cache.ensureSubCacheForScaledIndex(itemIndex)}),this._hasData=!0,delete cache.pendingRequests[page],this._cache.isLoading()||(this._setLoading(!1),this._cache.updateSize(),this._effectiveSize=this._cache.effectiveSize,Array.from(this.$.items.children).filter(row=>!row.hidden).forEach(row=>{const cachedItem=this._cache.getItemForIndex(row.index);cachedItem&&(this._toggleAttribute("loading",!1,row),this._updateItem(row,cachedItem))}),this._increasePoolIfNeeded(0)),this.__setInitialColumnWidths()})}}_getPageForIndex(index){return Math.floor(index/this.pageSize)}clearCache(){this._cache=new ItemCache(this),Array.from(this.$.items.children).forEach(row=>{Array.from(row.children).forEach(cell=>{cell._instance&&cell._instance._setPendingProperty("item",{},!1)})}),this._cache.size=this.size||0,this._cache.updateSize(),this._hasData=!1,this._assignModels(),this._effectiveSize||this._loadPage(0,this._cache)}_flushItemsDebouncer(){this._debouncerLoad&&this._debouncerLoad.flush()}_pageSizeChanged(pageSize,oldPageSize){void 0!==oldPageSize&&pageSize!==oldPageSize&&this.clearCache()}_checkSize(){void 0===this.size&&0===this._effectiveSize&&console.warn("The <vaadin-grid> needs the total number of items in order to display rows. Set the total number of items to the `size` property, or provide the total number of items in the second argument of the `dataProvider`’s `callback` call.")}_dataProviderChanged(dataProvider,oldDataProvider){void 0!==oldDataProvider&&this.clearCache(),dataProvider&&this.items&&this.items.length&&this._scrollToIndex(this._firstVisibleIndex),this._ensureFirstPageLoaded(),this._debouncerCheckSize=_debounce.Debouncer.debounce(this._debouncerCheckSize,_async.timeOut.after(2e3),this._checkSize.bind(this)),this._scrollHandler()}_ensureFirstPageLoaded(){this._hasData||this._loadPage(0,this._cache,()=>{const hadData=this._hasData;this._hasData=!0,hadData||this.notifyResize()})}_itemsEqual(item1,item2){return this.getItemId(item1)===this.getItemId(item2)}_getItemIndexInArray(item,array){let result=-1;return array.forEach((i,idx)=>{this._itemsEqual(i,item)&&(result=idx)}),result}})}));