define(["exports"],(function(_exports){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.DragAndDropMixin=void 0;
/**
  @license
  Copyright (c) 2019 Vaadin Ltd.
  This program is available under Apache License Version 2.0, available at https://vaadin.com/license/
  */
const DropMode_BETWEEN="between",DropMode_ON_TOP_OR_BETWEEN="on-top-or-between",DropMode_ON_GRID="on-grid",DropLocation_ON_TOP="on-top",DropLocation_ABOVE="above",DropLocation_BELOW="below",DropLocation_EMPTY="empty";_exports.DragAndDropMixin=superClass=>(class DragAndDropMixin extends superClass{static get properties(){return{dropMode:String,rowsDraggable:Boolean,dragFilter:Function,dropFilter:Function,__dndAutoScrollThreshold:{value:50}}}static get observers(){return["_dragDropAccessChanged(rowsDraggable, dropMode, dragFilter, dropFilter)"]}ready(){super.ready(),this.$.table.addEventListener("dragstart",this._onDragStart.bind(this)),this.$.table.addEventListener("dragend",this._onDragEnd.bind(this)),this.$.table.addEventListener("dragover",this._onDragOver.bind(this)),this.$.table.addEventListener("dragleave",this._onDragLeave.bind(this)),this.$.table.addEventListener("drop",this._onDrop.bind(this)),this.$.table.addEventListener("dragenter",e=>{this.dropMode&&(e.preventDefault(),e.stopPropagation())})}_onDragStart(e){if(this.rowsDraggable){let row=e.target;if("vaadin-grid-cell-content"===row.localName&&(row=row.assignedSlot.parentNode.parentNode),row.parentNode!==this.$.items)return;if(e.stopPropagation(),this._toggleAttribute("dragging-rows",!0,this),this._safari){const transform=row.style.transform;row.style.top=/translateY\((.*)\)/.exec(transform)[1],row.style.transform="none",requestAnimationFrame(()=>{row.style.top="",row.style.transform=transform})}const rowRect=row.getBoundingClientRect();window.ShadyDOM||(this._ios?e.dataTransfer.setDragImage(row):e.dataTransfer.setDragImage(row,e.clientX-rowRect.left,e.clientY-rowRect.top));let rows=[row];this._isSelected(row._item)&&(rows=this.__getViewportRows().filter(row=>this._isSelected(row._item)).filter(row=>!this.dragFilter||this.dragFilter(this.__getRowModel(row)))),e.dataTransfer.setData("text",this.__formatDefaultTransferData(rows)),row.setAttribute("dragstart",rows.length>1?rows.length:""),this.updateStyles({"--_grid-drag-start-x":`${e.clientX-rowRect.left+20}px`,"--_grid-drag-start-y":`${e.clientY-rowRect.top+10}px`}),requestAnimationFrame(()=>{row.removeAttribute("dragstart"),this.updateStyles({"--_grid-drag-start-x":"","--_grid-drag-start-y":""})});const event=new CustomEvent("grid-dragstart",{detail:{draggedItems:rows.map(row=>row._item),setDragData:(type,data)=>e.dataTransfer.setData(type,data),setDraggedItemsCount:count=>row.setAttribute("dragstart",count)}});event.originalEvent=e,this.dispatchEvent(event)}}_onDragEnd(e){this._toggleAttribute("dragging-rows",!1,this),e.stopPropagation();const event=new CustomEvent("grid-dragend");event.originalEvent=e,this.dispatchEvent(event)}_onDragLeave(e){e.stopPropagation(),this._clearDragStyles()}_onDragOver(e){if(this.dropMode){if(this._dropLocation=void 0,this._dragOverItem=void 0,this.__dndAutoScroll(e.clientY))return void this._clearDragStyles();let row=e.composedPath().filter(node=>"tr"===node.localName)[0];if(this._effectiveSize&&this.dropMode!==DropMode_ON_GRID)if(row&&row.parentNode===this.$.items){const rowRect=row.getBoundingClientRect();if(this._dropLocation=DropLocation_ON_TOP,this.dropMode===DropMode_BETWEEN){const dropAbove=e.clientY-rowRect.top<rowRect.bottom-e.clientY;this._dropLocation=dropAbove?DropLocation_ABOVE:DropLocation_BELOW}else this.dropMode===DropMode_ON_TOP_OR_BETWEEN&&(e.clientY-rowRect.top<rowRect.height/3?this._dropLocation=DropLocation_ABOVE:e.clientY-rowRect.top>rowRect.height/3*2&&(this._dropLocation=DropLocation_BELOW))}else{if(row)return;if(this.dropMode!==DropMode_BETWEEN&&this.dropMode!==DropMode_ON_TOP_OR_BETWEEN)return;row=Array.from(this.$.items.children).filter(row=>!row.hidden).pop(),this._dropLocation=DropLocation_BELOW}else this._dropLocation=DropLocation_EMPTY;if(row&&row.hasAttribute("drop-disabled"))return void(this._dropLocation=void 0);e.stopPropagation(),e.preventDefault(),this._dropLocation===DropLocation_EMPTY?this._toggleAttribute("dragover",!0,this):row?(this._dragOverItem=row._item,row.getAttribute("dragover")!==this._dropLocation&&row.setAttribute("dragover",this._dropLocation)):this._clearDragStyles()}}__dndAutoScroll(clientY){if(this.__dndAutoScrolling)return!0;const headerBottom=this.$.header.getBoundingClientRect().bottom,footerTop=this.$.footer.getBoundingClientRect().top,topDiff=headerBottom-clientY+this.__dndAutoScrollThreshold,bottomDiff=clientY-footerTop+this.__dndAutoScrollThreshold;let scrollTopDelta=0;if(bottomDiff>0?scrollTopDelta=2*bottomDiff:topDiff>0&&(scrollTopDelta=2*-topDiff),scrollTopDelta){const scrollTop=this.$.table.scrollTop;if(this.$.table.scrollTop+=scrollTopDelta,scrollTop!==this.$.table.scrollTop)return this.__dndAutoScrolling=!0,setTimeout(()=>this.__dndAutoScrolling=!1,20),this._scrollHandler(),!0}}__getViewportRows(){const headerBottom=this.$.header.getBoundingClientRect().bottom,footerTop=this.$.footer.getBoundingClientRect().top;return Array.from(this.$.items.children).filter(row=>{const rowRect=row.getBoundingClientRect();return rowRect.bottom>headerBottom&&rowRect.top<footerTop})}_clearDragStyles(){this.removeAttribute("dragover"),Array.from(this.$.items.children).forEach(row=>row.removeAttribute("dragover"))}_onDrop(e){if(this.dropMode){e.stopPropagation(),e.preventDefault();const dragData=e.dataTransfer.types&&Array.from(e.dataTransfer.types).map(type=>({type:type,data:e.dataTransfer.getData(type)}));this._clearDragStyles();const event=new CustomEvent("grid-drop",{bubbles:e.bubbles,cancelable:e.cancelable,detail:{dropTargetItem:this._dragOverItem,dropLocation:this._dropLocation,dragData:dragData}});event.originalEvent=e,this.dispatchEvent(event)}}__formatDefaultTransferData(rows){return rows.map(row=>Array.from(row.children).filter(cell=>!cell.hidden&&-1===cell.getAttribute("part").indexOf("details-cell")).sort((a,b)=>a._column._order>b._column._order?1:-1).map(cell=>cell._content.textContent.trim()).filter(content=>content).join("\t")).join("\n")}_dragDropAccessChanged(rowsDraggable,dropMode,dragFilter,dropFilter){this.filterDragAndDrop()}filterDragAndDrop(){Array.from(this.$.items.children).filter(row=>!row.hidden).forEach(row=>{this._filterDragAndDrop(row,this.__getRowModel(row))})}_filterDragAndDrop(row,rowData){const dragDisabled=!this.rowsDraggable||this.dragFilter&&!this.dragFilter(rowData),dropDisabled=!this.dropMode||this.dropFilter&&!this.dropFilter(rowData);(window.ShadyDOM?[row]:Array.from(row.children).map(cell=>cell._content)).forEach(e=>{dragDisabled?e.removeAttribute("draggable"):e.setAttribute("draggable",!0)}),this._toggleAttribute("drag-disabled",dragDisabled,row),this._toggleAttribute("drop-disabled",dropDisabled,row)}})}));