define(["exports","./style-settings.js","./css-parse.js","./common-regex.js","./unscoped-style-handler.js"],(function(_exports,_styleSettings,_cssParse,_commonRegex,_unscopedStyleHandler){function forEachRule(node,styleRuleCallback,keyframesRuleCallback,onlyActiveRules){if(!node)return;let skipRules=!1,type=node.type;if(onlyActiveRules&&type===_cssParse.types.MEDIA_RULE){let matchMedia=node.selector.match(_commonRegex.MEDIA_MATCH);matchMedia&&(window.matchMedia(matchMedia[1]).matches||(skipRules=!0))}type===_cssParse.types.STYLE_RULE?styleRuleCallback(node):keyframesRuleCallback&&type===_cssParse.types.KEYFRAMES_RULE?keyframesRuleCallback(node):type===_cssParse.types.MIXIN_RULE&&(skipRules=!0);let r$=node.rules;if(r$&&!skipRules)for(let r,i=0,l=r$.length;i<l&&(r=r$[i]);i++)forEachRule(r,styleRuleCallback,keyframesRuleCallback,onlyActiveRules)}function createScopeStyle(cssText,moniker){let style=document.createElement("style");return moniker&&style.setAttribute("scope",moniker),style.textContent=cssText,style}Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.toCssText=function toCssText(rules,callback){if(!rules)return"";"string"==typeof rules&&(rules=(0,_cssParse.parse)(rules));callback&&forEachRule(rules,callback);return(0,_cssParse.stringify)(rules,_styleSettings.nativeCssVariables)},_exports.rulesForStyle=function rulesForStyle(style){!style.__cssRules&&style.textContent&&(style.__cssRules=(0,_cssParse.parse)(style.textContent));return style.__cssRules||null},_exports.isKeyframesSelector=function isKeyframesSelector(rule){return Boolean(rule.parent)&&rule.parent.type===_cssParse.types.KEYFRAMES_RULE},_exports.forEachRule=forEachRule,_exports.applyCss=function applyCss(cssText,moniker,target,contextNode){let style=createScopeStyle(cssText,moniker);return applyStyle(style,target,contextNode),style},_exports.createScopeStyle=createScopeStyle,_exports.applyStylePlaceHolder=function applyStylePlaceHolder(moniker){let placeHolder=document.createComment(" Shady DOM styles for "+moniker+" "),after=lastHeadApplyNode?lastHeadApplyNode.nextSibling:null,scope=document.head;return scope.insertBefore(placeHolder,after||scope.firstChild),lastHeadApplyNode=placeHolder,placeHolder},_exports.applyStyle=applyStyle,_exports.isTargetedBuild=function isTargetedBuild(buildType){return _styleSettings.nativeShadow?"shadow"===buildType:"shady"===buildType},_exports.findMatchingParen=findMatchingParen,_exports.processVariableAndFallback=function processVariableAndFallback(str,callback){let start=str.indexOf("var(");if(-1===start)return callback(str,"","","");let end=findMatchingParen(str,start+3),inner=str.substring(start+4,end),prefix=str.substring(0,start),suffix=processVariableAndFallback(str.substring(end+1),callback),comma=inner.indexOf(",");if(-1===comma)return callback(prefix,inner.trim(),"",suffix);let value=inner.substring(0,comma).trim(),fallback=inner.substring(comma+1).trim();return callback(prefix,value,fallback,suffix)},_exports.setElementClassRaw=function setElementClassRaw(element,value){_styleSettings.nativeShadow?element.setAttribute("class",value):window.ShadyDOM.nativeMethods.setAttribute.call(element,"class",value)},_exports.getIsExtends=function getIsExtends(element){let localName=element.localName,is="",typeExtension="";localName?localName.indexOf("-")>-1?is=localName:(typeExtension=localName,is=element.getAttribute&&element.getAttribute("is")||""):(is=element.is,typeExtension=element.extends);return{is:is,typeExtension:typeExtension}},_exports.gatherStyleText=function gatherStyleText(element){const styleTextParts=[],styles=element.querySelectorAll("style");for(let i=0;i<styles.length;i++){const style=styles[i];(0,_unscopedStyleHandler.isUnscopedStyle)(style)?_styleSettings.nativeShadow||((0,_unscopedStyleHandler.processUnscopedStyle)(style),style.parentNode.removeChild(style)):(styleTextParts.push(style.textContent),style.parentNode.removeChild(style))}return styleTextParts.join("").trim()},_exports.splitSelectorList=function splitSelectorList(selector){const parts=[];let part="";for(let i=0;i>=0&&i<selector.length;i++)if("("===selector[i]){const end=findMatchingParen(selector,i);part+=selector.slice(i,end+1),i=end}else","===selector[i]?(parts.push(part),part=""):part+=selector[i];part&&parts.push(part);return parts},_exports.getCssBuild=getCssBuild,_exports.elementHasBuiltCss=function elementHasBuiltCss(element){return""!==getCssBuild(element)},_exports.getBuildComment=getBuildComment,_exports.isOptimalCssBuild=function isOptimalCssBuild(cssBuild=""){if(""===cssBuild||!_styleSettings.nativeCssVariables)return!1;return _styleSettings.nativeShadow?"shadow"===cssBuild:"shady"===cssBuild},_exports.wrap=void 0;let lastHeadApplyNode=null;function applyStyle(style,target,contextNode){target=target||document.head;let after=contextNode&&contextNode.nextSibling||target.firstChild;if(target.insertBefore(style,after),lastHeadApplyNode){style.compareDocumentPosition(lastHeadApplyNode)===Node.DOCUMENT_POSITION_PRECEDING&&(lastHeadApplyNode=style)}else lastHeadApplyNode=style}function findMatchingParen(text,start){let level=0;for(let i=start,l=text.length;i<l;i++)if("("===text[i])level++;else if(")"===text[i]&&0==--level)return i;return-1}const wrap=window.ShadyDOM&&window.ShadyDOM.wrap||(node=>node);_exports.wrap=wrap;const CSS_BUILD_ATTR="css-build";function getCssBuild(element){if(void 0!==_styleSettings.cssBuild)return _styleSettings.cssBuild;if(void 0===element.__cssBuild){const attrValue=element.getAttribute(CSS_BUILD_ATTR);if(attrValue)element.__cssBuild=attrValue;else{const buildComment=getBuildComment(element);""!==buildComment&&function removeBuildComment(element){const buildComment="template"===element.localName?element.content.firstChild:element.firstChild;buildComment.parentNode.removeChild(buildComment)}(element),element.__cssBuild=buildComment}}return element.__cssBuild||""}function getBuildComment(element){const buildComment="template"===element.localName?element.content.firstChild:element.firstChild;if(buildComment instanceof Comment){const commentParts=buildComment.textContent.trim().split(":");if(commentParts[0]===CSS_BUILD_ATTR)return commentParts[1]}return""}}));