define(["exports","./directive.js","./dom.js","./part.js","./template-instance.js","./template-result.js","./template.js"],(function(_exports,_directive,_dom,_part,_templateInstance,_templateResult,_template){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.EventPart=_exports.PropertyPart=_exports.PropertyCommitter=_exports.BooleanAttributePart=_exports.NodePart=_exports.AttributePart=_exports.AttributeCommitter=_exports.isIterable=_exports.isPrimitive=void 0;
/**
   * @license
   * Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
   * This code may only be used under the BSD style license found at
   * http://polymer.github.io/LICENSE.txt
   * The complete set of authors may be found at
   * http://polymer.github.io/AUTHORS.txt
   * The complete set of contributors may be found at
   * http://polymer.github.io/CONTRIBUTORS.txt
   * Code distributed by Google as part of the polymer project is also
   * subject to an additional IP rights grant found at
   * http://polymer.github.io/PATENTS.txt
   */
const isPrimitive=value=>null===value||!("object"==typeof value||"function"==typeof value);_exports.isPrimitive=isPrimitive;const isIterable=value=>Array.isArray(value)||!(!value||!value[Symbol.iterator]);_exports.isIterable=isIterable;class AttributeCommitter{constructor(element,name,strings){this.dirty=!0,this.element=element,this.name=name,this.strings=strings,this.parts=[];for(let i=0;i<strings.length-1;i++)this.parts[i]=this._createPart()}_createPart(){return new AttributePart(this)}_getValue(){const strings=this.strings,l=strings.length-1;let text="";for(let i=0;i<l;i++){text+=strings[i];const part=this.parts[i];if(void 0!==part){const v=part.value;if(isPrimitive(v)||!isIterable(v))text+="string"==typeof v?v:String(v);else for(const t of v)text+="string"==typeof t?t:String(t)}}return text+=strings[l],text}commit(){this.dirty&&(this.dirty=!1,this.element.setAttribute(this.name,this._getValue()))}}_exports.AttributeCommitter=AttributeCommitter;class AttributePart{constructor(committer){this.value=void 0,this.committer=committer}setValue(value){value===_part.noChange||isPrimitive(value)&&value===this.value||(this.value=value,(0,_directive.isDirective)(value)||(this.committer.dirty=!0))}commit(){for(;(0,_directive.isDirective)(this.value);){const directive=this.value;this.value=_part.noChange,directive(this)}this.value!==_part.noChange&&this.committer.commit()}}_exports.AttributePart=AttributePart;class NodePart{constructor(options){this.value=void 0,this.__pendingValue=void 0,this.options=options}appendInto(container){this.startNode=container.appendChild((0,_template.createMarker)()),this.endNode=container.appendChild((0,_template.createMarker)())}insertAfterNode(ref){this.startNode=ref,this.endNode=ref.nextSibling}appendIntoPart(part){part.__insert(this.startNode=(0,_template.createMarker)()),part.__insert(this.endNode=(0,_template.createMarker)())}insertAfterPart(ref){ref.__insert(this.startNode=(0,_template.createMarker)()),this.endNode=ref.endNode,ref.endNode=this.startNode}setValue(value){this.__pendingValue=value}commit(){for(;(0,_directive.isDirective)(this.__pendingValue);){const directive=this.__pendingValue;this.__pendingValue=_part.noChange,directive(this)}const value=this.__pendingValue;value!==_part.noChange&&(isPrimitive(value)?value!==this.value&&this.__commitText(value):value instanceof _templateResult.TemplateResult?this.__commitTemplateResult(value):value instanceof Node?this.__commitNode(value):isIterable(value)?this.__commitIterable(value):value===_part.nothing?(this.value=_part.nothing,this.clear()):this.__commitText(value))}__insert(node){this.endNode.parentNode.insertBefore(node,this.endNode)}__commitNode(value){this.value!==value&&(this.clear(),this.__insert(value),this.value=value)}__commitText(value){const node=this.startNode.nextSibling,valueAsString="string"==typeof(value=null==value?"":value)?value:String(value);node===this.endNode.previousSibling&&3===node.nodeType?node.data=valueAsString:this.__commitNode(document.createTextNode(valueAsString)),this.value=value}__commitTemplateResult(value){const template=this.options.templateFactory(value);if(this.value instanceof _templateInstance.TemplateInstance&&this.value.template===template)this.value.update(value.values);else{const instance=new _templateInstance.TemplateInstance(template,value.processor,this.options),fragment=instance._clone();instance.update(value.values),this.__commitNode(fragment),this.value=instance}}__commitIterable(value){Array.isArray(this.value)||(this.value=[],this.clear());const itemParts=this.value;let itemPart,partIndex=0;for(const item of value)itemPart=itemParts[partIndex],void 0===itemPart&&(itemPart=new NodePart(this.options),itemParts.push(itemPart),0===partIndex?itemPart.appendIntoPart(this):itemPart.insertAfterPart(itemParts[partIndex-1])),itemPart.setValue(item),itemPart.commit(),partIndex++;partIndex<itemParts.length&&(itemParts.length=partIndex,this.clear(itemPart&&itemPart.endNode))}clear(startNode=this.startNode){(0,_dom.removeNodes)(this.startNode.parentNode,startNode.nextSibling,this.endNode)}}_exports.NodePart=NodePart;_exports.BooleanAttributePart=class BooleanAttributePart{constructor(element,name,strings){if(this.value=void 0,this.__pendingValue=void 0,2!==strings.length||""!==strings[0]||""!==strings[1])throw new Error("Boolean attributes can only contain a single expression");this.element=element,this.name=name,this.strings=strings}setValue(value){this.__pendingValue=value}commit(){for(;(0,_directive.isDirective)(this.__pendingValue);){const directive=this.__pendingValue;this.__pendingValue=_part.noChange,directive(this)}if(this.__pendingValue===_part.noChange)return;const value=!!this.__pendingValue;this.value!==value&&(value?this.element.setAttribute(this.name,""):this.element.removeAttribute(this.name),this.value=value),this.__pendingValue=_part.noChange}};_exports.PropertyCommitter=class PropertyCommitter extends AttributeCommitter{constructor(element,name,strings){super(element,name,strings),this.single=2===strings.length&&""===strings[0]&&""===strings[1]}_createPart(){return new PropertyPart(this)}_getValue(){return this.single?this.parts[0].value:super._getValue()}commit(){this.dirty&&(this.dirty=!1,this.element[this.name]=this._getValue())}};class PropertyPart extends AttributePart{}_exports.PropertyPart=PropertyPart;let eventOptionsSupported=!1;try{const options={get capture(){return eventOptionsSupported=!0,!1}};window.addEventListener("test",options,options),window.removeEventListener("test",options,options)}catch(_e){}_exports.EventPart=class EventPart{constructor(element,eventName,eventContext){this.value=void 0,this.__pendingValue=void 0,this.element=element,this.eventName=eventName,this.eventContext=eventContext,this.__boundHandleEvent=e=>this.handleEvent(e)}setValue(value){this.__pendingValue=value}commit(){for(;(0,_directive.isDirective)(this.__pendingValue);){const directive=this.__pendingValue;this.__pendingValue=_part.noChange,directive(this)}if(this.__pendingValue===_part.noChange)return;const newListener=this.__pendingValue,oldListener=this.value,shouldRemoveListener=null==newListener||null!=oldListener&&(newListener.capture!==oldListener.capture||newListener.once!==oldListener.once||newListener.passive!==oldListener.passive),shouldAddListener=null!=newListener&&(null==oldListener||shouldRemoveListener);shouldRemoveListener&&this.element.removeEventListener(this.eventName,this.__boundHandleEvent,this.__options),shouldAddListener&&(this.__options=getOptions(newListener),this.element.addEventListener(this.eventName,this.__boundHandleEvent,this.__options)),this.value=newListener,this.__pendingValue=_part.noChange}handleEvent(event){"function"==typeof this.value?this.value.call(this.eventContext||this.element,event):this.value.handleEvent(event)}};const getOptions=o=>o&&(eventOptionsSupported?{capture:o.capture,passive:o.passive,once:o.once}:o.capture)}));