/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement,html,css}from"../../../lit-element/lit-element.js";class A11yMediaYoutube extends LitElement{static get tag(){return"a11y-media-youtube"}static get styles(){return[css`
        iframe .ytp-pause-overlay {
          display: none !important;
        }
      `]}render(){return html`
      <slot></slot>
    `}static get properties(){return{...super.properties,id:{type:String},autoplay:{type:Boolean},height:{type:String},loop:{type:Boolean},muted:{type:Boolean},preload:{type:String,attribute:"preload",reflect:!0},playbackRate:{type:Number},t:{type:Number,attribute:"t",reflect:!0},videoId:{type:String,attribute:"video-id",reflect:!0},volume:{type:Number},width:{type:String},__video:{type:Object},__yt:{type:Object}}}constructor(){super(),this.autoplay=!1,this.height="100%",this.loop=!1,this.playbackRate=1,this.preload="metadata",this.muted=!1,this.volume=.7,this.width="100%",this.__video=null,this.__yt=null}get api(){let ytapi=window.document.getElementById("a11y-media-youtube-api");return ytapi||(ytapi=document.createElement("script"),ytapi.setAttribute("id","a11y-media-youtube-api"),ytapi.setAttribute("src","https://www.youtube.com/iframe_api"),ytapi.setAttribute("type","text/javascript"),window.document.body.appendChild(ytapi)),ytapi}get buffered(){return this.__yt&&this.__yt.buffered&&this.__yt.buffered.length>0?this.__yt.buffered.end(0):-1}get currentTime(){return this.__yt&&this.__yt.getCurrentTime?this.__yt.getCurrentTime():void 0}get duration(){return this.__yt&&this.__yt.getDuration?this.__yt.getDuration():0}get paused(){return!this.__yt||!this.__yt.getPlayerState||1!==this.__yt.getPlayerState()}get seekable(){let seekable={length:0};return this.duration>0&&(seekable.length=1,seekable.start=index=>0,seekable.end=index=>this.duration),seekable}init(){window.A11yMediaYoutubeManager=window.A11yMediaYoutubeManager||{getIframes:()=>{window.A11yMediaYoutubeManager.queue.forEach(instance=>instance.__yt=instance._preloadVideo(!0)),window.A11yMediaYoutubeManager.queue=[]},queue:[]},window.A11yMediaYoutubeManager.queue.push(this),window.A11yMediaYoutubeManager.api?window.YT&&window.A11yMediaYoutubeManager.getIframes():(window.onYouTubeIframeAPIReady=e=>window.A11yMediaYoutubeManager.getIframes(),window.A11yMediaYoutubeManager.api=this.api)}updated(changedProperties){let iframeChanged=!1,videoChanged=!1,autoChanged=!1;changedProperties.forEach((oldValue,propName)=>{"muted"===propName&&this.setMute(this.muted),"loop"===propName&&this.setLoop(this.loop),"currentTime"===propName&&this.seek(this.currentTime),"playbackRate"===propName&&this.setPlaybackRate(this.playbackRate),"volume"===propName&&this.setVolume(this.volume),"videoId"===propName&&this.videoId&&!this.__yt&&this.init(),["id","height","width","preload"].includes(propName)&&this.__yt&&(iframeChanged=!0),["autoplay","videoId","__video"].includes(propName)&&this.__video&&(videoChanged=!0),["preload","t"].includes(propName)&&("auto"===this.preload||this.t)&&(autoChanged=!0)}),iframeChanged?this.__yt=this._preloadVideo(!0):videoChanged&&(this._loadVideo(),autoChanged&&this._autoMetadata())}play(){this.__yt||(this.__yt=this._preloadVideo(!1)),this.__yt&&this.__yt.playVideo&&this.__yt.playVideo()}pause(){this.__yt&&this.__yt.pauseVideo&&this.__yt.pauseVideo()}seek(time=0){this.__yt&&this.__yt.seekTo&&this.__yt.seekTo(time,!0)}setLoop(loop){this.__yt&&this.__yt.setLoop&&this.media.setLoop(loop)}setMute(muted){this.__yt&&(muted&&this.__yt.mute?this.__yt.mute():this.__yt.unMute&&this.__yt.unMute())}setPlaybackRate(value){this.__yt&&this.__yt.setPlaybackRate&&this.__yt.setPlaybackRate(value)}setVolume(volume=.7){this.__yt&&this.__yt.setVolume(100*volume)}_getSeconds(time=0){let units=time.replace(/[hm]{1,2}&?/g,":0").replace(/[s]{1,2}$/g,"").split(/:/);return 3600*(units.length>2?parseInt(units[units.length-3]):0)+60*(units.length>1?parseInt(units[units.length-2]):0)+(units.length>0?parseFloat(units[units.length-1]):0)}_handleMediaLoaded(e){this.dispatchEvent(new CustomEvent("loadedmetadata",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}_handleTimeupdate(){this.dispatchEvent(new CustomEvent("timeupdate",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}_autoMetadata(){let seek=this.t||0,autoplay=this.autoplay;this.setMute(!0),this.__yt.playVideo();let timeout=12e4,checkDuration=setInterval(()=>{timeout--,(this.duration&&this.duration>0||timeout<=0)&&(this.pause(),this.setMute(this.muted),clearInterval(checkDuration),this.seek(seek),autoplay&&this.play())},1);this.seek(seek)}_loadVideo(preload=this.preload){this.videoId&&this.__video.cueVideoById({videoId:this.videoId})}_preloadVideo(auto=!1){let root=this,load=(!auto||"none"!==this.preload)&&this.videoId&&!this.__video,div=document.createElement("div"),divid=`container-${this.id}`,youtube=null;if(document.body.appendChild(div),div.setAttribute("id",divid),load){let setYT=e=>this.__video=e.target,port=window.location.port?`:${window.location.port}`:"",origin=`//${window.location.hostname}${port}`;youtube=new YT.Player(divid,{width:root.width,height:root.height,events:{onReady:setYT},playerVars:{color:"white",controls:0,autoplay:root.autoplay,disablekb:1,enablejsapi:1,origin,iv_load_policy:3,modestbranding:1,rel:0,widget_referrer:window.location.href}}),youtube.timeupdate,youtube.addEventListener("onStateChange",()=>{root.paused?clearInterval(youtube.timeupdate):youtube.timeupdate=setInterval(()=>root._handleTimeupdate(),1)}),this.appendChild(youtube.getIframe()),div.remove()}return youtube}_removeIframe(){this.__yt&&(this.__yt.remove,this.__yt.destroy()),this.innerHTML=""}disconnectedCallback(){this._removeIframe(),super.disconnectedCallback()}}window.customElements.define(A11yMediaYoutube.tag,A11yMediaYoutube);export{A11yMediaYoutube};