/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
export class HAXWiring{constructor(){this.haxProperties={canScale:!1,canPosition:!1,canEditSource:!1,settings:{quick:[],configure:[],advanced:[]},wipeSlot:{}},this.pathFromUrl=url=>url.substring(0,url.lastIndexOf("/")+1),this.setup=(props,tag="",context=this)=>(void 0!==this.tagName&&(tag=this.tagName.toLowerCase()),window.addEventListener("hax-store-ready",this._haxStoreReady.bind(this)),void 0!==window.HaxStore&&null!=window.HaxStore.instance&&window.HaxStore.ready?this.setHaxProperties(props,tag,context,!0):this.setHaxProperties(props,tag,context,!1)),this._haxStoreReady=e=>{if(e.detail&&void 0!==this.tagName&&void 0!==this.haxProperties){let tag=this.tagName,props=this.haxProperties,context=this;if(""!=tag&&void 0===window.HaxStore){const evt=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:tag.toLowerCase(),properties:props,polymer:!1}});context.dispatchEvent(evt)}else if(""!=tag&&void 0===window.HaxStore.instance.elementList[tag.toLowerCase()]){const evt=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:tag.toLowerCase(),properties:props}});context.dispatchEvent(evt)}else if(void 0!==this.tagName&&void 0===window.HaxStore.instance.elementList[this.tagName.toLowerCase()]){const evt=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:this.tagName.toLowerCase(),properties:props}});context.dispatchEvent(evt)}}},this.setHaxProperties=(props={},tag="",context=document,isReady=!1)=>{if(void 0===props.api&&(props.api="1"),"1"==props.api){if(void 0===props.canPosition&&(props.canPosition=!0),void 0===props.canScale&&(props.canScale=!0),void 0===props.canEditSource&&(props.canEditSource=!1),void 0===props.gizmo)props.gizmo=!1;else if(void 0!==props.gizmo.iconLib){const basePath=this.pathFromUrl(decodeURIComponent(import.meta.url));import(`${basePath}../../../${props.gizmo.iconLib}`)}if(void 0!==props.settings){void 0===props.settings.quick&&(props.settings.quick=[]);for(let i=0;i<props.settings.quick.length;i++)props.settings.quick[i]=this.validateSetting(props.settings.quick[i]),props.settings.quick[i]||props.settings.quick.splice(i,1);void 0===props.settings.configure&&(props.settings.configure=[]);for(let i=0;i<props.settings.configure.length;i++)props.settings.configure[i]=this.validateSetting(props.settings.configure[i]),props.settings.configure[i]||props.settings.configure.splice(i,1);void 0===props.settings.advanced&&(props.settings.advanced=[]);for(let i=0;i<props.settings.advanced.length;i++)props.settings.advanced[i]=this.validateSetting(props.settings.advanced[i]),props.settings.advanced[i]||props.settings.advanced.splice(i,1);props.settings.advanced.push({attribute:"class",title:"Classes",description:"CSS classes applied manually to the element",inputMethod:"textfield"}),props.settings.advanced.push({attribute:"style",title:"Styles",description:"Custom CSS styles as applied to the element",inputMethod:"textfield"}),props.settings.advanced.push({attribute:"prefix",title:"Schema: prefix",description:"Schema prefixes",inputMethod:"textfield"}),props.settings.advanced.push({attribute:"typeof",title:"Schema: TypeOf",description:"typeof definition for Schema usage",inputMethod:"textfield"}),props.settings.advanced.push({attribute:"property",title:"Schema: Property",description:"typeof definition for Schema usage",inputMethod:"textfield"}),props.settings.advanced.push({attribute:"resource",title:"Schema: Resource ID",description:"Schema resource identifier",inputMethod:"textfield"}),props.settings.advanced.push({attribute:"id",title:"ID",description:"element ID, only set this if you know why",inputMethod:"textfield"}),props.settings.advanced.push({attribute:"data-hax-slot",title:"slot",description:"DOM slot area",inputMethod:"textfield"})}if(void 0===props.saveOptions&&(props.saveOptions={wipeSlot:!1}),isReady)if(""!=tag&&void 0===window.HaxStore){const evt=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:tag.toLowerCase(),properties:props,polymer:!1}});context.dispatchEvent(evt)}else if(""!=tag){const evt=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:tag.toLowerCase(),properties:props}});context.dispatchEvent(evt)}else if(void 0!==this.tagName){const evt=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:this.tagName.toLowerCase(),properties:props}});context.dispatchEvent(evt)}else console.warn(`${tag} missed our checks and has an issue in implementation with HAX`);""===tag&&("function"==typeof this._setHaxProperties?this._setHaxProperties(props):this.haxProperties=props)}else console.warn("This is't a valid usage of hax API. See hax-body-behaviors/lib/HAXWiring.js for more details on how to implement the API. Most likely your hax item just was placed in an iframe as a fallback as opposed to a custom element.")},this.validateSetting=setting=>(void 0!==setting.property||void 0!==setting.slot||void 0!==setting.attribute)&&(void 0===setting.title&&(void 0===setting.attribute?setting.title=setting.property:setting.title=setting.attribute),void 0===setting.description&&(setting.description=""),void 0===setting.inputMethod&&(setting.inputMethod="textfield"),void 0===setting.type&&(setting.type="settings"),void 0===setting.icon&&(setting.icon="android"),void 0===setting.options&&(setting.options={}),void 0===setting.required&&(setting.required=!1),void 0===setting.disabled&&(setting.disabled=!1),void 0===setting.validation&&(setting.validation=".*"),void 0===setting.validationType&&(setting.validationType=""),void 0!==setting.slot&&(void 0===setting.slotWrapper&&(setting.slotWrapper="span"),void 0===setting.slotAttributes&&(setting.slotAttributes={})),setting),this.getHaxProperties=()=>this.haxProperties,this.getHaxJSONSchema=(type,haxProperties,target=this)=>{void 0===type&&(type="configure"),void 0===haxProperties&&(haxProperties=target.haxProperties);let settings=haxProperties.settings[type];var schema={$schema:"http://json-schema.org/schema#",title:"HAX "+type+" form schema",type:"object",properties:{}};if(schema.properties=target._getHaxJSONSchemaProperty(settings,target),haxProperties.gizmo&&haxProperties.gizmo.tag&&window.customElements.get(haxProperties.gizmo.tag)){let tmp=document.createElement(haxProperties.gizmo.tag);schema="function"==typeof tmp.postProcessgetHaxJSONSchema?tmp.postProcessgetHaxJSONSchema(schema):target.postProcessgetHaxJSONSchema(schema)}else schema=target.postProcessgetHaxJSONSchema(schema);return schema},this.postProcessgetHaxJSONSchema=schema=>schema,this._getHaxJSONSchemaProperty=(settings,target)=>{var props={};for(var value in settings)if(settings.hasOwnProperty(value))if(void 0!==settings[value].property){switch(props[settings[value].property]={title:settings[value].title,type:this.getHaxJSONSchemaType(settings[value].inputMethod)},void 0!==target[settings[value].property]&&(props[settings[value].property].value=target[settings[value].property]),"url"==settings[value].validationType&&(props[settings[value].property].format="uri"),"datepicker"==settings[value].inputMethod&&(props[settings[value].property].format="date-time"),".*"!=settings[value].validation&&(props[settings[value].property].pattern=settings[value].validation),settings[value].inputMethod){case"number":props[settings[value].property].component={name:"paper-input",valueProperty:"value",properties:{required:settings[value].required,disabled:settings[value].disabled},attributes:{type:"number"}};break;case"select":let options=[];for(var option in settings[value].options){let item=[{alt:settings[value].options[option],value:option}];options.push(item)}props[settings[value].property].component={name:"simple-picker",valueProperty:"value",properties:{allowNull:settings[value].allowNull,blockLabel:!0,required:settings[value].required,options,disabled:settings[value].disabled}};break;case"textarea":props[settings[value].property].component={name:"paper-textarea",valueProperty:"value",properties:{required:settings[value].required,disabled:settings[value].disabled},attributes:{"char-counter":"char-counter"}};break;case"code-editor":props[settings[value].property].component={name:"code-editor",valueProperty:"value",properties:{editorValue:settings[value].value,title:settings[value].title,theme:"vs",mode:"html",className:"hax-code-editor"}};break;case"array":props[settings[value].property].component={valueProperty:"value"},props[settings[value].property].items={type:"object",properties:this._getHaxJSONSchemaProperty(settings[value].properties,target),itemLabel:settings[value].itemLabel},props[settings[value].property].type="array";break;case"fieldset":props[settings[value].property].component={valueProperty:"value"},props[settings[value].property].items={type:"object",properties:this._getHaxJSONSchemaProperty(settings[value].properties,target)},props[settings[value].property].type="fieldset";break;case"tabs":props[settings[value].property].component={valueProperty:"value"},settings[value].properties.map(tab=>(tab.inputMethod="tab",tab)),props[settings[value].property].items={type:"object",properties:this._getHaxJSONSchemaProperty(settings[value].properties,target)},props[settings[value].property].type="tabs";break;case"tab":props[settings[value].property].property=settings[value].property,props[settings[value].property].items={type:"object",properties:this._getHaxJSONSchemaProperty(settings[value].properties,target),label:settings[value].itemLabel},props[settings[value].property].type="tabs";break;case"textfield":props[settings[value].property].component={name:"paper-input",valueProperty:"value",properties:{required:settings[value].required,disabled:settings[value].disabled},attributes:{"auto-validate":"auto-validate"}};break;case"markup":props[settings[value].property].component={name:"marked-element",valueProperty:"markdown"},props[settings[value].property].slot=settings[value].value;break;case"alt":props[settings[value].property].component={name:"paper-input-flagged",valueProperty:"value",properties:{required:settings[value].required,disabled:settings[value].disabled},attributes:{"auto-validate":"auto-validate"}};break;case"colorpicker":props[settings[value].property].component={name:"simple-colors-picker",valueProperty:"value",properties:{allowNull:settings[value].allowNull,blockLabel:!0,required:settings[value].required,label:settings[value].title,disabled:settings[value].disabled}};break;case"iconpicker":props[settings[value].property].component={name:"simple-icon-picker",valueProperty:"value",properties:{allowNull:settings[value].allowNull,blockLabel:!0,required:settings[value].required,hideOptionLabels:!0,label:settings[value].title,disabled:settings[value].disabled}};let opts=void 0!==settings[value].options&&null!==settings[value].options?settings[value].options:[];props[settings[value].property].component.properties.icons=opts;break;case"datepicker":props[settings[value].property].component={name:"paper-input",valueProperty:"date",properties:{type:"date",required:settings[value].required,disabled:settings[value].disabled}};break;case"haxupload":props[settings[value].property].component={name:"hax-upload-field",valueProperty:"value",properties:{formDataName:"file-upload",disabled:settings[value].disabled,required:settings[value].required,noCamera:settings[value].noCamera,noVoiceRecord:settings[value].noVoiceRecord}};break;case"slider":props[settings[value].property].component={name:"paper-slider",valueProperty:"immediateValue",properties:{pin:!0,required:settings[value].required,disabled:settings[value].disabled,min:settings[value].min,max:settings[value].max,step:settings[value].step}}}"undefined"!==settings[value].hidden&&(props[settings[value].property].hidden=settings[value].hidden),"undefined"!==settings[value].description&&(props[settings[value].property].description=settings[value].description)}else if(void 0!==settings[value].attribute){switch(props[settings[value].attribute]={title:settings[value].title,type:target.getHaxJSONSchemaType(settings[value].inputMethod)},"class"===settings[value].attribute?props[settings[value].attribute].value=target.className:"style"===settings[value].attribute?props[settings[value].attribute].value=target.style.cssText:"loading"===settings[value].attribute?props[settings[value].attribute].value="lazy":void 0!==target.attributes[settings[value].attribute]&&(props[settings[value].attribute].value=target.getAttribute(settings[value].attribute)),"href"!=value&&"src"!=value||(props[settings[value].attribute].format="uri"),"url"==settings[value].validationType&&(props[settings[value].attribute].format="uri"),"datepicker"==settings[value].inputMethod&&(props[settings[value].attribute].format="date-time"),".*"!=settings[value].validation&&(props[settings[value].attribute].pattern=settings[value].validation),settings[value].inputMethod){case"number":props[settings[value].attribute].component={name:"paper-input",valueProperty:"value",properties:{required:settings[value].required,disabled:settings[value].disabled},attributes:{type:"number"}};break;case"select":let options=[];for(var option in settings[value].options){let item=[{alt:settings[value].options[option],value:option}];options.push(item)}props[settings[value].attribute].component={name:"simple-picker",valueProperty:"value",properties:{allowNull:settings[value].allowNull,blockLabel:!0,required:settings[value].required,options,disabled:settings[value].disabled}};break;case"textarea":props[settings[value].attribute].component={name:"paper-textarea",valueProperty:"value",properties:{required:settings[value].required,disabled:settings[value].disabled},attributes:{"char-counter":"char-counter"}};break;case"code-editor":props[settings[value].attribute].component={name:"code-editor",valueProperty:"value",properties:{editorValue:props[settings[value].attribute].value,title:settings[value].title,readOnly:!1,theme:"vs",mode:"html",className:"hax-code-editor"}};break;case"textfield":props[settings[value].attribute].component={name:"paper-input",valueProperty:"value",properties:{required:settings[value].required,disabled:settings[value].disabled},attributes:{"auto-validate":"auto-validate"}};break;case"alt":props[settings[value].attribute].component={name:"paper-input-flagged",valueProperty:"value",properties:{required:settings[value].required,disabled:settings[value].disabled},attributes:{"auto-validate":"auto-validate"}};break;case"colorpicker":props[settings[value].attribute].component={name:"simple-colors-picker",valueProperty:"value",properties:{required:settings[value].required,disabled:settings[value].disabled}};break;case"haxupload":props[settings[value].attribute].component={name:"hax-upload-field",valueProperty:"value",properties:{formDataName:"file-upload",required:settings[value].required,disabled:settings[value].disabled,noCamera:settings[value].noCamera,noVoiceRecord:settings[value].noVoiceRecord}};break;case"slider":props[settings[value].attribute].component={name:"paper-slider",valueProperty:"immediateValue",properties:{pin:!0,required:settings[value].required,disabled:settings[value].disabled,min:settings[value].min,max:settings[value].max,step:settings[value].step}}}"undefined"!==settings[value].description&&(props[settings[value].attribute].description=settings[value].description)}else{props[settings[value].slot]={title:settings[value].title,type:target.getHaxJSONSchemaType(settings[value].inputMethod),value:"",component:{name:"code-editor",valueProperty:"value",properties:{editorValue:settings[value].value,title:settings[value].title,theme:"vs",mode:"html",className:"hax-code-editor"}}};var slot="";for(var i in target.childNodes)void 0!==target.childNodes[i]&&(1===target.childNodes[i].nodeType?settings[value].slot===target.childNodes[i].slot&&(slot+=target.childNodes[i].innerHTML):1!==target.childNodes[i].nodeType&&void 0!==target.childNodes[i].textContent&&""!==target.childNodes[i].textContent&&(slot+=target.childNodes[i].textContent));props[settings[value].slot].component.properties.editorValue=slot.trim(),"undefined"!==settings[value].description&&(props[settings[value].slot].description=settings[value].description)}return props},this.getHaxJSONSchemaType=inputMethod=>{if(this.validHAXPropertyInputMethod().includes(inputMethod))switch(inputMethod){case"flipboolean":case"boolean":return"boolean";case"number":case"slider":return"number";case"select":case"textarea":case"colorpicker":case"iconpicker":case"datepicker":case"haxupload":case"markup":case"textfield":case"alt":return"string";case"array":return"array";default:return"string"}},this.validHAXPropertyInputMethod=()=>{return["flipboolean","boolean","select","textfield","textarea","datepicker","haxupload","slider","markup","colorpicker","iconpicker","alt","number","code-editor","array"]},this.prototypeHaxProperties=()=>{return{api:"1",canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Tag name",description:"A description",icon:"av:play-circle-filled",color:"blue",groups:["Content"],handles:[{type:"data",url:"src"}],meta:{author:""}},settings:{quick:[{property:"title",title:"Title",inputMethod:"textfield",icon:"android"},{property:"primaryColor",title:"Primary color",inputMethod:"colorpicker",icon:"color"}],configure:[{slot:"",title:"Inner content",description:"The slotted content that lives inside the tag",inputMethod:"textfield",icon:"android",required:!0,validationType:"text"},{slot:"button",title:"Button content",description:"The content that can override the button",inputMethod:"textfield",icon:"android",required:!0,validationType:"text"},{property:"title",title:"Title",description:"",inputMethod:"textfield",icon:"android",required:!0,validationType:"text"},{property:"primaryColor",title:"Title",description:"",inputMethod:"textfield",icon:"android",required:!1,validation:".*",validationType:"text"}],advanced:[{property:"secondaryColor",title:"Secondary color",description:"An optional secondary color used in certain edge cases.",inputMethod:"colorpicker",icon:"color"},{property:"endPoint",title:"API endpoint",description:"An optional endpoint to hit and load in more data dymaically.",inputMethod:"textfield",icon:"android",validation:"[a-z0-9]",validationType:"url"}]},saveOptions:{wipeSlot:!1,unsetAttributes:["end-point","secondary-color"]}}}}}export const HAXElement=function(SuperClass){return class extends SuperClass{constructor(){super(),this.HAXWiring=new HAXWiring}static get properties(){return{...super.properties,haxProperties:window.HAXWiring.haxProperties}}setHaxProperties(props,tag="",context=this){return""==tag&&void 0!==this.tagName&&(tag=this.tagName.toLowerCase()),window.addEventListener("hax-store-ready",this._haxStoreReady.bind(this)),void 0!==window.HaxStore&&null!=window.HaxStore.instance&&window.HaxStore.ready?this.HAXWiring.setHaxProperties(props,tag,context,!0):this.HAXWiring.setHaxProperties(props,tag,context,!1)}disconnectedCallback(){window.removeEventListener("hax-store-ready",this._haxStoreReady.bind(this)),super.disconnectedCallback&&super.disconnectedCallback()}setup(props,tag="",context=this){return this.HAXWiring.setup(props,"",this)}_haxStoreReady(e){return this.HAXWiring._haxStoreReady(e)}validateSetting(setting){return this.HAXWiring.validateSetting(setting)}getHaxProperties(){return this.haxProperties}getHaxJSONSchema(type,haxProperties,target=this){return this.HAXWiring.getHaxJSONSchema(type,haxProperties,target)}postProcessgetHaxJSONSchema(schema){return this.HAXWiring.postProcessgetHaxJSONSchema(schema)}_getHaxJSONSchemaProperty(settings,target){return this.HAXWiring._getHaxJSONSchemaProperty(settings,target)}getHaxJSONSchemaType(inputMethod){return this.HAXWiring.getHaxJSONSchemaType(inputMethod)}validHAXPropertyInputMethod(){return this.HAXWiring.validHAXPropertyInputMethod()}prototypeHaxProperties(){return this.HAXWiring.prototypeHaxProperties()}}};window.HAXWiring=new HAXWiring,window.HAXBehaviors=window.HAXBehaviors||{},window.HAXBehaviors.PropertiesBehaviors={properties:{haxProperties:window.HAXWiring.haxProperties},setHaxProperties:function(props,tag="",context=this){return""==tag&&void 0!==this.tagName&&(tag=this.tagName.toLowerCase()),window.addEventListener("hax-store-ready",this._haxStoreReady.bind(this)),void 0!==window.HaxStore&&null!=window.HaxStore.instance&&window.HaxStore.ready?window.HAXWiring.setHaxProperties(props,tag,context,!0):window.HAXWiring.setHaxProperties(props,tag,context,!1)},_haxStoreReady:function(e){return window.HAXWiring._haxStoreReady(e)},validateSetting:function(setting){return window.HAXWiring.validateSetting(setting)},getHaxProperties:function(){return this.haxProperties},getHaxJSONSchema:function(type,haxProperties,target=this){return window.HAXWiring.getHaxJSONSchema(type,haxProperties,target)},postProcessgetHaxJSONSchema:function(schema){return window.HAXWiring.postProcessgetHaxJSONSchema(schema)},_getHaxJSONSchemaProperty:function(settings,target){return window.HAXWiring._getHaxJSONSchemaProperty(settings,target)},getHaxJSONSchemaType:function(inputMethod){return window.HAXWiring.getHaxJSONSchemaType(inputMethod)},validHAXPropertyInputMethod:function(){return window.HAXWiring.validHAXPropertyInputMethod()},prototypeHaxProperties:function(){return window.HAXWiring.prototypeHaxProperties()}};