/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
import"../utils/boot.js";import{wrap}from"../utils/wrap.js";import"../utils/settings.js";import{FlattenedNodesObserver}from"../utils/flattened-nodes-observer.js";export{flush,enqueueDebouncer as addDebouncer}from"../utils/flush.js";import{Debouncer}from"../utils/debounce.js";const p=Element.prototype,normalizedMatchesSelector=p.matches||p.matchesSelector||p.mozMatchesSelector||p.msMatchesSelector||p.oMatchesSelector||p.webkitMatchesSelector;export const matchesSelector=function(node,selector){return normalizedMatchesSelector.call(node,selector)};class DomApiNative{constructor(node){window.ShadyDOM&&window.ShadyDOM.inUse&&window.ShadyDOM.patch(node),this.node=node}observeNodes(callback){return new FlattenedNodesObserver(this.node,callback)}unobserveNodes(observerHandle){observerHandle.disconnect()}notifyObserver(){}deepContains(node){if(wrap(this.node).contains(node))return!0;let n=node,doc=node.ownerDocument;for(;n&&n!==doc&&n!==this.node;)n=wrap(n).parentNode||wrap(n).host;return n===this.node}getOwnerRoot(){return wrap(this.node).getRootNode()}getDistributedNodes(){return"slot"===this.node.localName?wrap(this.node).assignedNodes({flatten:!0}):[]}getDestinationInsertionPoints(){let ip$=[],n=wrap(this.node).assignedSlot;for(;n;)ip$.push(n),n=wrap(n).assignedSlot;return ip$}importNode(node,deep){let doc=this.node instanceof Document?this.node:this.node.ownerDocument;return wrap(doc).importNode(node,deep)}getEffectiveChildNodes(){return FlattenedNodesObserver.getFlattenedNodes(this.node)}queryDistributedElements(selector){let c$=this.getEffectiveChildNodes(),list=[];for(let c,i=0,l=c$.length;i<l&&(c=c$[i]);i++)c.nodeType===Node.ELEMENT_NODE&&matchesSelector(c,selector)&&list.push(c);return list}get activeElement(){let node=this.node;return void 0!==node._activeElement?node._activeElement:node.activeElement}}function forwardReadOnlyProperties(proto,properties){for(let i=0;i<properties.length;i++){let name=properties[i];Object.defineProperty(proto,name,{get:function(){return this.node[name]},configurable:!0})}}export class EventApi{constructor(event){this.event=event}get rootTarget(){return this.path[0]}get localTarget(){return this.event.target}get path(){return this.event.composedPath()}}DomApiNative.prototype.cloneNode,DomApiNative.prototype.appendChild,DomApiNative.prototype.insertBefore,DomApiNative.prototype.removeChild,DomApiNative.prototype.replaceChild,DomApiNative.prototype.setAttribute,DomApiNative.prototype.removeAttribute,DomApiNative.prototype.querySelector,DomApiNative.prototype.querySelectorAll,DomApiNative.prototype.parentNode,DomApiNative.prototype.firstChild,DomApiNative.prototype.lastChild,DomApiNative.prototype.nextSibling,DomApiNative.prototype.previousSibling,DomApiNative.prototype.firstElementChild,DomApiNative.prototype.lastElementChild,DomApiNative.prototype.nextElementSibling,DomApiNative.prototype.previousElementSibling,DomApiNative.prototype.childNodes,DomApiNative.prototype.children,DomApiNative.prototype.classList,DomApiNative.prototype.textContent,DomApiNative.prototype.innerHTML;let DomApiImpl=DomApiNative;if(window.ShadyDOM&&window.ShadyDOM.inUse&&window.ShadyDOM.noPatch&&window.ShadyDOM.Wrapper){class Wrapper extends window.ShadyDOM.Wrapper{}Object.getOwnPropertyNames(DomApiNative.prototype).forEach(prop=>{"activeElement"!=prop&&(Wrapper.prototype[prop]=DomApiNative.prototype[prop])}),forwardReadOnlyProperties(Wrapper.prototype,["classList"]),DomApiImpl=Wrapper,Object.defineProperties(EventApi.prototype,{localTarget:{get(){const current=this.event.currentTarget,currentRoot=current&&dom(current).getOwnerRoot(),p$=this.path;for(let i=0;i<p$.length;i++){const e=p$[i];if(dom(e).getOwnerRoot()===currentRoot)return e}},configurable:!0},path:{get(){return window.ShadyDOM.composedPath(this.event)},configurable:!0}})}else!function forwardMethods(proto,methods){for(let i=0;i<methods.length;i++){let method=methods[i];proto[method]=function(){return this.node[method].apply(this.node,arguments)}}}(DomApiNative.prototype,["cloneNode","appendChild","insertBefore","removeChild","replaceChild","setAttribute","removeAttribute","querySelector","querySelectorAll"]),forwardReadOnlyProperties(DomApiNative.prototype,["parentNode","firstChild","lastChild","nextSibling","previousSibling","firstElementChild","lastElementChild","nextElementSibling","previousElementSibling","childNodes","children","classList"]),function forwardProperties(proto,properties){for(let i=0;i<properties.length;i++){let name=properties[i];Object.defineProperty(proto,name,{get:function(){return this.node[name]},set:function(value){this.node[name]=value},configurable:!0})}}(DomApiNative.prototype,["textContent","innerHTML","className"]);export const DomApi=DomApiImpl;export const dom=function(obj){if((obj=obj||document)instanceof DomApiImpl)return obj;if(obj instanceof EventApi)return obj;let helper=obj.__domApi;return helper||(helper=obj instanceof Event?new EventApi(obj):new DomApiImpl(obj),obj.__domApi=helper),helper};