/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
import"../utils/boot.js";import{dedupingMixin}from"../utils/mixin.js";const templateExtensions={"dom-if":!0,"dom-repeat":!0};let placeholderBugDetect=!1,placeholderBug=!1;function fixPlaceholder(node){(function hasPlaceholderBug(){if(!placeholderBugDetect){placeholderBugDetect=!0;const t=document.createElement("textarea");t.placeholder="a",placeholderBug=t.placeholder===t.textContent}return placeholderBug})()&&"textarea"===node.localName&&node.placeholder&&node.placeholder===node.textContent&&(node.textContent=null)}function wrapTemplateExtension(node){let is=node.getAttribute("is");if(is&&templateExtensions[is]){let t=node;for(t.removeAttribute("is"),node=t.ownerDocument.createElement(is),t.parentNode.replaceChild(node,t),node.appendChild(t);t.attributes.length;)node.setAttribute(t.attributes[0].name,t.attributes[0].value),t.removeAttribute(t.attributes[0].name)}return node}function findTemplateNode(root,nodeInfo){let parent=nodeInfo.parentInfo&&findTemplateNode(root,nodeInfo.parentInfo);if(!parent)return root;for(let n=parent.firstChild,i=0;n;n=n.nextSibling)if(nodeInfo.parentIndex===i++)return n}function applyIdToMap(inst,map,node,nodeInfo){nodeInfo.id&&(map[nodeInfo.id]=node)}function applyEventListener(inst,node,nodeInfo){if(nodeInfo.events&&nodeInfo.events.length)for(let e,j=0,e$=nodeInfo.events;j<e$.length&&(e=e$[j]);j++)inst._addMethodEventListenerToNode(node,e.name,e.value,inst)}function applyTemplateContent(inst,node,nodeInfo){nodeInfo.templateInfo&&(node._templateInfo=nodeInfo.templateInfo)}export const TemplateStamp=dedupingMixin(superClass=>{return class TemplateStamp extends superClass{static _parseTemplate(template,outerTemplateInfo){if(!template._templateInfo){let templateInfo=template._templateInfo={};templateInfo.nodeInfoList=[],templateInfo.stripWhiteSpace=outerTemplateInfo&&outerTemplateInfo.stripWhiteSpace||template.hasAttribute("strip-whitespace"),this._parseTemplateContent(template,templateInfo,{parent:null})}return template._templateInfo}static _parseTemplateContent(template,templateInfo,nodeInfo){return this._parseTemplateNode(template.content,templateInfo,nodeInfo)}static _parseTemplateNode(node,templateInfo,nodeInfo){let noted=!1,element=node;return"template"!=element.localName||element.hasAttribute("preserve-content")?"slot"===element.localName&&(templateInfo.hasInsertionPoint=!0):noted=this._parseTemplateNestedTemplate(element,templateInfo,nodeInfo)||noted,fixPlaceholder(element),element.firstChild&&this._parseTemplateChildNodes(element,templateInfo,nodeInfo),element.hasAttributes&&element.hasAttributes()&&(noted=this._parseTemplateNodeAttributes(element,templateInfo,nodeInfo)||noted),noted}static _parseTemplateChildNodes(root,templateInfo,nodeInfo){if("script"!==root.localName&&"style"!==root.localName)for(let next,node=root.firstChild,parentIndex=0;node;node=next){if("template"==node.localName&&(node=wrapTemplateExtension(node)),next=node.nextSibling,node.nodeType===Node.TEXT_NODE){let n=next;for(;n&&n.nodeType===Node.TEXT_NODE;)node.textContent+=n.textContent,next=n.nextSibling,root.removeChild(n),n=next;if(templateInfo.stripWhiteSpace&&!node.textContent.trim()){root.removeChild(node);continue}}let childInfo={parentIndex,parentInfo:nodeInfo};this._parseTemplateNode(node,templateInfo,childInfo)&&(childInfo.infoIndex=templateInfo.nodeInfoList.push(childInfo)-1),node.parentNode&&parentIndex++}}static _parseTemplateNestedTemplate(node,outerTemplateInfo,nodeInfo){let element=node,templateInfo=this._parseTemplate(element,outerTemplateInfo);return(templateInfo.content=element.content.ownerDocument.createDocumentFragment()).appendChild(element.content),nodeInfo.templateInfo=templateInfo,!0}static _parseTemplateNodeAttributes(node,templateInfo,nodeInfo){let noted=!1,attrs=Array.from(node.attributes);for(let a,i=attrs.length-1;a=attrs[i];i--)noted=this._parseTemplateNodeAttribute(node,templateInfo,nodeInfo,a.name,a.value)||noted;return noted}static _parseTemplateNodeAttribute(node,templateInfo,nodeInfo,name,value){return"on-"===name.slice(0,3)?(node.removeAttribute(name),nodeInfo.events=nodeInfo.events||[],nodeInfo.events.push({name:name.slice(3),value}),!0):"id"===name&&(nodeInfo.id=value,!0)}static _contentForTemplate(template){let templateInfo=template._templateInfo;return templateInfo&&templateInfo.content||template.content}_stampTemplate(template){template&&!template.content&&window.HTMLTemplateElement&&HTMLTemplateElement.decorate&&HTMLTemplateElement.decorate(template);let templateInfo=this.constructor._parseTemplate(template),nodeInfo=templateInfo.nodeInfoList,content=templateInfo.content||template.content,dom=document.importNode(content,!0);dom.__noInsertionPoint=!templateInfo.hasInsertionPoint;let nodes=dom.nodeList=new Array(nodeInfo.length);dom.$={};for(let info,i=0,l=nodeInfo.length;i<l&&(info=nodeInfo[i]);i++){let node=nodes[i]=findTemplateNode(dom,info);applyIdToMap(0,dom.$,node,info),applyTemplateContent(0,node,info),applyEventListener(this,node,info)}return dom=dom,dom}_addMethodEventListenerToNode(node,eventName,methodName,context){let handler=function createNodeEventHandler(context,eventName,methodName){return context=context._methodHost||context,function(e){context[methodName]?context[methodName](e,e.detail):console.warn("listener method `"+methodName+"` not defined")}}(context=context||node,0,methodName);return this._addEventListenerToNode(node,eventName,handler),handler}_addEventListenerToNode(node,eventName,handler){node.addEventListener(eventName,handler)}_removeEventListenerFromNode(node,eventName,handler){node.removeEventListener(eventName,handler)}}});