/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
import{DomModule}from"../elements/dom-module.js";import{resolveCss}from"./resolve-url.js";const MODULE_STYLE_LINK_SELECTOR="link[rel=import][type~=css]",INCLUDE_ATTR="include",SHADY_UNSCOPED_ATTR="shady-unscoped";function importModule(moduleId){return DomModule.import(moduleId)}function styleForImport(importDoc){let container=importDoc.body?importDoc.body:importDoc;const importCss=resolveCss(container.textContent,importDoc.baseURI),style=document.createElement("style");return style.textContent=importCss,style}export function stylesFromModules(moduleIds){const modules=moduleIds.trim().split(/\s+/),styles=[];for(let i=0;i<modules.length;i++)styles.push(...stylesFromModule(modules[i]));return styles}export function stylesFromModule(moduleId){const m=importModule(moduleId);if(!m)return console.warn("Could not find style data in module named",moduleId),[];if(void 0===m._styles){const styles=[];styles.push(..._stylesFromModuleImports(m));const template=m.querySelector("template");template&&styles.push(...stylesFromTemplate(template,m.assetpath)),m._styles=styles}return m._styles}export function stylesFromTemplate(template,baseURI){if(!template._styles){const styles=[],e$=template.content.querySelectorAll("style");for(let i=0;i<e$.length;i++){let e=e$[i],include=e.getAttribute(INCLUDE_ATTR);include&&styles.push(...stylesFromModules(include).filter((function(item,index,self){return self.indexOf(item)===index}))),baseURI&&(e.textContent=resolveCss(e.textContent,baseURI)),styles.push(e)}template._styles=styles}return template._styles}export function stylesFromModuleImports(moduleId){let m=importModule(moduleId);return m?_stylesFromModuleImports(m):[]}function _stylesFromModuleImports(module){const styles=[],p$=module.querySelectorAll(MODULE_STYLE_LINK_SELECTOR);for(let i=0;i<p$.length;i++){let p=p$[i];if(p.import){const importDoc=p.import,unscoped=p.hasAttribute(SHADY_UNSCOPED_ATTR);if(unscoped&&!importDoc._unscopedStyle){const style=styleForImport(importDoc);style.setAttribute(SHADY_UNSCOPED_ATTR,""),importDoc._unscopedStyle=style}else importDoc._style||(importDoc._style=styleForImport(importDoc));styles.push(unscoped?importDoc._unscopedStyle:importDoc._style)}}return styles}export function cssFromModules(moduleIds){let modules=moduleIds.trim().split(/\s+/),cssText="";for(let i=0;i<modules.length;i++)cssText+=cssFromModule(modules[i]);return cssText}export function cssFromModule(moduleId){let m=importModule(moduleId);if(m&&void 0===m._cssText){let cssText=_cssFromModuleImports(m),t=m.querySelector("template");t&&(cssText+=cssFromTemplate(t,m.assetpath)),m._cssText=cssText||null}return m||console.warn("Could not find style data in module named",moduleId),m&&m._cssText||""}export function cssFromTemplate(template,baseURI){let cssText="";const e$=stylesFromTemplate(template,baseURI);for(let i=0;i<e$.length;i++){let e=e$[i];e.parentNode&&e.parentNode.removeChild(e),cssText+=e.textContent}return cssText}export function cssFromModuleImports(moduleId){let m=importModule(moduleId);return m?_cssFromModuleImports(m):""}function _cssFromModuleImports(module){let cssText="",styles=_stylesFromModuleImports(module);for(let i=0;i<styles.length;i++)cssText+=styles[i].textContent;return cssText}