/**
@license
Copyright (c) 2018 Vaadin Ltd.
This program is available under Apache License Version 2.0, available at https://vaadin.com/license/
*/
import{PolymerElement}from"../../../@polymer/polymer/polymer-element.js";import{FlattenedNodesObserver}from"../../../@polymer/polymer/lib/utils/flattened-nodes-observer.js";import{Templatizer}from"./vaadin-grid-templatizer.js";export const ColumnBaseMixin=superClass=>(class ColumnBaseMixin extends superClass{static get properties(){return{resizable:{type:Boolean,value:function(){if("vaadin-grid-column-group"===this.localName)return;const parent=this.parentNode;return parent&&"vaadin-grid-column-group"===parent.localName&&parent.resizable||!1}},_headerTemplate:{type:Object},_footerTemplate:{type:Object},frozen:{type:Boolean,value:!1},hidden:{type:Boolean},header:{type:String},textAlign:{type:String},_lastFrozen:{type:Boolean,value:!1},_order:Number,_reorderStatus:Boolean,_emptyCells:Array,_headerCell:Object,_footerCell:Object,_grid:Object,headerRenderer:Function,footerRenderer:Function}}static get observers(){return["_widthChanged(width, _headerCell, _footerCell, _cells.*)","_frozenChanged(frozen, _headerCell, _footerCell, _cells.*)","_flexGrowChanged(flexGrow, _headerCell, _footerCell, _cells.*)","_pathOrHeaderChanged(path, header, _headerCell, _footerCell, _cells.*, renderer, headerRenderer, _bodyTemplate, _headerTemplate)","_textAlignChanged(textAlign, _cells.*, _headerCell, _footerCell)","_orderChanged(_order, _headerCell, _footerCell, _cells.*)","_lastFrozenChanged(_lastFrozen)","_setBodyTemplateOrRenderer(_bodyTemplate, renderer, _cells, _cells.*)","_setHeaderTemplateOrRenderer(_headerTemplate, headerRenderer, _headerCell)","_setFooterTemplateOrRenderer(_footerTemplate, footerRenderer, _footerCell)","_resizableChanged(resizable, _headerCell)","_reorderStatusChanged(_reorderStatus, _headerCell, _footerCell, _cells.*)","_hiddenChanged(hidden, _headerCell, _footerCell, _cells.*)"]}connectedCallback(){super.connectedCallback(),this._bodyTemplate&&(this._bodyTemplate.templatizer._grid=this._grid),this._headerTemplate&&(this._headerTemplate.templatizer._grid=this._grid),this._footerTemplate&&(this._footerTemplate.templatizer._grid=this._grid),this._templateObserver.flush(),this._bodyTemplate||this._templateObserver.callback(),requestAnimationFrame(()=>{this._allCells.forEach(cell=>{cell._content.parentNode||this._grid&&this._grid.appendChild(cell._content)})})}disconnectedCallback(){super.disconnectedCallback(),requestAnimationFrame(()=>{this._findHostGrid()||this._allCells.forEach(cell=>{cell._content.parentNode&&cell._content.parentNode.removeChild(cell._content)})}),this._gridValue=void 0}_findHostGrid(){let el=this;for(;el&&!/^vaadin.*grid(-pro)?$/.test(el.localName);)el=el.assignedSlot?el.assignedSlot.parentNode:el.parentNode;return el||void 0}get _grid(){return this._gridValue||(this._gridValue=this._findHostGrid()),this._gridValue}get _allCells(){return[].concat(this._cells||[]).concat(this._emptyCells||[]).concat(this._headerCell).concat(this._footerCell).filter(cell=>cell)}constructor(){super(),this._templateObserver=new FlattenedNodesObserver(this,info=>{this._headerTemplate=this._prepareHeaderTemplate(),this._footerTemplate=this._prepareFooterTemplate(),this._bodyTemplate=this._prepareBodyTemplate()})}_prepareHeaderTemplate(){return this._prepareTemplatizer(this._findTemplate(!0)||null,{})}_prepareFooterTemplate(){return this._prepareTemplatizer(this._findTemplate(!1,!0)||null,{})}_prepareBodyTemplate(){return this._prepareTemplatizer(this._findTemplate()||null)}_prepareTemplatizer(template,instanceProps){if(template&&!template.templatizer){const templatizer=new Templatizer;templatizer._grid=this._grid,templatizer.dataHost=this.dataHost,templatizer._instanceProps=instanceProps||templatizer._instanceProps,templatizer.template=template,template.templatizer=templatizer}return template}_renderHeaderAndFooter(){this.headerRenderer&&this.__runRenderer(this.headerRenderer,this._headerCell),this.footerRenderer&&this.__runRenderer(this.footerRenderer,this._footerCell)}__runRenderer(renderer,cell,rowData){const args=[cell._content,this];rowData&&rowData.item&&args.push(rowData),renderer.apply(this,args)}__setColumnTemplateOrRenderer(template,renderer,cells){if(template&&renderer)throw new Error("You should only use either a renderer or a template");cells.forEach(cell=>{const model=this._grid.__getRowModel(cell.parentElement);if(renderer)cell._renderer=renderer,(model.item||renderer===this.headerRenderer||renderer===this.footerRenderer)&&this.__runRenderer(renderer,cell,model);else if(cell._template!==template){cell._template=template,cell._content.innerHTML="",template.templatizer._grid=template.templatizer._grid||this._grid;const inst=template.templatizer.createInstance();cell._content.appendChild(inst.root),cell._instance=inst,model.item&&cell._instance.setProperties(model)}})}_setBodyTemplateOrRenderer(template,renderer,cells,splices){(template||renderer)&&cells&&this.__setColumnTemplateOrRenderer(template,renderer,cells)}_setHeaderTemplateOrRenderer(headerTemplate,headerRenderer,headerCell){(headerTemplate||headerRenderer)&&headerCell&&this.__setColumnTemplateOrRenderer(headerTemplate,headerRenderer,[headerCell])}_setFooterTemplateOrRenderer(footerTemplate,footerRenderer,footerCell){(footerTemplate||footerRenderer)&&footerCell&&(this.__setColumnTemplateOrRenderer(footerTemplate,footerRenderer,[footerCell]),this._grid.__updateHeaderFooterRowVisibility(footerCell.parentElement))}_selectFirstTemplate(header=!1,footer=!1){return FlattenedNodesObserver.getFlattenedNodes(this).filter(node=>"template"===node.localName&&node.classList.contains("header")===header&&node.classList.contains("footer")===footer)[0]}_findTemplate(header,footer){const template=this._selectFirstTemplate(header,footer);return template&&this.dataHost&&(template._rootDataHost=this.dataHost._rootDataHost||this.dataHost),template}_flexGrowChanged(flexGrow,headerCell,footerCell,cells){this.parentElement&&this.parentElement._columnPropChanged&&this.parentElement._columnPropChanged("flexGrow"),this._allCells.forEach(cell=>cell.style.flexGrow=flexGrow)}_orderChanged(order,headerCell,footerCell,cells){this._allCells.forEach(cell=>cell.style.order=order)}_widthChanged(width,headerCell,footerCell,cells){this.parentElement&&this.parentElement._columnPropChanged&&this.parentElement._columnPropChanged("width"),this._allCells.forEach(cell=>cell.style.width=width),this._grid&&this._grid.__forceReflow&&this._grid.__forceReflow()}_frozenChanged(frozen,headerCell,footerCell,cells){this.parentElement&&this.parentElement._columnPropChanged&&this.parentElement._columnPropChanged("frozen",frozen),this._allCells.forEach(cell=>this._toggleAttribute("frozen",frozen,cell)),this._grid&&this._grid._frozenCellsChanged&&this._grid._frozenCellsChanged()}_lastFrozenChanged(lastFrozen){this._allCells.forEach(cell=>this._toggleAttribute("last-frozen",lastFrozen,cell)),this.parentElement&&this.parentElement._columnPropChanged&&(this.parentElement._lastFrozen=lastFrozen)}_pathOrHeaderChanged(path,header,headerCell,footerCell,cells,renderer,headerRenderer,bodyTemplate,headerTemplate){const hasHeaderText=void 0!==header;if(!headerRenderer&&!headerTemplate&&hasHeaderText&&headerCell&&this.__setTextContent(headerCell._content,header),path&&cells.value){if(!renderer&&!bodyTemplate){const pathRenderer=(root,owner,{item})=>this.__setTextContent(root,this.get(path,item));this.__setColumnTemplateOrRenderer(void 0,pathRenderer,cells.value)}headerRenderer||headerTemplate||hasHeaderText||!headerCell||null===header||this.__setTextContent(headerCell._content,this._generateHeader(path))}headerCell&&this._grid.__updateHeaderFooterRowVisibility(headerCell.parentElement)}__setTextContent(node,textContent){node.textContent!==textContent&&(node.textContent=textContent)}_generateHeader(path){return path.substr(path.lastIndexOf(".")+1).replace(/([A-Z])/g,"-$1").toLowerCase().replace(/-/g," ").replace(/^./,match=>match.toUpperCase())}_toggleAttribute(name,bool,node){node.hasAttribute(name)===!bool&&(bool?node.setAttribute(name,""):node.removeAttribute(name))}_reorderStatusChanged(reorderStatus,headerCell,footerCell,cells){this._allCells.forEach(cell=>cell.setAttribute("reorder-status",reorderStatus))}_resizableChanged(resizable,headerCell){void 0!==resizable&&void 0!==headerCell&&headerCell&&[headerCell].concat(this._emptyCells).forEach(cell=>{if(cell){const existingHandle=cell.querySelector('[part~="resize-handle"]');if(existingHandle&&cell.removeChild(existingHandle),resizable){const handle=document.createElement("div");handle.setAttribute("part","resize-handle"),cell.appendChild(handle)}}})}_textAlignChanged(textAlign,_cells,_headerCell,_footerCell){if(void 0===textAlign)return;if(-1===["start","end","center"].indexOf(textAlign))return void console.warn('textAlign can only be set as "start", "end" or "center"');let textAlignFallback;"ltr"===getComputedStyle(this._grid).direction?"start"===textAlign?textAlignFallback="left":"end"===textAlign&&(textAlignFallback="right"):"start"===textAlign?textAlignFallback="right":"end"===textAlign&&(textAlignFallback="left"),this._allCells.forEach(cell=>{cell._content.style.textAlign=textAlign,getComputedStyle(cell._content).textAlign!==textAlign&&(cell._content.style.textAlign=textAlignFallback)})}_hiddenChanged(hidden,headerCell,footerCell,cells){this.parentElement&&this.parentElement._columnPropChanged&&this.parentElement._columnPropChanged("hidden",hidden),this._allCells.forEach(cell=>this._toggleAttribute("hidden",hidden,cell)),!!hidden!=!!this._previousHidden&&this._grid&&(this._grid._updateLastFrozen&&this._grid._updateLastFrozen(),this._grid.notifyResize&&this._grid.notifyResize(),this._grid._resetKeyboardNavigation&&this._grid._resetKeyboardNavigation()),this._previousHidden=hidden}});class GridColumnElement extends(ColumnBaseMixin(PolymerElement)){static get is(){return"vaadin-grid-column"}static get properties(){return{width:{type:String,value:"100px"},flexGrow:{type:Number,value:1},renderer:Function,path:{type:String},autoWidth:{type:Boolean,value:!1},_bodyTemplate:{type:Object},_cells:Array}}}customElements.define(GridColumnElement.is,GridColumnElement);export{GridColumnElement};